"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const app_service_1 = require("./app.service");
const request_builder_1 = require("./request/request.builder");
const hostcfgData_types_1 = require("./common/hostcfgs/hostcfgData.types");
let AppController = class AppController {
    constructor(appService) {
        this.appService = appService;
    }
    async getInfo() {
        const data = await this.appService.getInfo();
        return {
            statusCode: common_1.HttpStatus.OK,
            data: data
        };
    }
    async getInfoToken() {
        return {
            statusCode: common_1.HttpStatus.OK,
            message: "Connection succesful"
        };
    }
    async getInfoRemote(body) {
        try {
            const { body: responseBody } = await new request_builder_1.RequestBuilder(hostcfgData_types_1.PROTO.HTTPS, body.url, request_builder_1.RequestMethod.GET)
                .addAgent()
                .setHeaders({ Authorization: "Bearer " + body.token })
                .setRequestTimeout(20000)
                .processRequest();
            return JSON.parse(responseBody);
        }
        catch (error) {
            if (error.error) {
                if (error.error.code && error.error.code === "EHOSTUNREACH") {
                    return {
                        statusCode: common_1.HttpStatus.SERVICE_UNAVAILABLE,
                        message: "No route to host"
                    };
                }
            }
            if (error.code && error.code === "EHOSTUNREACH") {
                return {
                    statusCode: common_1.HttpStatus.SERVICE_UNAVAILABLE,
                    message: "No route to host"
                };
            }
            return {
                statusCode: common_1.HttpStatus.SERVICE_UNAVAILABLE,
                message: "Couldn't reach destination"
            };
        }
    }
    async getTables() {
        const tables = await this.appService.getTables();
        return {
            statusCode: common_1.HttpStatus.OK,
            data: tables
        };
    }
    async getServices() {
        const services = await this.appService.getServices();
        return {
            statusCode: common_1.HttpStatus.OK,
            data: services
        };
    }
    async getDevices() {
        const devices = await this.appService.getDevices();
        return {
            statusCode: common_1.HttpStatus.OK,
            data: devices
        };
    }
    async getLicenseLimits() {
        return {
            statusCode: common_1.HttpStatus.OK,
            data: await this.appService.getLicenseLimits()
        };
    }
};
exports.AppController = AppController;
__decorate([
    (0, common_1.Get)('/api/info'),
    openapi.ApiResponse({ status: 200, type: require("./common/backendResponse.dto").BackendResponseDTO }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getInfo", null);
__decorate([
    (0, common_1.Get)('/api/info/remote/token'),
    openapi.ApiResponse({ status: 200, type: require("./common/basicResponse.dto").BasicResponseDTO }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getInfoToken", null);
__decorate([
    (0, common_1.Post)('/api/info/remote'),
    openapi.ApiResponse({ status: 201, type: require("./common/basicResponse.dto").BasicResponseDTO }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getInfoRemote", null);
__decorate([
    (0, common_1.Get)('/api/info/tables'),
    openapi.ApiResponse({ status: 200, type: require("./common/backendResponse.dto").TablesResponseDTO }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getTables", null);
__decorate([
    (0, common_1.Get)('/api/info/services'),
    openapi.ApiResponse({ status: 200, type: require("./common/backendResponse.dto").ServicesResponseDTO }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getServices", null);
__decorate([
    (0, common_1.Get)('/api/info/devices'),
    openapi.ApiResponse({ status: 200, type: require("./common/backendResponse.dto").DevicesResponseDTO }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getDevices", null);
__decorate([
    (0, common_1.Get)('/api/info/license'),
    openapi.ApiResponse({ status: 200, type: require("./common/backendResponse.dto").LicenseLimitsResponseDTO }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getLicenseLimits", null);
exports.AppController = AppController = __decorate([
    (0, swagger_1.ApiTags)('Backend'),
    (0, swagger_1.ApiBearerAuth)(),
    (0, common_1.Controller)(),
    __metadata("design:paramtypes", [app_service_1.AppService])
], AppController);
//# sourceMappingURL=app.controller.js.map