"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppModule = void 0;
const common_1 = require("@nestjs/common");
const config_1 = require("@nestjs/config");
const core_1 = require("@nestjs/core");
const event_emitter_1 = require("@nestjs/event-emitter");
const schedule_1 = require("@nestjs/schedule");
const serve_static_1 = require("@nestjs/serve-static");
const typeorm_1 = require("@nestjs/typeorm");
const path_1 = require("path");
const app_controller_1 = require("./app.controller");
const app_service_1 = require("./app.service");
const bucket_config_1 = require("./config/bucket.config");
const db_config_1 = require("./config/db.config");
const backend_entity_1 = require("./entity/backend.entity");
const objectItem_entity_1 = require("./entity/objectItem.entity");
const roles_guard_1 = require("./guard/roles.guard");
const demo_middleware_1 = require("./middleware/demo.middleware");
const https_middleware_1 = require("./middleware/https.middleware");
const regenerateCookie_middleware_1 = require("./middleware/regenerateCookie.middleware");
const token_middleware_1 = require("./middleware/token.middleware");
const acl_module_1 = require("./service/acl/acl.module");
const apis_module_1 = require("./service/apis/apis.module");
const architecture_module_1 = require("./service/architecture/architecture.module");
const audit_module_1 = require("./service/audit/audit.module");
const configuration_module_1 = require("./service/configuration/configuration.module");
const custom_group_module_1 = require("./service/custom_group/custom_group.module");
const dashboard_module_1 = require("./service/dashboard/dashboard.module");
const exporter_module_1 = require("./service/exporter/exporter.module");
const healthStatus_module_1 = require("./service/health_status/healthStatus.module");
const heatmap_module_1 = require("./service/heatmap/heatmap.module");
const ldap_module_1 = require("./service/ldap/ldap.module");
const log_module_1 = require("./service/log/log.module");
const mapping_module_1 = require("./service/mapping/mapping.module");
const menu_module_1 = require("./service/menu/menu.module");
const messages_module_1 = require("./service/messages/messages.module");
const metrics_module_1 = require("./service/metrics/metrics.module");
const microservices_module_1 = require("./service/microservices/microservices.module");
const reporter_module_1 = require("./service/reporter/reporter.module");
const search_module_1 = require("./service/search/search.module");
const storage_group_module_1 = require("./service/storage_group/storage_group.module");
const token_module_1 = require("./service/token/token.module");
const users_module_1 = require("./service/users/users.module");
const tasks_module_1 = require("./tasks/tasks.module");
const tag_module_1 = require("./service/tag/tag.module");
const public_module_1 = require("./service/public/public.module");
const publicApi_middleware_1 = require("./middleware/publicApi.middleware");
const freeVersion_middleware_1 = require("./middleware/freeVersion.middleware");
const session_middleware_1 = require("./middleware/session.middleware");
const session_module_1 = require("./service/session/session.module");
const PM2_1 = require("./service/configuration/PM2");
const alerting_module_1 = require("./service/alerting/alerting.module");
const custom_task_module_1 = require("./service/custom_task/custom_task.module");
const import_module_1 = require("./service/import/import.module");
const App_1 = require("./service/configuration/App");
const debug_module_1 = require("./service/debug/debug.module");
const serverGroup_module_1 = require("./service/server_group/serverGroup.module");
const imports = [
    typeorm_1.TypeOrmModule.forRootAsync({
        inject: [config_1.ConfigService],
        useFactory: async (configService) => ({ ...configService.get('database') }),
    }),
    config_1.ConfigModule.forRoot({ isGlobal: true, load: [db_config_1.default, bucket_config_1.default] }),
    schedule_1.ScheduleModule.forRoot(),
    architecture_module_1.ArchitectureModule,
    session_module_1.SessionModule,
    token_module_1.TokenModule,
    log_module_1.LogModule,
    metrics_module_1.MetricsModule,
    configuration_module_1.ConfigurationModule,
    healthStatus_module_1.HealthStatusModule,
    microservices_module_1.MicroservicesModule,
    apis_module_1.ApisModule,
    menu_module_1.MenuModule,
    users_module_1.UsersModule,
    acl_module_1.ACLModule,
    event_emitter_1.EventEmitterModule.forRoot({
        maxListeners: 30
    }),
    messages_module_1.MessagesModule,
    custom_group_module_1.CustomGroupModule,
    dashboard_module_1.DashboardModule,
    search_module_1.SearchModule,
    exporter_module_1.ExporterModule,
    mapping_module_1.MappingModule,
    audit_module_1.AuditModule,
    storage_group_module_1.StorageGroupModule,
    heatmap_module_1.HeatmapModule,
    reporter_module_1.ReporterModule,
    ldap_module_1.LdapModule,
    public_module_1.PublicModule,
    tag_module_1.TagModule,
    alerting_module_1.AlertingModule,
    custom_task_module_1.CustomTaskModule,
    import_module_1.ImportModule,
    serverGroup_module_1.ServerGroupModule,
    typeorm_1.TypeOrmModule.forFeature([backend_entity_1.Backend, objectItem_entity_1.ObjectItem]),
];
if (!PM2_1.PM2.isRunning() || PM2_1.PM2.isMasterBackend()) {
    imports.push(tasks_module_1.TasksModule);
}
if (!App_1.App.isProduction()) {
    imports.push(debug_module_1.DebugModule);
}
const fs = require('fs');
if (fs.existsSync('./client/')) {
    imports.push(serve_static_1.ServeStaticModule.forRoot({
        rootPath: (0, path_1.join)(__dirname, '..', 'client'),
        exclude: ['/api/(.*)'],
    }));
}
let AppModule = class AppModule {
    configure(consumer) {
        consumer
            .apply(https_middleware_1.HttpsMiddleware)
            .forRoutes({ path: '*', method: common_1.RequestMethod.ALL });
        consumer
            .apply(session_middleware_1.SessionMiddleware)
            .exclude({ path: 'api/session/(.*)', method: common_1.RequestMethod.ALL }, { path: 'api/token/(.*)', method: common_1.RequestMethod.ALL }, { path: 'api/info', method: common_1.RequestMethod.ALL }, { path: 'api/public/(.*)', method: common_1.RequestMethod.ALL }, { path: 'api/debug/(.*)', method: common_1.RequestMethod.ALL }, { path: '/api/configuration/v1/microservices/variables', method: common_1.RequestMethod.GET })
            .forRoutes({ path: 'api*', method: common_1.RequestMethod.ALL });
        consumer
            .apply(token_middleware_1.TokenMiddleware)
            .exclude({ path: 'api/session/(.*)', method: common_1.RequestMethod.ALL }, { path: 'api/token/(.*)', method: common_1.RequestMethod.ALL }, { path: 'api/info', method: common_1.RequestMethod.ALL }, { path: 'api/public/(.*)', method: common_1.RequestMethod.ALL }, { path: 'api/debug/(.*)', method: common_1.RequestMethod.ALL }, { path: '/api/configuration/v1/microservices/variables', method: common_1.RequestMethod.GET })
            .forRoutes({ path: 'api*', method: common_1.RequestMethod.ALL });
        consumer
            .apply(regenerateCookie_middleware_1.RegenerateCookieMiddleware)
            .exclude({ path: 'api/session/(.*)', method: common_1.RequestMethod.ALL }, { path: 'api/token/(.*)', method: common_1.RequestMethod.ALL }, { path: 'api/info', method: common_1.RequestMethod.ALL }, { path: 'api/public/(.*)', method: common_1.RequestMethod.ALL }, { path: 'api/debug/(.*)', method: common_1.RequestMethod.ALL }, { path: 'api/metrics/v([0-9])/data/timeseries', method: common_1.RequestMethod.ALL })
            .forRoutes({ path: 'api*', method: common_1.RequestMethod.ALL });
        consumer
            .apply(publicApi_middleware_1.PublicApiMiddleware)
            .exclude({ path: 'api/public/v1/auth', method: common_1.RequestMethod.ALL })
            .forRoutes({ path: 'api/public/*', method: common_1.RequestMethod.ALL });
        consumer
            .apply(freeVersion_middleware_1.FreeVersionMiddleware)
            .forRoutes({ path: 'api/public/*', method: common_1.RequestMethod.ALL });
        if (process.env['APP_DEMO']) {
            consumer
                .apply(demo_middleware_1.DemoMiddleware)
                .exclude({ path: 'api/session/(.*)', method: common_1.RequestMethod.ALL }, { path: 'api/token/v1/generate', method: common_1.RequestMethod.ALL }, { path: 'api/token/v1/refresh', method: common_1.RequestMethod.ALL }, { path: 'api/token/v1/remove', method: common_1.RequestMethod.ALL }, { path: 'api/metrics/v([0-9])/data/timeseries', method: common_1.RequestMethod.ALL }, { path: 'api/architecture/v1/labels', method: common_1.RequestMethod.ALL }, { path: 'api/dashboard/v1/graph/find', method: common_1.RequestMethod.ALL }, { path: 'api/menu/v1/top', method: common_1.RequestMethod.ALL }, { path: 'api/menu/v1/overview', method: common_1.RequestMethod.ALL }, { path: 'api/menu/v1/topology', method: common_1.RequestMethod.ALL }, { path: 'api/metrics/v1/data/prediction', method: common_1.RequestMethod.ALL })
                .forRoutes({ path: 'api*', method: common_1.RequestMethod.POST }, { path: 'api*', method: common_1.RequestMethod.PUT }, { path: 'api*', method: common_1.RequestMethod.DELETE });
        }
    }
};
exports.AppModule = AppModule;
exports.AppModule = AppModule = __decorate([
    (0, common_1.Module)({
        imports: imports,
        controllers: [app_controller_1.AppController],
        providers: [
            app_service_1.AppService,
            {
                provide: core_1.APP_GUARD,
                useClass: roles_guard_1.RolesGuard,
            },
        ],
    })
], AppModule);
//# sourceMappingURL=app.module.js.map