"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const process_1 = require("process");
const Crypto_1 = require("./service/configuration/Crypto");
if (!process.argv[3]) {
    console.error("Not all parameters are specified");
    console.log("change-password [user] [password]");
    (0, process_1.exit)(1);
}
const userName = process.argv[2];
const newPassword = process.argv[3];
async function changePassword() {
    require('dotenv').config();
    try {
        const { Pool, Client } = require('pg');
        const pool = new Pool({
            user: process.env['DB_USERNAME'],
            host: process.env['DB_HOST'],
            password: await Crypto_1.Crypto.decrypt(process.env['DB_PASSWORD'], process.env['APP_SECRET']),
            port: process.env['DB_PORT'],
            database: process.env['DB_DATABASE'],
        });
        const userSelect = await pool.query('SELECT * FROM public.users WHERE username = $1 LIMIT 1', [userName]);
        if (userSelect.rows && userSelect.rows.length === 1) {
            const bcrypt = require('bcryptjs');
            const salt = await bcrypt.genSaltSync(10);
            const password = bcrypt.hashSync(newPassword, salt);
            await pool.query('UPDATE public.users SET password = $1 WHERE username = $2', [password, userName]);
            console.log("Password changed");
            (0, process_1.exit)(0);
        }
        else {
            console.error("User not found");
            (0, process_1.exit)(1);
        }
    }
    catch (e) {
        console.error("Error during change pass: " + e);
        (0, process_1.exit)(1);
    }
}
changePassword();
//# sourceMappingURL=change-password.js.map