"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AclMenuResponseDTO = exports.AclMenuChangesResponseDTO = exports.AclResponseDTO = exports.AclMenuLink = exports.AclMenuFolder = exports.AclMenuItem = exports.CreateAclRuleDTO = exports.AclRule = void 0;
const openapi = require("@nestjs/swagger");
const basicResponse_dto_1 = require("./basicResponse.dto");
class AclRule {
    constructor(rule_id, type, value0, value1, value2) {
        this.rule_id = rule_id;
        this.type = type;
        if (value0 !== undefined) {
            this.value0 = value0;
        }
        if (value1 !== undefined) {
            this.value1 = value1;
        }
        if (value2 !== undefined) {
            this.value2 = value2;
        }
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { rule_id: { required: true, type: () => String }, type: { required: true, type: () => Object }, value0: { required: false, type: () => String }, value1: { required: false, type: () => String }, value2: { required: false, type: () => String } };
    }
}
exports.AclRule = AclRule;
class CreateAclRuleDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object }, value0: { required: false, type: () => String }, value1: { required: false, type: () => String }, value2: { required: false, type: () => String } };
    }
}
exports.CreateAclRuleDTO = CreateAclRuleDTO;
class AclMenuItem {
    constructor(title, path, status, disabled) {
        this.title = title;
        this.url = "/api/acl/v1/tree/" + path;
        this.status = status;
        if (disabled !== undefined) {
            this.disabled = disabled;
        }
    }
    getKey() {
        let str = JSON.stringify(this);
        const out = Buffer.from(str, "utf8").toString("base64");
        return out;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { title: { required: true, type: () => String }, url: { required: true, type: () => String }, status: { required: true, type: () => Object }, disabled: { required: false, type: () => Boolean }, checkable: { required: false, type: () => Boolean }, key: { required: false, type: () => String }, _class: { required: false, type: () => String }, hwType: { required: false, type: () => String }, subsystem: { required: false, type: () => String }, children: { required: false, type: () => [require("./aclResponse.dto").AclMenuItem] }, itemId: { required: false, type: () => String }, isLeaf: { required: false, type: () => Boolean }, isDefault: { required: false, type: () => Boolean }, pageType: { required: false, type: () => String } };
    }
}
exports.AclMenuItem = AclMenuItem;
class AclMenuFolder extends AclMenuItem {
    constructor(title, path, status, _class, hwType, subsystem, itemId) {
        if (hwType !== undefined) {
            path = 'hw_type/' + path;
        }
        super(title, path, status);
        if (_class !== undefined) {
            this._class = _class;
        }
        if (hwType !== undefined) {
            this.hwType = hwType;
        }
        if (subsystem !== undefined) {
            this.subsystem = subsystem;
        }
        if (itemId !== undefined) {
            this.itemId = itemId;
        }
        this.key = this.getKey();
    }
    static _OPENAPI_METADATA_FACTORY() {
        return {};
    }
}
exports.AclMenuFolder = AclMenuFolder;
class AclMenuLink extends AclMenuItem {
    constructor(title, path, status, itemId) {
        super(title, path, status);
        this.isLeaf = true;
        this.url = undefined;
        if (itemId !== undefined) {
            this.itemId = itemId;
        }
        this.key = this.getKey();
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { isLeaf: { required: true, type: () => Object, default: true } };
    }
}
exports.AclMenuLink = AclMenuLink;
class AclResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./aclResponse.dto").AclRule] } };
    }
}
exports.AclResponseDTO = AclResponseDTO;
class AclMenuChangesResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => Object } };
    }
}
exports.AclMenuChangesResponseDTO = AclMenuChangesResponseDTO;
class AclMenuResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./aclResponse.dto").AclMenuItem] } };
    }
}
exports.AclMenuResponseDTO = AclMenuResponseDTO;
//# sourceMappingURL=aclResponse.dto.js.map