"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LicenseLimitsResponseDTO = exports.HostcfgLimitsResponseDTO = exports.TablesResponseDTO = exports.ServicesResponseDTO = exports.DevicesResponseDTO = exports.BackendResponseDTO = exports.BackendServicesResponseDTO = exports.BackendServiceResponseDTO = exports.LicenseLimit = exports.HostcfgLimits = exports.Devices = exports.BackendDTO = exports.ILicenseTechnology = exports.BackendService = void 0;
const openapi = require("@nestjs/swagger");
const basicResponse_dto_1 = require("./basicResponse.dto");
class BackendService {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, microservice: { required: true, type: () => String }, active: { required: true, type: () => Boolean }, version: { required: true, type: () => String }, script: { required: false, type: () => String }, pid: { required: false, type: () => Number }, monitor: { required: false, type: () => ({ memory_byte: { required: true, type: () => Number }, cpu_percent: { required: true, type: () => Number } }) } };
    }
}
exports.BackendService = BackendService;
class ILicenseTechnology {
    static _OPENAPI_METADATA_FACTORY() {
        return { technology: { required: true, type: () => String }, expirationDate: { required: true, type: () => String }, limit: { required: true, type: () => Number } };
    }
}
exports.ILicenseTechnology = ILicenseTechnology;
class BackendDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { backend: { required: true, type: () => ({ free: { required: true, type: () => Boolean }, version: { required: true, type: () => String }, node_version: { required: true, type: () => String }, demo: { required: false, type: () => Boolean }, production: { required: false, type: () => Boolean }, docker: { required: false, type: () => Boolean }, appliance: { required: false, type: () => String }, premium: { required: false, type: () => ({ valid: { required: true, type: () => Boolean }, expirationDate: { required: false, type: () => String }, technologies: { required: true, type: () => [require("./backendResponse.dto").ILicenseTechnology] }, isTrial: { required: false, type: () => Boolean } }) }, limits: { required: false, type: () => require("./backendResponse.dto").HostcfgLimits }, cert: { required: false, type: () => ({ crt: { required: true, type: () => String }, key: { required: true, type: () => String } }) }, firstLogin: { required: false, type: () => Boolean } }) }, database: { required: true, type: () => ({ server: { required: true, type: () => String }, port: { required: true, type: () => Number }, database: { required: true, type: () => String }, version: { required: true, type: () => String }, tables: { required: false, type: () => Object } }) } };
    }
}
exports.BackendDTO = BackendDTO;
class Devices {
    static _OPENAPI_METADATA_FACTORY() {
        return {};
    }
}
exports.Devices = Devices;
class HostcfgLimits {
    static _OPENAPI_METADATA_FACTORY() {
        return {};
    }
}
exports.HostcfgLimits = HostcfgLimits;
class LicenseLimit {
    static _OPENAPI_METADATA_FACTORY() {
        return { technology: { required: true, type: () => String }, label: { required: true, type: () => String }, limit: { required: true, type: () => Number }, publicAPI: { required: true, type: () => Boolean }, subsystem: { required: true, type: () => String }, expiration: { required: true, type: () => String }, expired: { required: true, type: () => Boolean } };
    }
}
exports.LicenseLimit = LicenseLimit;
class BackendServiceResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => require("./backendResponse.dto").BackendService } };
    }
}
exports.BackendServiceResponseDTO = BackendServiceResponseDTO;
class BackendServicesResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./backendResponse.dto").BackendService] } };
    }
}
exports.BackendServicesResponseDTO = BackendServicesResponseDTO;
class BackendResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => require("./backendResponse.dto").BackendDTO } };
    }
}
exports.BackendResponseDTO = BackendResponseDTO;
class DevicesResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => require("./backendResponse.dto").Devices } };
    }
}
exports.DevicesResponseDTO = DevicesResponseDTO;
class ServicesResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./backendResponse.dto").BackendService] } };
    }
}
exports.ServicesResponseDTO = ServicesResponseDTO;
class TablesResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => Object } };
    }
}
exports.TablesResponseDTO = TablesResponseDTO;
class HostcfgLimitsResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => require("./backendResponse.dto").HostcfgLimits } };
    }
}
exports.HostcfgLimitsResponseDTO = HostcfgLimitsResponseDTO;
class LicenseLimitsResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./backendResponse.dto").LicenseLimit] } };
    }
}
exports.LicenseLimitsResponseDTO = LicenseLimitsResponseDTO;
//# sourceMappingURL=backendResponse.dto.js.map