import { BasicResponseDTO } from "./basicResponse.dto";
import { ConsistencyGroupDTO } from "./consistencyGroup.dto";
import { Severity } from "./constants/healthStatusMirror.constants";
export declare class HealthStatusMirrorDTO {
    source_vol_id: string;
    target_vol_id: string;
    source_item_id: string;
    source_item_label?: string;
    target_item_id?: string;
    target_item_label?: string;
    type_state: string;
    severity: Severity;
    system_name: string;
    remote_system_name: string;
    freeze_time?: number;
    progress?: number;
    consistency_group_id?: string;
    consistency_group_label?: string;
    _consistency_group?: ConsistencyGroupDTO;
}
export declare class HealthStatusMirrorBackDTO {
    vol_id: string;
    hostcfg_id: string;
    item_id: string;
}
export type ConsistencyGroupMirrorMapDTO = {
    cgMirrors: {
        [key: string]: {
            mirrors: HealthStatusMirrorDTO[];
            label: string;
            id: string;
        };
    };
    noCgMirrors: HealthStatusMirrorDTO[];
};
export declare class HealthStatusMirrorRelDTO {
    source_vol_id: string;
    source_hostcfg_id: string;
    target_vol_id: string;
    target_hostcfg_id?: string;
    system_name: string;
    remote_system_name: string;
    consistency_group_id?: string;
    consistency_group_label?: string;
    type_state: string;
    severity: Severity;
    freeze_time?: number;
    progress?: number;
    item_id: string;
}
export declare class MirrorsDTO {
    mirrors: HealthStatusMirrorRelDTO[];
    consistencyGroups: ConsistencyGroupDTO[];
}
export declare class HealthStatusMirrorsDTOResponse extends BasicResponseDTO {
    data?: HealthStatusMirrorDTO[];
}
export declare class HealthStatusMirrorDTOResponse extends BasicResponseDTO {
    data?: HealthStatusMirrorDTO;
}
export declare class MirrorsResponseDTO extends BasicResponseDTO {
    data?: MirrorsDTO;
}
export declare class CGMirrorsResponseDTO extends BasicResponseDTO {
    data?: ConsistencyGroupMirrorMapDTO;
}
