import { BaseDeviceProps, IHostcfgDataDescription, OldDeviceProps } from "./deviceProps";
export declare enum Par3Radio {
    CLI = "cli",
    WSAPI = "wsapi",
    SSH = "ssh"
}
export declare class Par3Props extends BaseDeviceProps {
    host: string;
    sshUsername: string;
    sshKeyFile: string;
    sshPort: number;
    apiPort: number;
    apiUsername: string;
    apiPassword: string;
    volumeCapacityHistory: boolean;
    cliApiSshRadio: Par3Radio;
    cliDir: string;
    cliUsername: string;
    cliPassword: string;
}
export declare enum Par3OldRadio {
    REST = "3par-rest-api",
    SSH = "3par-ssh",
    CLI = "3par-cli"
}
export declare class Par3PropsOld extends OldDeviceProps {
    "api-port": string;
    "api-user": string;
    volume_capacity: boolean;
    auth_ssh: boolean;
    "ssh-key-id": string;
    "ssh-user": string;
    "ssh-port": string;
    "clidir-gui": string;
    radio: Par3OldRadio;
    "api-password": string;
}
export declare const Par3DataDescription: IHostcfgDataDescription;
