"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GcloudDataDescription = exports.GcloudPropsOld = exports.GcloudProps = exports.GCloudCredentials = void 0;
const hostcfg_metadata_1 = require("../../resolve/hostcfg.metadata");
const deviceProps_1 = require("./deviceProps");
class GCloudCredentials {
    constructor() {
        this.client_id = undefined;
        this.private_key = undefined;
        this.token_uri = undefined;
        this.client_email = undefined;
        this.client_x509_cert_url = undefined;
        this.private_key_id = undefined;
        this.type = undefined;
        this.auth_uri = undefined;
        this.auth_provider_x509_cert_url = undefined;
        this.project_id = undefined;
    }
}
exports.GCloudCredentials = GCloudCredentials;
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], GCloudCredentials.prototype, "client_id", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], GCloudCredentials.prototype, "private_key", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], GCloudCredentials.prototype, "token_uri", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], GCloudCredentials.prototype, "client_email", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], GCloudCredentials.prototype, "client_x509_cert_url", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], GCloudCredentials.prototype, "private_key_id", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], GCloudCredentials.prototype, "type", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], GCloudCredentials.prototype, "auth_uri", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], GCloudCredentials.prototype, "auth_provider_x509_cert_url", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], GCloudCredentials.prototype, "project_id", void 0);
class GcloudProps extends deviceProps_1.BaseDeviceProps {
    constructor() {
        super(...arguments);
        this.host = "monitoring.googleapis.com";
        this.credentials = [new GCloudCredentials()];
    }
}
exports.GcloudProps = GcloudProps;
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], GcloudProps.prototype, "host", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], GcloudProps.prototype, "username", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], GcloudProps.prototype, "apiPort", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.ArrayItemType)(GCloudCredentials),
    __metadata("design:type", Array)
], GcloudProps.prototype, "credentials", void 0);
class GcloudPropsOld extends deviceProps_1.OldDeviceProps {
}
exports.GcloudPropsOld = GcloudPropsOld;
exports.GcloudDataDescription = {
    ...deviceProps_1.BaseDeviceDescription,
    credentials: {
        required: true,
        type: "format[]",
        description: "Gcloud credential files as json array",
        format: {
            client_id: {
                required: true,
                type: "string",
            },
            private_key: {
                required: true,
                type: "string",
            },
            token_uri: {
                required: true,
                type: "string",
            },
            client_email: {
                required: true,
                type: "string",
            },
            client_x509_cert_url: {
                required: true,
                type: "string",
            },
            private_key_id: {
                required: true,
                type: "string",
            },
            type: {
                required: true,
                type: "string",
            },
            auth_uri: {
                required: true,
                type: "string",
            },
            auth_provider_x509_cert_url: {
                required: true,
                type: "string",
            },
            project_id: {
                required: true,
                type: "string",
            }
        }
    }
};
//# sourceMappingURL=gcloud.data.js.map