import { AbstractDBProps, AbstractOldDBProps, IHostcfgDataDescription } from "./deviceProps";
import { DataGuardOld, HostService } from "./hostcfgData.types";
export declare class OracledbProps implements Omit<AbstractDBProps, "host"> {
    vendor: string;
    device: string;
    created: number;
    updated: number | null;
    description: string;
    managementUrl: string;
    instance: string;
    username: string;
    password: string;
    use_whitelist: boolean;
    dbs: string[];
    driver: string;
    port: number;
    type: string;
    hosts: Array<HostService>;
    dataguard: Array<HostService>;
    disabled: boolean;
    radio: string;
    main_group_id: string;
    sub_group_id: string;
    licType: string;
    sourceAddress?: string;
}
export declare class OracledbPropsOld extends AbstractOldDBProps {
    instance: string;
    hosts?: string[];
    services?: Array<Array<string>>;
    port: number;
    type: string;
    username: string;
    password: string;
    dataguard: Array<DataGuardOld>;
}
export declare const OracledbDataDescription: IHostcfgDataDescription;
