import { BasicResponseDTO } from "./basicResponse.dto";
import { MENU_STYLE_CLASS } from "./constants/menuResponse.constants";
export type MenuStyleClass = (typeof MENU_STYLE_CLASS)[keyof typeof MENU_STYLE_CLASS];
export declare class MenuLevel {
    title: string;
    children?: MenuLevel;
    next_level_url?: string;
}
export interface IMenuItem {
    url?: string;
    hwType?: string;
    subsystem?: string;
    itemId?: string;
    isLeaf?: boolean;
    isDefault?: boolean;
    styleClass?: MenuStyleClass;
    pageType?: string;
}
export declare abstract class MenuItem implements IMenuItem {
    static readonly API_URL_GEN = "/api/menu/v1/folder/";
    title: string;
    url?: string;
    hwType?: string;
    subsystem?: string;
    children?: Array<MenuItem>;
    itemId?: string;
    isLeaf?: boolean;
    isDefault?: boolean;
    status?: string;
    styleClass?: MenuStyleClass;
    pageType?: string;
    class?: string;
    isActive?: boolean;
    key?: string;
    disabled?: boolean;
    checkable?: boolean;
    _new?: Newable<any>;
    constructor(title: string, path?: string);
}
export declare class MenuClassFolder extends MenuItem {
    constructor(title: string, pClass: string, isActive?: boolean);
}
export type Newable<T> = {
    new (...args: any[]): T;
};
export declare class MenuFolder extends MenuItem {
    constructor(title: string, path: string, hwType?: string, subsystem?: string, itemId?: string, _new?: Newable<any>);
}
export declare class MenuLink extends MenuItem {
    static readonly API_URL_PAGE = "/api/menu/v1/page/";
    isLeaf: boolean;
    constructor(title: string, path: string, pageType?: string, itemId?: string, isDefault?: boolean);
}
export declare class MenuResponseDTO extends BasicResponseDTO {
    data: Array<MenuItem>;
}
