"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MenuResponseDTO = exports.MenuLink = exports.MenuFolder = exports.MenuClassFolder = exports.MenuItem = exports.MenuLevel = void 0;
const openapi = require("@nestjs/swagger");
const basicResponse_dto_1 = require("./basicResponse.dto");
class MenuLevel {
    static _OPENAPI_METADATA_FACTORY() {
        return { title: { required: true, type: () => String }, children: { required: false, type: () => require("./menuResponse.dto").MenuLevel }, next_level_url: { required: false, type: () => String } };
    }
}
exports.MenuLevel = MenuLevel;
class MenuItem {
    constructor(title, path) {
        this.title = title;
        if (path !== undefined) {
            this.url = MenuItem.API_URL_GEN + path;
        }
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { title: { required: true, type: () => String }, url: { required: false, type: () => String }, hwType: { required: false, type: () => String }, subsystem: { required: false, type: () => String }, children: { required: false, type: () => [require("./menuResponse.dto").MenuItem] }, itemId: { required: false, type: () => String }, isLeaf: { required: false, type: () => Boolean }, isDefault: { required: false, type: () => Boolean }, status: { required: false, type: () => String }, styleClass: { required: false, type: () => Object }, pageType: { required: false, type: () => String }, class: { required: false, type: () => String }, isActive: { required: false, type: () => Boolean }, key: { required: false, type: () => String }, disabled: { required: false, type: () => Boolean }, checkable: { required: false, type: () => Boolean }, _new: { required: false, type: () => Object } };
    }
}
exports.MenuItem = MenuItem;
MenuItem.API_URL_GEN = "/api/menu/v1/folder/";
class MenuClassFolder extends MenuItem {
    constructor(title, pClass, isActive) {
        super(title);
        this.class = pClass;
        if (isActive !== undefined) {
            this.isActive = isActive;
        }
    }
    static _OPENAPI_METADATA_FACTORY() {
        return {};
    }
}
exports.MenuClassFolder = MenuClassFolder;
class MenuFolder extends MenuItem {
    constructor(title, path, hwType, subsystem, itemId, _new) {
        if (hwType !== undefined) {
            path = 'hw_type/' + path;
        }
        super(title, path);
        if (hwType != undefined && hwType != null) {
            this.hwType = hwType;
        }
        if (subsystem != undefined && subsystem != null) {
            this.subsystem = subsystem;
        }
        if (itemId != undefined && itemId != null) {
            this.itemId = itemId;
        }
        if (_new !== undefined) {
            this._new = _new;
        }
    }
    static _OPENAPI_METADATA_FACTORY() {
        return {};
    }
}
exports.MenuFolder = MenuFolder;
class MenuLink extends MenuItem {
    constructor(title, path, pageType, itemId, isDefault) {
        super(title, path);
        this.isLeaf = true;
        this.url = MenuLink.API_URL_PAGE + path;
        if (pageType != undefined) {
            this.pageType = pageType;
        }
        if (itemId != undefined && itemId != null) {
            this.itemId = itemId;
        }
        if (isDefault != undefined) {
            this.isDefault = isDefault;
        }
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { isLeaf: { required: true, type: () => Object, default: true } };
    }
}
exports.MenuLink = MenuLink;
MenuLink.API_URL_PAGE = "/api/menu/v1/page/";
class MenuResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./menuResponse.dto").MenuItem] } };
    }
}
exports.MenuResponseDTO = MenuResponseDTO;
//# sourceMappingURL=menuResponse.dto.js.map