import type { ReportItemFormat, ReportItemType, TopInterval, TopOrderByField } from '@const/reportItem.constants';
import { ItemGroup, ItemGroupWithLabels } from './customGroup.dto';
import { ReportItemDataElement, ReportItemDataSingleElement } from './elements/reportItem.elements';
export type { ReportItemFormat, ReportItemType, TopInterval, TopOrderByField };
export declare class ReportItemBase {
    format?: ReportItemFormat;
    type?: ReportItemType | null;
    class?: string | null;
    hw_type?: string | null;
    subsystem?: string | null;
    item_group_id?: string | null;
    item_index?: number;
    custom_group_id?: string | null;
}
export declare class PlainReportItem extends ReportItemBase {
    data?: ReportItemDataElement;
}
export declare class SavePlainReportItem extends ReportItemBase {
    data: ReportItemDataElement;
}
export declare class ReportItemOut extends PlainReportItem {
    report_id?: string;
}
export declare class SingleReportItem extends ReportItemBase {
    data: ReportItemDataSingleElement;
}
export type NewReportItem = ReportItemOut & ItemGroup;
export type UpdateReportItem = ReportItemOut & ItemGroup & {
    report_item_id?: string;
};
export type FullReportItem = ReportItemOut & ItemGroupWithLabels & ItemGroup & {
    report_item_id?: string;
};
