import { BasicResponseDTO } from './basicResponse.dto';
import { AdminFeatures, Group } from './groupsResponse.dto';
export declare class UserApiKey {
    label: string;
    api_key: string;
    expiration: string;
}
export declare class CreateUserApiKey {
    label: string;
    expiration: number;
}
export declare class UserBase {
    username: string;
    email?: string;
    password: string;
    timezone: string;
    active?: boolean;
    configuration?: {
        top?: number;
        searchHistoryLimit?: number;
    };
}
export declare class UserDTO extends UserBase {
    user_id: number;
    isAdmin?: boolean;
    isManager?: boolean;
    allowedFeatures?: AdminFeatures;
    groups?: Group[];
    created?: string;
    updated?: string;
    logged?: string;
    ldap_id?: string;
}
export declare class UpdateLoggedUserDTO {
    oldPassword?: string;
    password?: string;
    timezone?: string;
    email?: string;
    configuration?: {
        top?: number;
        searchHistoryLimit?: number;
    };
}
export declare class RegisterUserDTO extends UserBase {
    groups_id: number[];
}
export interface UpdateUserDTO extends Partial<RegisterUserDTO> {
}
export declare class UsersResponseDTO extends BasicResponseDTO {
    data: UserDTO[];
}
export declare class UserResponseDTO extends BasicResponseDTO {
    data: UserDTO;
}
export declare class UserApiKeysResponseDTO extends BasicResponseDTO {
    data: UserApiKey[];
}
export declare class UserApiKeyResponseDTO extends BasicResponseDTO {
    data: UserApiKey;
}
export interface UserEditResponseDTO<T> extends BasicResponseDTO {
    data: T;
    message: string;
    statusCode: number;
}
