"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserApiKeyResponseDTO = exports.UserApiKeysResponseDTO = exports.UserResponseDTO = exports.UsersResponseDTO = exports.RegisterUserDTO = exports.UpdateLoggedUserDTO = exports.UserDTO = exports.UserBase = exports.CreateUserApiKey = exports.UserApiKey = void 0;
const openapi = require("@nestjs/swagger");
const basicResponse_dto_1 = require("./basicResponse.dto");
class UserApiKey {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, api_key: { required: true, type: () => String }, expiration: { required: true, type: () => String } };
    }
}
exports.UserApiKey = UserApiKey;
class CreateUserApiKey {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, expiration: { required: true, type: () => Number } };
    }
}
exports.CreateUserApiKey = CreateUserApiKey;
class UserBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { username: { required: true, type: () => String }, email: { required: false, type: () => String }, password: { required: true, type: () => String }, timezone: { required: true, type: () => String }, active: { required: false, type: () => Boolean }, configuration: { required: false, type: () => ({ top: { required: false, type: () => Number }, searchHistoryLimit: { required: false, type: () => Number } }) } };
    }
}
exports.UserBase = UserBase;
class UserDTO extends UserBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { user_id: { required: true, type: () => Number }, isAdmin: { required: false, type: () => Boolean }, isManager: { required: false, type: () => Boolean }, allowedFeatures: { required: false, type: () => require("./groupsResponse.dto").AdminFeatures }, groups: { required: false, type: () => [require("./groupsResponse.dto").Group] }, created: { required: false, type: () => String }, updated: { required: false, type: () => String }, logged: { required: false, type: () => String }, ldap_id: { required: false, type: () => String } };
    }
}
exports.UserDTO = UserDTO;
class UpdateLoggedUserDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { oldPassword: { required: false, type: () => String }, password: { required: false, type: () => String }, timezone: { required: false, type: () => String }, email: { required: false, type: () => String }, configuration: { required: false, type: () => ({ top: { required: false, type: () => Number }, searchHistoryLimit: { required: false, type: () => Number } }) } };
    }
}
exports.UpdateLoggedUserDTO = UpdateLoggedUserDTO;
class RegisterUserDTO extends UserBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { groups_id: { required: true, type: () => [Number] } };
    }
}
exports.RegisterUserDTO = RegisterUserDTO;
class UsersResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./usersResponse.dto").UserDTO] } };
    }
}
exports.UsersResponseDTO = UsersResponseDTO;
class UserResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => require("./usersResponse.dto").UserDTO } };
    }
}
exports.UserResponseDTO = UserResponseDTO;
class UserApiKeysResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./usersResponse.dto").UserApiKey] } };
    }
}
exports.UserApiKeysResponseDTO = UserApiKeysResponseDTO;
class UserApiKeyResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => require("./usersResponse.dto").UserApiKey } };
    }
}
exports.UserApiKeyResponseDTO = UserApiKeyResponseDTO;
//# sourceMappingURL=usersResponse.dto.js.map