"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Dashboard = void 0;
const openapi = require("@nestjs/swagger");
const dashboard_constants_1 = require("../common/constants/dashboard.constants");
const typeorm_1 = require("typeorm");
const dashboardFolder_entity_1 = require("./dashboardFolder.entity");
const dashboardGroup_entity_1 = require("./dashboardGroup.entity");
const user_entity_1 = require("./user.entity");
const group_entity_1 = require("./group.entity");
const enumsVersion = 'v' + 1;
let Dashboard = class Dashboard {
    static _OPENAPI_METADATA_FACTORY() {
        return { dashboard_id: { required: true, type: () => String }, label: { required: true, type: () => String }, width: { required: true, type: () => Number }, parent: { required: true, type: () => require("./dashboardFolder.entity").DashboardFolder }, type: { required: true, type: () => Object }, default: { required: true, type: () => Boolean }, dashboard_groups: { required: true, type: () => [require("./dashboardGroup.entity").DashboardGroup] }, user_id: { required: true, type: () => Number }, created_by: { required: false, type: () => require("./user.entity").User }, group_id: { required: true, type: () => Number }, _group: { required: false, type: () => require("./group.entity").Group } };
    }
};
exports.Dashboard = Dashboard;
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], Dashboard.prototype, "dashboard_id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], Dashboard.prototype, "label", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", Number)
], Dashboard.prototype, "width", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => dashboardFolder_entity_1.DashboardFolder, (folder) => folder.dashboards, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'parent' }),
    __metadata("design:type", dashboardFolder_entity_1.DashboardFolder)
], Dashboard.prototype, "parent", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: dashboard_constants_1.DASHBOARD_TYPE,
        default: dashboard_constants_1.DASHBOARD_TYPE.personal,
        enumName: `dashboard_type_${enumsVersion}`,
    }),
    __metadata("design:type", String)
], Dashboard.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'boolean',
        default: false
    }),
    __metadata("design:type", Boolean)
], Dashboard.prototype, "default", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => dashboardGroup_entity_1.DashboardGroup, (dashboard_folder) => dashboard_folder.dashboard),
    __metadata("design:type", Array)
], Dashboard.prototype, "dashboard_groups", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], Dashboard.prototype, "user_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => user_entity_1.User, (user) => user.created_dashboards, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'user_id' }),
    __metadata("design:type", user_entity_1.User)
], Dashboard.prototype, "created_by", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], Dashboard.prototype, "group_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => group_entity_1.Group, (group) => group._dashboards, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'group_id' }),
    __metadata("design:type", group_entity_1.Group)
], Dashboard.prototype, "_group", void 0);
exports.Dashboard = Dashboard = __decorate([
    (0, typeorm_1.Entity)({ name: 'dashboards', synchronize: false })
], Dashboard);
//# sourceMappingURL=dashboard.entity.js.map