"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Ldap = void 0;
const openapi = require("@nestjs/swagger");
const ldap_constants_1 = require("../common/constants/ldap.constants");
const typeorm_1 = require("typeorm");
const ldapGroup_entity_1 = require("./ldapGroup.entity");
const user_entity_1 = require("./user.entity");
const enumsVersion = 'v' + 1;
let Ldap = class Ldap {
    static _OPENAPI_METADATA_FACTORY() {
        return { ldap_id: { required: true, type: () => String }, label: { required: true, type: () => String }, full_dn_auth: { required: true, type: () => Boolean }, url: { required: true, type: () => [String] }, protocol: { required: true, type: () => Object }, base_dn: { required: true, type: () => String }, group_base: { required: true, type: () => String }, group_object_class: { required: true, type: () => String }, group_filter_attribute: { required: true, type: () => String }, group_filter_type: { required: true, type: () => Object }, user_base: { required: true, type: () => String }, user_object_class: { required: true, type: () => String }, user_filter_attribute: { required: true, type: () => String }, user_prefix: { required: false, type: () => String }, user_postfix: { required: false, type: () => String }, required_user_group: { required: true, type: () => String }, disabled: { required: true, type: () => Boolean }, createdAt: { required: false, type: () => Date }, updatedAt: { required: false, type: () => Date }, _groups: { required: false, type: () => [require("./ldapGroup.entity").LdapGroup] }, _users: { required: false, type: () => [require("./user.entity").User] } };
    }
};
exports.Ldap = Ldap;
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], Ldap.prototype, "ldap_id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], Ldap.prototype, "label", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Boolean)
], Ldap.prototype, "full_dn_auth", void 0);
__decorate([
    (0, typeorm_1.Column)("text", { array: true }),
    __metadata("design:type", Array)
], Ldap.prototype, "url", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: false,
        name: 'ldap_protocol',
        enumName: `ldap_protocol_${enumsVersion}`,
        type: 'enum',
        enum: ldap_constants_1.LDAP_PROTOCOL,
        default: ldap_constants_1.LDAP_PROTOCOL.ldap,
    }),
    __metadata("design:type", String)
], Ldap.prototype, "protocol", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], Ldap.prototype, "base_dn", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], Ldap.prototype, "group_base", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], Ldap.prototype, "group_object_class", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], Ldap.prototype, "group_filter_attribute", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: false,
        name: 'group_filter_type',
        enumName: 'ldapfiltertype',
        type: 'enum',
        enum: ldap_constants_1.LDAP_GROUP_FILTER_TYPE,
        default: ldap_constants_1.LDAP_GROUP_FILTER_TYPE.group
    }),
    __metadata("design:type", String)
], Ldap.prototype, "group_filter_type", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], Ldap.prototype, "user_base", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], Ldap.prototype, "user_object_class", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], Ldap.prototype, "user_filter_attribute", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], Ldap.prototype, "user_prefix", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], Ldap.prototype, "user_postfix", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], Ldap.prototype, "required_user_group", void 0);
__decorate([
    (0, typeorm_1.Column)({
        default: false
    }),
    __metadata("design:type", Boolean)
], Ldap.prototype, "disabled", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ name: 'created_at', type: 'timestamp with time zone' }),
    __metadata("design:type", Date)
], Ldap.prototype, "createdAt", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)({ name: 'updated_at', type: 'timestamp with time zone' }),
    __metadata("design:type", Date)
], Ldap.prototype, "updatedAt", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => ldapGroup_entity_1.LdapGroup, (ldapGroup) => ldapGroup._ldap, { cascade: true }),
    __metadata("design:type", Array)
], Ldap.prototype, "_groups", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => user_entity_1.User, (user) => user._ldap),
    __metadata("design:type", Array)
], Ldap.prototype, "_users", void 0);
exports.Ldap = Ldap = __decorate([
    (0, typeorm_1.Entity)({ name: 'ldaps', synchronize: false })
], Ldap);
//# sourceMappingURL=ldap.entity.js.map