"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AzureAccount = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.AzureAccount = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_azure_account',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        used_capacity: {
            type: 'float4',
            nullable: true,
        },
        account_transactions: {
            type: 'float4',
            nullable: true,
        },
        account_ingress: {
            type: 'float4',
            nullable: true,
        },
        account_egress: {
            type: 'float4',
            nullable: true,
        },
        account_suc_server_lat: {
            type: 'float4',
            nullable: true,
        },
        account_suc_e2e_lat: {
            type: 'float4',
            nullable: true,
        },
        account_availibility: {
            type: 'float4',
            nullable: true,
        },
        blob_capacity: {
            type: 'float4',
            nullable: true,
        },
        blob_count: {
            type: 'float4',
            nullable: true,
        },
        container_count: {
            type: 'float4',
            nullable: true,
        },
        blob_transactions: {
            type: 'float4',
            nullable: true,
        },
        blob_ingress: {
            type: 'float4',
            nullable: true,
        },
        blob_egress: {
            type: 'float4',
            nullable: true,
        },
        blob_suc_server_lat: {
            type: 'float4',
            nullable: true,
        },
        blob_suc_e2e_lat: {
            type: 'float4',
            nullable: true,
        },
        blob_availibility: {
            type: 'float4',
            nullable: true,
        },
        file_capacity: {
            type: 'float4',
            nullable: true,
        },
        file_count: {
            type: 'float4',
            nullable: true,
        },
        file_share_capacity_quota: {
            type: 'float4',
            nullable: true,
        },
        file_share_count: {
            type: 'float4',
            nullable: true,
        },
        file_share_snapshot_count: {
            type: 'float4',
            nullable: true,
        },
        file_share_snapshot_size: {
            type: 'float4',
            nullable: true,
        },
        file_transactions: {
            type: 'float4',
            nullable: true,
        },
        file_ingress: {
            type: 'float4',
            nullable: true,
        },
        file_egress: {
            type: 'float4',
            nullable: true,
        },
        file_suc_server_lat: {
            type: 'float4',
            nullable: true,
        },
        file_suc_e2e_lat: {
            type: 'float4',
            nullable: true,
        },
        file_availibility: {
            type: 'float4',
            nullable: true,
        },
        queue_capacity: {
            type: 'float4',
            nullable: true,
        },
        queue_count: {
            type: 'float4',
            nullable: true,
        },
        queue_message_count: {
            type: 'float4',
            nullable: true,
        },
        queue_transactions: {
            type: 'float4',
            nullable: true,
        },
        queue_egress: {
            type: 'float4',
            nullable: true,
        },
        queue_ingress: {
            type: 'float4',
            nullable: true,
        },
        queue_suc_server_lat: {
            type: 'float4',
            nullable: true,
        },
        queue_suc_e2e_lat: {
            type: 'float4',
            nullable: true,
        },
        queue_availibility: {
            type: 'float4',
            nullable: true,
        },
        table_capacity: {
            type: 'float4',
            nullable: true,
        },
        table_count: {
            type: 'float4',
            nullable: true,
        },
        table_entity_count: {
            type: 'float4',
            nullable: true,
        },
        table_transactions: {
            type: 'float4',
            nullable: true,
        },
        table_ingress: {
            type: 'float4',
            nullable: true,
        },
        table_egress: {
            type: 'float4',
            nullable: true,
        },
        table_suc_server_lat: {
            type: 'float4',
            nullable: true,
        },
        table_suc_e2e_lat: {
            type: 'float4',
            nullable: true,
        },
        table_availibility: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=azureAccount.entity.js.map