"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.prepareCoreObject = void 0;
;
function getTechnologySchema(section) {
    return "metrics";
}
function getMetricName(storage, section) {
    let metricName = 'metrics_' + storage + '_' + section;
    return metricName;
}
function getMetricType(metric) {
    return 'float4';
}
function getMetricNullable(metric) {
    return true;
}
function prepareColumnObject(metricNames) {
    let collumnBase = {};
    collumnBase = {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
    };
    function fillColumnObject(metricNames, collumnObject) {
        for (let name of metricNames) {
            collumnObject[name] = {
                type: getMetricType(name),
                nullable: getMetricNullable(name)
            };
        }
        return collumnObject;
    }
    let collumnObject = fillColumnObject(metricNames, collumnBase);
    return collumnObject;
}
function prepareCoreObject(storage, section, metricNames) {
    let coreObject = {
        schema: getTechnologySchema(section),
        name: getMetricName(storage, section),
        columns: prepareColumnObject(metricNames)
    };
    return coreObject;
}
exports.prepareCoreObject = prepareCoreObject;
//# sourceMappingURL=Compose.js.map