"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IbmcossSlicestor = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.IbmcossSlicestor = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_ibmcoss_slicestor',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        cpu_busy: {
            type: 'float4',
            nullable: true,
        },
        cpu_user: {
            type: 'float4',
            nullable: true,
        },
        cpu_system: {
            type: 'float4',
            nullable: true,
        },
        cpu_wait: {
            type: 'float4',
            nullable: true,
        },
        system_memory_total: {
            type: 'float4',
            nullable: true,
        },
        system_memory_used: {
            type: 'float4',
            nullable: true,
        },
        onheap_memory_total: {
            type: 'float4',
            nullable: true,
        },
        onheap_memory_used: {
            type: 'float4',
            nullable: true,
        },
        offheap_memory_total: {
            type: 'float4',
            nullable: true,
        },
        offheap_memory_used: {
            type: 'float4',
            nullable: true,
        },
        acknowledge_time: {
            type: 'float4',
            nullable: true,
        },
        network_rx: {
            type: 'float4',
            nullable: true,
        },
        network_tx: {
            type: 'float4',
            nullable: true,
        },
        network_rate: {
            type: 'float4',
            nullable: true,
        },
        tcp_timeouts: {
            type: 'float4',
            nullable: true,
        },
        os_r: {
            type: 'float4',
            nullable: true,
        },
        os_w: {
            type: 'float4',
            nullable: true,
        },
        os_total: {
            type: 'float4',
            nullable: true,
        },
        scanned_srcs: {
            type: 'float4',
            nullable: true,
        },
        rebuild_writes_in: {
            type: 'float4',
            nullable: true,
        },
        rebuild_writes_out: {
            type: 'float4',
            nullable: true,
        },
        rebuild_writes_total: {
            type: 'float4',
            nullable: true,
        },
        rebuild_deletes_in: {
            type: 'float4',
            nullable: true,
        },
        rebuild_deletes_out: {
            type: 'float4',
            nullable: true,
        },
        rebuild_deletes_total: {
            type: 'float4',
            nullable: true,
        },
        rebuild_bytes_in: {
            type: 'float4',
            nullable: true,
        },
        rebuild_bytes_out: {
            type: 'float4',
            nullable: true,
        },
        rebuild_bytes_total: {
            type: 'float4',
            nullable: true,
        },
        capacity_total: {
            type: 'float4',
            nullable: true,
        },
        capacity_used: {
            type: 'float4',
            nullable: true,
        },
        capacity_used_percent: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=ibmcossSlicestor.entity.js.map