"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinuxSan = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.LinuxSan = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_linux_san',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        recv_bytes: {
            type: 'float4',
            nullable: true,
        },
        trans_bytes: {
            type: 'float4',
            nullable: true,
        },
        iops_write: {
            type: 'float4',
            nullable: true,
        },
        iops_read: {
            type: 'float4',
            nullable: true,
        },
        san_error: {
            type: 'float4',
            nullable: true,
        },
        resp_t_r: {
            type: 'float4',
            nullable: true,
        },
        resp_t_w: {
            type: 'float4',
            nullable: true,
        },
        rx_power: {
            type: 'float4',
            nullable: true,
        },
        tx_power: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        },
    },
});
//# sourceMappingURL=linuxSan.entity.js.map