"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpenshiftContainer = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.OpenshiftContainer = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_openshift_container',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        cpu: {
            type: 'float4',
            nullable: true,
        },
        cpu_request: {
            type: 'float4',
            nullable: true,
        },
        cpu_limit: {
            type: 'float4',
            nullable: true,
        },
        memory: {
            type: 'float4',
            nullable: true,
        },
        memory_request: {
            type: 'float4',
            nullable: true,
        },
        memory_limit: {
            type: 'float4',
            nullable: true,
        },
        container_fs_writes: {
            type: 'float4',
            nullable: true,
        },
        container_fs_reads: {
            type: 'float4',
            nullable: true,
        },
        container_fs_writes_bytes: {
            type: 'float4',
            nullable: true,
        },
        container_fs_reads_bytes: {
            type: 'float4',
            nullable: true,
        },
        container_fs_write_latency: {
            type: 'float4',
            nullable: true,
        },
        container_fs_read_latency: {
            type: 'float4',
            nullable: true,
        },
        container_fs_usage_bytes: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=openshiftContainer.entity.js.map