"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OvirtHost = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.OvirtHost = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_ovirt_host',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        cpu_utilization_percent: {
            type: 'float4',
            nullable: true,
        },
        cpu_utilization_cores: {
            type: 'float4',
            nullable: true,
        },
        user_cpu_utilization_percent: {
            type: 'float4',
            nullable: true,
        },
        system_cpu_utilization_percent: {
            type: 'float4',
            nullable: true,
        },
        ksm_cpu_utilization_percent: {
            type: 'float4',
            nullable: true,
        },
        cpu_load: {
            type: 'float4',
            nullable: true,
        },
        totals_vms_vcpus: {
            type: 'float4',
            nullable: true,
        },
        cpu_cores: {
            type: 'float4',
            nullable: true,
        },
        mem_percent: {
            type: 'float4',
            nullable: true,
        },
        used_mem: {
            type: 'float4',
            nullable: true,
        },
        free_mem: {
            type: 'float4',
            nullable: true,
        },
        ksm_mem: {
            type: 'float4',
            nullable: true,
        },
        used_swap: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=ovirtHost.entity.js.map