"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PowerServer = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.PowerServer = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_power_server',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        totalMem: {
            type: 'float4',
            nullable: true,
        },
        availableMem: {
            type: 'float4',
            nullable: true,
        },
        configurableMem: {
            type: 'float4',
            nullable: true,
        },
        assignedMemToLpars: {
            type: 'float4',
            nullable: true,
        },
        totalProcUnits: {
            type: 'float4',
            nullable: true,
        },
        totalProcUnitsMax: {
            type: 'float4',
            nullable: true,
        },
        cpu_physical_percent: {
            type: 'float4',
            nullable: true,
        },
        assignedProcUnits: {
            type: 'float4',
            nullable: true,
        },
        assignedProcUnitsPercent: {
            type: 'float4',
            nullable: true,
        },
        cpu_physical_cores: {
            type: 'float4',
            nullable: true,
        },
        availableProcUnits: {
            type: 'float4',
            nullable: true,
        },
        configurableProcUnits: {
            type: 'float4',
            nullable: true,
        },
        systemFirmwareUtilUtilizedProcUnits: {
            type: 'float4',
            nullable: true,
        },
        systemFirmwareUtilAssignedMem: {
            type: 'float4',
            nullable: true,
        },
        assignedProcUnitsPhysicalProcessor: {
            type: 'float4',
            nullable: true,
        },
        utilizedProcUnitsPhysicalProcessor: {
            type: 'float4',
            nullable: true,
        },
        availableProcUnitsPhysicalProcessor: {
            type: 'float4',
            nullable: true,
        },
        configuredProcUnitsPhysicalProcessor: {
            type: 'float4',
            nullable: true,
        },
        borrowedProcUnitsPhysicalProcessor: {
            type: 'float4',
            nullable: true,
        },
        cpu_utilization_cores: {
            type: 'float4',
            nullable: true,
        },
        cpu_utilization_percent: {
            type: 'float4',
            nullable: true,
        },
        powerReading: {
            type: 'float4',
            nullable: true,
        },
        assignedMinusBorrowed: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        },
        tmp8: {
            type: 'float4',
            nullable: true,
        },
        tmp9: {
            type: 'float4',
            nullable: true,
        },
        tmp10: {
            type: 'float4',
            nullable: true,
        },
        tmp11: {
            type: 'float4',
            nullable: true,
        },
        tmp12: {
            type: 'float4',
            nullable: true,
        },
        tmp13: {
            type: 'float4',
            nullable: true,
        },
        tmp14: {
            type: 'float4',
            nullable: true,
        },
        tmp15: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=powerServer.entity.js.map