"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PureDevice = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.PureDevice = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_pure_device',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        io_rate: {
            type: 'float4',
            nullable: true,
        },
        data_rate: {
            type: 'float4',
            nullable: true,
        },
        resp_t: {
            type: 'float4',
            nullable: true,
        },
        read_io: {
            type: 'float4',
            nullable: true,
        },
        write_io: {
            type: 'float4',
            nullable: true,
        },
        local_write_io: {
            type: 'float4',
            nullable: true,
        },
        mirrored_write_io: {
            type: 'float4',
            nullable: true,
        },
        read: {
            type: 'float4',
            nullable: true,
        },
        write: {
            type: 'float4',
            nullable: true,
        },
        local_write: {
            type: 'float4',
            nullable: true,
        },
        mirrored_write: {
            type: 'float4',
            nullable: true,
        },
        resp_t_r: {
            type: 'float4',
            nullable: true,
        },
        resp_t_w: {
            type: 'float4',
            nullable: true,
        },
        local_resp_t_w: {
            type: 'float4',
            nullable: true,
        },
        mirrored_resp_t_w: {
            type: 'float4',
            nullable: true,
        },
        capacity_total: {
            type: 'float4',
            nullable: true,
        },
        capacity_used: {
            type: 'float4',
            nullable: true,
        },
        capacity_free: {
            type: 'float4',
            nullable: true,
        },
        shared_space_capacity_used: {
            type: 'float4',
            nullable: true,
        },
        volumes_capacity_used: {
            type: 'float4',
            nullable: true,
        },
        system_capacity_used: {
            type: 'float4',
            nullable: true,
        },
        virtual_capacity_total: {
            type: 'float4',
            nullable: true,
        },
        snapshot_capacity_used: {
            type: 'float4',
            nullable: true,
        },
        replication_capacity_used: {
            type: 'float4',
            nullable: true,
        },
        block_size: {
            type: 'float4',
            nullable: true,
        },
        block_size_r: {
            type: 'float4',
            nullable: true,
        },
        block_size_w: {
            type: 'float4',
            nullable: true,
        },
        capacity_used_percent: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        },
        tmp8: {
            type: 'float4',
            nullable: true,
        },
        tmp9: {
            type: 'float4',
            nullable: true,
        },
        tmp10: {
            type: 'float4',
            nullable: true,
        },
        tmp11: {
            type: 'float4',
            nullable: true,
        },
        tmp12: {
            type: 'float4',
            nullable: true,
        },
        tmp13: {
            type: 'float4',
            nullable: true,
        },
        tmp14: {
            type: 'float4',
            nullable: true,
        },
        tmp15: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=pureDevice.entity.js.map