"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SqlserverDb = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.SqlserverDb = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_sqlserver_db',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        LockTimeoutssec: {
            type: 'float4',
            nullable: true,
        },
        Activecursors: {
            nullable: true,
            type: 'float4',
        },
        LocksWaitssec: {
            nullable: true,
            type: 'float4',
        },
        data_total: {
            type: 'float4',
            nullable: true,
        },
        data_rd: {
            type: 'float4',
            nullable: true,
        },
        ActiveTransactions: {
            nullable: true,
            type: 'float4',
        },
        latency_total: {
            nullable: true,
            type: 'float4',
        },
        data_wr: {
            type: 'float4',
            nullable: true,
        },
        Transactions: {
            nullable: true,
            type: 'float4',
        },
        latency_rd: {
            type: 'float4',
            nullable: true,
        },
        used: {
            type: 'float4',
            nullable: true,
        },
        Buffercachehitratio: {
            type: 'float4',
            nullable: true,
        },
        CacheHitRatio: {
            type: 'float4',
            nullable: true,
        },
        WriteTransactionssec: {
            nullable: true,
            type: 'float4',
        },
        Logoutssec: {
            nullable: true,
            type: 'float4',
        },
        Trackedtransactionssec: {
            type: 'float4',
            nullable: true,
        },
        LogCacheHitRatio: {
            type: 'float4',
            nullable: true,
        },
        log_space: {
            type: 'float4',
            nullable: true,
        },
        available: {
            nullable: true,
            type: 'float4',
        },
        Transactionssec: {
            nullable: true,
            type: 'float4',
        },
        Lazywritessec: {
            nullable: true,
            type: 'float4',
        },
        unused: {
            type: 'float4',
            nullable: true,
        },
        latency_wr: {
            type: 'float4',
            nullable: true,
        },
        io_rd: {
            nullable: true,
            type: 'float4',
        },
        io_wr: {
            type: 'float4',
            nullable: true,
        },
        CursorRequestssec: {
            type: 'float4',
            nullable: true,
        },
        CachedCursorsCounts: {
            type: 'float4',
            nullable: true,
        },
        NumberofDeadlockssec: {
            nullable: true,
            type: 'float4',
        },
        LocksRequestssec: {
            nullable: true,
            type: 'float4',
        },
        io_total: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=sqlserverDb.entity.js.map