"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TimescaledbDb = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.TimescaledbDb = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_timescaledb_db',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        buffersclean: {
            nullable: true,
            type: 'float4',
        },
        checkpointsreq: {
            nullable: true,
            type: 'float4',
        },
        bufferscheckpoint: {
            nullable: true,
            type: 'float4',
        },
        buffersbackend: {
            nullable: true,
            type: 'float4',
        },
        checkpointstimed: {
            nullable: true,
            type: 'float4',
        },
        numbackends: {
            nullable: true,
            type: 'float4',
        },
        size: {
            nullable: true,
            type: 'float4',
        },
        active: {
            nullable: true,
            type: 'float4',
        },
        idle: {
            nullable: true,
            type: 'float4',
        },
        idleintransaction: {
            nullable: true,
            type: 'float4',
        },
        hpage: {
            nullable: true,
            type: 'float4',
        },
        transactionid: {
            nullable: true,
            type: 'float4',
        },
        tuple: {
            nullable: true,
            type: 'float4',
        },
        bufferio: {
            nullable: true,
            type: 'float4',
        },
        replicationslotio: {
            nullable: true,
            type: 'float4',
        },
        tempfiles: {
            nullable: true,
            type: 'float4',
        },
        aextend: {
            nullable: true,
            type: 'float4',
        },
        object: {
            nullable: true,
            type: 'float4',
        },
        multixactmember: {
            nullable: true,
            type: 'float4',
        },
        hrelation: {
            nullable: true,
            type: 'float4',
        },
        speculativetoken: {
            nullable: true,
            type: 'float4',
        },
        walinsert: {
            nullable: true,
            type: 'float4',
        },
        async: {
            nullable: true,
            type: 'float4',
        },
        subtrans: {
            nullable: true,
            type: 'float4',
        },
        commitratio: {
            nullable: true,
            type: 'float4',
        },
        atuple: {
            nullable: true,
            type: 'float4',
        },
        htuple: {
            nullable: true,
            type: 'float4',
        },
        buffermapping: {
            nullable: true,
            type: 'float4',
        },
        virtualxid: {
            nullable: true,
            type: 'float4',
        },
        cursors: {
            nullable: true,
            type: 'float4',
        },
        deadlocks: {
            nullable: true,
            type: 'float4',
        },
        currenttransactions: {
            nullable: true,
            type: 'float4',
        },
        hobject: {
            nullable: true,
            type: 'float4',
        },
        advisory: {
            nullable: true,
            type: 'float4',
        },
        RelationMappingLock: {
            nullable: true,
            type: 'float4',
        },
        fastpathfunctioncall: {
            nullable: true,
            type: 'float4',
        },
        blkshit: {
            nullable: true,
            type: 'float4',
        },
        multixactoffset: {
            nullable: true,
            type: 'float4',
        },
        userlock: {
            nullable: true,
            type: 'float4',
        },
        auserlock: {
            nullable: true,
            type: 'float4',
        },
        cachehitratio: {
            nullable: true,
            type: 'float4',
        },
        disabled: {
            nullable: true,
            type: 'float4',
        },
        frozenid: {
            nullable: true,
            type: 'float4',
        },
        buffercontent: {
            nullable: true,
            type: 'float4',
        },
        relation: {
            nullable: true,
            type: 'float4',
        },
        aobject: {
            nullable: true,
            type: 'float4',
        },
        xactrollback: {
            nullable: true,
            type: 'float4',
        },
        committimestamp: {
            nullable: true,
            type: 'float4',
        },
        hextend: {
            nullable: true,
            type: 'float4',
        },
        xactcommit: {
            nullable: true,
            type: 'float4',
        },
        proc: {
            nullable: true,
            type: 'float4',
        },
        idleintransactionaborted: {
            nullable: true,
            type: 'float4',
        },
        huserlock: {
            nullable: true,
            type: 'float4',
        },
        replicationorigin: {
            nullable: true,
            type: 'float4',
        },
        tempbytes: {
            nullable: true,
            type: 'float4',
        },
        arelation: {
            nullable: true,
            type: 'float4',
        },
        clog: {
            nullable: true,
            type: 'float4',
        },
        apage: {
            nullable: true,
            type: 'float4',
        },
        extend: {
            nullable: true,
            type: 'float4',
        },
        predicatelockmanager: {
            nullable: true,
            type: 'float4',
        },
        lockmanager: {
            nullable: true,
            type: 'float4',
        },
        oldserxid: {
            nullable: true,
            type: 'float4',
        },
        Activity: {
            nullable: true,
            type: 'float4',
        },
        BufferPin: {
            nullable: true,
            type: 'float4',
        },
        Client: {
            nullable: true,
            type: 'float4',
        },
        Extension: {
            nullable: true,
            type: 'float4',
        },
        IO: {
            nullable: true,
            type: 'float4',
        },
        IPC: {
            nullable: true,
            type: 'float4',
        },
        Lock: {
            nullable: true,
            type: 'float4',
        },
        LWLock: {
            nullable: true,
            type: 'float4',
        },
        Timeout: {
            nullable: true,
            type: 'float4',
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
    },
});
//# sourceMappingURL=timescaledbDb.entity.js.map