"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WindowsServer = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.WindowsServer = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_windows_server',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        cpu_usage: {
            type: 'float4',
            nullable: true,
        },
        cpu_usage_perc: {
            type: 'float4',
            nullable: true,
        },
        host_hz: {
            type: 'float4',
            nullable: true,
        },
        memory_total: {
            type: 'float4',
            nullable: true,
        },
        avail_m_bytes: {
            type: 'float4',
            nullable: true,
        },
        memory_available: {
            type: 'float4',
            nullable: true,
        },
        memory_percent: {
            type: 'float4',
            nullable: true,
        },
        cache_bytes: {
            type: 'float4',
            nullable: true,
        },
        used_bytes: {
            type: 'float4',
            nullable: true,
        },
        disk_bytes_persec: {
            type: 'float4',
            nullable: true,
        },
        disk_read_bytes_persec: {
            type: 'float4',
            nullable: true,
        },
        disk_reads_persec: {
            type: 'float4',
            nullable: true,
        },
        disk_tranfers_persec: {
            type: 'float4',
            nullable: true,
        },
        disk_write_bytes_persec: {
            type: 'float4',
            nullable: true,
        },
        disk_writes_persec: {
            type: 'float4',
            nullable: true,
        },
        bytes_received_persec: {
            type: 'float4',
            nullable: true,
        },
        bytes_sent_persec: {
            type: 'float4',
            nullable: true,
        },
        bytes_total_persec: {
            type: 'float4',
            nullable: true,
        },
        pages_input_persec: {
            type: 'float4',
            nullable: true,
        },
        pages_output_persec: {
            type: 'float4',
            nullable: true,
        },
        vCPU: {
            type: 'float4',
            nullable: true,
        },
        ProcessorQueueLength: {
            type: 'float4',
            nullable: true,
        },
        processes: {
            type: 'float4',
            nullable: true,
        },
        threads: {
            type: 'float4',
            nullable: true,
        },
        SystemCallsPersec: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=windowsServer.entity.js.map