"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReportItem = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
const report_entity_1 = require("./report.entity");
const reportItem_constants_1 = require("../common/constants/reportItem.constants");
const class_entity_1 = require("./class.entity");
const hwType_entity_1 = require("./hwType.entity");
const itemGroup_entity_1 = require("./itemGroup.entity");
const customGroup_entity_1 = require("./customGroup.entity");
let ReportItem = class ReportItem {
    static _OPENAPI_METADATA_FACTORY() {
        return { report_item_id: { required: true, type: () => String }, report: { required: false, type: () => require("./report.entity").Report }, report_id: { required: true, type: () => String }, format: { required: true, type: () => Object }, type: { required: true, type: () => Object }, data: { required: true, type: () => Object }, item_index: { required: true, type: () => Number }, _class: { required: false, type: () => require("./class.entity").Class }, class: { required: true, type: () => String }, _hw_type: { required: false, type: () => require("./hwType.entity").HwType }, hw_type: { required: true, type: () => String }, subsystem: { required: true, type: () => String }, _item_group: { required: false, type: () => require("./itemGroup.entity").ItemGroup }, item_group_id: { required: true, type: () => String }, _custom_group: { required: false, type: () => require("./customGroup.entity").CustomGroup }, custom_group_id: { required: true, type: () => String } };
    }
};
exports.ReportItem = ReportItem;
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], ReportItem.prototype, "report_item_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => report_entity_1.Report, (report) => report.report_items, { cascade: true, onDelete: 'CASCADE', nullable: false }),
    (0, typeorm_1.JoinColumn)({ name: 'report_id' }),
    __metadata("design:type", report_entity_1.Report)
], ReportItem.prototype, "report", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ReportItem.prototype, "report_id", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: reportItem_constants_1.REPORT_ITEM_FORMAT,
    }),
    __metadata("design:type", String)
], ReportItem.prototype, "format", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: reportItem_constants_1.REPORT_ITEM_TYPE,
    }),
    __metadata("design:type", String)
], ReportItem.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'jsonb',
        default: '{}',
    }),
    __metadata("design:type", Object)
], ReportItem.prototype, "data", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], ReportItem.prototype, "item_index", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => class_entity_1.Class, (_class) => _class.report_items, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'class' }),
    __metadata("design:type", class_entity_1.Class)
], ReportItem.prototype, "_class", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], ReportItem.prototype, "class", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => hwType_entity_1.HwType, (hwType) => hwType.report_items, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'hw_type' }),
    __metadata("design:type", hwType_entity_1.HwType)
], ReportItem.prototype, "_hw_type", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], ReportItem.prototype, "hw_type", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], ReportItem.prototype, "subsystem", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => itemGroup_entity_1.ItemGroup, (itemGroup) => itemGroup.report_item, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'item_group_id' }),
    __metadata("design:type", itemGroup_entity_1.ItemGroup)
], ReportItem.prototype, "_item_group", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], ReportItem.prototype, "item_group_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => customGroup_entity_1.CustomGroup, (customGroup) => customGroup.report_items, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'custom_group_id' }),
    __metadata("design:type", customGroup_entity_1.CustomGroup)
], ReportItem.prototype, "_custom_group", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], ReportItem.prototype, "custom_group_id", void 0);
exports.ReportItem = ReportItem = __decorate([
    (0, typeorm_1.Entity)({ name: 'report_items', synchronize: false })
], ReportItem);
//# sourceMappingURL=reportItem.entity.js.map