"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.User = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
const audit_entity_1 = require("./audit.entity");
const group_entity_1 = require("./group.entity");
const ldap_entity_1 = require("./ldap.entity");
const customGroup_entity_1 = require("./customGroup.entity");
const customGroupFolder_entity_1 = require("./customGroupFolder.entity");
const export_entity_1 = require("./export.entity");
const dashboard_entity_1 = require("./dashboard.entity");
const dashboardFolder_entity_1 = require("./dashboardFolder.entity");
const userApiKey_entity_1 = require("./userApiKey.entity");
const report_entity_1 = require("./report.entity");
const storageGroup_entity_1 = require("./storageGroup.entity");
const mailGroup_entity_1 = require("./mailGroup.entity");
const recentlySearched_entity_1 = require("./recentlySearched.entity");
const serverGroup_entity_1 = require("./serverGroup.entity");
const alertingGroup_entity_1 = require("./alertingGroup.entity");
const tag_entity_1 = require("./tag.entity");
const customGroupFavorite_entity_1 = require("./customGroupFavorite.entity");
let User = class User {
    static _OPENAPI_METADATA_FACTORY() {
        return { user_id: { required: true, type: () => Number }, username: { required: true, type: () => String }, email: { required: true, type: () => String }, password: { required: true, type: () => String }, active: { required: true, type: () => Boolean }, _ldap: { required: false, type: () => require("./ldap.entity").Ldap }, ldap_id: { required: true, type: () => String }, groups: { required: true, type: () => [require("./group.entity").Group] }, timezone: { required: true, type: () => String }, created: { required: false, type: () => String }, updated: { required: false, type: () => String }, logged: { required: true, type: () => String }, configuration: { required: true, type: () => Object }, created_alerts: { required: true, type: () => [require("./alertingGroup.entity").AlertingGroup] }, created_custom_groups: { required: true, type: () => [require("./customGroup.entity").CustomGroup] }, created_custom_group_folders: { required: true, type: () => [require("./customGroupFolder.entity").CustomGroupFolder] }, created_exports: { required: true, type: () => [require("./export.entity").Export] }, created_reports: { required: true, type: () => [require("./report.entity").Report] }, created_dashboards: { required: true, type: () => [require("./dashboard.entity").Dashboard] }, created_dashboard_folders: { required: true, type: () => [require("./dashboardFolder.entity").DashboardFolder] }, created_storage_groups: { required: true, type: () => [require("./storageGroup.entity").StorageGroup] }, created_server_groups: { required: true, type: () => [require("./storageGroup.entity").StorageGroup] }, created_tags: { required: true, type: () => [require("./tag.entity").Tag] }, recently_searched: { required: true, type: () => [require("./recentlySearched.entity").RecentlySearched] }, audits: { required: true, type: () => [require("./audit.entity").Audit] }, apiKeys: { required: true, type: () => [require("./userApiKey.entity").UserApiKey] }, mailGroups: { required: true, type: () => [require("./mailGroup.entity").MailGroup] }, favoriteCustomGroups: { required: true, type: () => [require("./customGroupFavorite.entity").CustomGroupFavorite] } };
    }
};
exports.User = User;
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    __metadata("design:type", Number)
], User.prototype, "user_id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], User.prototype, "username", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], User.prototype, "email", void 0);
__decorate([
    (0, typeorm_1.Column)({ select: false }),
    __metadata("design:type", String)
], User.prototype, "password", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", Boolean)
], User.prototype, "active", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => ldap_entity_1.Ldap, (ldap) => ldap._users, { cascade: true, onDelete: 'CASCADE', nullable: true }),
    (0, typeorm_1.JoinColumn)({ name: 'ldap_id' }),
    __metadata("design:type", ldap_entity_1.Ldap)
], User.prototype, "_ldap", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], User.prototype, "ldap_id", void 0);
__decorate([
    (0, typeorm_1.ManyToMany)(() => group_entity_1.Group),
    (0, typeorm_1.JoinTable)({
        name: 'users_groups',
        joinColumn: {
            name: 'user_id',
            referencedColumnName: 'user_id',
        },
        inverseJoinColumn: {
            name: 'group_id',
            referencedColumnName: 'group_id',
        },
    }),
    __metadata("design:type", Array)
], User.prototype, "groups", void 0);
__decorate([
    (0, typeorm_1.Column)({ default: 'Etc/UTC' }),
    __metadata("design:type", String)
], User.prototype, "timezone", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ type: 'timestamp with time zone', name: 'created_at' }),
    __metadata("design:type", String)
], User.prototype, "created", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)({ type: 'timestamp with time zone', name: 'updated_at' }),
    __metadata("design:type", String)
], User.prototype, "updated", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: 'timestamp with time zone', nullable: true, name: 'logged_at' }),
    __metadata("design:type", String)
], User.prototype, "logged", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: 'jsonb', nullable: true }),
    __metadata("design:type", Object)
], User.prototype, "configuration", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => alertingGroup_entity_1.AlertingGroup, (ag) => ag.created_by),
    __metadata("design:type", Array)
], User.prototype, "created_alerts", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => customGroup_entity_1.CustomGroup, (customGroup) => customGroup.created_by),
    __metadata("design:type", Array)
], User.prototype, "created_custom_groups", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => customGroupFolder_entity_1.CustomGroupFolder, (customGroupFolder) => customGroupFolder.created_by),
    __metadata("design:type", Array)
], User.prototype, "created_custom_group_folders", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => export_entity_1.Export, (exporter) => exporter.created_by),
    __metadata("design:type", Array)
], User.prototype, "created_exports", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => report_entity_1.Report, (report) => report.created_by),
    __metadata("design:type", Array)
], User.prototype, "created_reports", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => dashboard_entity_1.Dashboard, (dashboard) => dashboard.created_by),
    __metadata("design:type", Array)
], User.prototype, "created_dashboards", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => dashboardFolder_entity_1.DashboardFolder, (dashboardFolder) => dashboardFolder.created_by),
    __metadata("design:type", Array)
], User.prototype, "created_dashboard_folders", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => storageGroup_entity_1.StorageGroup, (storageGroup) => storageGroup.created_by),
    __metadata("design:type", Array)
], User.prototype, "created_storage_groups", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => serverGroup_entity_1.ServerGroup, (serverGroup) => serverGroup.created_by),
    __metadata("design:type", Array)
], User.prototype, "created_server_groups", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => tag_entity_1.Tag, (tag) => tag.created_by),
    __metadata("design:type", Array)
], User.prototype, "created_tags", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => recentlySearched_entity_1.RecentlySearched, (recentlySearched) => recentlySearched.created_by),
    __metadata("design:type", Array)
], User.prototype, "recently_searched", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => audit_entity_1.Audit, (audit) => audit.user),
    __metadata("design:type", Array)
], User.prototype, "audits", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => userApiKey_entity_1.UserApiKey, (userApiKey) => userApiKey._user),
    __metadata("design:type", Array)
], User.prototype, "apiKeys", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => mailGroup_entity_1.MailGroup, (mailGroup) => mailGroup.created_by),
    __metadata("design:type", Array)
], User.prototype, "mailGroups", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => customGroupFavorite_entity_1.CustomGroupFavorite, (customGroupFavorite) => customGroupFavorite._user),
    __metadata("design:type", Array)
], User.prototype, "favoriteCustomGroups", void 0);
exports.User = User = __decorate([
    (0, typeorm_1.Entity)({ name: 'users', synchronize: false })
], User);
//# sourceMappingURL=user.entity.js.map