"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminModifyGuard = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const dataSource_1 = require("../config/dataSource");
const adminGroup_entity_1 = require("../entity/adminGroup.entity");
const user_entity_1 = require("../entity/user.entity");
const User_1 = require("../service/users/User");
const typeorm_2 = require("typeorm");
let AdminModifyGuard = class AdminModifyGuard {
    constructor(usersRepository) {
        this.usersRepository = usersRepository;
    }
    async canActivate(context) {
        const request = context.switchToHttp().getRequest();
        const method = request.method.toUpperCase();
        const user = await User_1.User.getUserByRequest(request, true);
        const groupIds = user.groups.map(group => group.group_id);
        const isAdminGroup = groupIds.includes(1)
            || ((await (0, dataSource_1.getDataSource)().getRepository(adminGroup_entity_1.AdminGroup).findOne({
                relations: {
                    group: true
                },
                where: {
                    group: {
                        group_id: (0, typeorm_2.In)(groupIds)
                    }
                }
            })) !== null);
        const adminMethods = ["POST", "PUT", "DELETE"];
        return (isAdminGroup || !adminMethods.includes(method));
    }
};
exports.AdminModifyGuard = AdminModifyGuard;
exports.AdminModifyGuard = AdminModifyGuard = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(user_entity_1.User)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], AdminModifyGuard);
//# sourceMappingURL=adminModify.guard.js.map