"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminGroupsInterceptor = void 0;
const common_1 = require("@nestjs/common");
const User_1 = require("../service/users/User");
const operators_1 = require("rxjs/operators");
const dataSource_1 = require("../config/dataSource");
const adminGroup_entity_1 = require("../entity/adminGroup.entity");
const adminGroups_constants_1 = require("../common/constants/adminGroups.constants");
let AdminGroupsInterceptor = class AdminGroupsInterceptor {
    constructor() { }
    async intercept(context, next) {
        const rulesRepository = (0, dataSource_1.getDataSource)().getRepository(adminGroup_entity_1.AdminGroup);
        const request = context.switchToHttp().getRequest();
        const response = context.switchToHttp().getResponse();
        const user = await User_1.User.getUserByRequest(request, true);
        const groupIds = user.groups.map(group => group.group_id);
        const caller = context.getHandler().name;
        return next
            .handle()
            .pipe((0, operators_1.map)(async (data) => {
            if (groupIds.includes(1)) {
                for (let item of data.data) {
                    item.allowed = true;
                }
                return data;
            }
            for (let groupId of groupIds) {
                for (let item of data.data) {
                    if (item.allowed) {
                        continue;
                    }
                    let found = false;
                    const classRules = await rulesRepository.find({ relations: { group: true }, where: { group: { group_id: groupId }, type: adminGroups_constants_1.RULE_TYPE.CLASS } });
                    for (let rule of classRules) {
                        if (rule.value && rule.value == item.class) {
                            item.allowed = true;
                            found = true;
                            break;
                        }
                    }
                    if (found) {
                        continue;
                    }
                    const hwTypeRules = await rulesRepository.find({ relations: { group: true }, where: { group: { group_id: groupId }, type: adminGroups_constants_1.RULE_TYPE.HWTYPE } });
                    for (let rule of hwTypeRules) {
                        if (rule.value && rule.value == item.hw_type) {
                            item.allowed = true;
                            break;
                        }
                    }
                }
            }
            return data;
        }));
    }
};
exports.AdminGroupsInterceptor = AdminGroupsInterceptor;
exports.AdminGroupsInterceptor = AdminGroupsInterceptor = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [])
], AdminGroupsInterceptor);
//# sourceMappingURL=adminGroups.interceptor.js.map