"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const app_service_1 = require("./app.service");
const rawbody = require("raw-body");
const xormon_exception_1 = require("../exception/xormon.exception");
let AppController = class AppController {
    constructor(appService) {
        this.appService = appService;
    }
    async saveMetrics(res, data, hw_type, subsystem) {
        const metrics = [];
        for (const item in data) {
            for (const time in data[item]) {
                let datetime = new Date(parseInt(time) * 1000).toISOString();
                for (const metric of data[item][time]) {
                    if (!data[item][time][time][metric] || data[item][time][metric].length == 0) {
                        delete data[item][time][metric];
                    }
                }
                let metric = {
                    time: datetime,
                    item_id: item,
                    data: data[item][time],
                };
                metrics.push(metric);
            }
        }
        let inserted = 0;
        if (hw_type && subsystem) {
            inserted = await this.appService.saveMetrics(metrics, hw_type, subsystem);
        }
        else {
            inserted = await this.appService.saveMetrics(metrics);
        }
        res.status(common_1.HttpStatus.CREATED);
        return {
            statusCode: common_1.HttpStatus.CREATED,
            message: 'saved ' + inserted + ' rows',
        };
    }
    async saveMetrics2(res, data) {
        let metrics = [];
        let inserted = 0;
        for (const hwType in data) {
            for (const subsystem in data[hwType]) {
                for (const item_id in data[hwType][subsystem]) {
                    for (const time in data[hwType][subsystem][item_id]) {
                        for (const metric in data[hwType][subsystem][item_id][time]) {
                            if (data[hwType][subsystem][item_id][time][metric] === undefined ||
                                data[hwType][subsystem][item_id][time][metric] === null ||
                                data[hwType][subsystem][item_id][time][metric].length == 0) {
                                delete data[hwType][subsystem][item_id][time][metric];
                            }
                        }
                        let metric = {
                            time: new Date(parseInt(time) * 1000).toISOString(),
                            item_id: item_id,
                            data: data[hwType][subsystem][item_id][time],
                        };
                        metrics.push(metric);
                    }
                }
                inserted += await this.appService.saveMetrics(metrics, hwType, subsystem);
                metrics = [];
            }
        }
        res.status(common_1.HttpStatus.CREATED);
        return {
            statusCode: common_1.HttpStatus.CREATED,
            message: 'saved ' + inserted + ' rows',
        };
    }
    async saveMetricsCSV(req, hw_type, subsystem) {
        if (req.readable) {
            let metrics = [];
            let raw;
            try {
                raw = await rawbody(req);
            }
            catch (e) {
                throw new xormon_exception_1.XormonException("Unable to process incoming data", common_1.HttpStatus.BAD_REQUEST);
            }
            const csv = raw.toString().trim().split('\n');
            const legend = csv[0].split(';');
            for (let i = 1; i < csv.length; i++) {
                if (csv[i].charAt(0) == " ") {
                    csv[i] = csv[i].substring(1);
                }
                const sublines = csv[i].split('|');
                if (sublines.length >= 2) {
                    const m_line = csv[i].split(';');
                    const item_id = m_line[0];
                    for (let sub_index = 0; sub_index < sublines.length; sub_index++) {
                        const subline = sublines[sub_index];
                        const line = subline.split(';');
                        const l_offset = sub_index == 0 ? 0 : 1;
                        const d_offset = sub_index == 0 ? 1 : 0;
                        const datetime = new Date(parseInt(line[d_offset]) * 1000).toISOString();
                        let data = {};
                        for (let x = 1 + d_offset; x < line.length; x++) {
                            if (!legend[x + l_offset] || legend[x + l_offset].length === 0) {
                                continue;
                            }
                            let value = line[x] && line[x].length >= 1 ? this.appService.checkValue(line[x]) : null;
                            if (value) {
                                data[legend[x + l_offset]] = value;
                            }
                        }
                        if (Object.keys(data).length >= 1) {
                            let metric = {
                                time: datetime,
                                item_id: item_id,
                                data: data,
                            };
                            metrics.push(metric);
                        }
                    }
                }
                else {
                    const line = csv[i].split(';');
                    const datetime = new Date(parseInt(line[1]) * 1000).toISOString();
                    let data = {};
                    for (let x = 2; x < line.length; x++) {
                        if (!legend[x] || legend[x].length === 0) {
                            continue;
                        }
                        let value = line[x] ? this.appService.checkValue(line[x]) : null;
                        if (value) {
                            data[legend[x]] = value;
                        }
                    }
                    if (Object.keys(data).length >= 1) {
                        let metric = {
                            time: datetime,
                            item_id: line[0],
                            data: data,
                        };
                        metrics.push(metric);
                    }
                }
            }
            let inserted = 0;
            if (hw_type && subsystem) {
                inserted = await this.appService.saveMetrics(metrics, hw_type, subsystem);
            }
            else {
                inserted = await this.appService.saveMetrics(metrics);
            }
            return {
                statusCode: common_1.HttpStatus.CREATED,
                message: 'saved ' + inserted + ' rows',
            };
        }
        else {
            throw new common_1.HttpException({
                statusCode: common_1.HttpStatus.BAD_REQUEST,
                error: 'bad request',
            }, common_1.HttpStatus.BAD_REQUEST);
        }
    }
};
exports.AppController = AppController;
__decorate([
    (0, common_1.Post)('v1/data/store'),
    openapi.ApiResponse({ status: 201, type: require("../common/basicResponse.dto").BasicResponseDTO }),
    __param(0, (0, common_1.Res)({ passthrough: true })),
    __param(1, (0, common_1.Body)()),
    __param(2, (0, common_1.Query)('hw_type')),
    __param(3, (0, common_1.Query)('subsystem')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, String, String]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "saveMetrics", null);
__decorate([
    openapi.ApiOperation({ description: "stores metrics data from JSON format" }),
    (0, common_1.Post)('v3/data/store'),
    openapi.ApiResponse({ status: 201, type: require("../common/basicResponse.dto").BasicResponseDTO }),
    __param(0, (0, common_1.Res)({ passthrough: true })),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "saveMetrics2", null);
__decorate([
    openapi.ApiOperation({ description: "stores metrics data from CSV format" }),
    (0, common_1.Post)('v2/data/store'),
    openapi.ApiResponse({ status: 201, type: require("../common/basicResponse.dto").BasicResponseDTO }),
    __param(0, (0, common_1.Req)()),
    __param(1, (0, common_1.Query)('hw_type')),
    __param(2, (0, common_1.Query)('subsystem')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String, String]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "saveMetricsCSV", null);
exports.AppController = AppController = __decorate([
    (0, common_1.Controller)('api/metrics'),
    __metadata("design:paramtypes", [app_service_1.AppService])
], AppController);
//# sourceMappingURL=app.controller.js.map