import { EntityManager, Repository } from 'typeorm';
import { HostcfgRelation } from '@xormon/entity/hostcfgRelation.entity';
import { ItemRelation } from '@xormon/entity/itemRelation.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
import { AgentMapping } from '@xormon/entity/agentMapping.entity';
import { StorageMapping } from '@xormon/entity/storageMapping.entity';
import { ItemProperty } from '@xormon/entity/itemProperty.entity';
import { HealthStatus } from '@xormon/entity/healthStatus.entity';
import { Heatmap } from '@xormon/entity/heatmap.entity';
import { HostCfg } from '@xormon/entity/hostcfg.entity';
import { Top } from '@xormon/entity/top.entity';
export interface ItemPropertyObject {
    [item_id: string]: {
        [property_key: string]: string;
    };
}
export declare class ConfigurationService {
    private hostcfgRepository;
    private itemPropertiesRepository;
    private objectItemsRepository;
    private itemRelationsRepository;
    private agentMappingRepository;
    private storageMappingRepository;
    private healthStatusRepository;
    private hostcfgRelationsRepository;
    private heatmapRepository;
    private topRepository;
    private dataSource;
    constructor(hostcfgRepository: Repository<HostCfg>, itemPropertiesRepository: Repository<ItemProperty>, objectItemsRepository: Repository<ObjectItem>, itemRelationsRepository: Repository<ItemRelation>, agentMappingRepository: Repository<AgentMapping>, storageMappingRepository: Repository<StorageMapping>, healthStatusRepository: Repository<HealthStatus>, hostcfgRelationsRepository: Repository<HostcfgRelation>, heatmapRepository: Repository<Heatmap>, topRepository: Repository<Top>, dataSource: EntityManager);
    saveItemProperties(items: ItemProperty[]): Promise<number>;
    getItemIds(): Promise<string[]>;
    saveArchitecture(objectItems: ObjectItem[]): Promise<number>;
    saveArchitectureAgent(objectItems: ObjectItem[]): Promise<number>;
    saveAgentMapping(agentMapping: AgentMapping[]): Promise<number>;
    saveHostcfgRelations(hostcfgRelations: HostcfgRelation[]): Promise<number>;
    saveStorageMapping(storageMapping: StorageMapping[]): Promise<number>;
    saveItemRelations(itemRelations: ItemRelation[]): Promise<number>;
    deleteArchitecture(id?: string): Promise<number>;
    gatherLineage(ids: any): Promise<any>;
    getArrayFromResponse(response: any, elmntType: any): Promise<any[]>;
    transformObjToItemProperties(data: ItemPropertyObject): ItemProperty[];
    hashCode(s: string): string;
    getHostCfgs(_class?: string, hwType?: string): Promise<HostCfg[]>;
    saveHostCfg(hostcfg: Partial<HostCfg>): Promise<HostCfg>;
    private filterProxyItems;
    addHeatmap(items: Heatmap[]): Promise<import("typeorm").InsertResult>;
    addTop(items: Top[]): Promise<import("typeorm").InsertResult>;
}
