import { Repository } from 'typeorm';
import { HealthStatus } from '@xormon/entity/healthStatus.entity';
import { HostcfgStatus } from '@xormon/entity/hostcfgStatus.entity';
import { HwTypeKey } from '@xormon/common/constants/hwTypeKey.constants';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
export interface IHostcfgStatus {
    hostcfg_id: string;
    connection?: number | boolean;
    data?: number | boolean;
    message?: string;
    updatedAt: Date;
    lastData?: Date;
    perfTriggered: boolean;
    hwType?: HwTypeKey;
}
export declare class HealthStatusService {
    private healthStatusRepository;
    private hostcfgStatusRepository;
    private objectItemrepository;
    constructor(healthStatusRepository: Repository<HealthStatus>, hostcfgStatusRepository: Repository<HostcfgStatus>, objectItemrepository: Repository<ObjectItem>);
    saveHealthStatus(healthStatus: HealthStatus[]): Promise<number>;
    saveDataOrConntest(data: IHostcfgStatus): Promise<boolean>;
    propagateParents(hostcfgStatus: IHostcfgStatus): Promise<void>;
}
