"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HealthStatusService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const typeorm_2 = require("typeorm");
const healthStatus_entity_1 = require("../entity/healthStatus.entity");
const hostcfgStatus_entity_1 = require("../entity/hostcfgStatus.entity");
const objectItem_entity_1 = require("../entity/objectItem.entity");
let HealthStatusService = class HealthStatusService {
    constructor(healthStatusRepository, hostcfgStatusRepository, objectItemrepository) {
        this.healthStatusRepository = healthStatusRepository;
        this.hostcfgStatusRepository = hostcfgStatusRepository;
        this.objectItemrepository = objectItemrepository;
    }
    async saveHealthStatus(healthStatus) {
        const insert = await this.healthStatusRepository.save(healthStatus, { chunk: 250 });
        return insert.length;
    }
    async saveDataOrConntest(data) {
        if (data.connection !== undefined) {
            data.connection = data.connection === 1 ? true : false;
        }
        if (data.data !== undefined) {
            data.data = data.data === 1 ? true : false;
            if (data.data === true) {
                data.perfTriggered = false;
                data.lastData = new Date();
            }
        }
        if (!data.message) {
            data.message = null;
        }
        data.updatedAt = new Date();
        return (await this.hostcfgStatusRepository.save(data)).hostcfg_id !== undefined;
    }
    async propagateParents(hostcfgStatus) {
        const items = await this.objectItemrepository.find({
            where: {
                hw_type: hostcfgStatus.hwType,
                parents: {
                    parent: (0, typeorm_2.IsNull)()
                },
                hostcfg_relations: {
                    hostcfg_id: hostcfgStatus.hostcfg_id
                }
            }
        });
        if (!items.length) {
            return;
        }
        const partiaHs = {
            status: hostcfgStatus.connection ? healthStatus_entity_1.Status.OK : healthStatus_entity_1.Status.ERROR,
            type: healthStatus_entity_1.StatusType.CONNECTION,
            data: hostcfgStatus.message,
            item_id: null
        };
        const hs = items.map(it => ({
            ...partiaHs,
            item_id: it.item_id,
        }));
        await this.saveHealthStatus(hs);
    }
};
exports.HealthStatusService = HealthStatusService;
exports.HealthStatusService = HealthStatusService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(healthStatus_entity_1.HealthStatus)),
    __param(1, (0, typeorm_1.InjectRepository)(hostcfgStatus_entity_1.HostcfgStatus)),
    __param(2, (0, typeorm_1.InjectRepository)(objectItem_entity_1.ObjectItem)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository])
], HealthStatusService);
//# sourceMappingURL=healthStatus.service.js.map