"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProxyController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const configuration_service_1 = require("./configuration.service");
let ProxyController = class ProxyController {
    constructor(configurationService) {
        this.configurationService = configurationService;
    }
    async postHeatmaps(heatmapItems) {
        const saved = await this.configurationService.addHeatmap(heatmapItems);
        console.log("Saved heatmaps for " + heatmapItems.length + " items");
        return {
            statusCode: common_1.HttpStatus.OK,
            message: 'Heatmaps saved successfully',
        };
    }
    async postTops(topItems) {
        const saved = await this.configurationService.addTop(topItems);
        console.log("Saved tops for " + topItems.length + " items");
        return {
            statusCode: common_1.HttpStatus.OK,
            message: 'Heatmaps saved successfully',
        };
    }
};
exports.ProxyController = ProxyController;
__decorate([
    (0, common_1.Post)("v1/heatmap"),
    openapi.ApiResponse({ status: 201 }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Array]),
    __metadata("design:returntype", Promise)
], ProxyController.prototype, "postHeatmaps", null);
__decorate([
    (0, common_1.Post)("v1/top"),
    openapi.ApiResponse({ status: 201 }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Array]),
    __metadata("design:returntype", Promise)
], ProxyController.prototype, "postTops", null);
exports.ProxyController = ProxyController = __decorate([
    (0, swagger_1.ApiTags)('Proxy'),
    (0, swagger_1.ApiBearerAuth)(),
    (0, common_1.Controller)('api/proxy'),
    __metadata("design:paramtypes", [configuration_service_1.ConfigurationService])
], ProxyController);
//# sourceMappingURL=proxy.controller.js.map