"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServerGRoupItems1714977729139 = void 0;
const typeorm_1 = require("typeorm");
class ServerGRoupItems1714977729139 {
    constructor() {
        this.name = 'ServerGRoupItems1714977729139';
    }
    async up(queryRunner) {
        await queryRunner.createTable(new typeorm_1.Table({
            name: "server_group_items",
            columns: [
                {
                    name: "server_group_id",
                    type: "varchar",
                    isPrimary: true
                },
                {
                    name: "item_id",
                    type: "varchar",
                    isPrimary: true
                },
                {
                    name: "created_at",
                    type: "timestamptz",
                    isNullable: false,
                    default: "now()"
                }
            ]
        }));
        await queryRunner.createForeignKeys("server_group_items", [
            new typeorm_1.TableForeignKey({
                columnNames: ["server_group_id"],
                referencedColumnNames: ["server_group_id"],
                referencedTableName: "server_group",
                onDelete: "CASCADE",
            }),
            new typeorm_1.TableForeignKey({
                columnNames: ["item_id"],
                referencedColumnNames: ["item_id"],
                referencedTableName: "object_items",
                onDelete: "CASCADE",
            }),
        ]);
    }
    async down(queryRunner) {
        await queryRunner.dropTable("server_group_items");
    }
}
exports.ServerGRoupItems1714977729139 = ServerGRoupItems1714977729139;
//# sourceMappingURL=1714977729139-ServerGRoupItems.migration.js.map