"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HealthStatusType1724407123000 = void 0;
class HealthStatusType1724407123000 {
    constructor() {
        this.name = 'HealthStatusType1724407123000';
    }
    async up(queryRunner) {
        await queryRunner.query(`
        CREATE TYPE public.status_type_enum AS ENUM (
        	'health',
        	'data',
        	'connection'); 

        drop table if exists public.health_status;

        CREATE TABLE public.health_status (
        	item_id varchar NOT NULL,
        	"type" public.status_type_enum DEFAULT 'health'::status_type_enum NOT NULL,
        	status public.hs_v1 DEFAULT 'unknown'::hs_v1 NOT NULL,
        	created_at timestamptz DEFAULT now() NOT NULL,
        	updated_at timestamptz DEFAULT now() NOT NULL,
        	"data" varchar NULL,
        	PRIMARY KEY (item_id, type)
        );
    `);
    }
    async down(queryRunner) {
        await queryRunner.query(`
        drop table if exists public.health_status;

        CREATE TABLE public.health_status (
        	item_id varchar NOT NULL,
        	status public.hs_v1 DEFAULT 'unknown'::hs_v1 NOT NULL,
        	created_at timestamptz DEFAULT now() NOT NULL,
        	updated_at timestamptz DEFAULT now() NOT NULL,
        	"data" varchar NULL,
        	PRIMARY KEY (item_id)
        );
      
      `);
    }
}
exports.HealthStatusType1724407123000 = HealthStatusType1724407123000;
//# sourceMappingURL=1724407123000-HealthStatusType.migration.js.map