"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.readdDeletedGroups1725015019962 = void 0;
const itemRelation_entity_1 = require("../../entity/itemRelation.entity");
const objectItem_entity_1 = require("../../entity/objectItem.entity");
const serverGroup_entity_1 = require("../../entity/serverGroup.entity");
class readdDeletedGroups1725015019962 {
    constructor() {
        this.name = 'readdDeletedGroups1725015019962';
    }
    async up(queryRunner) {
        const server_groups = await queryRunner.manager.getRepository(serverGroup_entity_1.ServerGroup).find({ relations: { server_group_items: { _item: true } } });
        for (const server_group of server_groups) {
            let hw_type = server_group.hw_type;
            if (!server_group.hw_type) {
                if (!server_group.server_group_items) {
                    continue;
                }
                else {
                    hw_type = server_group.server_group_items[0]._item.hw_type;
                }
            }
            const parent = await queryRunner.manager.getRepository(objectItem_entity_1.ObjectItem).save({
                item_id: server_group.server_group_id,
                hw_type: hw_type,
                object_id: hw_type,
                subsystem: "group",
                label: server_group.label
            });
            await queryRunner.manager.getRepository(itemRelation_entity_1.ItemRelation).save(server_group.server_group_items.map((item) => {
                return {
                    parent: parent.item_id,
                    child: item.item_id,
                    origin: itemRelation_entity_1.RelationOrigin.parent
                };
            }));
        }
    }
    async down(queryRunner) {
    }
}
exports.readdDeletedGroups1725015019962 = readdDeletedGroups1725015019962;
//# sourceMappingURL=1725015019962-readdDeletedGroups.migration.js.map