"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TagV2ItemGroupEntityChange1725627858370 = void 0;
class TagV2ItemGroupEntityChange1725627858370 {
    constructor() {
        this.name = 'TagV2ItemGroupEntityChange1725627858370';
    }
    async up(queryRunner) {
        await queryRunner.query(`
      TRUNCATE TABLE public.item_group_parent_tags;
      ALTER TABLE public.item_group_parent_tags DROP COLUMN tag_id;

      TRUNCATE TABLE public.item_group_tags;
      ALTER TABLE public.item_group_tags DROP COLUMN tag_id;
    `);
        await queryRunner.query(`
      
      ALTER TABLE public.item_group_parent_tags ADD COLUMN tag_value_id uuid NOT NULL;
      ALTER TABLE public.item_group_parent_tags ADD COLUMN subsystem varchar NOT NULL;

      ALTER TABLE public.item_group_tags ADD COLUMN tag_value_id uuid NOT NULL;

      ALTER TABLE public.item_group_parent_tags ADD CONSTRAINT "PK_b80d88844b479d4c79d4396826a" PRIMARY KEY (item_group_id, tag_value_id);
      ALTER TABLE public.item_group_parent_tags ADD CONSTRAINT "FK_21332854f3250deeb80acb209d0" FOREIGN KEY (tag_value_id) REFERENCES public.tag_values(tag_value_id) ON DELETE CASCADE;

      ALTER TABLE public.item_group_tags ADD CONSTRAINT "PK_a9708e055359b4e97045d6c614a" PRIMARY KEY (item_group_id, tag_value_id);
      ALTER TABLE public.item_group_tags ADD CONSTRAINT "FK_17baf4237558cc0d9ed88875fbe" FOREIGN KEY (tag_value_id) REFERENCES public.tag_values(tag_value_id) ON DELETE CASCADE;
    `);
    }
    async down(queryRunner) {
        await queryRunner.query(`
      TRUNCATE TABLE public.item_group_parent_tags;
      ALTER TABLE public.item_group_parent_tags DROP COLUMN tag_value_id;
      ALTER TABLE public.item_group_parent_tags DROP COLUMN IF EXISTS subsystem;

      TRUNCATE TABLE public.item_group_tags;
      ALTER TABLE public.item_group_tags DROP COLUMN tag_value_id;
    `);
        await queryRunner.query(`
      ALTER TABLE public.item_group_parent_tags ADD COLUMN tag_id uuid NOT NULL;
      ALTER TABLE public.item_group_tags ADD COLUMN tag_id uuid NOT NULL;

      ALTER TABLE public.item_group_parent_tags ADD CONSTRAINT "PK_617cad35b0df69d6a6a7b0cb1ce" PRIMARY KEY (item_group_id, tag_id);
      ALTER TABLE public.item_group_parent_tags ADD CONSTRAINT "FK_c868e355c66f37f203a08742009" FOREIGN KEY (tag_id) REFERENCES public.tags_legacy(tag_id) ON DELETE CASCADE;

      ALTER TABLE public.item_group_tags ADD CONSTRAINT "PK_65f4446fb78e33606dcd9a7fe23" PRIMARY KEY (item_group_id, tag_id);
      ALTER TABLE public.item_group_tags ADD CONSTRAINT "FK_29aee9193addc263fd86d1b1df1" FOREIGN KEY (tag_id) REFERENCES public.tags_legacy(tag_id) ON DELETE CASCADE;
    `);
    }
}
exports.TagV2ItemGroupEntityChange1725627858370 = TagV2ItemGroupEntityChange1725627858370;
//# sourceMappingURL=1725627858370-TagV2ItemGroupEntityChange.migration.js.map