import { AclMenuChangesResponseDTO, AclMenuResponseDTO, AclResponseDTO } from '@xormon/common/aclResponse.dto';
import { BasicResponseDTO } from '@xormon/common/basicResponse.dto';
import { MenuService } from '@xormon/service/menu/menu.service';
import { ACLService } from './acl.service';
import { Request } from 'express';
export declare class ACLController {
    private readonly menuService;
    private readonly ACLService;
    constructor(menuService: MenuService, ACLService: ACLService);
    getRules(): Promise<AclResponseDTO>;
    getGroupRules(group_id: number): Promise<AclResponseDTO>;
    createRules(request: Request, headers: any, group_id: number, AclRule: AclResponseDTO): Promise<AclResponseDTO>;
    clearRules(request: Request, headers: any): Promise<BasicResponseDTO>;
    deleteRules(request: Request, headers: any, group_id: number, strict?: boolean): Promise<BasicResponseDTO>;
    updateRules(request: Request, headers: any, group_id: number, AclTree: AclMenuResponseDTO): Promise<BasicResponseDTO>;
    updateRulesChanges(request: Request, headers: any, group_id: number, changes: AclMenuChangesResponseDTO): Promise<BasicResponseDTO>;
    getRoot(group_id: number): Promise<AclMenuResponseDTO>;
    getHwType(hw_type: string, group_id: number): Promise<AclMenuResponseDTO>;
    getSubsystem(hw_type: string, subsystem: string, group_id: number, item_ids?: string): Promise<AclMenuResponseDTO>;
    parents(uuid?: string): Promise<any>;
    parent(uuid?: string): Promise<any>;
    children(uuid?: string): Promise<any>;
}
