import { MailGroupsResponseDTO } from '@xormon/common/mailGroup.dto';
import { MailService } from '@xormon/mail/mail.service';
import { Request } from 'express';
import { AlertHistoryDTO, AlertsResponseDTO, CreateAlertGroupDTO } from '../../common/alerting.dto';
import { BasicResponseDTO } from '../../common/basicResponse.dto';
import { AlertingService } from './alerting.service';
import { DeviceGroupResponseDTO, CreateDeviceGroupHwAlertingBody, UpdateDeviceGroupHwAlertingBody, DeviceGroupsResponseDTO } from '@xormon/common/deviceGroupHwAlerting.dto';
export declare class AlertingController {
    private readonly alertingService;
    private readonly mailService;
    private log;
    constructor(alertingService: AlertingService, mailService: MailService);
    getAlerts(request: Request): Promise<AlertsResponseDTO>;
    saveAlertGroups(request: Request, alertGroupsDto: CreateAlertGroupDTO[]): Promise<AlertsResponseDTO>;
    updateAlertGroup(request: Request, alert_group_id: string, alert_group: CreateAlertGroupDTO): Promise<BasicResponseDTO>;
    deleteAlertGroups(alertGroupIds: string[]): Promise<BasicResponseDTO>;
    getHwAlertingEmails(): Promise<MailGroupsResponseDTO>;
    updateHwAlertingEmails(mailGroupIds: number[]): Promise<BasicResponseDTO>;
    testHwAlertingEmails(): Promise<BasicResponseDTO>;
    getDeviceGroups(request: Request): Promise<DeviceGroupsResponseDTO>;
    createDeviceGroups(request: Request, deviceGroupHwAlertingBody: CreateDeviceGroupHwAlertingBody): Promise<DeviceGroupResponseDTO>;
    updateDeviceGroup(request: Request, deviceGroupHwAlertingBody: UpdateDeviceGroupHwAlertingBody): Promise<DeviceGroupResponseDTO>;
    deleteDeviceGroupById(request: Request, deviceGroupId: string): Promise<BasicResponseDTO>;
    history(request: Request, from: Date, to: Date): Promise<AlertHistoryDTO>;
}
