import { HwTypeKey } from "@xormon/common/constants/hwTypeKey.constants";
export declare class App {
    static ROOT_PATH: string;
    static APPLIANCE_LOGS_PATH: string;
    static LOGS_PATH: string;
    static CUSTOM_SCRIPT_PATH: string;
    static TMP_FILES_PATH: string;
    static CERT_FILES_PATH: string;
    static LDAP_CERT_FILES_PATH: string;
    static DEFAULT_APP_SECRET: string;
    static DEFAULT_NAMESPACE: string;
    static isDemo(): boolean;
    static isProduction(): boolean;
    static isDebug(): Promise<boolean>;
    static isDockerVersion(): boolean;
    static isFree(): Promise<boolean>;
    static isMaster(): Promise<boolean>;
    static isExistsMaster(): Promise<boolean>;
    static isFirstLogin(): Promise<boolean>;
    static setMaster(): Promise<void>;
    static restart(): Promise<void>;
    static registerNode(): Promise<void>;
    static getSecret(): string;
    static getIp(): string;
    static getHostname(): string;
    static getId(): string;
    static getVersion(): string;
    static checkVersionInDatabase(): Promise<void>;
    static getTimescaleVersion(): Promise<string>;
    static allowedHwTypes(): HwTypeKey[];
    static getApplianceVersion(): Promise<string>;
    static getActiveHwTypes(): Promise<string[]>;
    static checkEnv(env: string, value: string): boolean | undefined;
    static checkGlobalMsVariables(key: string, hw_type?: string, hostcfg_id?: string): Promise<string>;
    static getCert(): Promise<{
        crt: string;
        key: string;
    }>;
    static sleep(ms: number): Promise<unknown>;
}
