"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ItemPropertiesWrapper = void 0;
const dataSource_1 = require("../../config/dataSource");
const itemProperty_entity_1 = require("../../entity/itemProperty.entity");
const typeorm_1 = require("typeorm");
class ItemPropertiesWrapper {
    static async getProperties(itemIds, properties) {
        let itemProperties = {};
        const propertiesFromDb = await (0, dataSource_1.getDataSource)().getRepository(itemProperty_entity_1.ItemProperty).find({
            where: {
                item_id: (0, typeorm_1.In)(itemIds),
                property_name: (0, typeorm_1.In)(properties)
            }
        });
        propertiesFromDb.forEach(property => {
            if (!itemProperties[property.item_id]) {
                itemProperties[property.item_id] = {
                    [property.property_name]: property.property_value
                };
            }
            else {
                itemProperties[property.item_id][property.property_name] = property.property_value;
            }
        });
        return itemProperties;
    }
    static async getProperty(itemIds, property) {
        let itemProperties = {};
        const propertiesFromDb = await (0, dataSource_1.getDataSource)().getRepository(itemProperty_entity_1.ItemProperty).find({
            where: {
                item_id: (0, typeorm_1.In)(itemIds),
                property_name: property
            }
        });
        propertiesFromDb.forEach(property => {
            itemProperties[property.item_id] = {
                value: property.property_value
            };
        });
        return itemProperties;
    }
}
exports.ItemPropertiesWrapper = ItemPropertiesWrapper;
//# sourceMappingURL=ItemPropertiesWrapper.js.map