"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigurationModule = void 0;
const common_1 = require("@nestjs/common");
const config_1 = require("@nestjs/config");
const typeorm_1 = require("@nestjs/typeorm");
const hostcfg_entity_1 = require("../../entity/hostcfg.entity");
const hostcfgRelation_entity_1 = require("../../entity/hostcfgRelation.entity");
const itemProperty_entity_1 = require("../../entity/itemProperty.entity");
const itemRelation_entity_1 = require("../../entity/itemRelation.entity");
const mailGroup_entity_1 = require("../../entity/mailGroup.entity");
const microserviceJobs_entity_1 = require("../../entity/microserviceJobs.entity");
const microserviceJobsStatus_entity_1 = require("../../entity/microserviceJobsStatus.entity");
const microserviceVariables_entity_1 = require("../../entity/microserviceVariables.entity");
const objectItem_entity_1 = require("../../entity/objectItem.entity");
const agentMapping_entity_1 = require("../../entity/agentMapping.entity");
const storageMapping_entity_1 = require("../../entity/storageMapping.entity");
const targetDestination_entity_1 = require("../../entity/targetDestination.entity");
const targetDestinationHostcfg_entity_1 = require("../../entity/targetDestinationHostcfg.entity");
const mail_module_1 = require("../../mail/mail.module");
const metrics_module_1 = require("../metrics/metrics.module");
const configuration_controller_1 = require("./configuration.controller");
const configuration_service_1 = require("./configuration.service");
const fabric_service_1 = require("./fabric.service");
const hostCfg_service_1 = require("./hostCfg.service");
const mailgroup_service_1 = require("./mailgroup.service");
const microserviceVariable_service_1 = require("./microserviceVariable.service");
const reload_gateway_1 = require("./reload.gateway");
const storageGroupDevice_entity_1 = require("../../entity/storageGroupDevice.entity");
const top_entity_1 = require("../../entity/top.entity");
const heatmap_entity_1 = require("../../entity/heatmap.entity");
const menuGroup_service_1 = require("./menuGroup.service");
let ConfigurationModule = class ConfigurationModule {
};
exports.ConfigurationModule = ConfigurationModule;
exports.ConfigurationModule = ConfigurationModule = __decorate([
    (0, common_1.Module)({
        imports: [
            config_1.ConfigModule.forRoot({ isGlobal: true }),
            typeorm_1.TypeOrmModule.forFeature([
                objectItem_entity_1.ObjectItem,
                itemProperty_entity_1.ItemProperty,
                itemRelation_entity_1.ItemRelation,
                hostcfg_entity_1.HostCfg,
                microserviceJobs_entity_1.MicroserviceJob,
                microserviceJobsStatus_entity_1.MicroserviceJobStatus,
                hostcfgRelation_entity_1.HostcfgRelation,
                agentMapping_entity_1.AgentMapping,
                storageMapping_entity_1.StorageMapping,
                targetDestination_entity_1.TargetDestination,
                targetDestinationHostcfg_entity_1.TargetDestinationHostcfg,
                mailGroup_entity_1.MailGroup,
                microserviceVariables_entity_1.MicroserviceVariables,
                storageGroupDevice_entity_1.StorageGroupDevice,
                top_entity_1.Top,
                heatmap_entity_1.Heatmap
            ]),
            mail_module_1.MailModule,
            metrics_module_1.MetricsModule
        ],
        controllers: [configuration_controller_1.ConfigurationController],
        providers: [
            configuration_service_1.ConfigurationService,
            reload_gateway_1.ReloadGateway,
            microserviceVariable_service_1.MicroserviceVariablesService,
            hostCfg_service_1.HostCfgService,
            fabric_service_1.FabricService,
            mailgroup_service_1.MailGroupService,
            menuGroup_service_1.MenuGroupService
        ],
        exports: [typeorm_1.TypeOrmModule],
    })
], ConfigurationModule);
//# sourceMappingURL=configuration.module.js.map