"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigurationService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const hostcfg_entity_1 = require("../../entity/hostcfg.entity");
const hostcfgRelation_entity_1 = require("../../entity/hostcfgRelation.entity");
const itemProperty_entity_1 = require("../../entity/itemProperty.entity");
const itemRelation_entity_1 = require("../../entity/itemRelation.entity");
const mailGroup_entity_1 = require("../../entity/mailGroup.entity");
const microserviceJobsStatus_entity_1 = require("../../entity/microserviceJobsStatus.entity");
const objectItem_entity_1 = require("../../entity/objectItem.entity");
const agentMapping_entity_1 = require("../../entity/agentMapping.entity");
const storageMapping_entity_1 = require("../../entity/storageMapping.entity");
const targetDestination_entity_1 = require("../../entity/targetDestination.entity");
const targetDestinationHostcfg_entity_1 = require("../../entity/targetDestinationHostcfg.entity");
const Architecture_1 = require("../architecture/Architecture");
const typeorm_2 = require("typeorm");
const storageGroupDevice_entity_1 = require("../../entity/storageGroupDevice.entity");
const heatmap_entity_1 = require("../../entity/heatmap.entity");
const top_entity_1 = require("../../entity/top.entity");
const MetricsWrapper_1 = require("../metrics/MetricsWrapper");
const Linux_1 = require("../menu/menu/Linux");
const URL_1 = require("../menu/menu/URL");
const User_1 = require("../users/User");
let ConfigurationService = class ConfigurationService {
    constructor(itemPropertiesRepository, hostCfgRepository, hostCfgRelationsRepository, microservicesJobsStatusRepository, objectItemsRepository, itemRelationsRepository, agentMappingRepository, storageMappingRepository, targetDestinationRepository, targetDestinationHostcfgRepository, storageGroupRepository, topRepository, heatmapRepository, mailGroupsRepository) {
        this.itemPropertiesRepository = itemPropertiesRepository;
        this.hostCfgRepository = hostCfgRepository;
        this.hostCfgRelationsRepository = hostCfgRelationsRepository;
        this.microservicesJobsStatusRepository = microservicesJobsStatusRepository;
        this.objectItemsRepository = objectItemsRepository;
        this.itemRelationsRepository = itemRelationsRepository;
        this.agentMappingRepository = agentMappingRepository;
        this.storageMappingRepository = storageMappingRepository;
        this.targetDestinationRepository = targetDestinationRepository;
        this.targetDestinationHostcfgRepository = targetDestinationHostcfgRepository;
        this.storageGroupRepository = storageGroupRepository;
        this.topRepository = topRepository;
        this.heatmapRepository = heatmapRepository;
        this.mailGroupsRepository = mailGroupsRepository;
    }
    async saveItemProperties(items) {
        const insert = await this.itemPropertiesRepository.createQueryBuilder().insert().into(itemProperty_entity_1.ItemProperty).values(items).orUpdate(['property_value'], ['item_id', 'property_name']).execute();
        return insert.generatedMaps.length;
    }
    async saveMicroservicesJobStatus(items) {
        const insert = await this.microservicesJobsStatusRepository.save(items);
        return insert.identification ? 1 : 0;
    }
    async getMicroservicesJobStatus(microservice, job, identification, pid) {
        return await this.microservicesJobsStatusRepository.findOneBy({
            microservice: microservice,
            job: job,
            identification: identification,
            pid: pid,
        });
    }
    async getMicroservicesJobsStatus(microservice) {
        return microservice
            ? await this.microservicesJobsStatusRepository.findBy({ microservice: microservice })
            : await this.microservicesJobsStatusRepository.find();
    }
    async getMicroserviceJobStatus(ms, job, identification, pid) {
        return await this.microservicesJobsStatusRepository.findBy({
            microservice: ms,
            job: job,
            identification: identification,
            pid: pid
        });
    }
    async saveMicroserviceJobStatus(data) {
        try {
            await this.microservicesJobsStatusRepository.save(data);
            return true;
        }
        catch (e) {
            console.error(e);
            return false;
        }
    }
    async getItemProperties(uuid, property_name) {
        if (property_name) {
            return this.itemPropertiesRepository.findBy({ item_id: uuid, property_name: property_name });
        }
        else {
            return this.itemPropertiesRepository.findBy({ item_id: uuid });
        }
    }
    async getItemsProperties(uuids, properties) {
        return await this.itemPropertiesRepository.findBy({
            item_id: (0, typeorm_2.In)(uuids),
            property_name: (0, typeorm_2.In)(properties)
        });
    }
    async getPropertiesKey(uuid) {
        const properties = await this.itemPropertiesRepository
            .createQueryBuilder('itemProperty')
            .select('itemProperty.property_name', 'property_name')
            .distinct(true)
            .where('itemProperty.item_id IN (:...itemIds)', {
            itemIds: uuid
        })
            .getRawMany();
        return properties.map(property => property.property_name);
    }
    async checkObjectItemsByHWType(hw_type = null) {
        return this.objectItemsRepository.findOneBy({ hw_type: hw_type });
    }
    async saveArchitecture(objectItems) {
        const insert = await this.objectItemsRepository.save(objectItems);
        return insert.length;
    }
    async saveAgentMapping(agentMapping) {
        const insert = await this.agentMappingRepository.save(agentMapping);
        return insert.length;
    }
    async saveStorageMapping(storageMapping) {
        const insert = await this.storageMappingRepository.save(storageMapping);
        return insert.length;
    }
    async saveArchitectureAgent(objectItems) {
        let toSave = [];
        const items = await this.objectItemsRepository.findByIds(objectItems.map((item) => {
            return item.item_id;
        }));
        for (const index in objectItems) {
            let item = items.find((i) => i.item_id === objectItems[index]['item_id']);
            if (item && item.hw_type !== 'LINUX') {
                item.hasAgent = true;
                toSave.push(item);
            }
            else {
                toSave.push(objectItems[index]);
            }
        }
        const insert = await this.objectItemsRepository.save(toSave);
        return insert.length;
    }
    async saveItemRelations(itemRelations) {
        const insert = await this.itemRelationsRepository.save(itemRelations);
        return insert.length;
    }
    async getClasses(active) {
        return Architecture_1.Architecture.getClasses();
    }
    async getHwTypes(active) {
        const hw_types = await Architecture_1.Architecture.getHwTypes();
        const hw_types_active = [];
        for (let hw_type of hw_types) {
            let check = await this.checkObjectItemsByHWType(hw_type.hw_type);
            if (check) {
                hw_types_active.push(hw_type);
                hw_type.active = true;
            }
        }
        if (active) {
            return hw_types_active;
        }
        return hw_types;
    }
    async getSubsystems(hw_type) {
        return hw_type ? Architecture_1.Architecture.getSubsystems(hw_type) : Architecture_1.Architecture.getSubsystems();
    }
    async getHwType(hw_type) {
        return Architecture_1.Architecture.getHwType(hw_type) ? Architecture_1.Architecture.getHwType(hw_type) : null;
    }
    async getItemIds() {
        return (await this.objectItemsRepository.find({ select: { item_id: true } })).map(item => item.item_id);
    }
    async getTargetDestinations() {
        return await this.targetDestinationRepository.find({
            relations: {
                _target_destination_hostcfgs: {
                    _hostcfg: true
                }
            }
        });
    }
    async joinDestinationDevices(destination) {
        if (typeof destination === "string") {
            return (await this.hostCfgRepository.findBy({
                hostcfg_id: (0, typeorm_2.In)(await this.targetDestinationHostcfgRepository.findBy({ target_destination_id: destination }))
            })).map(cfg => cfg.label).join(", ");
        }
        if (destination.hostcfg_ids === null) {
            return (await this.hostCfgRepository.find()).map(cfg => cfg.label).join(", ");
        }
        return (await this.hostCfgRepository.findBy({ hostcfg_id: (0, typeorm_2.In)(destination.hostcfg_ids) })).map(cfg => cfg.label).join(", ");
    }
    async getTargetDestination(target_destination_id) {
        return await this.targetDestinationRepository.findOne({
            relations: {
                _target_destination_hostcfgs: {
                    _hostcfg: true
                }
            },
            where: {
                target_destination_id: target_destination_id
            }
        });
    }
    async saveTargetDestination(destination) {
        const saved = await this.targetDestinationRepository.save({
            destination: destination.destination.split(":")[0],
            token: destination.token,
            port: destination.port,
            url: destination.url
        });
        if (destination.hostcfg_ids) {
            await this.targetDestinationHostcfgRepository.save(destination.hostcfg_ids.map(hostcfg => {
                return {
                    target_destination_id: saved.target_destination_id,
                    hostcfg_id: hostcfg
                };
            }));
        }
        return await this.targetDestinationRepository.findOne({
            relations: {
                _target_destination_hostcfgs: {
                    _hostcfg: true
                }
            },
            where: {
                target_destination_id: saved.target_destination_id
            }
        });
    }
    async updateTargetDestination(target_destination_id, destination) {
        const currentHostcfgs = (await this.targetDestinationHostcfgRepository.findBy({ target_destination_id: target_destination_id })).map((desti) => desti.hostcfg_id);
        if (destination.hostcfg_ids !== null) {
            await this.targetDestinationHostcfgRepository.delete({
                target_destination_id: target_destination_id,
                hostcfg_id: (0, typeorm_2.Not)((0, typeorm_2.In)(currentHostcfgs.filter((desti) => destination.hostcfg_ids.includes(desti))))
            });
        }
        if (destination.hostcfg_ids) {
            await this.targetDestinationHostcfgRepository.save(destination.hostcfg_ids.map(hostcfg => {
                return {
                    hostcfg_id: hostcfg,
                    target_destination_id: target_destination_id
                };
            }));
        }
        return (await this.targetDestinationRepository.save({
            target_destination_id: target_destination_id,
            hostcfg_ids: destination.hostcfg_ids
        }));
    }
    async deleteTargetDestination(target_destination_id) {
        return (await this.targetDestinationRepository.delete(target_destination_id)).affected === 1;
    }
    async getOSAgentStatus(request) {
        let servers = await this.objectItemsRepository.find({
            where: {
                hw_type: (0, typeorm_2.In)(['linux', 'as400', 'windows']),
                subsystem: 'server',
            }, relations: {
                properties: true,
                server_group_items: {
                    _server_group: true
                }
            }
        });
        const user = await User_1.User.getUserByRequest(request);
        let agents = [];
        servers.sort((a, b) => a.label.localeCompare(b.label, undefined, { numeric: true, sensitivity: 'base' }));
        let ids = servers.map(item => item.item_id);
        let lastTimestamps = await (new MetricsWrapper_1.MetricsWrapper([], ids)).getLastTimestampFromTable();
        let idsToDoublecheck = ids.filter(id => Object.keys(lastTimestamps).indexOf(id) === -1);
        if (idsToDoublecheck.length > 0) {
            lastTimestamps = { ...lastTimestamps, ...await (new MetricsWrapper_1.MetricsWrapper([], idsToDoublecheck)).getLastTimestampFromTable('1d') };
        }
        const mappedIds = await (0, Linux_1.getLinuxMappedIds)(true);
        const linuxMapping = await (0, Linux_1.getLinuxMapping)();
        for (const server of servers) {
            let prefix = server.item_id.split('_');
            let agentType = "";
            if (prefix.length > 0 && prefix[0].toLowerCase() === 'linux') {
                agentType = "Linux";
            }
            else if (prefix.length > 0 && prefix[0].toLowerCase() === 'power') {
                agentType = "IBM Power";
            }
            else if (server.hw_type === 'windows') {
                agentType = "Windows / Hyper-V";
            }
            else if (server.hw_type === 'as400') {
                agentType = "IBM i";
            }
            let url = "";
            if (server.server_group_items && server.server_group_items[0]) {
                url = new URL_1.URL().generateFromObject(server, undefined, undefined, user);
            }
            else {
                url = URL_1.URL.generate(server.hw_type, server.subsystem, server.item_id);
            }
            let id = server.item_id;
            if (mappedIds.includes(server.item_id)) {
                const mapping = linuxMapping.find(item => item.agent_id === server.item_id);
                if (mapping) {
                    const objectItem = await this.objectItemsRepository.findOne({ where: { item_id: mapping.item_id } });
                    if (objectItem) {
                        const newURL = URL_1.URL.generate(objectItem.hw_type, objectItem.subsystem, objectItem.item_id);
                        id = objectItem.item_id;
                        url = newURL;
                    }
                }
            }
            const versionProp = server.properties.find(property => property.property_name === 'version');
            const ipAddressProp = server.properties.find(property => property.property_name === 'ip_address');
            let agent = {
                server: server.label,
                agent_type: agentType,
                version: versionProp ? versionProp.property_value : ' ',
                timestamp: lastTimestamps[server.item_id] ? new Date(lastTimestamps[server.item_id]).getTime() / 1000 : null,
                ip_address: ipAddressProp ? ipAddressProp.property_value : ' ',
                url: url,
                uuid: server.item_id,
            };
            agents.push(agent);
        }
        return agents;
    }
};
exports.ConfigurationService = ConfigurationService;
exports.ConfigurationService = ConfigurationService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(itemProperty_entity_1.ItemProperty)),
    __param(1, (0, typeorm_1.InjectRepository)(hostcfg_entity_1.HostCfg)),
    __param(2, (0, typeorm_1.InjectRepository)(hostcfgRelation_entity_1.HostcfgRelation)),
    __param(3, (0, typeorm_1.InjectRepository)(microserviceJobsStatus_entity_1.MicroserviceJobStatus)),
    __param(4, (0, typeorm_1.InjectRepository)(objectItem_entity_1.ObjectItem)),
    __param(5, (0, typeorm_1.InjectRepository)(itemRelation_entity_1.ItemRelation)),
    __param(6, (0, typeorm_1.InjectRepository)(agentMapping_entity_1.AgentMapping)),
    __param(7, (0, typeorm_1.InjectRepository)(storageMapping_entity_1.StorageMapping)),
    __param(8, (0, typeorm_1.InjectRepository)(targetDestination_entity_1.TargetDestination)),
    __param(9, (0, typeorm_1.InjectRepository)(targetDestinationHostcfg_entity_1.TargetDestinationHostcfg)),
    __param(10, (0, typeorm_1.InjectRepository)(storageGroupDevice_entity_1.StorageGroupDevice)),
    __param(11, (0, typeorm_1.InjectRepository)(top_entity_1.Top)),
    __param(12, (0, typeorm_1.InjectRepository)(heatmap_entity_1.Heatmap)),
    __param(13, (0, typeorm_1.InjectRepository)(mailGroup_entity_1.MailGroup)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository])
], ConfigurationService);
//# sourceMappingURL=configuration.service.js.map