"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FabricService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const typeorm_2 = require("typeorm");
const objectItem_entity_1 = require("../../entity/objectItem.entity");
const crypto_1 = require("crypto");
let FabricService = class FabricService {
    constructor(objectItemsRepository) {
        this.objectItemsRepository = objectItemsRepository;
    }
    async getFabric(itemId) {
        return this.objectItemsRepository.findOneBy({ hw_type: 'sanbrcd', subsystem: 'fabric', item_id: itemId });
    }
    async getFabrics() {
        return this.objectItemsRepository.findBy({ hw_type: 'sanbrcd', subsystem: 'fabric' });
    }
    async saveFabric(fabric) {
        const check = await this.objectItemsRepository.findOneBy({
            hw_type: 'sanbrcd',
            subsystem: 'fabric',
            label: fabric.label
        });
        if (check) {
            return check;
        }
        return await this.objectItemsRepository.save({ ...fabric, item_id: (0, crypto_1.createHash)('md5').update(fabric.label).digest("hex") });
    }
    async deleteFabric(itemId) {
        const deleted = await this.objectItemsRepository.delete({
            item_id: itemId
        });
        return deleted.affected >= 1 ? true : false;
    }
};
exports.FabricService = FabricService;
exports.FabricService = FabricService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(objectItem_entity_1.ObjectItem)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], FabricService);
//# sourceMappingURL=fabric.service.js.map