import { HostcfgDefinition, HostCfgDTO } from "@xormon/common/hostCfgResponse.dto";
import { HostCfg } from "@xormon/entity/hostcfg.entity";
import { HostcfgRelation } from "@xormon/entity/hostcfgRelation.entity";
import { Repository } from "typeorm";
import { MicroserviceJobStatus } from "@xormon/entity/microserviceJobsStatus.entity";
import { ObjectItem } from "@xormon/entity/objectItem.entity";
import { FabricService } from "./fabric.service";
import { MenuGroupService } from "./menuGroup.service";
import { MetricsTableService } from "../metrics/metricsTable.service";
import { EventEmitter2 } from "@nestjs/event-emitter";
import { HwTypeKey } from "@xormon/common/constants/hwTypeKey.constants";
export declare class HostCfgService {
    private objectItemRepository;
    private hostCfgRepository;
    private hostCfgRelationsRepository;
    private microservicesJobsStatusRepository;
    private readonly fabricService;
    private readonly menugroupService;
    private readonly metricsTableService;
    private eventEmitter;
    constructor(objectItemRepository: Repository<ObjectItem>, hostCfgRepository: Repository<HostCfg>, hostCfgRelationsRepository: Repository<HostcfgRelation>, microservicesJobsStatusRepository: Repository<MicroserviceJobStatus>, fabricService: FabricService, menugroupService: MenuGroupService, metricsTableService: MetricsTableService, eventEmitter: EventEmitter2);
    getHostCfgData(_class?: string, hw_type?: string): Promise<HostCfg[]>;
    saveHostcfgData(hostcfg: HostCfgDTO, source?: string): Promise<HostCfg & {
        hw_type_label: string;
    }>;
    updateHostcfgData(hostcfg_id: string, hostcfg: HostCfgDTO): Promise<[boolean, Partial<HostCfg>]>;
    updateHostcfgLabel(hostcfgs: HostCfgDTO[]): Promise<(HostCfgDTO & HostCfg)[]>;
    getHostCfg(uuid: string): Promise<HostCfg>;
    getHostCfgs(_class?: string, hwType?: string): Promise<HostCfg[]>;
    getHostsCfg(): Promise<HostCfg[]>;
    getHostCfgByHWType(hw_type?: string): Promise<HostCfg[]>;
    getHostCfgByClass(_class: string): Promise<HostCfg[]>;
    copyPasswords(sourceHostCfg: HostCfg, hostcfg: HostCfgDTO): Promise<HostCfgDTO>;
    findInHostcfgObject(source: {}, obj: {}): {};
    getHostcfgRelations(hostcfg_id: string): Promise<HostcfgRelation[]>;
    saveHostCfg(hostcfg: Partial<HostCfg>): Promise<HostCfg>;
    saveHostcfgRelations(hostcfgRelations: HostcfgRelation[]): Promise<number>;
    updateHostCfg(hostcfg_id: string, hostcfg: Partial<HostCfg>): Promise<[HostCfg, Partial<HostCfg>]>;
    deleteHostCfg(hostcfg: HostCfg): Promise<boolean>;
    disableHostCfgs(hostcfgs: Array<Partial<HostCfg>>): Promise<({
        disabled: boolean;
        hostcfg_id?: string;
        label?: string;
        hw_type_entity?: import("../../entity/hwType.entity").HwType;
        hw_type?: string;
        target?: boolean;
        ignore_health_status?: boolean;
        ignore_health_status_reason?: string;
        data?: any;
        createdAt?: Date;
        updatedAt?: Date;
        relations?: HostcfgRelation[];
        destinations?: import("../../entity/targetDestinationHostcfg.entity").TargetDestinationHostcfg[];
        microserviceVariables?: import("../../entity/microserviceVariables.entity").MicroserviceVariables[];
        status?: import("../../entity/hostcfgStatus.entity").HostcfgStatus;
        _health_status_mirrors?: import("../../entity/healthStatusMirror.entity").HealthStatusMirror[];
    } & HostCfg)[]>;
    renameItem(hostcfgId: string, label: string): Promise<void>;
    getHostcfgDefinition(hwType?: HwTypeKey): HostcfgDefinition | Record<string, HostcfgDefinition>;
    getHostcfgDefinitionByLabel(device?: string): [HostcfgDefinition | Record<string, HostcfgDefinition>, string];
}
