"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MenuGroupService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const objectItem_entity_1 = require("../../entity/objectItem.entity");
const crypto_1 = require("crypto");
const typeorm_2 = require("typeorm");
let MenuGroupService = class MenuGroupService {
    constructor(objectItemsRepository) {
        this.objectItemsRepository = objectItemsRepository;
        this.hw_type = "oracledb";
    }
    async getMenuGroup(itemId) {
        return this.objectItemsRepository.findOneBy({ hw_type: this.hw_type, item_id: itemId });
    }
    async getMenugroups(type) {
        return this.objectItemsRepository.findBy({ hw_type: this.hw_type, subsystem: type });
    }
    async saveMenuGroups(menuGroup) {
        const check = await this.objectItemsRepository.findOneBy({
            hw_type: this.hw_type,
            label: menuGroup.label
        });
        if (check) {
            return check;
        }
        if (menuGroup.item_id) {
            const deleted = await this.objectItemsRepository.delete({ item_id: menuGroup.item_id });
            console.log("deleted", deleted.affected);
        }
        return await this.objectItemsRepository.save({ ...menuGroup, item_id: (0, crypto_1.createHash)('md5').update(menuGroup.label).digest("hex") });
    }
    async deleteMenuGroup(itemId) {
        const deleted = await this.objectItemsRepository.delete({
            item_id: itemId
        });
        return deleted.affected >= 1 ? true : false;
    }
};
exports.MenuGroupService = MenuGroupService;
exports.MenuGroupService = MenuGroupService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(objectItem_entity_1.ObjectItem)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], MenuGroupService);
//# sourceMappingURL=menuGroup.service.js.map