"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MicroserviceVariablesService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const microserviceVariables_entity_1 = require("../../entity/microserviceVariables.entity");
const xormon_exception_1 = require("../../exception/xormon.exception");
const typeorm_2 = require("typeorm");
const Architecture_1 = require("../architecture/Architecture");
const Microservice_1 = require("../microservices/Microservice");
let MicroserviceVariablesService = class MicroserviceVariablesService {
    constructor(microserviceVariablesRepository) {
        this.microserviceVariablesRepository = microserviceVariablesRepository;
    }
    getByTypeOrConfig(hw_type, hostcfg_id) {
        const whereOptions = hw_type ? { hw_type: hw_type } : hostcfg_id ? { hostcfg_id: hostcfg_id } : { hw_type: (0, typeorm_2.IsNull)(), hostcfg_id: (0, typeorm_2.IsNull)() };
        return this.microserviceVariablesRepository.find({
            where: whereOptions
        });
    }
    async createMicroserviceVariable(microserviceVariableDTO) {
        const microserviceVariable = this.microserviceVariablesRepository.create(microserviceVariableDTO);
        return await this.microserviceVariablesRepository.save(microserviceVariable);
    }
    findByKey(where) {
        return this.microserviceVariablesRepository.find({
            where: where
        });
    }
    findById(microservice_variables_id) {
        return this.microserviceVariablesRepository.findOne({ where: { microservice_variables_id: microservice_variables_id } });
    }
    getWhereOptions(microserviceVariableDTO) {
        if (microserviceVariableDTO.hw_type) {
            return {
                hw_type: microserviceVariableDTO.hw_type,
                key: microserviceVariableDTO.key
            };
        }
        else if (microserviceVariableDTO.hostcfg_id) {
            return {
                hostcfg_id: microserviceVariableDTO.hostcfg_id,
                key: microserviceVariableDTO.key
            };
        }
        else {
            return {
                key: microserviceVariableDTO.key,
                hostcfg_id: (0, typeorm_2.IsNull)(),
                hw_type: (0, typeorm_2.IsNull)()
            };
        }
    }
    getWhereOptionsUpdate(microserviceVariableDTO) {
        if (microserviceVariableDTO.hw_type) {
            return {
                hw_type: microserviceVariableDTO.hw_type,
                key: microserviceVariableDTO.key,
                microservice_variables_id: (0, typeorm_2.Not)(microserviceVariableDTO.microservice_variables_id)
            };
        }
        else if (microserviceVariableDTO.hostcfg_id) {
            return {
                hostcfg_id: microserviceVariableDTO.hostcfg_id,
                key: microserviceVariableDTO.key,
                microservice_variables_id: (0, typeorm_2.Not)(microserviceVariableDTO.microservice_variables_id)
            };
        }
        else {
            return {
                key: microserviceVariableDTO.key,
                hostcfg_id: (0, typeorm_2.IsNull)(),
                hw_type: (0, typeorm_2.IsNull)(),
                microservice_variables_id: (0, typeorm_2.Not)(microserviceVariableDTO.microservice_variables_id)
            };
        }
    }
    async checkIfKeyExistsForTypeOrConf(microserviceVariableDTO) {
        const whereOptions = this.getWhereOptions(microserviceVariableDTO);
        const microserviceVariables = await this.findByKey(whereOptions);
        return microserviceVariables && microserviceVariables.length > 0 ? true : false;
    }
    async canUpdateMicroserviceVariable(microserviceVariableDTO, microservice_variables_id) {
        const whereOptions = this.getWhereOptionsUpdate(microserviceVariableDTO);
        const microserviceVariables = await this.findByKey(whereOptions);
        const keyExistsOtherCfgOrType = microserviceVariables.reduce((prevValue, curValue) => {
            return prevValue ? true : (curValue.microservice_variables_id !== microservice_variables_id) ? true : false;
        }, false);
        return !keyExistsOtherCfgOrType;
    }
    async updateMicroserviceVariable(microservice_variables_id, microserviceVariableDTO) {
        microserviceVariableDTO.microservice_variables_id = microservice_variables_id;
        const whereOptions = this.getWhereOptionsUpdate(microserviceVariableDTO);
        const microserviceVariables = await this.findByKey(whereOptions);
        if (microserviceVariables.length > 0) {
            throw new xormon_exception_1.XormonException("key pair already exists", common_1.HttpStatus.BAD_REQUEST);
        }
        const microserviceVariable = await this.microserviceVariablesRepository.save(microserviceVariableDTO);
        if (microserviceVariable.hw_type === "linux" && microserviceVariable.key === "PORT") {
            let microservice = new Microservice_1.Microservice();
            await microservice.init("linux");
            if (microservice.isRegistered()) {
                await microservice.start();
            }
            else {
                throw new xormon_exception_1.XormonException("Service not found", common_1.HttpStatus.NOT_FOUND);
            }
        }
        return microserviceVariable;
    }
    async deleteById(ids) {
        const deleted = await this.microserviceVariablesRepository.delete(ids);
        return deleted.affected >= 1 ? true : false;
    }
    async getByIds(ids) {
        return await this.microserviceVariablesRepository.findBy({ microservice_variables_id: (0, typeorm_2.In)(ids) });
    }
    auditLog() {
        let label = null;
        return async function (variable) {
            if (variable.hw_type) {
                if (!label) {
                    label = (await Architecture_1.Architecture.getHwType(variable.hw_type)).label;
                }
                return `[${label}] key: ${variable.key}, value: ${variable.value}`;
            }
            else if (variable.hostcfg_id) {
                if (!label) {
                    label = await this.hostcfgRepository.findOneBy({ hostcfg_id: variable.hostcfg_id });
                }
                return `[${label})}] key: ${variable.key}, value: ${variable.value}`;
            }
            return `[Global] key: ${variable.key}, value: ${variable.value}`;
        };
    }
};
exports.MicroserviceVariablesService = MicroserviceVariablesService;
exports.MicroserviceVariablesService = MicroserviceVariablesService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(microserviceVariables_entity_1.MicroserviceVariables)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], MicroserviceVariablesService);
//# sourceMappingURL=microserviceVariable.service.js.map