import { IMetric, Item, Property } from "@xormon/common/architecture.dto";
import { ItemGroup as ItemGroupData } from "@xormon/common/customGroup.dto";
import { ItemGroup } from "@xormon/entity/itemGroup.entity";
export declare class ItemGroupWrapper {
    static getItemGroup(item_group_id: string, tool?: 'export' | 'report' | 'alerting' | 'hw_event'): Promise<ItemGroup>;
    static transformItemGroupEntity(itemGroupEntity: ItemGroup): ItemGroupData;
    static saveItemGroup(group: ItemGroupData, oldItemGroupId?: string): Promise<string>;
    static getItems(item_group_id: string, tool?: 'export' | 'report' | 'alerting' | 'hw_event', withArch?: boolean): Promise<Item[]>;
    static getMetrics(item_group_id: string, tool?: 'export' | 'report' | 'alerting'): Promise<IMetric[]>;
    static getItemsByData(group: Partial<ItemGroupData>, subsystem: string, hwType?: string, _class?: string, withProps?: {
        hw_type?: boolean;
        subsystem?: boolean;
    }): Promise<Item[]>;
    static getMetricsByData(group: Partial<ItemGroupData>, subsystem: string, hwType?: string, _class?: string, type?: 'alerting' | 'customGroup' | 'exporter' | 'reporter'): Promise<IMetric[]>;
    static getPropertiesByData(group: Partial<ItemGroupData>, subsystem: string, hwType?: string, _class?: string): Promise<Property[]>;
}
