import { MetricsResponseDTO } from '@xormon/common/architecture.dto';
import { BasicResponseDTO } from '@xormon/common/basicResponse.dto';
import { CreateCustomGroupDTO, CreateCustomGroupFolder, CustomGroupFavoriteResponseDTO, CustomGroupFolderResponseDTO, CustomGroupFoldersResponseDTO, CustomGroupItemDTO, CustomGroupResponseDTO, CustomGroupSearchDTO, CustomGroupsResponseDTO, GroupCustomGroupFoldersDTO, GroupCustomGroupFoldersTreeDTO, UpdateCustomGroupDTO } from '@xormon/common/customGroup.dto';
import { MenuItem, MenuResponseDTO } from '@xormon/common/menuResponse.dto';
import { PageResponseDTO } from '@xormon/common/pageResponse.dto';
import { ArchitectureService } from '@xormon/service/architecture/architecture.service';
import { Request } from 'express';
import { CustomGroupService } from './custom_group.service';
export declare class CustomGroupController {
    private readonly customGroupService;
    private readonly architectureService;
    constructor(customGroupService: CustomGroupService, architectureService: ArchitectureService);
    search(hw_type?: string, subsystem?: string, search?: string, page?: number, limit?: number): Promise<CustomGroupSearchDTO>;
    getFolders(request: Request): Promise<CustomGroupFoldersResponseDTO>;
    getGrouoFolders(request: Request): Promise<GroupCustomGroupFoldersTreeDTO>;
    saveFolder(request: Request, custom_group_folder: CreateCustomGroupFolder): Promise<CustomGroupFolderResponseDTO>;
    getFolder(request: Request, custom_group_folder_id: string): Promise<CustomGroupFolderResponseDTO>;
    updateFolder(request: Request, custom_group_folder_id: string, custom_group_folder: CreateCustomGroupFolder): Promise<BasicResponseDTO>;
    deleteFolder(request: Request, custom_group_folder_id: string): Promise<BasicResponseDTO>;
    getCustomGroups(request: Request): Promise<CustomGroupsResponseDTO>;
    saveCustomGroups(request: Request, custom_group: CreateCustomGroupDTO): Promise<CustomGroupResponseDTO>;
    getCustomGroup(request: Request, custom_group_id: string): Promise<CustomGroupResponseDTO>;
    updateCustomGroups(request: Request, custom_group_id: string, custom_group: UpdateCustomGroupDTO): Promise<BasicResponseDTO>;
    deleteCustomGroups(request: Request, custom_group_id: string): Promise<BasicResponseDTO>;
    getCustomGroupMetrics(request: Request, custom_group_id: string): Promise<MetricsResponseDTO>;
    getCustomGroupItems(request: Request, custom_group_id: string, withParents?: boolean): Promise<CustomGroupItemDTO>;
    getCustomGroupFavorite(request: Request, custom_group_id: string): Promise<CustomGroupFavoriteResponseDTO>;
    setCustomGroupFavorite(request: Request, custom_group_id: string): Promise<BasicResponseDTO>;
    deleteCustomGroupFavorite(request: Request, custom_group_id: string): Promise<BasicResponseDTO>;
    getCustomGroupsMenu(request: Request): Promise<MenuResponseDTO>;
    getGroupsMenu(request: Request): Promise<GroupCustomGroupFoldersDTO>;
    getCustomGroupMenu(request: Request, custom_group_id: string): Promise<PageResponseDTO>;
    getCustomGroupDashboard(request: Request, custom_group_id: string): Promise<PageResponseDTO>;
    getCustomGroupFolderMenu(request: Request, custom_group_folder_id: string): Promise<MenuResponseDTO>;
    getPath(request: Request, custom_group_id: string): Promise<MenuResponseDTO>;
    findCustomGroup(request: Request, menuItems: MenuItem[], parents: string[]): Promise<MenuItem[]>;
    getCustomGroupDashboardFolder(request: Request): Promise<MenuResponseDTO>;
}
