"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HealthStatusController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const healthStatus_dto_1 = require("../../common/healthStatus.dto");
const healthStatus_entity_1 = require("../../entity/healthStatus.entity");
const healthStatus_service_1 = require("./healthStatus.service");
const healthStatus_interceptor_1 = require("../../interceptor/healthStatus.interceptor");
const User_1 = require("../users/User");
let HealthStatusController = class HealthStatusController {
    constructor(healthStatusService) {
        this.healthStatusService = healthStatusService;
    }
    async getHealthStatusCount(request) {
        const user = await User_1.User.getUserByRequest(request, true);
        const groupIds = user ? user.groups.map(group => group.group_id) : [];
        let hostcfgs = await this.healthStatusService.getHostsCfg(undefined);
        let hsSever = [];
        let count = new healthStatus_dto_1.Count;
        count.data = 0;
        count.connection = 0;
        let healthStatusHostCfg = await this.healthStatusService.getDeviceHS(hostcfgs, undefined, groupIds);
        let nStatus = { ...healthStatus_entity_1.Status };
        nStatus["IGNORED"] = [];
        for (const health of healthStatusHostCfg) {
            if (!health.status) {
                continue;
            }
            count.data += health.data === 1 ? 1 : 0;
            count.connection += health.connection === 1 ? 1 : 0;
            let upperStatus = health.status.toString().toUpperCase();
            if (health.ignored) {
                upperStatus = "IGNORED";
            }
            if (upperStatus in nStatus) {
                if (!Array.isArray(nStatus[upperStatus])) {
                    nStatus[upperStatus] = [];
                }
                nStatus[upperStatus].push(health);
            }
        }
        for (const stat in nStatus) {
            let cleanArray = [];
            if (!Array.isArray(nStatus[stat])) {
                nStatus[stat] = cleanArray;
            }
            count[stat.toLowerCase()] = nStatus[stat].length;
        }
        count["bell"] = count.error;
        return {
            statusCode: common_1.HttpStatus.OK,
            data: count,
        };
    }
    async getHealthStatusHostsCfg() {
        let hostcfgs = await this.healthStatusService.getHostsCfg(undefined);
        let hsSever = [];
        let healthStatusHostCfg = await this.healthStatusService.getDeviceHS(hostcfgs, undefined);
        let nStatus = { ...healthStatus_entity_1.Status };
        nStatus["IGNORED"] = [];
        for (const health of healthStatusHostCfg) {
            if (!health.status) {
                continue;
            }
            delete health.data;
            delete health.connection;
            let upperStatus = health.status.toString().toUpperCase();
            if (health.ignored) {
                upperStatus = "IGNORED";
            }
            if (upperStatus in nStatus) {
                if (!Array.isArray(nStatus[upperStatus])) {
                    nStatus[upperStatus] = [];
                }
                nStatus[upperStatus].push(health);
            }
        }
        for (const stat in nStatus) {
            let cleanArray = [];
            if (!Array.isArray(nStatus[stat])) {
                nStatus[stat] = cleanArray;
            }
            cleanArray = nStatus[stat].sort((a, b) => (a.updatedAt > b.updatedAt ? -1 : 1));
            hsSever.push({ status: stat, count: cleanArray.length, devices: cleanArray });
        }
        return {
            statusCode: common_1.HttpStatus.OK,
            data: hsSever,
        };
    }
    async getHealthStatusSpecificSeverity(severity) {
        severity = severity.toUpperCase();
        let ignored = undefined;
        if (severity === "IGNORED") {
            ignored = true;
        }
        let hostcfgs = await this.healthStatusService.getHostsCfg(ignored);
        let hsSever = [];
        let healthStatusHostCfg = await this.healthStatusService.getDeviceHS(hostcfgs, ignored === undefined ? healthStatus_entity_1.Status[severity] : undefined);
        let nStatus = [];
        for (const health of healthStatusHostCfg) {
            if (!health.status) {
                continue;
            }
            delete health.data;
            delete health.connection;
            let upperStatus = health.status.toString().toUpperCase();
            if (health.ignored) {
                upperStatus = "IGNORED";
            }
            if (upperStatus === severity) {
                nStatus.push(health);
            }
        }
        nStatus = nStatus.sort((a, b) => (a.updatedAt > b.updatedAt ? -1 : 1));
        hsSever.push({ status: severity, count: nStatus.length, devices: nStatus });
        return {
            statusCode: common_1.HttpStatus.OK,
            data: hsSever,
        };
    }
    async getDataStatus(request, type) {
        const name = (type === "data" || type === "connection") ? type.charAt(0).toUpperCase() + type.slice(1) : type;
        let wholeStatus = {
            name: name,
            count: 0,
            devices: []
        };
        if (name !== "Data" && name !== "Connection") {
            return {
                statusCode: common_1.HttpStatus.BAD_REQUEST,
                message: "Unknown parameter",
                error: "Unknown parameter",
                data: wholeStatus,
            };
        }
        const hostcfgs = await this.healthStatusService.getHostCfgStatus(false);
        for (const hostcfg_entity of hostcfgs) {
            const entityStatus = this.healthStatusService.getStatus(hostcfg_entity, type);
            wholeStatus.count += entityStatus.status === healthStatus_entity_1.Status.ERROR ? 1 : 0;
            wholeStatus.devices.push(entityStatus);
        }
        return {
            statusCode: common_1.HttpStatus.OK,
            data: wholeStatus,
        };
    }
};
exports.HealthStatusController = HealthStatusController;
__decorate([
    (0, common_1.Get)('v1/count'),
    openapi.ApiResponse({ status: 200, type: require("../../common/healthStatus.dto").CountDTO }),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], HealthStatusController.prototype, "getHealthStatusCount", null);
__decorate([
    (0, common_1.Get)('v1/health/severity'),
    (0, common_1.UseInterceptors)(healthStatus_interceptor_1.HealthStatusInterceptor),
    openapi.ApiResponse({ status: 200, type: require("../../common/healthStatus.dto").HealthStatusSeverityDTO }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], HealthStatusController.prototype, "getHealthStatusHostsCfg", null);
__decorate([
    openapi.ApiOperation({ description: "/* /** returns health status by hostcfg" }),
    (0, common_1.Get)('v1/health/severity/:severity'),
    (0, common_1.UseInterceptors)(healthStatus_interceptor_1.HealthStatusInterceptor),
    openapi.ApiResponse({ status: 200, type: require("../../common/healthStatus.dto").HealthStatusSeverityDTO }),
    __param(0, (0, common_1.Param)('severity')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], HealthStatusController.prototype, "getHealthStatusSpecificSeverity", null);
__decorate([
    (0, common_1.Get)('v1/status/:type'),
    (0, common_1.UseInterceptors)(healthStatus_interceptor_1.HealthStatusInterceptor),
    openapi.ApiResponse({ status: 200, type: require("../../common/healthStatus.dto").HostcfgStatusDTO }),
    __param(0, (0, common_1.Req)()),
    __param(1, (0, common_1.Param)('type')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", Promise)
], HealthStatusController.prototype, "getDataStatus", null);
exports.HealthStatusController = HealthStatusController = __decorate([
    (0, swagger_1.ApiTags)('Global Status'),
    (0, swagger_1.ApiBearerAuth)(),
    (0, common_1.Controller)('api/global_status'),
    __metadata("design:paramtypes", [healthStatus_service_1.HealthStatusService])
], HealthStatusController);
//# sourceMappingURL=globalStatus.controller.js.map