"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HealthStatusMirrorController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const xormon_exception_1 = require("../../exception/xormon.exception");
const healtStatusMirror_service_1 = require("./healtStatusMirror.service");
let HealthStatusMirrorController = class HealthStatusMirrorController {
    constructor(healthStatusMirrorService) {
        this.healthStatusMirrorService = healthStatusMirrorService;
    }
    async getMirror() {
        try {
            const mirror = await this.healthStatusMirrorService.getMirrors();
            return {
                statusCode: common_1.HttpStatus.OK,
                message: "Successfuly fetched health status mirror",
                data: mirror
            };
        }
        catch (error) {
            console.error(error);
            throw new xormon_exception_1.XormonException(error, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
};
exports.HealthStatusMirrorController = HealthStatusMirrorController;
__decorate([
    (0, common_1.Get)("v1/mirrors"),
    openapi.ApiResponse({ status: 200, type: require("../../common/healthStatusMirror.dto").HealthStatusMirrorsDTOResponse }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], HealthStatusMirrorController.prototype, "getMirror", null);
exports.HealthStatusMirrorController = HealthStatusMirrorController = __decorate([
    (0, swagger_1.ApiTags)('Health Status Mirror'),
    (0, swagger_1.ApiBearerAuth)(),
    (0, common_1.Controller)('api/health_status_mirror'),
    __metadata("design:paramtypes", [healtStatusMirror_service_1.HealthStatusMirrorService])
], HealthStatusMirrorController);
//# sourceMappingURL=healthStatusMirror.controller.js.map