/// <reference types="node" />
import { HostCfg } from "../../entity/hostcfg.entity";
import { Repository } from "typeorm";
import * as rl from "readline";
import { MetricsTableService } from "../metrics/metricsTable.service";
import { ImportAuth, ImportResult } from "@xormon/common/import.dto";
export declare class DeviceImporter {
    metricsTableService: MetricsTableService;
    hwTypes: Array<string>;
    hostCfgRepository: Repository<HostCfg>;
    lparType: ImportAuth;
    storType: ImportAuth;
    doStor: boolean;
    doLpar: boolean;
    decoder: ConfigurationDownloadDecoder;
    unsupportedDevices?: HostCfg[];
    alreadyExistingConfiguration?: HostCfg[];
    insertedDevices?: HostCfg[];
    devicesToSave: HostCfg[];
    init(metricsTableService: MetricsTableService): Promise<void>;
    private logInformation;
    private importByType;
    private parseByType;
    private goThroughAliases;
    private transformByHwType;
    private importRemoteDevices;
    startFromREST(lparAuth: ImportAuth, storAuth: ImportAuth): Promise<ImportResult>;
    gatherAuth(type: "stor" | "lpar", rl: rl.Interface): Promise<ImportAuth>;
    gatherInformation(): Promise<void>;
}
declare class ConfigurationDownloadDecoder {
    private url;
    private username;
    private password;
    private passphrase;
    private type;
    private fileName;
    static TMP_PATH: string;
    private decodedFilePath;
    private encodedFilePath;
    private proto;
    private fileType;
    constructor(url: string, username: string, password: string, passphrase: string, type: string, fileName: string);
    private sanitize;
    private isUrlHttp;
    private parseUrl;
    private get;
    private httpsOrHttp;
    private downloadFile;
    cleanUp(): Promise<void>;
    decodeFile(): Promise<any>;
}
export {};
