"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LdapCertService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const ldapCertificate_entity_1 = require("../../entity/ldapCertificate.entity");
const fs = require("fs");
const typeorm_2 = require("typeorm");
const uuid_1 = require("uuid");
const App_1 = require("../configuration/App");
const ldap_service_1 = require("./ldap.service");
let LdapCertService = class LdapCertService {
    constructor(ldapCertificateRepository) {
        this.ldapCertificateRepository = ldapCertificateRepository;
    }
    onModuleInit() {
        if (!fs.existsSync(App_1.App.LDAP_CERT_FILES_PATH)) {
            fs.mkdirSync(App_1.App.LDAP_CERT_FILES_PATH);
        }
    }
    async saveLdapCertificate(data, fileName) {
        const uuid = (0, uuid_1.v4)();
        try {
            const filePath = this.createLdapCertificatePath(fileName);
            fs.writeFileSync(filePath, data);
            await this.ldapCertificateRepository.save({
                ldap_certificate_id: uuid,
                path: filePath
            });
        }
        catch (e) {
            ldap_service_1.LdapService.logger.error(`[saveLdapCertificate] Error: ${e}`);
            return false;
        }
        return true;
    }
    createLdapCertificatePath(fileName) {
        return `${App_1.App.LDAP_CERT_FILES_PATH}/${fileName}`;
    }
    async checkLdapCertificatePath(path) {
        return (await this.ldapCertificateRepository.findOneBy({ path: path })) !== null;
    }
    async getLdapCertificate(ldapCertificateId) {
        return await this.ldapCertificateRepository.findOneBy({
            ldap_certificate_id: ldapCertificateId
        });
    }
    async getLdapCertificates() {
        return await this.ldapCertificateRepository.find();
    }
    async deleteLdapCertificates(ldapCertificateId) {
        return (await this.ldapCertificateRepository.delete({
            ldap_certificate_id: ldapCertificateId
        })).affected == 1;
    }
};
exports.LdapCertService = LdapCertService;
exports.LdapCertService = LdapCertService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(ldapCertificate_entity_1.LdapCertificate)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], LdapCertService);
//# sourceMappingURL=ldap.cert.service.js.map