import { StreamableFile } from '@nestjs/common';
import { BasicResponseDTO, TextResponseDTO } from '@xormon/common/basicResponse.dto';
import { LogRequest, LogsResponseDTO, UILog } from '@xormon/common/log.dto';
import { LogService } from './log.service';
import { Response } from 'express';
import { Request } from 'express';
export declare class LogController {
    private readonly logService;
    constructor(logService: LogService);
    list(): Promise<LogsResponseDTO>;
    genLogs(res: Response, logRequest: LogRequest): Promise<StreamableFile>;
    backendLogs(query: any): Promise<TextResponseDTO>;
    alertingLogs(query: any): Promise<TextResponseDTO>;
    getLogs(file: string, query: any): Promise<TextResponseDTO>;
    microserviceLogs(microservice: string, query: any): Promise<TextResponseDTO>;
    logUI(request: Request, log: UILog): Promise<BasicResponseDTO>;
}
