import { MenuItem, Newable } from "@xormon/common/menuResponse.dto";
import { Page } from "@xormon/common/pageResponse.dto";
import { HostCfg } from "@xormon/entity/hostcfg.entity";
import { ItemProperty } from "@xormon/entity/itemProperty.entity";
import { ItemRelation } from "@xormon/entity/itemRelation.entity";
import { ObjectItem } from "@xormon/entity/objectItem.entity";
import { Request } from 'express';
export declare class AbstractFolder {
    hwType: string;
    children?: Array<MenuItem>;
    subsystem: string;
    itemId: string;
    request?: Request;
    subRootFolders: Newable<AbstractFolder>[];
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
    constructor(itemId?: string, request?: Request);
    setItemId(itemId: string): void;
    setRequest(request: Request): void;
    getPath(parentIds: string[]): Promise<Array<MenuItem>>;
    getChildren(request?: Request, useFirst?: boolean): Promise<Array<MenuItem>>;
}
export declare class StorAbstractFolder extends AbstractFolder {
    hostCfgRepository: import("typeorm").Repository<HostCfg>;
    constructor(hwType: string, subsystem?: string, itemId?: string, request?: Request);
    getPath(parentIds: string[]): Promise<Array<MenuItem>>;
}
export declare class AbstractPage {
    itemId: string;
    request: Request;
    hwType: string;
    page: Page;
    withItemId: boolean;
    rootFolder: Newable<AbstractFolder>;
    constructor(itemId: string, request: Request);
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
    itemPropertiesRepository: import("typeorm").Repository<ItemProperty>;
    getPath(): Promise<MenuItem[]>;
}
export declare class StorAbstractPage extends AbstractPage {
    type: string;
    withItemId: boolean;
    rootFolder: Newable<StorAbstractFolder>;
    constructor(hwType: string, type?: string, itemId?: string, request?: Request);
    hostCfgRepository: import("typeorm").Repository<HostCfg>;
    getPath(): Promise<MenuItem[]>;
}
export declare class UniversalGroupAbstractPage extends AbstractPage {
    rootFolder: Newable<StorUniversalGroupAbstractFolder>;
    groupId: string;
    getPath(): Promise<MenuItem[]>;
}
export declare class UniversalGroupStorAbstractPage extends StorAbstractPage {
    rootFolder: Newable<StorUniversalGroupAbstractFolder>;
    groupId: string;
    getPath(): Promise<MenuItem[]>;
}
export declare class StorUniversalGroupAbstractFolder extends StorAbstractFolder {
    getPath(parentIds: string[], useFirst?: boolean): Promise<Array<MenuItem>>;
}
export declare class UniversalGroupAbstractFolder extends AbstractFolder {
    getPath(parentIds: string[], useFirst?: boolean): Promise<Array<MenuItem>>;
}
