import { Newable } from '@xormon/common/menuResponse.dto';
import { ChartType, Page } from '@xormon/common/pageResponse.dto';
import { AbstractFolder, AbstractPage } from "./AbstractMenu";
export declare class AwsFolder extends AbstractFolder {
    hwType: string;
}
export declare class AwsSubsystemFolder extends AwsFolder {
    subsystem: string;
    itemId: string;
    constructor(itemId?: string);
}
export declare class AwsRootFolder extends AwsFolder {
    getChildren(): Promise<any[]>;
}
export declare class AwsRegionFolder extends AwsSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class AwsEc2Folder extends AwsSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class AwsEbsFolder extends AwsSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class AwsLambdaFolder extends AwsSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class AwsPage extends AbstractPage {
    hwType: string;
    rootFolder: Newable<AbstractFolder>;
}
export declare abstract class AwsItemPage extends AwsPage {
    subsystem: string;
}
export declare class AwsEc2Page extends AwsItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class AwsEbsPage extends AwsItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class AwsLambdaPage extends AwsItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class AwsEc2totalPage extends AwsItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class AwsEbstotalPage extends AwsItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class AwsLambdatotalPage extends AwsItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class AwsHeatmapPage extends AwsPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class AwsTopPage extends AwsPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class AwsConfigurationPage extends AwsPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class AwsMetrics {
    static Metric: {
        new (subsystem: string, metric: string): {
            getGraph(type: ChartType, stacked?: boolean, order?: number, color?: string): any;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
}
