import { Newable } from '@xormon/common/menuResponse.dto';
import { ChartType, Page } from '@xormon/common/pageResponse.dto';
import { AbstractFolder, AbstractPage } from './AbstractMenu';
export declare class Db2Folder extends AbstractFolder {
    hwType: string;
}
export declare class Db2SubsystemFolder extends Db2Folder {
    subsystem: string;
    itemId: string;
    constructor(itemId?: string);
}
export declare class Db2RootFolder extends Db2Folder {
    getChildren(): Promise<any[]>;
}
export declare class Db2DbfolderFolder extends Db2SubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class Db2ChildSubsystemFolder extends Db2SubsystemFolder {
    subsystem: string;
    itemId: string;
    getChildren(): Promise<any[]>;
}
export declare class Db2ChildSubsystemItemsFolder extends Db2ChildSubsystemFolder {
    subsystem: string;
    itemId: string;
    getChildren(): Promise<any[]>;
}
export declare class Db2MembersFolder extends Db2SubsystemFolder {
    subsystem: string;
    itemId: string;
    getChildren(): Promise<any[]>;
}
export declare class Db2MemberFolder extends Db2SubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class Db2Page extends AbstractPage {
    hwType: string;
    rootFolder: Newable<AbstractFolder>;
}
export declare class Db2TotalsPage extends Db2Page {
    withItemId: boolean;
}
export declare abstract class Db2SingleItemPage extends Db2Page {
    subsystem: string;
    parentSubsystem: string;
    parentId: string;
    withItemId: boolean;
}
export declare class Db2OverviewPage extends Db2SingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class Db2ConfigurationPage extends Db2SingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class Db2HealthstatusPage extends Db2Page {
    title: string;
    getPage(): Promise<Page>;
}
export declare class Db2CapacityPage extends Db2SingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<void>;
}
export declare class Db2TopPage extends Db2Page {
    title: string;
    getPage(): Promise<Page>;
}
export declare class Db2AgentsPage extends Db2SingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class Db2LocksPage extends Db2SingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class Db2IoPage extends Db2SingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class Db2LatencyPage extends Db2SingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class Db2RowsPage extends Db2SingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class Db2NetworkPage extends Db2SingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class Db2SqlqueryPage extends Db2SingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class Db2WaitsPage extends Db2SingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class Db2SessionPage extends Db2SingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class Db2RatioPage extends Db2SingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class Db2BufferpoolsFolder extends Db2SubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class Db2BufferpoolPage extends Db2SingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class Db2Metrics {
    static Metric: {
        new (): {
            subsystem: string;
            init(): Promise<any>;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static BasicDbMetric: {
        new (metric: string, type: ChartType, subsystem: string, stacked: boolean, order: number, color?: string): {
            metric: string;
            type: ChartType;
            subsystem: string;
            stacked: boolean;
            order: number;
            color?: string;
            init(): Promise<any>;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
}
export declare abstract class Db2IototalPage extends Db2IoPage {
    subsystem: string;
    total: boolean;
}
export declare abstract class Db2AgentstotalPage extends Db2AgentsPage {
    subsystem: string;
    total: boolean;
}
export declare abstract class Db2LockstotalPage extends Db2LocksPage {
    subsystem: string;
    total: boolean;
}
export declare abstract class Db2LatencytotalPage extends Db2LatencyPage {
    subsystem: string;
    total: boolean;
}
export declare abstract class Db2RowstotalPage extends Db2RowsPage {
    subsystem: string;
    total: boolean;
}
export declare abstract class Db2SessiontotalPage extends Db2SessionPage {
    subsystem: string;
    total: boolean;
}
export declare abstract class Db2SqlquerytotalPage extends Db2SqlqueryPage {
    subsystem: string;
    total: boolean;
}
export declare abstract class Db2NetworktotalPage extends Db2NetworkPage {
    subsystem: string;
    total: boolean;
}
export declare abstract class Db2RatiototalPage extends Db2RatioPage {
    subsystem: string;
    total: boolean;
}
export declare abstract class Db2WaitstotalPage extends Db2WaitsPage {
    subsystem: string;
    total: boolean;
}
