"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Db2WaitstotalPage = exports.Db2RatiototalPage = exports.Db2NetworktotalPage = exports.Db2SqlquerytotalPage = exports.Db2SessiontotalPage = exports.Db2RowstotalPage = exports.Db2LatencytotalPage = exports.Db2LockstotalPage = exports.Db2AgentstotalPage = exports.Db2IototalPage = exports.Db2Metrics = exports.Db2BufferpoolPage = exports.Db2BufferpoolsFolder = exports.Db2RatioPage = exports.Db2SessionPage = exports.Db2WaitsPage = exports.Db2SqlqueryPage = exports.Db2NetworkPage = exports.Db2RowsPage = exports.Db2LatencyPage = exports.Db2IoPage = exports.Db2LocksPage = exports.Db2AgentsPage = exports.Db2TopPage = exports.Db2CapacityPage = exports.Db2HealthstatusPage = exports.Db2ConfigurationPage = exports.Db2OverviewPage = exports.Db2SingleItemPage = exports.Db2TotalsPage = exports.Db2Page = exports.Db2MemberFolder = exports.Db2MembersFolder = exports.Db2ChildSubsystemItemsFolder = exports.Db2ChildSubsystemFolder = exports.Db2DbfolderFolder = exports.Db2RootFolder = exports.Db2SubsystemFolder = exports.Db2Folder = void 0;
const pageResponse_constants_1 = require("../../../common/constants/pageResponse.constants");
const menuResponse_dto_1 = require("../../../common/menuResponse.dto");
const pageResponse_dto_1 = require("../../../common/pageResponse.dto");
const dataSource_1 = require("../../../config/dataSource");
const itemProperty_entity_1 = require("../../../entity/itemProperty.entity");
const itemRelation_entity_1 = require("../../../entity/itemRelation.entity");
const objectItem_entity_1 = require("../../../entity/objectItem.entity");
const hwTypeKey_constants_1 = require("../../../common/constants/hwTypeKey.constants");
const class_constants_1 = require("../../../common/constants/class.constants");
const Metric_1 = require("../../metrics/Metric");
const typeorm_1 = require("typeorm");
const HealthStatus_1 = require("./HealthStatus");
const Table_1 = require("./Table");
const Top_1 = require("./Top");
const AbstractMenu_1 = require("./AbstractMenu");
const Color_1 = require("../../metrics/Color");
const TabFactory_1 = require("./TabFactory");
class Db2Folder extends AbstractMenu_1.AbstractFolder {
    constructor() {
        super(...arguments);
        this.hwType = hwTypeKey_constants_1.HwTypeKey.DB2;
    }
}
exports.Db2Folder = Db2Folder;
class Db2SubsystemFolder extends Db2Folder {
    constructor(itemId) {
        super();
        if (itemId !== null) {
            this.itemId = itemId;
        }
    }
}
exports.Db2SubsystemFolder = Db2SubsystemFolder;
class Db2RootFolder extends Db2Folder {
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('Health Status', this.hwType + '/health-status', 'health-status'));
        menuItems.push(new menuResponse_dto_1.MenuLink('DB TOP', this.hwType + '/top', 'top'));
        let subsystem_server = 'dbfolder';
        let servers = await this.objectItemsRepository.findBy({
            hw_type: this.hwType,
            subsystem: subsystem_server,
        });
        servers.sort((a, b) => a.label.localeCompare(b.label, undefined, { numeric: true, sensitivity: 'base' }));
        for (let item of servers) {
            let path = this.hwType + '/' + subsystem_server + '?ids=' + item.item_id;
            menuItems.push(new menuResponse_dto_1.MenuFolder(item.label, path, this.hwType, subsystem_server, item.item_id, Db2DbfolderFolder));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.Db2RootFolder = Db2RootFolder;
class Db2DbfolderFolder extends Db2SubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
    }
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('Overview', this.hwType + '/overview?item_id=' + this.itemId, 'overview'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Configuration', this.hwType + '/configuration?item_id=' + this.itemId, 'configuration'));
        menuItems.push(new menuResponse_dto_1.MenuLink('IO', this.hwType + '/iototal?item_id=' + this.itemId, 'io'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Latency', this.hwType + '/latencytotal?item_id=' + this.itemId, 'latency'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Rows', this.hwType + '/rowstotal?item_id=' + this.itemId, 'rows'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Session', this.hwType + '/sessiontotal?item_id=' + this.itemId, 'session'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Network', this.hwType + '/networktotal?item_id=' + this.itemId, 'network'));
        menuItems.push(new menuResponse_dto_1.MenuLink('SQL query', this.hwType + '/sql-querytotal?item_id=' + this.itemId, 'sql-query'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Waits', this.hwType + '/waitstotal?item_id=' + this.itemId, 'waits'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Agents', this.hwType + '/agentstotal?item_id=' + this.itemId, 'agents'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Locks', this.hwType + '/lockstotal?item_id=' + this.itemId, 'locks'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Ratio', this.hwType + '/ratiototal?item_id=' + this.itemId, 'ratio'));
        let subsystems = [{
                subsystem: "Member",
                folder: Db2MembersFolder
            }, {
                subsystem: "Bufferpool",
                folder: Db2BufferpoolsFolder
            }];
        for (let childSubsystem of subsystems) {
            let childSubsystemItems = await this.objectItemsRepository.findBy({
                hw_type: this.hwType,
                subsystem: childSubsystem.subsystem,
            });
            if (childSubsystemItems !== null) {
                let path = this.hwType + '/' + childSubsystem.subsystem + 's' + (this.itemId !== null ? '?ids=' + this.itemId : '');
                menuItems.push(new menuResponse_dto_1.MenuFolder(childSubsystem.subsystem + 's', path, this.hwType, childSubsystem.subsystem.toLowerCase(), this.itemId, childSubsystem.folder));
            }
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.Db2DbfolderFolder = Db2DbfolderFolder;
class Db2ChildSubsystemFolder extends Db2SubsystemFolder {
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('Total', this.hwType + '/server-' + this.subsystem + '-totals?item_id=' + this.itemId, 'server-' + this.subsystem + '-totals'));
        let path = this.hwType + '/' + this.subsystem.toLowerCase() + 'items' + (this.itemId !== null ? '?ids=' + this.itemId : '');
        menuItems.push(new menuResponse_dto_1.MenuFolder('Items', path, this.hwType, this.subsystem.toLowerCase()));
        this.children = menuItems;
        return menuItems;
    }
}
exports.Db2ChildSubsystemFolder = Db2ChildSubsystemFolder;
class Db2ChildSubsystemItemsFolder extends Db2ChildSubsystemFolder {
    async getChildren() {
        let menuItems = [];
        let items = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: this.subsystem,
                parents: {
                    parent: this.itemId.toString()
                }
            },
            relations: {
                parents: true
            }
        });
        for (let item of items.sort((a, b) => (a.label.localeCompare(b.label) < b.label.localeCompare(a.label) ? -1 : 1))) {
            let path = this.hwType + '/' + this.subsystem + '?item_id=' + item.item_id;
            menuItems.push(new menuResponse_dto_1.MenuLink(item.label, path, this.subsystem, item.item_id));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.Db2ChildSubsystemItemsFolder = Db2ChildSubsystemItemsFolder;
class Db2MembersFolder extends Db2SubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
    }
    async getChildren() {
        let menuItems = [];
        let items = await this.objectItemsRepository.findBy({ hw_type: this.hwType, subsystem: this.subsystem });
        if (this.itemId) {
            let parentChildren = await this.itemRelationsRepository.find({ where: { parent: this.itemId.toString() } });
            let childrenIds = parentChildren.map((relation) => relation.child);
            for (let item of items) {
                if (childrenIds.includes(item.item_id)) {
                    let path = this.hwType + '/' + this.subsystem + '?ids=' + item.item_id;
                    menuItems.push(new menuResponse_dto_1.MenuFolder(item.label, path, this.hwType, this.subsystem, item.item_id, Db2MemberFolder));
                }
            }
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.Db2MembersFolder = Db2MembersFolder;
class Db2MemberFolder extends Db2SubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
    }
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('IO', this.hwType + '/io?item_id=' + this.itemId, 'io'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Latency', this.hwType + '/latency?item_id=' + this.itemId, 'latency'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Rows', this.hwType + '/rows?item_id=' + this.itemId, 'rows'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Session', this.hwType + '/session?item_id=' + this.itemId, 'session'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Network', this.hwType + '/network?item_id=' + this.itemId, 'network'));
        menuItems.push(new menuResponse_dto_1.MenuLink('SQL query', this.hwType + '/sql-query?item_id=' + this.itemId, 'sql-query'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Waits', this.hwType + '/waits?item_id=' + this.itemId, 'waits'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Agents', this.hwType + '/agents?item_id=' + this.itemId, 'agents'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Locks', this.hwType + '/locks?item_id=' + this.itemId, 'locks'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Ratio', this.hwType + '/ratio?item_id=' + this.itemId, 'ratio'));
        this.children = menuItems;
        return menuItems;
    }
}
exports.Db2MemberFolder = Db2MemberFolder;
class Db2Page extends AbstractMenu_1.AbstractPage {
    constructor() {
        super(...arguments);
        this.hwType = hwTypeKey_constants_1.HwTypeKey.DB2;
        this.rootFolder = Db2RootFolder;
    }
}
exports.Db2Page = Db2Page;
class Db2TotalsPage extends Db2Page {
    constructor() {
        super(...arguments);
        this.withItemId = true;
    }
}
exports.Db2TotalsPage = Db2TotalsPage;
class Db2SingleItemPage extends Db2Page {
    constructor() {
        super(...arguments);
        this.parentSubsystem = 'dbfolder';
        this.withItemId = true;
    }
}
exports.Db2SingleItemPage = Db2SingleItemPage;
class Db2OverviewPage extends Db2SingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.title = 'Overview';
    }
    async getPage() {
        let title = 'Overview';
        let tabs = [];
        let uuids = await getMembers(this.subsystem, this.hwType, this.itemId);
        ;
        if (uuids === undefined) {
            uuids[0] = this.itemId;
        }
        tabs.push({
            title: 'Overview',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.MultiGraphBox,
                    graphs: [
                        {
                            metrics: [
                                await new Db2Metrics.BasicDbMetric('CONNECTIONSTOP', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init(),
                                await new Db2Metrics.BasicDbMetric('TOTALCONS', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init(),
                                await new Db2Metrics.BasicDbMetric('APPLSCURCONS', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init()
                            ],
                            uuids: uuids,
                            interval: pageResponse_constants_1.GRAPH_INTERVAL.day,
                            aggregated: true,
                        },
                        {
                            type: pageResponse_constants_1.BOX_TYPE.MultiGraphBox,
                            metrics: [
                                await new Db2Metrics.BasicDbMetric('AGENTSTOP', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init(),
                                await new Db2Metrics.BasicDbMetric('NUMASSOCAGENTS', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init(),
                                await new Db2Metrics.BasicDbMetric('NUMPOOLEDAGENTS', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init()
                            ],
                            uuids: uuids,
                            interval: pageResponse_constants_1.GRAPH_INTERVAL.day,
                            aggregated: true,
                        },
                        {
                            type: pageResponse_constants_1.BOX_TYPE.MultiGraphBox,
                            metrics: [
                                await new Db2Metrics.BasicDbMetric('DIRECTREADS', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init(),
                                await new Db2Metrics.BasicDbMetric('LOGICALREADS', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init(),
                                await new Db2Metrics.BasicDbMetric('PHYSICALREADS', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init()
                            ],
                            uuids: uuids,
                            interval: pageResponse_constants_1.GRAPH_INTERVAL.day,
                            aggregated: true,
                        },
                        {
                            type: pageResponse_constants_1.BOX_TYPE.MultiGraphBox,
                            metrics: [
                                await new Db2Metrics.BasicDbMetric('DIRECTWRITES', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init(),
                                await new Db2Metrics.BasicDbMetric('WRITES', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init()
                            ],
                            uuids: uuids,
                            interval: pageResponse_constants_1.GRAPH_INTERVAL.day,
                            aggregated: true,
                        },
                        {
                            type: pageResponse_constants_1.BOX_TYPE.MultiGraphBox,
                            metrics: [
                                await new Db2Metrics.BasicDbMetric('TCPIPSENDVOLUME', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init(),
                                await new Db2Metrics.BasicDbMetric('TCPIPRECVVOLUME', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init()
                            ],
                            uuids: uuids,
                            interval: pageResponse_constants_1.GRAPH_INTERVAL.day,
                            aggregated: true,
                        }
                    ],
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.Db2OverviewPage = Db2OverviewPage;
class Db2ConfigurationPage extends Db2SingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'dbfolder';
        this.title = 'Configuration';
    }
    async getPage() {
        let id = this.itemId;
        let title = 'Configuration';
        let tabs = [];
        let serverTable = await gen_table('db2main', id, {
            "Service level": "Service level",
            "Server platform": "Server platform",
            "Status": "Status",
            "Member": "Member",
            "Product name": "Product name",
            "Timezone": "Timezone",
            "Start time": "Start time",
        });
        tabs.push({
            title: 'Main',
            content: [serverTable.generateBox()],
        });
        serverTable = await gen_table('db2size', id, {
            'Name': 'Name',
            'Used': 'Used\n[GiB]',
            'Free': 'Free\n[GiB]',
            'Total': 'Total\n[GiB]',
            'Used %': 'Usage\n[%]',
        });
        tabs.push({
            title: 'Tablespaces',
            content: [serverTable.generateBox()],
        });
        serverTable = await gen_table('db2member', id, {
            'ID': 'ID',
            'HOME_HOST': 'Home host',
            'CUR_HOST': 'Current host',
            'STATE': 'State',
            'ALERT': 'Alert',
        });
        tabs.push({
            title: 'Members',
            content: [serverTable.generateBox()],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.Db2ConfigurationPage = Db2ConfigurationPage;
class Db2HealthstatusPage extends Db2Page {
    constructor() {
        super(...arguments);
        this.title = 'Health Status';
    }
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatus = await new HealthStatus_1.HealthStatus().setAcl(this.request).useDeviceAliasColumn(true).useLinkToItem(true).getStatusByParameters("dbfolder", "database", "Database", "db2");
        tabs.push({
            title: 'Health Status',
            content: [healthStatus],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.Db2HealthstatusPage = Db2HealthstatusPage;
class Db2CapacityPage extends Db2SingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'db';
        this.title = 'Capacity';
    }
    async getPage() {
        let title = this.title;
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.DB2, "db", [this.itemId]);
        tabFactory.addTab('Size', [
            { metric: 'unused', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'used', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'available', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'log_space', color: Color_1.Color.pallete.orangeDark, default: TabFactory_1.MPDefault.LINE },
        ]);
    }
}
exports.Db2CapacityPage = Db2CapacityPage;
class Db2TopPage extends Db2Page {
    constructor() {
        super(...arguments);
        this.title = 'DB TOP';
    }
    async getPage() {
        const top = new Top_1.Top();
        top.setSubsystem('db2', 'member');
        top.setParentSubsystem('dbfolder');
        top.setAcl(this.request);
        const tabs = await top.genTabs();
        this.page = new pageResponse_dto_1.Page(this.title, tabs);
        return this.page;
    }
}
exports.Db2TopPage = Db2TopPage;
class Db2AgentsPage extends Db2SingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.title = 'Agents';
    }
    async getPage() {
        let aggregated = false;
        let uuids = [this.itemId];
        if (this.total) {
            uuids = await getMembers(this.subsystem, this.hwType, this.itemId);
            aggregated = true;
        }
        let title = this.title;
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.DB2, "member", uuids);
        tabFactory.addTab('Agents', [
            { metric: 'AGENTSSTOLEN', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'IDLEAGENTS', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'AGENTSREGISTERED', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'AGENTSTOP', color: Color_1.Color.pallete.orangeDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'NUMPOOLEDAGENTS', color: Color_1.Color.pallete.yellowDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'NUMASSOCAGENTS', color: Color_1.Color.pallete.brownDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'NUMCOORDAGENTS', color: Color_1.Color.pallete.purpleDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.Db2AgentsPage = Db2AgentsPage;
class Db2LocksPage extends Db2SingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.title = 'Locks';
    }
    async getPage() {
        let aggregated = false;
        let uuids = [this.itemId];
        if (this.total) {
            uuids = await getMembers(this.subsystem, this.hwType, this.itemId);
            aggregated = true;
        }
        let title = this.title;
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.DB2, "member", uuids);
        tabFactory.addTab('Locks', [
            { metric: 'NUMLOCKSHELD', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'NUMLOCKSWAITING', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'LOCKESCALS', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'LOCKTIMEOUTS', color: Color_1.Color.pallete.orangeDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        tabFactory.addTab('Deadlocks', [
            { metric: 'DEADLOCKS', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.Db2LocksPage = Db2LocksPage;
class Db2IoPage extends Db2SingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.title = 'IO';
    }
    async getPage() {
        let aggregated = false;
        let uuids = [this.itemId];
        if (this.total) {
            uuids = await getMembers(this.subsystem, this.hwType, this.itemId);
            aggregated = true;
        }
        let title = this.title;
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.DB2, "member", uuids);
        tabFactory.addTab('IO Read', [
            { metric: 'LOGICALREADS', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'PHYSICALREADS', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'DIRECTREADS', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        tabFactory.addTab('IO Write', [
            { metric: 'WRITES', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'DIRECTWRITES', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.Db2IoPage = Db2IoPage;
class Db2LatencyPage extends Db2SingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.title = 'Latency';
    }
    async getPage() {
        let aggregated = false;
        let uuids = [this.itemId];
        if (this.total) {
            uuids = await getMembers(this.subsystem, this.hwType, this.itemId);
            aggregated = true;
        }
        let title = this.title;
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.DB2, "member", uuids);
        tabFactory.addTab('Latency direct', [
            { metric: 'DIRECTREADTIME', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'DIRECTWRITETIME', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        tabFactory.addTab('Latency pool', [
            { metric: 'POOLWRITETIME', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'POOLREADTIME', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        tabFactory.addTab('Latency log', [
            { metric: 'LOGDISKWAITTIME', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.Db2LatencyPage = Db2LatencyPage;
class Db2RowsPage extends Db2SingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.title = 'Rows';
    }
    async getPage() {
        let aggregated = false;
        let uuids = [this.itemId];
        if (this.total) {
            uuids = await getMembers(this.subsystem, this.hwType, this.itemId);
            aggregated = true;
        }
        let title = this.title;
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.DB2, "member", uuids);
        tabFactory.addTab('Total', [
            { metric: 'ROWSMODIFIED', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'ROWSRETURNED', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'ROWSREAD', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'ROWSUPDATED', color: Color_1.Color.pallete.orangeDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'ROWSDELETED', color: Color_1.Color.pallete.yellowDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'ROWSINSERTED', color: Color_1.Color.pallete.brownDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        tabFactory.addTab('INT', [
            { metric: 'INTROWSDELETED', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'INTROWSINSERTED', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'INTROWSUPDATED', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        tabFactory.addTab('FED', [
            { metric: 'FEDROWSRETURNED', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'FEDROWSREAD', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'FEDROWSUPDATED', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'FEDROWSDELETED', color: Color_1.Color.pallete.orangeDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'FEDROWSINSERTED', color: Color_1.Color.pallete.yellowDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.Db2RowsPage = Db2RowsPage;
class Db2NetworkPage extends Db2SingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.title = 'Network';
    }
    async getPage() {
        let aggregated = false;
        let uuids = [this.itemId];
        if (this.total) {
            uuids = await getMembers(this.subsystem, this.hwType, this.itemId);
            aggregated = true;
        }
        let title = this.title;
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.DB2, "member", uuids);
        tabFactory.addTab('Remote', [
            { metric: 'TCPIPSENDVOLUME', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.AREA_STACKED },
            { metric: 'TCPIPRECVVOLUME', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.AREA_STACKED },
        ]);
        tabFactory.addTab('Local clients', [
            { metric: 'IPCSENDVOLUME', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.AREA_STACKED },
            { metric: 'IPCRECVVOLUME', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.AREA_STACKED },
        ]);
        tabFactory.addTab('FCM', [
            { metric: 'FCMSENDVOLUME', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.AREA_STACKED },
            { metric: 'FCMRECVVOLUME', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.AREA_STACKED },
        ]);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.Db2NetworkPage = Db2NetworkPage;
class Db2SqlqueryPage extends Db2SingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.title = 'SQL query';
    }
    async getPage() {
        let aggregated = false;
        let uuids = [this.itemId];
        if (this.total) {
            uuids = await getMembers(this.subsystem, this.hwType, this.itemId);
            aggregated = true;
        }
        let title = this.title;
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.DB2, "member", uuids);
        tabFactory.addTab('Transaction', [
            { metric: 'TOTALAPPCOMMITS', color: Color_1.Color.pallete.red, default: TabFactory_1.MPDefault.AREA_STACKED },
            { metric: 'TOTALAPPROLLBACKS', color: Color_1.Color.pallete.blue, default: TabFactory_1.MPDefault.AREA_STACKED },
        ]);
        tabFactory.addTab('Compilation', [
            { metric: 'PKGCACHELOOKUPS', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'PKGCACHEINSERTS', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.Db2SqlqueryPage = Db2SqlqueryPage;
class Db2WaitsPage extends Db2SingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.title = 'Waits';
    }
    async getPage() {
        let aggregated = false;
        let uuids = [this.itemId];
        if (this.total) {
            uuids = await getMembers(this.subsystem, this.hwType, this.itemId);
            aggregated = true;
        }
        let title = this.title;
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.DB2, "member", uuids);
        tabFactory.addTab('Total', [
            { metric: 'TCPIPSENDWAITTIME', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'LOGDISKWAITTIME', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'TCPIPRECVWAITTIME', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'IPCSENDWAITTIME', color: Color_1.Color.pallete.orangeDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'IPCRECVWAITTIME', color: Color_1.Color.pallete.yellowDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'FCMSENDWAITTIME', color: Color_1.Color.pallete.brownDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'FCMRECVWAITTIME', color: Color_1.Color.pallete.purpleDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'CFWAITTIME', color: Color_1.Color.pallete.black, default: TabFactory_1.MPDefault.LINE },
            { metric: 'LOCKWAITTIME', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'AGENTWAITTIME', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'WLMQUEUETIMETOTAL', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'POOLREADTIME', color: Color_1.Color.pallete.orangeDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'POOLWRITETIME', color: Color_1.Color.pallete.yellowDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'DIRECTREADTIME', color: Color_1.Color.pallete.brownDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'DIRECTWRITETIME', color: Color_1.Color.pallete.purpleDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        tabFactory.addTab('IO', [
            { metric: 'LOGDISKWAITTIME', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'POOLREADTIME', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'POOLWRITETIME', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'DIRECTREADTIME', color: Color_1.Color.pallete.orangeDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'DIRECTWRITETIME', color: Color_1.Color.pallete.yellowDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        tabFactory.addTab('Network', [
            { metric: 'TCPIPSENDWAITTIME', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'TCPIPRECVWAITTIME', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'IPCSENDWAITTIME', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'IPCRECVWAITTIME', color: Color_1.Color.pallete.orangeDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'FCMSENDWAITTIME', color: Color_1.Color.pallete.yellowDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'FCMRECVWAITTIME', color: Color_1.Color.pallete.brownDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        tabFactory.addTab('Misc', [
            { metric: 'CFWAITTIME', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'LOCKWAITTIME', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'AGENTWAITTIME', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'WLMQUEUETIMETOTAL', color: Color_1.Color.pallete.orangeDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.Db2WaitsPage = Db2WaitsPage;
class Db2SessionPage extends Db2SingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.title = 'Session';
    }
    async getPage() {
        let aggregated = false;
        let uuids = [this.itemId];
        if (this.total) {
            uuids = await getMembers(this.subsystem, this.hwType, this.itemId);
            aggregated = true;
        }
        let title = this.title;
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.DB2, "member", uuids);
        tabFactory.addTab('Session', [
            { metric: 'TOTALCONS', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'TOTALSECCONS', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'APPLSCURCONS', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'CONNECTIONSTOP', color: Color_1.Color.pallete.orangeDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.Db2SessionPage = Db2SessionPage;
class Db2RatioPage extends Db2SingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.title = 'Ratio';
    }
    async getPage() {
        let aggregated = false;
        let uuids = [this.itemId];
        if (this.total) {
            uuids = await getMembers(this.subsystem, this.hwType, this.itemId);
            aggregated = true;
        }
        let title = this.title;
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.DB2, "member", uuids);
        tabFactory.addTab('Ratio', [
            { metric: 'RATINLOG', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'RATIOCACHE', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'RATIOBUFFER', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'RATIOCPUT', color: Color_1.Color.pallete.orangeDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.Db2RatioPage = Db2RatioPage;
class Db2BufferpoolsFolder extends Db2SubsystemFolder {
    async getChildren() {
        let menuItems = [];
        let bufferpools = await this.objectItemsRepository.findOne({
            relations: {
                children: {
                    _child: {
                        parents: true
                    }
                }
            },
            where: {
                item_id: this.itemId.toString(),
                children: {
                    _child: {
                        subsystem: 'bufferpool'
                    }
                }
            }
        });
        if (bufferpools) {
            bufferpools.children.sort((a, b) => {
                return a._child.label > b._child.label ? 1 : -1;
            });
            for (const childIndex in bufferpools.children) {
                const datastore = bufferpools.children[childIndex]._child;
                menuItems.push(new menuResponse_dto_1.MenuLink(datastore.label, this.hwType + '/bufferpool?item_id=' + datastore.item_id, 'bufferpool'));
            }
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.Db2BufferpoolsFolder = Db2BufferpoolsFolder;
class Db2BufferpoolPage extends Db2SingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'bufferpool';
        this.title = 'Bufferpool';
    }
    async getPage() {
        let aggregated = false;
        let uuids = [this.itemId];
        let item = await this.objectItemsRepository.findOneBy({
            hw_type: this.hwType,
            subsystem: this.subsystem,
            item_id: this.itemId,
        });
        let title = 'Bufferpool ' + (item !== null ? item.label : this.itemId);
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.DB2, "bufferpool", [this.itemId]);
        tabFactory.addTab('IO Read', [
            { metric: 'LOGICALREADS', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'PHYSICALREADS', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'DIRECTREADS', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        tabFactory.addTab('IO Write', [
            { metric: 'WRITES', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'DIRECWRITES', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        tabFactory.addTab('Latency direct', [
            { metric: 'DIRECTREADTIME', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'DIRECTWRITETIME', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        tabFactory.addTab('Latency pool', [
            { metric: 'POOLWRITETIME', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'POOLREADTIME', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        tabFactory.addTab('Ratio', [
            { metric: 'RATINLOG', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'RATIOCACHE', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'RATIOBUFFER', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'RATIOCPUT', color: Color_1.Color.pallete.orangeDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.Db2BufferpoolPage = Db2BufferpoolPage;
class Db2Metrics {
}
exports.Db2Metrics = Db2Metrics;
Db2Metrics.Metric = class extends pageResponse_dto_1.Metric {
    async init() {
        const metric = Metric_1.Metric.getMetric(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.DB2, this.subsystem, this.metric);
        if (metric) {
            Object.assign(this, metric);
        }
        return this;
    }
};
Db2Metrics.BasicDbMetric = class extends Db2Metrics.Metric {
    constructor(metric, type, subsystem, stacked, order, color) {
        super();
        this.metric = metric;
        this.type = type;
        this.subsystem = subsystem;
        this.stacked = stacked;
        this.order = order;
        this.color = color;
    }
};
class Db2IototalPage extends Db2IoPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.total = true;
    }
}
exports.Db2IototalPage = Db2IototalPage;
class Db2AgentstotalPage extends Db2AgentsPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.total = true;
    }
}
exports.Db2AgentstotalPage = Db2AgentstotalPage;
class Db2LockstotalPage extends Db2LocksPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.total = true;
    }
}
exports.Db2LockstotalPage = Db2LockstotalPage;
class Db2LatencytotalPage extends Db2LatencyPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.total = true;
    }
}
exports.Db2LatencytotalPage = Db2LatencytotalPage;
class Db2RowstotalPage extends Db2RowsPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.total = true;
    }
}
exports.Db2RowstotalPage = Db2RowstotalPage;
class Db2SessiontotalPage extends Db2SessionPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.total = true;
    }
}
exports.Db2SessiontotalPage = Db2SessiontotalPage;
class Db2SqlquerytotalPage extends Db2SqlqueryPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.total = true;
    }
}
exports.Db2SqlquerytotalPage = Db2SqlquerytotalPage;
class Db2NetworktotalPage extends Db2NetworkPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.total = true;
    }
}
exports.Db2NetworktotalPage = Db2NetworktotalPage;
class Db2RatiototalPage extends Db2RatioPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.total = true;
    }
}
exports.Db2RatiototalPage = Db2RatiototalPage;
class Db2WaitstotalPage extends Db2WaitsPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'member';
        this.total = true;
    }
}
exports.Db2WaitstotalPage = Db2WaitstotalPage;
async function gen_table(tableType, id, dict) {
    const itemsPropertiesRepository = (0, dataSource_1.getDataSource)().getRepository(itemProperty_entity_1.ItemProperty);
    let serverTable = new Table_1.Table();
    for (const item in dict) {
        let value = dict[item];
        let properties = {};
        if (value.includes("[GiB]")) {
            value = value.replace('\n[GiB]', '');
            properties = {
                prefix: "Gi",
                unit: "bytes",
                shortcut: "GiB",
                number: true,
            };
        }
        serverTable.addHeader({ property: value, value: value, ...properties });
    }
    let rawProperties = Object.keys(dict);
    let tableRes = await itemsPropertiesRepository.findOneBy({ item_id: id, property_name: tableType });
    if (tableRes) {
        let wholeStuff = JSON.parse(tableRes.property_value);
        for (const dbRow of wholeStuff) {
            let row = [];
            for (const rawHeader of rawProperties) {
                let value = dbRow[rawHeader] ? dbRow[rawHeader] : "";
                row.push({
                    value: value,
                });
            }
            serverTable.addRow(row);
        }
        return serverTable;
    }
    else {
        let row = [];
        row.push({
            order: 1,
            value: "value",
        });
        return serverTable.addRow(row);
    }
}
async function getMembers(subsystem, hw_type, item_id) {
    let itemsTotal = [];
    let member_ids = [];
    let objectItemsRepository = (0, dataSource_1.getDataSource)().getRepository(objectItem_entity_1.ObjectItem);
    let itemRelationsRepository = (0, dataSource_1.getDataSource)().getRepository(itemRelation_entity_1.ItemRelation);
    let items = [];
    let ItemRelations = await itemRelationsRepository.findBy({ parent: item_id });
    for (let relation of ItemRelations) {
        items.push(relation.child);
    }
    let members = await objectItemsRepository.findBy({ hw_type: hw_type, subsystem: subsystem, item_id: (0, typeorm_1.In)(items) });
    for (let member of members) {
        member_ids.push(member.item_id);
    }
    return member_ids;
}
//# sourceMappingURL=Db2.js.map