import { MenuFolder, Newable } from '@xormon/common/menuResponse.dto';
import { Page } from '@xormon/common/pageResponse.dto';
import { AbstractFolder, AbstractPage } from './AbstractMenu';
export declare class GcloudFolder extends AbstractFolder {
    hwType: string;
}
export declare class GcloudRootFolder extends GcloudFolder {
    _get(): Promise<MenuFolder[]>;
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<MenuFolder[]>;
}
export declare class GcloudPage extends AbstractPage {
    hwType: string;
    rootFolder: Newable<AbstractFolder>;
}
export declare class GcloudSubsystemFolder extends GcloudFolder {
    subsystem: string;
    itemId: string;
    constructor(itemId?: string);
}
export declare abstract class GcloudSingleItemPage extends GcloudPage {
    subsystem: string;
}
export declare class GcloudConfigurationPage extends GcloudPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class GcloudProjectFolder extends GcloudSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class GcloudOverviewPage extends GcloudPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class GcloudProjectinstanceoverviewPage extends GcloudPage {
    title: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class GcloudRegionFolder extends GcloudSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class GcloudComputetopPage extends GcloudPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class GcloudDatabasetopPage extends GcloudPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class GcloudHeatmapPage extends GcloudPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class GcloudComputetotalsPage extends GcloudSingleItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class GcloudRegioncomputetotalsPage extends GcloudSingleItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class GcloudDatabasetotalsPage extends GcloudSingleItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class GcloudRegiondatabasetotalsPage extends GcloudSingleItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class GcloudComputeFolder extends GcloudSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class GcloudDatabaseFolder extends GcloudSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class GcloudComputePage extends GcloudSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class GcloudDatabasePage extends GcloudSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class GCloudOverviewPage extends GcloudPage {
    title: string;
    getPage(): Promise<Page>;
}
