import { ChartType, FourGraphBox, GraphBaseParent, MetricAggregate } from "@xormon/common/pageResponse.dto";
import { HwTypeKey } from '@xormon/common/constants/hwTypeKey.constants';
import { ClassKey } from '@xormon/common/constants/class.constants';
export declare class GraphBuilder {
    #private;
    private _class;
    private hwType;
    private subsystem;
    constructor(_class: ClassKey, hwType: HwTypeKey, subsystem: string);
    addMetric(metric: string, type?: ChartType, stacked?: boolean, order?: number, color?: string, aggregate?: MetricAggregate): this;
    addItems(itemIds: string[]): this;
    setAggregated(): this;
    setParent(parent: GraphBaseParent): this;
    setLabel(label: string): this;
    generateGraph(): FourGraphBox;
}
