"use strict";
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _GraphBuilder_aggregated, _GraphBuilder_itemIds, _GraphBuilder_metrics, _GraphBuilder_parent, _GraphBuilder_label;
Object.defineProperty(exports, "__esModule", { value: true });
exports.GraphBuilder = void 0;
const pageResponse_constants_1 = require("../../../common/constants/pageResponse.constants");
const MetricsWrapper_1 = require("../../metrics/MetricsWrapper");
class GraphBuilder {
    constructor(_class, hwType, subsystem) {
        this._class = _class;
        this.hwType = hwType;
        this.subsystem = subsystem;
        _GraphBuilder_aggregated.set(this, false);
        _GraphBuilder_itemIds.set(this, []);
        _GraphBuilder_metrics.set(this, []);
        _GraphBuilder_parent.set(this, void 0);
        _GraphBuilder_label.set(this, void 0);
    }
    addMetric(metric, type, stacked, order, color, aggregate) {
        let gMetric = {
            metric: metric,
            type: type ? type : 'line',
            stacked: stacked ? stacked : false,
            order: order ? order : 0,
            color: color ? color : undefined,
            aggregate: aggregate ? aggregate : undefined
        };
        const definition = MetricsWrapper_1.MetricsWrapper.getMetric(this._class, this.hwType, this.subsystem, metric);
        if (definition) {
            Object.assign(gMetric, definition);
        }
        __classPrivateFieldGet(this, _GraphBuilder_metrics, "f").push(gMetric);
        return this;
    }
    addItems(itemIds) {
        __classPrivateFieldSet(this, _GraphBuilder_itemIds, itemIds, "f");
        return this;
    }
    setAggregated() {
        __classPrivateFieldSet(this, _GraphBuilder_aggregated, true, "f");
        return this;
    }
    setParent(parent) {
        __classPrivateFieldSet(this, _GraphBuilder_parent, parent, "f");
        return this;
    }
    setLabel(label) {
        __classPrivateFieldSet(this, _GraphBuilder_label, label, "f");
        return this;
    }
    generateGraph() {
        return {
            type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
            metrics: __classPrivateFieldGet(this, _GraphBuilder_metrics, "f"),
            uuids: __classPrivateFieldGet(this, _GraphBuilder_itemIds, "f"),
            aggregated: __classPrivateFieldGet(this, _GraphBuilder_aggregated, "f"),
            parent: __classPrivateFieldGet(this, _GraphBuilder_parent, "f") ? __classPrivateFieldGet(this, _GraphBuilder_parent, "f") : undefined,
            label: __classPrivateFieldGet(this, _GraphBuilder_label, "f") ? __classPrivateFieldGet(this, _GraphBuilder_label, "f") : undefined
        };
    }
}
exports.GraphBuilder = GraphBuilder;
_GraphBuilder_aggregated = new WeakMap(), _GraphBuilder_itemIds = new WeakMap(), _GraphBuilder_metrics = new WeakMap(), _GraphBuilder_parent = new WeakMap(), _GraphBuilder_label = new WeakMap();
//# sourceMappingURL=GraphBuilder.js.map