import { MenuItem, Newable } from '@xormon/common/menuResponse.dto';
import { Page, Tab } from '@xormon/common/pageResponse.dto';
import { ItemProperty } from '@xormon/entity/itemProperty.entity';
import { ItemRelation } from '@xormon/entity/itemRelation.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
import { Request } from 'express';
export interface PageDefinition {
    itemId: string;
    request?: Request;
    rootFolder?: Newable<DefaultFolder>;
    withItemId?: boolean;
    getPath(): MenuItem[] | Promise<MenuItem[]>;
    getPage(): Page | Promise<Page>;
    getTab?(tab: string): Tab | Promise<Tab>;
}
export interface FolderDefinition {
    itemId: string;
    request?: Request;
    getChildren(request?: Request): MenuItem[] | Promise<MenuItem[]>;
    getChildrenAcl?(): MenuItem[] | Promise<MenuItem[]>;
    getPath?(parentIds: string[]): MenuItem[] | Promise<MenuItem[]>;
}
export declare abstract class DefaultFolder implements FolderDefinition {
    itemId: string;
    request: Request;
    constructor(itemId: string, request: Request);
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
    itemPropertiesRepository: import("typeorm").Repository<ItemProperty>;
    getChildren(): Promise<MenuItem[]>;
    getChildrenAcl(): Promise<MenuItem[]>;
    getPath(parentIds: string[]): Promise<Array<MenuItem>>;
}
export declare abstract class DefaultPage implements PageDefinition {
    itemId: string;
    request: Request;
    withItemId: boolean;
    rootFolder: Newable<DefaultFolder>;
    constructor(itemId: string, request: Request);
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
    itemPropertiesRepository: import("typeorm").Repository<ItemProperty>;
    getPage(): Promise<Page>;
    getPath(): Promise<MenuItem[]>;
    getTab(tab: string): Promise<Tab>;
}
export declare const createLazyContentURL: (hwType: string, pageType: string, tab: string, itemId?: string) => string;
