import { Newable } from '@xormon/common/menuResponse.dto';
import { ChartType, Page } from '@xormon/common/pageResponse.dto';
import { HostCfg } from '@xormon/entity/hostcfg.entity';
import { AbstractFolder, AbstractPage } from './AbstractMenu';
export declare class OpenshiftFolder extends AbstractFolder {
    hwType: string;
    hostcfgRepository: import("typeorm").Repository<HostCfg>;
}
export declare class OpenshiftSubsystemFolder extends OpenshiftFolder {
    subsystem: string;
    itemId: string;
    constructor(itemId?: string);
}
export declare class OpenshiftRootFolder extends OpenshiftFolder {
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class OpenshiftClusterFolder extends OpenshiftSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class OpenshiftNodeFolder extends OpenshiftSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class OpenshiftProjectsFolder extends OpenshiftSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class OpenshiftProjectFolder extends OpenshiftSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class OpenshiftPodFolder extends OpenshiftSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class OpenshiftPage extends AbstractPage {
    hwType: string;
    rootFolder: Newable<AbstractFolder>;
}
export declare abstract class OpenshiftItemPage extends OpenshiftPage {
    subsystem: string;
    itemId: string;
    withItemId: boolean;
}
export declare class OpenshiftClusternodetotalsPage extends OpenshiftItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class OpenshiftClusterprojecttotalsPage extends OpenshiftItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class OpenshiftClusterpodsaggregatedPage extends OpenshiftItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class OpenshiftNodePage extends OpenshiftItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class OpenshiftProjectPage extends OpenshiftItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class OpenshiftPodPage extends OpenshiftItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class OpenshiftConfigurationPage extends OpenshiftPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class OpenshiftPodoverviewPage extends OpenshiftPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class OpenshiftContainerPage extends OpenshiftItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class OpenshiftHeatmapPage extends OpenshiftPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class OpenshiftTopPage extends OpenshiftPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class OpenshiftMetrics {
    static Metric: {
        new (subsystem: string, metric: string): {
            getGraph(type: ChartType, stacked?: boolean, order?: number, color?: string): any;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
}
