"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpenshiftMetrics = exports.OpenshiftTopPage = exports.OpenshiftHeatmapPage = exports.OpenshiftContainerPage = exports.OpenshiftPodoverviewPage = exports.OpenshiftConfigurationPage = exports.OpenshiftPodPage = exports.OpenshiftProjectPage = exports.OpenshiftNodePage = exports.OpenshiftClusterpodsaggregatedPage = exports.OpenshiftClusterprojecttotalsPage = exports.OpenshiftClusternodetotalsPage = exports.OpenshiftItemPage = exports.OpenshiftPage = exports.OpenshiftPodFolder = exports.OpenshiftProjectFolder = exports.OpenshiftProjectsFolder = exports.OpenshiftNodeFolder = exports.OpenshiftClusterFolder = exports.OpenshiftRootFolder = exports.OpenshiftSubsystemFolder = exports.OpenshiftFolder = void 0;
const pageResponse_constants_1 = require("../../../common/constants/pageResponse.constants");
const menuResponse_dto_1 = require("../../../common/menuResponse.dto");
const pageResponse_dto_1 = require("../../../common/pageResponse.dto");
const dataSource_1 = require("../../../config/dataSource");
const hostcfg_entity_1 = require("../../../entity/hostcfg.entity");
const hwTypeKey_constants_1 = require("../../../common/constants/hwTypeKey.constants");
const class_constants_1 = require("../../../common/constants/class.constants");
const MetricsWrapper_1 = require("../../metrics/MetricsWrapper");
const Heatmap_1 = require("./Heatmap");
const Top_1 = require("./Top");
const ConfigurationTable_1 = require("./ConfigurationTable");
const Table_1 = require("./Table");
const URL_1 = require("./URL");
const Color_1 = require("../../metrics/Color");
const subsystemMetricsResponse_constants_1 = require("../../../common/constants/subsystemMetricsResponse.constants");
const ACLCheck_1 = require("../../acl/ACLCheck");
const AbstractMenu_1 = require("./AbstractMenu");
class OpenshiftFolder extends AbstractMenu_1.AbstractFolder {
    constructor() {
        super(...arguments);
        this.hwType = 'openshift';
        this.hostcfgRepository = (0, dataSource_1.getDataSource)().getRepository(hostcfg_entity_1.HostCfg);
    }
}
exports.OpenshiftFolder = OpenshiftFolder;
class OpenshiftSubsystemFolder extends OpenshiftFolder {
    constructor(itemId) {
        super();
        if (itemId !== null) {
            this.itemId = itemId;
        }
    }
}
exports.OpenshiftSubsystemFolder = OpenshiftSubsystemFolder;
class OpenshiftRootFolder extends OpenshiftFolder {
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('Heatmap', this.hwType + '/heatmap', 'heatmap'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Configuration', this.hwType + '/configuration', 'configuration'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Pods TOP', this.hwType + '/top', 'top'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Pods Overview', this.hwType + '/pod-overview', 'pod-overview'));
        let subsystem_cluster = 'cluster';
        let clusters = await this.objectItemsRepository.findBy({
            hw_type: this.hwType,
            subsystem: subsystem_cluster,
        });
        for (let item of clusters) {
            let path = this.hwType + '/' + subsystem_cluster + '?ids=' + item.item_id;
            menuItems.push(new menuResponse_dto_1.MenuFolder(item.label, path, this.hwType, subsystem_cluster, item.item_id, OpenshiftClusterFolder));
        }
        this.children = menuItems;
        return menuItems;
    }
    async getChildrenAcl() {
        let menuItems = [];
        let subsystem_cluster = 'cluster';
        let clusters = await this.objectItemsRepository.findBy({
            hw_type: this.hwType,
            subsystem: subsystem_cluster,
        });
        for (let item of clusters) {
            let path = this.hwType + '/' + subsystem_cluster + '?ids=' + item.item_id;
            menuItems.push(new menuResponse_dto_1.MenuFolder(item.label, path, this.hwType, subsystem_cluster, item.item_id, OpenshiftClusterFolder));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.OpenshiftRootFolder = OpenshiftRootFolder;
class OpenshiftClusterFolder extends OpenshiftSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'cluster';
    }
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('Node Totals', this.hwType + '/' + this.subsystem + '-node-totals' + '?item_id=' + this.itemId, 'node-totals', undefined, true));
        menuItems.push(new menuResponse_dto_1.MenuLink('Projects Totals', this.hwType + '/' + this.subsystem + '-project-totals' + '?item_id=' + this.itemId, 'project-totals'));
        const checkPod = await this.objectItemsRepository.findOne({
            where: {
                parents: {
                    parent: this.itemId.toString()
                },
                subsystem: 'pod',
                hw_type: 'openshift'
            }, relations: {
                parents: true
            }
        });
        if (checkPod) {
            menuItems.push(new menuResponse_dto_1.MenuLink('Pods Aggregated', this.hwType + '/' + this.subsystem + '-pods-aggregated' + '?item_id=' + this.itemId, 'pods-aggregated'));
        }
        const subsystems = ['Node', 'Project'];
        const folders = {
            "Node": OpenshiftNodeFolder,
            "Project": OpenshiftProjectsFolder
        };
        for (let childSubsystem of subsystems) {
            let childSubsystemItem = await this.objectItemsRepository.findOneBy({
                hw_type: this.hwType,
                subsystem: childSubsystem.toLowerCase(),
            });
            if (childSubsystemItem) {
                let childSubsystemPath = childSubsystem === 'Project' ? "Projects" : childSubsystem;
                let path = this.hwType + '/' + childSubsystemPath.toLowerCase() + (this.itemId !== null ? '?ids=' + this.itemId : '');
                menuItems.push(new menuResponse_dto_1.MenuFolder(childSubsystem, path, this.hwType, childSubsystemPath.toLowerCase(), this.itemId, folders[childSubsystem]));
            }
        }
        this.children = menuItems;
        return menuItems;
    }
    async getChildrenAcl() {
        let menuItems = [];
        let projects = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: 'project',
                parents: {
                    parent: this.itemId.toString()
                }
            },
            relations: {
                parents: true
            }
        });
        for (const project of projects) {
            let path = this.hwType + '/project?item_id=' + project.item_id;
            menuItems.push(new menuResponse_dto_1.MenuLink(project.label, path, 'project', project.item_id));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.OpenshiftClusterFolder = OpenshiftClusterFolder;
class OpenshiftNodeFolder extends OpenshiftSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'node';
    }
    async getChildren() {
        let menuItems = [];
        let nodes = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: this.subsystem,
                parents: {
                    parent: this.itemId.toString()
                }
            },
            relations: {
                parents: true
            }
        });
        for (const node of nodes) {
            let path = this.hwType + '/' + this.subsystem + '?item_id=' + node.item_id;
            menuItems.push(new menuResponse_dto_1.MenuLink(node.label, path, this.subsystem, node.item_id));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.OpenshiftNodeFolder = OpenshiftNodeFolder;
class OpenshiftProjectsFolder extends OpenshiftSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'project';
    }
    async getChildren() {
        let menuItems = [];
        const onlyProjects = false;
        let projects = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: this.subsystem,
                parents: {
                    parent: this.itemId.toString()
                }
            },
            relations: {
                parents: true,
                children: true
            }
        });
        projects = projects.filter(project => project.children && project.children.length >= 1);
        for (const project of projects) {
            if (onlyProjects) {
                let path = this.hwType + '/' + this.subsystem + '?item_id=' + project.item_id;
                menuItems.push(new menuResponse_dto_1.MenuLink(project.label, path, this.subsystem, project.item_id));
            }
            else {
                let path = this.hwType + '/' + this.subsystem + '?ids=' + project.item_id;
                menuItems.push(new menuResponse_dto_1.MenuFolder(project.label, path, this.hwType, this.subsystem, project.item_id, OpenshiftProjectFolder));
            }
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.OpenshiftProjectsFolder = OpenshiftProjectsFolder;
class OpenshiftProjectFolder extends OpenshiftSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'pod';
    }
    async getChildren() {
        let menuItems = [];
        const onlyPods = false;
        let pods = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: this.subsystem,
                parents: {
                    parent: this.itemId.toString()
                }
            },
            relations: {
                parents: true
            }
        });
        let path = this.hwType + '/project?item_id=' + this.itemId.toString();
        menuItems.push(new menuResponse_dto_1.MenuLink("Totals", path, this.subsystem, this.itemId.toString(), true));
        for (const pod of pods) {
            if (onlyPods) {
                let path = this.hwType + '/' + this.subsystem + '?item_id=' + pod.item_id;
                menuItems.push(new menuResponse_dto_1.MenuLink(pod.label, path, this.subsystem, pod.item_id));
            }
            else {
                let path = this.hwType + '/' + this.subsystem + '?ids=' + pod.item_id;
                menuItems.push(new menuResponse_dto_1.MenuFolder(pod.label, path, this.hwType, this.subsystem, pod.item_id, OpenshiftPodFolder));
            }
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.OpenshiftProjectFolder = OpenshiftProjectFolder;
class OpenshiftPodFolder extends OpenshiftSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'container';
    }
    async getChildren() {
        let menuItems = [];
        let containers = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: this.subsystem,
                parents: {
                    parent: this.itemId.toString()
                }
            },
            relations: {
                parents: true
            }
        });
        let path = this.hwType + '/pod?item_id=' + this.itemId.toString();
        menuItems.push(new menuResponse_dto_1.MenuLink('Totals', path, 'pod', this.itemId.toString(), true));
        for (const container of containers) {
            let path = this.hwType + '/' + this.subsystem + '?item_id=' + container.item_id;
            menuItems.push(new menuResponse_dto_1.MenuLink(container.label, path, this.subsystem, container.item_id));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.OpenshiftPodFolder = OpenshiftPodFolder;
class OpenshiftPage extends AbstractMenu_1.AbstractPage {
    constructor() {
        super(...arguments);
        this.hwType = 'openshift';
        this.rootFolder = OpenshiftRootFolder;
    }
}
exports.OpenshiftPage = OpenshiftPage;
class OpenshiftItemPage extends OpenshiftPage {
    constructor() {
        super(...arguments);
        this.withItemId = true;
    }
}
exports.OpenshiftItemPage = OpenshiftItemPage;
class OpenshiftClusternodetotalsPage extends OpenshiftItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'node';
    }
    async getPage() {
        let items = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: this.subsystem,
                parents: {
                    parent: this.itemId
                }
            }, relations: {
                parents: true
            }
        });
        const itemIds = items.map(item => item.item_id);
        let title = 'Node Totals';
        let tabs = [];
        tabs.push({
            title: 'CPU%',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'cpu_usage').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Node'
                },
            ],
        });
        tabs.push({
            title: 'CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'cpu').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Node',
                },
            ],
        });
        tabs.push({
            title: 'Memory %',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'memory_usage').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Node',
                },
            ],
        });
        tabs.push({
            title: 'Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'memory').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Node'
                },
            ],
        });
        tabs.push({
            title: 'Pods',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'pods').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Node'
                },
            ],
        });
        tabs.push({
            title: 'Containers Data',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'container_fs_reads_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                        new OpenshiftMetrics.Metric('node', 'container_fs_writes_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Node',
                },
            ],
        });
        tabs.push({
            title: 'Containers IO',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'container_fs_reads').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                        new OpenshiftMetrics.Metric('node', 'container_fs_writes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    aggregated: true,
                    uuids: itemIds,
                    label: 'Node',
                },
            ],
        });
        tabs.push({
            title: 'Containers Latency',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'container_fs_read_latency').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1),
                        new OpenshiftMetrics.Metric('node', 'container_fs_write_latency').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0),
                    ],
                    aggregated: true,
                    uuids: itemIds,
                    label: 'Node'
                },
            ],
        });
        tabs.push({
            title: 'Containers LAN',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'container_network_receive_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                        new OpenshiftMetrics.Metric('node', 'container_network_transmit_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    aggregated: true,
                    uuids: itemIds,
                    label: 'Node'
                },
            ],
        });
        tabs.push({
            title: 'Containers Size',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'container_fs_usage_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true),
                    ],
                    aggregated: true,
                    uuids: itemIds,
                    label: 'Node'
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.OpenshiftClusternodetotalsPage = OpenshiftClusternodetotalsPage;
class OpenshiftClusterprojecttotalsPage extends OpenshiftItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'project';
    }
    async getPage() {
        let items = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: this.subsystem,
                parents: {
                    parent: this.itemId
                }
            }, relations: {
                parents: true
            }
        });
        const itemIds = items.map(item => item.item_id);
        let title = 'Projects Totals';
        let tabs = [];
        tabs.push({
            title: 'CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('project', 'cpu').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Project'
                },
            ],
        });
        tabs.push({
            title: 'Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('project', 'memory').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Project'
                },
            ],
        });
        tabs.push({
            title: 'Containers Data',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('project', 'container_fs_reads_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                        new OpenshiftMetrics.Metric('project', 'container_fs_writes_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Namespace'
                },
            ],
        });
        tabs.push({
            title: 'Containers IO',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('project', 'container_fs_reads').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                        new OpenshiftMetrics.Metric('project', 'container_fs_writes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Namespace'
                },
            ],
        });
        tabs.push({
            title: 'Containers LAN',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('project', 'container_network_receive_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                        new OpenshiftMetrics.Metric('project', 'container_network_transmit_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Namespace'
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.OpenshiftClusterprojecttotalsPage = OpenshiftClusterprojecttotalsPage;
class OpenshiftClusterpodsaggregatedPage extends OpenshiftItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'pod';
    }
    async getPage() {
        let items = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: this.subsystem,
                parents: {
                    parent: this.itemId
                }
            }, relations: {
                parents: true
            }
        });
        const itemIds = items.map(item => item.item_id);
        let title = 'Pods Aggregated';
        let tabs = [];
        tabs.push({
            title: 'CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('pod', 'cpu').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    parent: {
                        label: 'Project',
                        subsystem: 'project'
                    },
                    label: 'Pod'
                },
            ],
        });
        tabs.push({
            title: 'Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('pod', 'memory').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    parent: {
                        label: 'Project',
                        subsystem: 'project'
                    },
                    label: 'Pod'
                },
            ],
        });
        tabs.push({
            title: 'Processes',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('pod', 'container_processes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    parent: {
                        label: 'Project',
                        subsystem: 'project'
                    },
                    label: 'Pod'
                },
            ],
        });
        tabs.push({
            title: 'Containers Data',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('pod', 'container_fs_reads_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                        new OpenshiftMetrics.Metric('pod', 'container_fs_writes_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    parent: {
                        label: 'Project',
                        subsystem: 'project'
                    },
                    label: 'Pod'
                },
            ],
        });
        tabs.push({
            title: 'Containers IO',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('pod', 'container_fs_reads').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                        new OpenshiftMetrics.Metric('pod', 'container_fs_writes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    parent: {
                        label: 'Project',
                        subsystem: 'project'
                    },
                    label: 'Pod'
                },
            ],
        });
        tabs.push({
            title: 'Containers LAN',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('pod', 'container_network_receive_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                        new OpenshiftMetrics.Metric('pod', 'container_network_transmit_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    parent: {
                        label: 'Project',
                        subsystem: 'project'
                    },
                    label: 'Pod'
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.OpenshiftClusterpodsaggregatedPage = OpenshiftClusterpodsaggregatedPage;
class OpenshiftNodePage extends OpenshiftItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'node';
    }
    async getPage() {
        let item = await this.objectItemsRepository.findOneBy({
            hw_type: this.hwType,
            subsystem: this.subsystem,
            item_id: this.itemId,
        });
        let title = 'Node ' + (item !== null ? item.label : this.itemId);
        let tabs = [];
        tabs.push({
            title: 'CPU%',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'cpu_usage').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'cpu').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.used),
                        new OpenshiftMetrics.Metric('node', 'cpu_capacity').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 2, Color_1.Color.metric.total),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Memory %',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'memory_usage').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'memory').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.used),
                        new OpenshiftMetrics.Metric('node', 'memory_capacity').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 2, Color_1.Color.metric.total),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Pods',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'pods').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.used),
                        new OpenshiftMetrics.Metric('node', 'pods_capacity').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 2, Color_1.Color.metric.total)
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers Data',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'container_fs_reads_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new OpenshiftMetrics.Metric('node', 'container_fs_writes_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers IO',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'container_fs_reads').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new OpenshiftMetrics.Metric('node', 'container_fs_writes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers Latency',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'container_fs_read_latency').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new OpenshiftMetrics.Metric('node', 'container_fs_write_latency').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers LAN',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'container_network_receive_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.pallete.redDark),
                        new OpenshiftMetrics.Metric('node', 'container_network_transmit_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.blueDark),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers Size',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('node', 'container_fs_usage_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.OpenshiftNodePage = OpenshiftNodePage;
class OpenshiftProjectPage extends OpenshiftItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'project';
    }
    async getPage() {
        let item = await this.objectItemsRepository.findOneBy({
            hw_type: this.hwType,
            subsystem: this.subsystem,
            item_id: this.itemId,
        });
        let title = 'Project ' + (item !== null ? item.label : this.itemId);
        let tabs = [];
        tabs.push({
            title: 'CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('project', 'cpu').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('project', 'memory').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        const pods = await this.objectItemsRepository.find({
            relations: {
                parents: true
            },
            where: {
                subsystem: 'pod',
                parents: {
                    parent: this.itemId
                }
            }
        });
        tabs.push({
            title: 'Pods CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('pod', 'cpu').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red),
                    ],
                    uuids: pods.map(pod => pod.item_id),
                    aggregated: true,
                    label: 'Pod'
                },
            ],
        });
        tabs.push({
            title: 'Pods Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('pod', 'memory').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red),
                    ],
                    uuids: pods.map(pod => pod.item_id),
                    aggregated: true,
                    label: 'Pod'
                },
            ],
        });
        tabs.push({
            title: 'Pods Processes',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('pod', 'container_processes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red),
                    ],
                    uuids: pods.map(pod => pod.item_id),
                    aggregated: true,
                    label: 'Pod'
                },
            ],
        });
        tabs.push({
            title: 'Containers Data',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('project', 'container_fs_reads_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new OpenshiftMetrics.Metric('project', 'container_fs_writes_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers IO',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('project', 'container_fs_reads').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new OpenshiftMetrics.Metric('project', 'container_fs_writes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers LAN',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('project', 'container_network_receive_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.pallete.redDark),
                        new OpenshiftMetrics.Metric('project', 'container_network_transmit_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.blueDark),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        const containers = await this.objectItemsRepository.find({
            where: {
                subsystem: 'container',
                parents: {
                    parent: this.itemId
                }
            },
            relations: {
                parents: true
            }
        });
        if (containers.length >= 1) {
            tabs.push({
                title: 'Containers IO Aggr',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new OpenshiftMetrics.Metric('container', 'container_fs_reads').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                            new OpenshiftMetrics.Metric('container', 'container_fs_writes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                        ],
                        uuids: containers.map(item => item.item_id),
                        aggregated: true,
                        parent: {
                            label: 'Pod',
                            subsystem: 'pod'
                        },
                        label: 'Container'
                    },
                ],
            });
            tabs.push({
                title: 'Containers Data Aggr',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new OpenshiftMetrics.Metric('container', 'container_fs_reads_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                            new OpenshiftMetrics.Metric('container', 'container_fs_writes_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                        ],
                        uuids: containers.map(item => item.item_id),
                        aggregated: true,
                        parent: {
                            label: 'Pod',
                            subsystem: 'pod'
                        },
                        label: 'Container'
                    },
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.OpenshiftProjectPage = OpenshiftProjectPage;
class OpenshiftPodPage extends OpenshiftItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'pod';
    }
    async getPage() {
        let item = await this.objectItemsRepository.findOneBy({
            hw_type: this.hwType,
            subsystem: this.subsystem,
            item_id: this.itemId,
        });
        let title = 'Pod ' + (item !== null ? item.label : this.itemId);
        let tabs = [];
        tabs.push({
            title: 'CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('pod', 'cpu').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.used),
                        new OpenshiftMetrics.Metric('pod', 'cpu_limit').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 2, Color_1.Color.metric.total)
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('pod', 'memory').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.used),
                        new OpenshiftMetrics.Metric('pod', 'memory_limit').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 2, Color_1.Color.metric.total),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Processes',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('pod', 'container_processes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers Data',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('pod', 'container_fs_reads_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new OpenshiftMetrics.Metric('pod', 'container_fs_writes_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers IO',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('pod', 'container_fs_reads').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new OpenshiftMetrics.Metric('pod', 'container_fs_writes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers LAN',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('pod', 'container_network_receive_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.pallete.redDark),
                        new OpenshiftMetrics.Metric('pod', 'container_network_transmit_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.blueDark),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        const containers = await this.objectItemsRepository.find({
            where: {
                subsystem: 'container',
                parents: {
                    parent: this.itemId
                }
            },
            relations: {
                parents: true
            }
        });
        if (containers.length >= 1) {
            tabs.push({
                title: 'Containers IO Aggr',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new OpenshiftMetrics.Metric('container', 'container_fs_reads').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                            new OpenshiftMetrics.Metric('container', 'container_fs_writes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                        ],
                        uuids: containers.map(item => item.item_id),
                        aggregated: true,
                        parent: {
                            label: 'Pod',
                            subsystem: 'pod'
                        },
                        label: 'Container'
                    },
                ],
            });
            tabs.push({
                title: 'Containers Data Aggr',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new OpenshiftMetrics.Metric('container', 'container_fs_reads_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                            new OpenshiftMetrics.Metric('container', 'container_fs_writes_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                        ],
                        uuids: containers.map(item => item.item_id),
                        aggregated: true,
                        parent: {
                            label: 'Pod',
                            subsystem: 'pod'
                        },
                        label: 'Container'
                    },
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.OpenshiftPodPage = OpenshiftPodPage;
class OpenshiftConfigurationPage extends OpenshiftPage {
    constructor() {
        super(...arguments);
        this.title = 'Configuration';
    }
    async getPage() {
        let title = 'Configuration';
        let tabs = [];
        let nodes = await this.objectItemsRepository.find({
            where: {
                hw_type: 'openshift',
                subsystem: 'node'
            }
        });
        const configurationNodeTable = new ConfigurationTable_1.ConfigurationTable(nodes.map(node => node.item_id), ['kubeletVersion', 'containerRuntimeVersion', 'architecture', 'osImage'], ['cluster']);
        configurationNodeTable.setItemLabel("Node");
        configurationNodeTable.sortByColumn(0, 'desc');
        configurationNodeTable.setAcl(this.request);
        tabs.push({
            title: 'Node',
            content: [await configurationNodeTable.generate()],
        });
        let pods = await this.objectItemsRepository.find({
            where: {
                hw_type: 'openshift',
                subsystem: 'pod'
            }
        });
        const configurationPodTable = new ConfigurationTable_1.ConfigurationTable(pods.map(pod => pod.item_id), ['status', 'podIP'], ['cluster', 'project']);
        configurationPodTable.setItemLabel("Pod");
        configurationNodeTable.sortByColumn(0, 'desc');
        configurationPodTable.setAcl(this.request);
        tabs.push({
            title: 'Pod',
            content: [await configurationPodTable.generate()],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.OpenshiftConfigurationPage = OpenshiftConfigurationPage;
class OpenshiftPodoverviewPage extends OpenshiftPage {
    constructor() {
        super(...arguments);
        this.title = 'POD Overview';
    }
    async getPage() {
        const tabs = [];
        const clusters = await this.objectItemsRepository.findBy({
            hw_type: 'openshift',
            subsystem: 'cluster'
        });
        let overview = new Table_1.Table()
            .addHeader({ value: 'Cluster' })
            .addHeader({ value: 'Running' })
            .addHeader({ value: 'Pending' })
            .addHeader({ value: 'Succeeded' })
            .addHeader({ value: 'Failed' });
        const pods = await this.objectItemsRepository.find({
            relations: {
                properties: true,
                parents: {
                    _parent: true
                }
            },
            where: {
                hw_type: 'openshift',
                subsystem: 'pod'
            }
        });
        for (const cluster of clusters) {
            const clusterPods = pods.filter(pod => pod.parents.find(parent => parent.parent === cluster.item_id) !== undefined);
            overview.addRow([
                {
                    order: 0,
                    value: cluster.label
                },
                {
                    order: 1,
                    value: clusterPods.filter(pod => pod.properties.find(property => property.property_name === 'status' && property.property_value === 'Running') !== undefined).length
                },
                {
                    order: 2,
                    value: clusterPods.filter(pod => pod.properties.find(property => property.property_name === 'status' && property.property_value === 'Pending') !== undefined).length
                },
                {
                    order: 3,
                    value: clusterPods.filter(pod => pod.properties.find(property => property.property_name === 'status' && property.property_value === 'Succeeded') !== undefined).length
                },
                {
                    order: 4,
                    value: clusterPods.filter(pod => pod.properties.find(property => property.property_name === 'status' && property.property_value === 'Failed') !== undefined).length
                }
            ]);
        }
        overview.sortByIndex(0, false, true);
        let podTable = new Table_1.Table()
            .addHeader({ value: 'Pod' })
            .addHeader({ value: 'Cluster' })
            .addHeader({ value: 'Project' })
            .addHeader({ value: 'Status' });
        for (const pod of pods) {
            const cluster = pod.parents.find(parent => parent._parent.subsystem === 'cluster');
            const namespace = pod.parents.find(parent => parent._parent.subsystem === 'project');
            const status = pod.properties.find(property => property.property_name === 'status');
            podTable.addRow([
                {
                    order: 0,
                    value: pod.label,
                    url: new URL_1.URL().generateFromObject(pod)
                },
                {
                    order: 1,
                    value: cluster ? cluster._parent.label : '',
                    url: cluster ? new URL_1.URL().generateFromObject(cluster._parent) : undefined
                },
                {
                    order: 2,
                    value: namespace ? namespace._parent.label : '',
                    url: namespace ? new URL_1.URL().generateFromObject(namespace._parent) : undefined
                },
                {
                    order: 3,
                    value: status ? status.property_value : ''
                }
            ]);
        }
        podTable.sortByIndex(0, false, true);
        tabs.push({
            title: 'Overview',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.TextBox,
                    styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
                    text: "Overview"
                },
                overview.generateBox(),
                {
                    type: pageResponse_constants_1.BOX_TYPE.TextBox,
                    styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
                    text: "All Pods"
                },
                podTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(this.title, tabs);
        return this.page;
    }
}
exports.OpenshiftPodoverviewPage = OpenshiftPodoverviewPage;
class OpenshiftContainerPage extends OpenshiftItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'container';
    }
    async getPage() {
        let item = await this.objectItemsRepository.findOneBy({
            hw_type: this.hwType,
            subsystem: this.subsystem,
            item_id: this.itemId,
        });
        let title = 'Container ' + (item !== null ? item.label : this.itemId);
        let tabs = [];
        tabs.push({
            title: 'CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('container', 'cpu').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.used),
                        new OpenshiftMetrics.Metric('container', 'cpu_limit').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 2, Color_1.Color.metric.total)
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new OpenshiftMetrics.Metric('container', 'memory').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.used),
                        new OpenshiftMetrics.Metric('container', 'memory_limit').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 2, Color_1.Color.metric.total)
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.OpenshiftContainerPage = OpenshiftContainerPage;
class OpenshiftHeatmapPage extends OpenshiftPage {
    constructor() {
        super(...arguments);
        this.title = 'Heatmap';
    }
    async getPage() {
        let title = 'Heatmap';
        let tabs = [];
        tabs.push({
            title: 'Node Heatmap',
            content: Object.values(await new Heatmap_1.Heatmap(this.hwType, "node", true)
                .computedHeatmapBox(class_constants_1.ClassKey.CONTAINER, this.request)),
        });
        let nodeTable = new Table_1.Table()
            .addHeader({ value: 'Node' })
            .addHeader({ value: 'CPU', unit: subsystemMetricsResponse_constants_1.UNIT.percent, number: true })
            .addHeader({ value: 'Memory', unit: subsystemMetricsResponse_constants_1.UNIT.percent, number: true });
        let nodes = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: 'node',
            },
            relations: {
                heatmaps: true,
            }
        });
        if (this.request) {
            const ids = await ACLCheck_1.ACLCheck.filterItemsWithRequest(this.request, nodes.map(item => item.item_id));
            nodes = nodes.filter(item => ids.includes(item.item_id));
        }
        for (const node of nodes) {
            const cpu = node.heatmaps.find(heatmap => heatmap.metric === 'cpu_usage');
            const memory = node.heatmaps.find(heatmap => heatmap.metric === 'memory_usage');
            nodeTable.addRow([
                { order: 1, value: node.label, url: URL_1.URL.generate(this.hwType, 'node', node.item_id) },
                { order: 2, value: cpu ? cpu.value : null },
                { order: 3, value: memory ? memory.value : null }
            ]);
        }
        nodeTable.sortByIndex(1);
        nodeTable.setBoxExport("openshift-heatmap");
        tabs.push({
            title: 'Node table',
            content: [nodeTable.generateBox()],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.OpenshiftHeatmapPage = OpenshiftHeatmapPage;
class OpenshiftTopPage extends OpenshiftPage {
    constructor() {
        super(...arguments);
        this.title = 'POD TOP';
    }
    async getPage() {
        const top = new Top_1.Top();
        top.setSubsystem('openshift', 'pod');
        top.setParentSubsystem('project');
        const tabs = await top.genTabs();
        this.page = new pageResponse_dto_1.Page(this.title, tabs);
        return this.page;
    }
}
exports.OpenshiftTopPage = OpenshiftTopPage;
class OpenshiftMetrics {
}
exports.OpenshiftMetrics = OpenshiftMetrics;
OpenshiftMetrics.Metric = class extends pageResponse_dto_1.Metric {
    constructor(subsystem, metric) {
        super();
        this.metric = metric;
        const definition = MetricsWrapper_1.MetricsWrapper.getMetric(class_constants_1.ClassKey.CONTAINER, hwTypeKey_constants_1.HwTypeKey.OPENSHIFT, subsystem, metric);
        if (definition) {
            Object.assign(this, definition);
        }
    }
    getGraph(type, stacked, order, color) {
        this.type = type;
        this.stacked = stacked ? stacked : false;
        this.order = order ? order : 0;
        this.color = color ? color : undefined;
        return this;
    }
};
//# sourceMappingURL=Openshift.js.map