import { Newable } from '@xormon/common/menuResponse.dto';
import { ChartType, Page } from '@xormon/common/pageResponse.dto';
import { AbstractFolder, AbstractPage } from "./AbstractMenu";
export declare class OracledbFolder extends AbstractFolder {
    hwType: string;
}
export declare class OracledbSubsystemFolder extends OracledbFolder {
    subsystem: string;
    itemId: string;
    constructor(itemId?: string);
}
export declare class OracledbRootFolder extends OracledbFolder {
    getChildrenAcl(): Promise<any[]>;
    getChildren(): Promise<any[]>;
}
export declare class OracledbHostsFolder extends OracledbSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class OracledbHostitemsFolder extends OracledbSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class OracledbGroupFolder extends OracledbSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class OracledbSubmenugroupFolder extends OracledbSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class OracledbOdbfolderFolder extends OracledbSubsystemFolder {
    subsystem: string;
    isStandalone(): Promise<boolean>;
    getChildren(): Promise<any[]>;
}
export declare class OracledbChildSubsystemFolder extends OracledbSubsystemFolder {
    subsystem: string;
    itemId: string;
    getChildren(): Promise<any[]>;
}
export declare class OracledbInstancesFolder extends OracledbSubsystemFolder {
    subsystem: string;
    itemId: string;
    getChildren(): Promise<any[]>;
}
export declare class OracledbTotalsFolder extends OracledbSubsystemFolder {
    subsystem: string;
    itemId: string;
    getChildren(): Promise<any[]>;
}
export declare class OracledbPdbsFolder extends OracledbSubsystemFolder {
    subsystem: string;
    itemId: string;
    getChildren(): Promise<any[]>;
}
export declare class OracledbGlobalcacheFolder extends OracledbSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class OracledbInstanceFolder extends OracledbSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class OracledbPage extends AbstractPage {
    hwType: string;
    rootFolder: Newable<AbstractFolder>;
}
export declare abstract class OracledbSingleItemPage extends OracledbPage {
    withItemId: boolean;
    subsystem: string;
    itemId: string;
    parentSubsystem: string;
    parentId: string;
}
export declare class OracledbTopPage extends OracledbPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class OracledbTotalconfigurationPage extends OracledbPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class OracledbHealthstatusPage extends OracledbPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class OracledbConfigurationPage extends OracledbSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class OracledbDatafilesPage extends OracledbSingleItemPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class OracledbMetrics {
    static Metric: {
        new (): {
            subsystem: string;
            init(): Promise<any>;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static BasicDbMetric: {
        new (metric: string, type: ChartType, subsystem: string, stacked: boolean, order: number, color?: string): {
            metric: string;
            type: ChartType;
            subsystem: string;
            stacked: boolean;
            order: number;
            color: string;
            init(): Promise<any>;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static CheckpointMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): Promise<any>;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
}
export declare class OracledbOverviewPage extends OracledbSingleItemPage {
    subsystem: string;
    title: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class OracledbGlobalcachePage extends OracledbSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class OracledbViewonePage extends OracledbSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class OracledbViewtwoPage extends OracledbSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class OracledbViewthreePage extends OracledbSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class OracledbViewfourPage extends OracledbSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class OracledbViewfivePage extends OracledbSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class OracledbCapacityPage extends OracledbSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare abstract class OracledbHostPage extends OracledbSingleItemPage {
    subsystem: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare abstract class OracledbCpuPage extends OracledbSingleItemPage {
    subsystem: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class OracledbIoPage extends OracledbSingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class OracledbDataPage extends OracledbSingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class OracledbSgadataPage extends OracledbSingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class OracledbSessionPage extends OracledbSingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class OracledbSqlqueryPage extends OracledbSingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class OracledbNetworkPage extends OracledbSingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class OracledbRatioPage extends OracledbSingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare class OracledbLatencyPage extends OracledbSingleItemPage {
    subsystem: string;
    title: string;
    total: boolean;
    getPage(): Promise<Page>;
}
export declare abstract class OracledbHosttotalPage extends OracledbHostPage {
    subsystem: string;
    total: boolean;
    withItemId: boolean;
}
export declare abstract class OracledbCputotalPage extends OracledbCpuPage {
    subsystem: string;
    total: boolean;
    withItemId: boolean;
}
export declare abstract class OracledbIototalPage extends OracledbIoPage {
    subsystem: string;
    total: boolean;
    withItemId: boolean;
}
export declare abstract class OracledbDatatotalPage extends OracledbDataPage {
    subsystem: string;
    total: boolean;
    withItemId: boolean;
}
export declare abstract class OracledbSgadatatotalPage extends OracledbSgadataPage {
    subsystem: string;
    total: boolean;
    withItemId: boolean;
}
export declare abstract class OracledbSessiontotalPage extends OracledbSessionPage {
    subsystem: string;
    total: boolean;
    withItemId: boolean;
}
export declare abstract class OracledbSqlquerytotalPage extends OracledbSqlqueryPage {
    subsystem: string;
    total: boolean;
    withItemId: boolean;
}
export declare abstract class OracledbNetworktotalPage extends OracledbNetworkPage {
    subsystem: string;
    total: boolean;
    withItemId: boolean;
}
export declare abstract class OracledbRatiototalPage extends OracledbRatioPage {
    subsystem: string;
    total: boolean;
    withItemId: boolean;
}
export declare abstract class OracledbLatencytotalPage extends OracledbLatencyPage {
    subsystem: string;
    total: boolean;
    withItemId: boolean;
}
