import { MenuItem } from '@xormon/common/menuResponse.dto';
import { ChartType, Page } from '@xormon/common/pageResponse.dto';
import { ItemRelation } from '@xormon/entity/itemRelation.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
export declare class RandomFolder {
    hwType: string;
    children?: Array<MenuItem>;
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
}
export declare class RandomRootFolder extends RandomFolder {
    getChildren(): Promise<any[]>;
}
export declare class RandomPage {
    hwType: string;
    page: Page;
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
    getPath(): Promise<any[]>;
}
export declare class RandomHeatmapPage extends RandomPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class RandomTotalsPage extends RandomPage {
    title: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare class RandomTotalsstackedPage extends RandomPage {
    title: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare class RandomTotalssumPage extends RandomPage {
    title: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare class RandomTotals100Page extends RandomPage {
    title: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare class RandomTotals100stackedPage extends RandomPage {
    title: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare class RandomTotals100sumPage extends RandomPage {
    title: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare class RandomTotals1000Page extends RandomPage {
    title: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare class RandomTotals1000stackedPage extends RandomPage {
    title: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare class RandomTotals1000sumPage extends RandomPage {
    title: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare class RandomTotals5000Page extends RandomPage {
    title: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare class RandomTotals5000stackedPage extends RandomPage {
    title: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare class RandomTotals5000sumPage extends RandomPage {
    title: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare abstract class RandomSingleItemPage extends RandomPage {
    subsystem: string;
    itemId: string;
    constructor(itemId: string);
    getPath(): Promise<any[]>;
}
export declare class RandomDataPage extends RandomSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare class RandomMetrics {
    static Metric: {
        new (): {
            subsystem: string;
            unit: "percent";
            shortcut: "%";
            label: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unitLabel?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static FakeMetric: {
        new (): {
            subsystem: string;
            unit: "cpu";
            shortcut: "CPU";
            label: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unitLabel?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static CpuLineMetric: {
        new (): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            subsystem: string;
            unit: "percent";
            shortcut: "%";
            label: string;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unitLabel?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static CpuLineAggrMetric: {
        new (): {
            aggregate: "items";
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            subsystem: string;
            unit: "percent";
            shortcut: "%";
            label: string;
            unitLabel?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static CpuStackedAggrMetric: {
        new (): {
            aggregate: "items";
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            subsystem: string;
            unit: "cpu";
            shortcut: "CPU";
            label: string;
            unitLabel?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static CpuSumAggrMetric: {
        new (): {
            aggregate: "sum";
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            subsystem: string;
            unit: "cpu";
            shortcut: "CPU";
            label: string;
            unitLabel?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
}
