"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StorPortTypePage = exports.StorItemPage = exports.StorSingleItemPage = exports.StorCapacityPage = exports.StorDevicePage = exports.StorDevicetotalPage = exports.StorTotalPage = exports.StorOverviewPage = exports.StorHealthstatusPage = exports.StorSantopologyPage = exports.StorMappingPage = exports.StorHoststopPage = exports.StorVolumestopPage = exports.StorConfigurationPage = exports.StorInactivevolumesPage = exports.StorHeatmapPage = exports.SimpleStorPage = exports.StorPage = exports.StorSubsystemItemsFolder = exports.StorDeviceFolder = exports.StorRootFolder = exports.StorSubsystemFolder = exports.StorFolder = exports.sortStorageMetrics = exports.storageGlobalPages = exports.getStorageCustomGroupMetrics = exports.storageRegroupPages = exports.storageRegroupMetrics = exports.storageRegroupTotalMetric = exports.StoragePages = void 0;
const pageResponse_constants_1 = require("../../../common/constants/pageResponse.constants");
const subsystemMetricsResponse_constants_1 = require("../../../common/constants/subsystemMetricsResponse.constants");
const menuResponse_dto_1 = require("../../../common/menuResponse.dto");
const pageResponse_dto_1 = require("../../../common/pageResponse.dto");
const dataSource_1 = require("../../../config/dataSource");
const hostcfg_entity_1 = require("../../../entity/hostcfg.entity");
const storageGroup_entity_1 = require("../../../entity/storageGroup.entity");
const ACLCheck_1 = require("../../acl/ACLCheck");
const class_constants_1 = require("../../../common/constants/class.constants");
;
;
const MetricsWrapper_1 = require("../../metrics/MetricsWrapper");
const Prediction_1 = require("../../metrics/Prediction");
const Storage_1 = require("../../metrics/class/Storage");
const User_1 = require("../../users/User");
const typeorm_1 = require("typeorm");
const CustomTop_1 = require("./CustomTop");
const HealthStatus_1 = require("./HealthStatus");
const Heatmap_1 = require("./Heatmap");
const Overview_1 = require("./Overview");
const San_1 = require("./San");
const Table_1 = require("./Table");
const URL_1 = require("./URL");
const Color_1 = require("../../metrics/Color");
const common_1 = require("@nestjs/common");
const TableGenerator_1 = require("../../metrics/TableGenerator");
const AbstractMenu_1 = require("./AbstractMenu");
const CapacityTableBuilder_1 = require("./CapacityTableBuilder");
var StoragePages;
(function (StoragePages) {
    StoragePages["totals"] = "totals";
    StoragePages["capacity"] = "capacity";
    StoragePages["mapping"] = "mapping";
    StoragePages["heatmap"] = "heatmap";
    StoragePages["overview"] = "overview";
    StoragePages["configuration"] = "configuration";
    StoragePages["healthStatus"] = "healthStatus";
})(StoragePages || (exports.StoragePages = StoragePages = {}));
exports.storageRegroupTotalMetric = {
    Data: [
        'read',
        'write'
    ],
    IO: [
        'read_io',
        'write_io'
    ],
    Latency: [
        'resp_t'
    ],
    'Block Size': [
        'block_size'
    ]
};
exports.storageRegroupMetrics = {
    Read: [
        'read',
        'read_io',
        'resp_t_r',
        'block_size_r'
    ],
    Write: [
        'write',
        'write_io',
        'resp_t_w',
        'block_size_w'
    ],
    Sum: [
        'data_rate',
        'io_rate',
        'resp_t',
        'block_size'
    ]
};
exports.storageRegroupPages = {
    data: [
        'read',
        'write',
        'data_rate'
    ],
    io: [
        'read_io',
        'write_io',
        'io_rate'
    ],
    resp_t: [
        'resp_t_r',
        'resp_t_w',
        'resp_t'
    ],
    block_size: [
        'block_size_r',
        'block_size_w',
        'block_size'
    ]
};
const checkRegroupMetric = (metrics) => {
    for (const storageRegroupMetric in exports.storageRegroupMetrics) {
        if (metrics.find(metric => exports.storageRegroupMetrics[storageRegroupMetric].includes(metric.metric)) !== undefined) {
            if ((storageRegroupMetric === 'Read' && metrics.find(metric => exports.storageRegroupMetrics['Write'].includes(metric.metric)) !== undefined)
                || (storageRegroupMetric === 'Write' && metrics.find(metric => exports.storageRegroupMetrics['Read'].includes(metric.metric)) !== undefined)) {
                return exports.storageRegroupMetrics['Read'].concat(exports.storageRegroupMetrics['Write']);
            }
            return exports.storageRegroupMetrics[storageRegroupMetric];
        }
    }
    return null;
};
const getRegropMetricTab = (metric) => {
    if (metric === 'resp_t' || metric === 'block_size') {
        return 'Average';
    }
    for (const storageRegroupMetric in exports.storageRegroupMetrics) {
        if (exports.storageRegroupMetrics[storageRegroupMetric].find(regroupMetric => regroupMetric === metric) !== undefined) {
            return storageRegroupMetric;
        }
    }
    return null;
};
const getRegropMetricPage = (metric) => {
    for (const storageRegroupPage in exports.storageRegroupPages) {
        if (exports.storageRegroupPages[storageRegroupPage].find(regroupMetric => regroupMetric === metric) !== undefined) {
            return storageRegroupPage;
        }
    }
    return null;
};
const filterDeactivatedDevices = async (itemIds) => {
    const hostcfgs = await (0, dataSource_1.getDataSource)().getRepository(hostcfg_entity_1.HostCfg).findBy({
        hostcfg_id: (0, typeorm_1.In)(itemIds)
    });
    return hostcfgs.filter(hostcfg => hostcfg.disabled !== true).map(hostcfg => hostcfg.hostcfg_id);
};
const checkPeakMetric = (subsystem, metrics) => {
    const maxMetrics = TableGenerator_1.TableGenerator.getMaxMetricsByClass();
    if (maxMetrics['storage'][subsystem]) {
        const mMetrics = maxMetrics['storage'][subsystem];
        const metric = metrics.find(m => mMetrics.includes(m.metric));
        if (metric) {
            return {
                ...metric,
                label: metric.label + " (Peak)",
                metric: metric.metric + "_max",
                color: Color_1.Color.pallete.blueDark
            };
        }
    }
    return;
};
const getStorageCustomGroupMetrics = () => {
    return [
        Storage_1.Storage.metrics['io_rate'],
        Storage_1.Storage.metrics['read_io'],
        Storage_1.Storage.metrics['write_io'],
        Storage_1.Storage.metrics['data_rate'],
        Storage_1.Storage.metrics['read'],
        Storage_1.Storage.metrics['write'],
        Storage_1.Storage.metrics['resp_t'],
        Storage_1.Storage.metrics['resp_t_r'],
        Storage_1.Storage.metrics['resp_t_w'],
        Storage_1.Storage.metrics['capacity_total'],
        Storage_1.Storage.metrics['capacity_free'],
        Storage_1.Storage.metrics['capacity_used'],
        Storage_1.Storage.metrics['capacity_used_percent'],
        Storage_1.Storage.metrics['virtual_capacity_total']
    ];
};
exports.getStorageCustomGroupMetrics = getStorageCustomGroupMetrics;
const storageGlobalPages = (parent) => {
    let menuItems = [];
    menuItems.push(new menuResponse_dto_1.MenuLink('Total', parent + '/total', 'total'));
    menuItems.push(new menuResponse_dto_1.MenuLink('Health Status', parent + '/health-status', 'health-status'));
    menuItems.push(new menuResponse_dto_1.MenuLink('Heatmap', parent + '/heatmap', 'heatmap'));
    menuItems.push(new menuResponse_dto_1.MenuLink('Capacity', parent + '/capacity', 'capacity'));
    menuItems.push(new menuResponse_dto_1.MenuLink('Configuration', parent + '/configuration', 'configuration'));
    menuItems.push(new menuResponse_dto_1.MenuLink('Overview', parent + '/overview', 'overview'));
    menuItems.push(new menuResponse_dto_1.MenuLink('SAN Topology', parent + '/san-topology', 'san-topology'));
    menuItems.push(new menuResponse_dto_1.MenuLink('Mapping', parent + '/mapping', 'mapping'));
    menuItems.push(new menuResponse_dto_1.MenuLink('Hosts TOP', parent + '/hosts-top', 'configuration'));
    menuItems.push(new menuResponse_dto_1.MenuLink('Volumes TOP', parent + '/volumes-top', 'volumes-top'));
    menuItems.push(new menuResponse_dto_1.MenuLink('Volumes Inactive', parent + '/inactive-volumes', 'inactive-volumes'));
    return menuItems;
};
exports.storageGlobalPages = storageGlobalPages;
const sortStorageMetrics = (metrics) => {
    const storageMetricsMapping = {};
    let i = 0;
    for (const metric in Storage_1.Storage.metrics) {
        storageMetricsMapping[metric] = i;
        i++;
    }
    metrics.sort((a, b) => storageMetricsMapping[a.metric] - storageMetricsMapping[b.metric]);
    return metrics;
};
exports.sortStorageMetrics = sortStorageMetrics;
class StorFolder extends AbstractMenu_1.StorAbstractFolder {
}
exports.StorFolder = StorFolder;
class StorSubsystemFolder extends StorFolder {
    constructor(hwType, subsystem, itemId) {
        super(hwType);
        if (itemId !== null) {
            if (Array.isArray(itemId)) {
                if (itemId.length === 1) {
                    this.itemId = itemId[0];
                }
                else {
                    this.itemIds = itemId;
                }
            }
            else {
                this.itemId = itemId;
            }
        }
        if (subsystem !== null) {
            this.subsystem = subsystem.toString();
        }
    }
}
exports.StorSubsystemFolder = StorSubsystemFolder;
class StorRootFolder extends StorFolder {
    constructor(hw_type, request) {
        super(hw_type);
        this.request = request;
    }
    async getChildren() {
        let menuItems = [];
        let root_subsystem = 'device';
        let devices = await this.objectItemsRepository.findBy({
            hw_type: this.hwType,
            subsystem: root_subsystem,
        });
        if (this.request) {
            const user = await User_1.User.getUserByRequest(this.request, true);
            const ids = await ACLCheck_1.ACLCheck.filterItems(user.groups.map(group => group.group_id), devices.map(device => device.item_id));
            devices = devices.filter(device => ids.includes(device.item_id));
        }
        devices.sort((a, b) => a.label.localeCompare(b.label, undefined, { numeric: true, sensitivity: 'base' }));
        for (let item of devices) {
            let path = this.hwType.toLowerCase() + '/device?ids=' + item.item_id;
            menuItems.push(new menuResponse_dto_1.MenuFolder(item.label, path, this.hwType.toLowerCase(), 'device', item.item_id, StorDeviceFolder));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.StorRootFolder = StorRootFolder;
class StorDeviceFolder extends StorSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'device';
    }
    async getChildren() {
        let menuItems = [];
        if (!Storage_1.Storage.technology[this.hwType]) {
            return [];
        }
        const storage = Storage_1.Storage.technology[this.hwType];
        if (storage.pages) {
            for (const pageKey in storage.pages) {
                switch (storage.pages[pageKey]) {
                    case StoragePages.totals:
                        menuItems.push(new menuResponse_dto_1.MenuLink('Total', this.hwType + '/device?item_id=' + this.itemId, 'device', this.itemId, true));
                        break;
                    case StoragePages.heatmap:
                        menuItems.push(new menuResponse_dto_1.MenuLink('Heatmap', this.hwType + '/heatmap?item_id=' + this.itemId, 'heatmap', this.itemId));
                        break;
                    case StoragePages.configuration:
                        menuItems.push(new menuResponse_dto_1.MenuLink('Configuration', this.hwType + '/configuration?item_id=' + this.itemId, 'configuration', this.itemId));
                        break;
                    case StoragePages.mapping:
                        menuItems.push(new menuResponse_dto_1.MenuLink('Mapping', this.hwType + '/mapping?item_id=' + this.itemId, 'mapping', this.itemId));
                        break;
                    case StoragePages.capacity:
                        menuItems.push(new menuResponse_dto_1.MenuLink('Capacity', this.hwType + '/capacity?item_id=' + this.itemId, 'capacity', this.itemId));
                        break;
                    case StoragePages.healthStatus:
                        menuItems.push(new menuResponse_dto_1.MenuLink('Health Status', this.hwType + '/health-status?item_id=' + this.itemId, 'health-status', this.itemId));
                        break;
                    default:
                        break;
                }
            }
        }
        const hwTypeDefinition = Storage_1.Storage.technology[this.hwType];
        const subsystems = Object.keys(hwTypeDefinition['subsystems']);
        for (let childSubsystem of subsystems) {
            if (childSubsystem === "device") {
                continue;
            }
            const exceptionSubsystems = ['site', 'vdc'];
            if ((hwTypeDefinition['subsystems'][childSubsystem]['totals'] === undefined
                && hwTypeDefinition['subsystems'][childSubsystem]['totals'] === undefined)
                || (Object.keys(hwTypeDefinition['subsystems'][childSubsystem]['totals']).length === 0
                    && Object.keys(hwTypeDefinition['subsystems'][childSubsystem]['single']).length === 0
                    && !exceptionSubsystems.includes(childSubsystem))) {
                continue;
            }
            let childSubsystemItemCheck = await this.objectItemsRepository.findOne({
                where: {
                    hw_type: this.hwType,
                    subsystem: childSubsystem,
                    parents: this.itemId !== null ? {
                        parent: this.itemId
                    } : undefined
                }, relations: this.itemId !== null ? {
                    parents: true
                } : undefined
            });
            if (childSubsystemItemCheck) {
                const label = hwTypeDefinition.subsystems[childSubsystem].label ? hwTypeDefinition.subsystems[childSubsystem].label : childSubsystem;
                let path = this.hwType + '/' + childSubsystem + (this.itemId !== null ? '?ids=' + this.itemId : '');
                menuItems.push(new menuResponse_dto_1.MenuFolder(label, path, this.hwType, childSubsystem, this.itemId, StorSubsystemItemsFolder));
            }
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.StorDeviceFolder = StorDeviceFolder;
class StorSubsystemItemsFolder extends StorSubsystemFolder {
    constructor(hwType, subsystem, itemId) {
        super(hwType, subsystem, itemId);
        this.subsystem = subsystem.toString();
    }
    async getChildren() {
        let menuItems = [];
        this.subsystem = this.subsystem.replace('Cpucore', 'cpu-core');
        if (Storage_1.Storage.technology[this.hwType]['subsystems'][this.subsystem] ||
            Storage_1.Storage.technology[this.hwType]['subsystems'][this.subsystem.replace('-items', '').replace('items', '')]) {
            if (this.subsystem.includes('items')) {
                const subsys = this.subsystem.replace('-items', '').replace('items', '');
                let items = await this.objectItemsRepository.find({
                    where: {
                        hw_type: this.hwType,
                        subsystem: subsys,
                        parents: {
                            parent: this.itemId.toString()
                        }
                    },
                    relations: {
                        parents: true
                    }
                });
                items.sort((a, b) => a.label.localeCompare(b.label, undefined, { numeric: true, sensitivity: 'base' }));
                for (let item of items) {
                    let path = this.hwType.toLowerCase() + '/' + subsys + '?item_id=' + item.item_id;
                    menuItems.push(new menuResponse_dto_1.MenuLink(item.label, path, subsys, item.item_id));
                }
                this.children = menuItems;
            }
            else {
                const subsystemDefinition = Storage_1.Storage.technology[this.hwType]['subsystems'][this.subsystem];
                if (subsystemDefinition['totals'] && Object.keys(subsystemDefinition['totals']).length >= 1) {
                    for (const page in subsystemDefinition['totals']) {
                        const item = subsystemDefinition['totals'][page];
                        menuItems.push(new menuResponse_dto_1.MenuLink(item['label'], this.hwType + '/' + this.subsystem + '-' + page + '?item_id=' + this.itemId, this.subsystem + '-totals', this.itemId));
                    }
                }
                if (subsystemDefinition['single'] && Object.keys(subsystemDefinition['single']).length >= 1) {
                    let path = this.hwType + '/' + this.subsystem + '-items' + (this.itemId !== null ? '?ids=' + this.itemId : '');
                    menuItems.push(new menuResponse_dto_1.MenuFolder('Items', path, this.hwType, this.subsystem, this.itemId, StorSubsystemItemsFolder));
                }
                this.children = menuItems;
            }
        }
        return menuItems;
    }
}
exports.StorSubsystemItemsFolder = StorSubsystemItemsFolder;
class StorPage extends AbstractMenu_1.StorAbstractPage {
    constructor() {
        super(...arguments);
        this.withItemId = true;
        this.rootFolder = StorRootFolder;
        this.storageGroupsRepository = (0, dataSource_1.getDataSource)().getRepository(storageGroup_entity_1.StorageGroup);
    }
}
exports.StorPage = StorPage;
class SimpleStorPage extends AbstractMenu_1.AbstractPage {
    constructor() {
        super(...arguments);
        this.withItemId = true;
        this.rootFolder = StorRootFolder;
        this.storageGroupsRepository = (0, dataSource_1.getDataSource)().getRepository(storageGroup_entity_1.StorageGroup);
        this.hostCfgRepository = (0, dataSource_1.getDataSource)().getRepository(hostcfg_entity_1.HostCfg);
    }
}
exports.SimpleStorPage = SimpleStorPage;
class StorHeatmapPage extends SimpleStorPage {
    constructor() {
        super(...arguments);
        this.title = 'Heatmap';
    }
    async getTab(tab) {
        if (tab === 'pool') {
            const heatmap = new Heatmap_1.HeatmapStorage(this.request);
            return {
                title: 'Pool',
                content: [],
                subTabs: [
                    {
                        title: 'Heatmap',
                        content: Object.values(await heatmap.heatmapBox('pool', this.itemId ? this.itemId : undefined))
                    }, {
                        title: 'Table',
                        content: [
                            await heatmap.tableBox('pool')
                        ]
                    }
                ]
            };
        }
        else if (tab === 'volume') {
            const heatmap = new Heatmap_1.HeatmapStorage(this.request);
            return {
                title: 'Volume',
                content: [],
                subTabs: [
                    {
                        title: 'Heatmap',
                        content: Object.values(await heatmap.heatmapBox('volume', this.itemId ? this.itemId : undefined))
                    }, {
                        title: 'Table',
                        content: [
                            await heatmap.tableBox('volume')
                        ]
                    }
                ]
            };
        }
        else {
            throw new common_1.NotFoundException();
        }
    }
    async getPage() {
        let title = 'Heatmap';
        let tabs = [];
        const heatmap = new Heatmap_1.HeatmapStorage(this.request);
        tabs.push({
            title: 'Pool',
            content: Object.values(await heatmap.heatmapBox('pool', this.itemId ? this.itemId : undefined)),
        });
        tabs.push({
            title: 'Pool table',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.TextBox,
                    text: "Note: Pools below the Tier IOPS limit are not considered",
                    styleClass: "st"
                },
                {
                    type: pageResponse_constants_1.BOX_TYPE.TextBox,
                    text: "Check Settings ➡ Heatmap Tier ➡ Tiers.",
                    styleClass: "st"
                },
                await heatmap.tableBox('pool')
            ],
        });
        tabs.push({
            title: 'Volume',
            content: Object.values(await heatmap.heatmapBox('volume', this.itemId ? this.itemId : undefined)),
        });
        tabs.push({
            title: 'Volume table',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.TextBox,
                    text: "Note: Volumes below the Tier IOPS limit are not considered",
                    styleClass: "st"
                },
                {
                    type: pageResponse_constants_1.BOX_TYPE.TextBox,
                    text: "Check Settings ➡ Heatmap Tier ➡ Tiers.",
                    styleClass: "st"
                },
                await heatmap.tableBox('volume')
            ],
        });
        tabs.push({
            title: 'Capacity',
            content: Object.values(await (new Heatmap_1.HeatmapStorageCapacity(this.request)).gen(this.itemId || undefined))
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StorHeatmapPage = StorHeatmapPage;
class StorInactivevolumesPage extends SimpleStorPage {
    constructor() {
        super(...arguments);
        this.title = 'Volumes Inactive';
    }
    async getPage() {
        let title = 'Volumes Inactive';
        let tabs = [];
        let table = new Table_1.Table()
            .addHeader({ value: 'Volume' })
            .addHeader({ value: 'Storage' })
            .addHeader({ value: 'Pool' })
            .addHeader({ value: 'Capacity', unit: subsystemMetricsResponse_constants_1.UNIT.bytes, number: true, decimal: 0, prefix: pageResponse_constants_1.UNIT_PREFIX.gibi, multiplier: 1024 })
            .addHeader({ value: 'Host' });
        let volumes = await this.objectItemsRepository.find({
            where: {
                hw_type_entity: {
                    class: 'storage'
                },
                subsystem: 'volume',
                createdAt: (0, typeorm_1.LessThan)(new Date(new Date().getTime() - 7 * 24 * 60 * 60 * 1000))
            }, relations: {
                hw_type_entity: true,
                parents: {
                    _parent: true
                }
            }
        });
        if (this.request) {
            const user = await User_1.User.getUserByRequest(this.request, true);
            const volumesIds = await ACLCheck_1.ACLCheck.filterItems(user.groups.map(group => group.group_id), volumes.map(volume => volume.item_id));
            volumes = volumes.filter(volume => volumesIds.includes(volume.item_id));
        }
        const monthInSec = 60 * 60 * 24 * 31;
        if (volumes.length >= 1) {
            const lastValues = await new MetricsWrapper_1.MetricsWrapper(['capacity_total'], volumes.map(item => item.item_id)).getLastHourValueFromTable();
            const lastMonthMax = await new MetricsWrapper_1.MetricsWrapper(['io_rate'], volumes.map(item => item.item_id)).getAvgAndMax(monthInSec);
            for (const volume of volumes) {
                if (lastMonthMax[volume.item_id] && lastMonthMax[volume.item_id]['io_rate']['max'] > 0) {
                    continue;
                }
                const device = volume.parents.find(parent => parent._parent.subsystem === 'device');
                const pool = volume.parents.find(parent => parent._parent.subsystem === 'pool');
                const hosts = volume.parents.filter((item) => item._parent.subsystem === 'host');
                if (device === undefined || pool === undefined) {
                    continue;
                }
                table.addRow([
                    { order: 0, value: volume.label, url: URL_1.URL.generate(volume.hw_type, 'volume', volume.item_id) },
                    { order: 1, value: device ? device._parent.label : ' ' },
                    { order: 2, value: pool ? pool._parent.label : ' ' },
                    { order: 3, value: lastValues[volume.item_id] ? lastValues[volume.item_id]['capacity_total'] : null },
                    { order: 4, value: hosts.length >= 1 ? hosts.map(host => host._parent.label).toString() : ' ' }
                ]);
            }
        }
        table.sortByIndex(0, false, true);
        table.setBoxExport("inactive-volumes");
        tabs.push({
            title: 'Volumes Inactive',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.TextBox,
                    text: 'List of volumes with zero load in the last month (volumes monitored for more than a week are displayed).'
                },
                table.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StorInactivevolumesPage = StorInactivevolumesPage;
class StorConfigurationPage extends SimpleStorPage {
    constructor() {
        super(...arguments);
        this.title = 'Configuration';
    }
    async getPage() {
        let title = 'Configuration';
        let tabs = [];
        if (this.itemId) {
            const device = await this.objectItemsRepository.findOneBy({ item_id: this.itemId });
            let hwTable = new Table_1.Table();
            let itemProperties = [];
            const configurationDefinitions = await MetricsWrapper_1.MetricsWrapper.getConfiguration(class_constants_1.ClassKey.STORAGE, device.hw_type, 'device');
            if (configurationDefinitions) {
                itemProperties = await this.itemPropertiesRepository.find({
                    where: {
                        item_id: this.itemId,
                        property_name: (0, typeorm_1.In)(Object.keys(configurationDefinitions))
                    }
                });
            }
            else {
                itemProperties = await this.itemPropertiesRepository.find({
                    where: {
                        item_id: this.itemId,
                        property_name: (0, typeorm_1.Not)((0, typeorm_1.In)(['alerts', 'events', 'hs_nodes', 'hs_drives', 'hs_pd', 'hs_sds', 'hs_mdm', 'epar_remotecopy', 'epar_pool', 'epar_volumes', 'epar_ports', 'epar_disks', 'epar_cage', 'epar_psu']))
                    }
                });
            }
            if (configurationDefinitions) {
                for (const key in configurationDefinitions) {
                    if (!configurationDefinitions[key]) {
                        console.warn("No configuration definition for " + key + " found");
                        hwTable.addHeader({
                            value: key
                        });
                        continue;
                    }
                    hwTable.addHeader({
                        value: configurationDefinitions[key].label ? configurationDefinitions[key].label : key,
                        unit: configurationDefinitions[key].unit ? configurationDefinitions[key].unit : undefined,
                        number: configurationDefinitions[key].unit ? true : false,
                        prefix: configurationDefinitions[key].defaultPrefix ? configurationDefinitions[key].defaultPrefix : undefined,
                        decimal: configurationDefinitions[key].decimal ? configurationDefinitions[key].decimal : undefined
                    });
                }
            }
            else {
                for (const itemProperty of itemProperties) {
                    hwTable.addHeader({ value: configurationDefinitions[itemProperty.property_name] ? configurationDefinitions[itemProperty.property_name].label : itemProperty.property_name });
                }
            }
            let i = 0;
            let tableColumns = [];
            if (configurationDefinitions) {
                const dict = {};
                for (const itemProperty of itemProperties) {
                    dict[itemProperty.property_name] = itemProperty.property_value;
                }
                for (const key in configurationDefinitions) {
                    tableColumns.push({ order: i, value: dict[key] ? dict[key] : ' ' });
                }
            }
            else {
                for (const itemProperty of itemProperties) {
                    tableColumns.push({ order: i, value: itemProperty.property_value });
                    i++;
                }
            }
            hwTable.addRow(tableColumns);
            tabs.push({
                title: 'Configuration',
                content: [
                    hwTable.generatePivotBox(),
                ],
            });
            const pools = await this.objectItemsRepository.find({
                relations: {
                    parents: {
                        _parent: true
                    },
                    mappings: true
                },
                where: {
                    subsystem: 'pool',
                    parents: {
                        parent: this.itemId
                    }
                },
                order: {
                    label: 'DESC'
                }
            });
            if (pools.length > 0) {
                const poolConfigurationDefinitions = await MetricsWrapper_1.MetricsWrapper.getConfiguration(class_constants_1.ClassKey.STORAGE, device.hw_type, 'pool');
                if (Object.keys(poolConfigurationDefinitions).length > 0) {
                    let poolTable = new Table_1.Table();
                    let poolProperties = [];
                    poolProperties = await this.itemPropertiesRepository.find({
                        relations: {
                            _item: {
                                parents: {
                                    _parent: true
                                }
                            }
                        },
                        where: {
                            _item: {
                                subsystem: 'pool',
                                parents: {
                                    _parent: {
                                        item_id: this.itemId
                                    }
                                }
                            },
                            property_name: (0, typeorm_1.In)(Object.keys(poolConfigurationDefinitions))
                        }
                    });
                    poolTable.addHeader({ value: 'Pool' });
                    for (const key in poolConfigurationDefinitions) {
                        poolTable.addHeader({
                            value: poolConfigurationDefinitions[key].label,
                            unit: poolConfigurationDefinitions[key].unit ? poolConfigurationDefinitions[key].unit : undefined,
                            number: poolConfigurationDefinitions[key].unit ? true : false,
                            prefix: poolConfigurationDefinitions[key].defaultPrefix ? poolConfigurationDefinitions[key].defaultPrefix : undefined,
                            decimal: poolConfigurationDefinitions[key].decimal ? poolConfigurationDefinitions[key].decimal : undefined
                        });
                    }
                    let tableColumns = [];
                    for (const pool of pools) {
                        tableColumns = [];
                        tableColumns.push({ order: 0, value: pool.label, url: URL_1.URL.generate(pool.hw_type, 'pool', pool.item_id) });
                        const dict = {};
                        for (const itemProperty of poolProperties) {
                            if (itemProperty._item.item_id === pool.item_id) {
                                dict[itemProperty.property_name] = itemProperty.property_value;
                            }
                        }
                        let i = 1;
                        for (const key in poolConfigurationDefinitions) {
                            tableColumns.push({ order: i, value: dict[key] ? dict[key] : ' ' });
                            i++;
                        }
                        poolTable.addRow(tableColumns);
                    }
                    tabs.push({
                        title: 'Pool',
                        content: [poolTable.generateBox()],
                    });
                }
            }
            const volumes = await this.objectItemsRepository.find({
                relations: {
                    parents: {
                        _parent: true
                    },
                    mappings: true
                },
                where: {
                    subsystem: 'volume',
                    parents: {
                        _parent: [{
                                subsystem: (0, typeorm_1.In)(['pool', 'host']),
                                parents: {
                                    parent: this.itemId
                                }
                            }, {
                                item_id: this.itemId
                            }]
                    }
                },
                order: {
                    label: 'DESC'
                }
            });
            if (volumes.length > 0) {
                const lastValues = await new MetricsWrapper_1.MetricsWrapper(['capacity_total'], volumes.map(item => item.item_id)).getLastValuesFromTable();
                let volumeTable = new Table_1.Table()
                    .addHeader({ value: 'Volume' })
                    .addHeader({ value: 'Pool' })
                    .addHeader({ value: 'Capacity', unit: subsystemMetricsResponse_constants_1.UNIT.bytes, number: true, decimal: 0, prefix: pageResponse_constants_1.UNIT_PREFIX.gibi, multiplier: 1024 })
                    .addHeader({ value: 'Host' })
                    .addHeader({ value: 'Volume ID' });
                for (const volume of volumes) {
                    let parent_pool = volume.parents.find((item) => item._parent.subsystem === 'pool');
                    let hosts = volume.parents.filter((item) => item._parent.subsystem === 'host');
                    volumeTable.addRow([
                        { order: 0, value: volume.label, url: URL_1.URL.generate(volume.hw_type, 'volume', volume.item_id) },
                        {
                            order: 1,
                            value: parent_pool ? parent_pool._parent.label : ' ',
                            url: parent_pool ? URL_1.URL.generate(parent_pool._parent.hw_type, 'pool', parent_pool._parent.item_id) : undefined,
                        },
                        { order: 2, value: lastValues[volume.item_id] ? lastValues[volume.item_id]['capacity_total'] : null },
                        { order: 3, value: hosts.length >= 1 ? hosts.map(host => host._parent.label).toString() : ' ' },
                        { order: 4, value: volume.mappings.length >= 1 ? volume.mappings.map(mapping => mapping.wwn).toString() : ' ' },
                    ]);
                }
                tabs.push({
                    title: 'Volume',
                    content: [volumeTable.generateBox()],
                });
            }
        }
        else {
            let hwTable = new Table_1.Table()
                .addHeader({ value: 'Alias name' })
                .addHeader({ value: 'Node name' })
                .addHeader({ value: 'IP' })
                .addHeader({ value: 'Model' })
                .addHeader({ value: 'Serial' })
                .addHeader({ value: 'Version' })
                .addHeader({ value: 'Mgmt URL', styleClass: pageResponse_constants_1.TABLE_STYLE_CLASS.center })
                .addHeader({ value: 'Description' });
            let devicesIds = (await this.objectItemsRepository.find({
                relations: {
                    hw_type_entity: true
                },
                where: {
                    subsystem: 'device',
                    hw_type_entity: {
                        class: 'storage'
                    }
                }
            })).map((device) => device.item_id);
            if (this.request) {
                const user = await User_1.User.getUserByRequest(this.request, true);
                devicesIds = await ACLCheck_1.ACLCheck.filterItems(user.groups.map(group => group.group_id), devicesIds);
            }
            let nodes = {};
            const devicesNodes = (await this.objectItemsRepository.find({ where: { subsystem: 'node', hw_type: (0, typeorm_1.In)(['isilon', 'dothill', 'ecs', 'ddnintelliflash']) } })).map((device) => device.item_id);
            const hostcfgs = await this.hostCfgRepository.find({ where: { hostcfg_id: (0, typeorm_1.In)(devicesIds) } });
            const itemsWithParents = await this.objectItemsRepository.find({
                relations: {
                    parents: {
                        _parent: true
                    }
                },
                where: {
                    subsystem: 'node',
                    hw_type: (0, typeorm_1.In)(['isilon', 'dothill', 'ecs', 'ddnintelliflash'])
                }
            });
            for (const object_items of itemsWithParents) {
                for (const data of object_items.parents) {
                    if (!nodes[data.parent]) {
                        nodes[data.parent] = {
                            childs: []
                        };
                    }
                    nodes[data.parent].childs.push(data.child);
                }
            }
            let itemPropertiesObj = {};
            let itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: (0, typeorm_1.In)(devicesIds) } });
            let itemPropertiesNode = await this.itemPropertiesRepository.find({ where: { item_id: (0, typeorm_1.In)(devicesNodes) } });
            for (const itemProperty of itemProperties) {
                if (itemPropertiesObj[itemProperty.item_id]) {
                    itemPropertiesObj[itemProperty.item_id][itemProperty.property_name] = itemProperty.property_value;
                }
                else {
                    itemPropertiesObj[itemProperty.item_id] = {
                        [itemProperty.property_name]: itemProperty.property_value,
                    };
                }
            }
            for (const itemProperty of itemPropertiesNode) {
                if (itemPropertiesObj[itemProperty.item_id]) {
                    itemPropertiesObj[itemProperty.item_id][itemProperty.property_name] = itemProperty.property_value;
                }
                else {
                    itemPropertiesObj[itemProperty.item_id] = {
                        [itemProperty.property_name]: itemProperty.property_value,
                    };
                }
            }
            for (const hostcfg of hostcfgs) {
                if (itemPropertiesObj[hostcfg.hostcfg_id]) {
                    if (nodes[hostcfg.hostcfg_id]) {
                        for (const child of nodes[hostcfg.hostcfg_id].childs) {
                            let version = " ";
                            if (itemPropertiesObj[child]['version']) {
                                version = itemPropertiesObj[child]['version'];
                            }
                            else if (itemPropertiesObj[hostcfg.hostcfg_id]['version']) {
                                version = itemPropertiesObj[hostcfg.hostcfg_id]['version'];
                            }
                            hwTable.addRow([
                                { order: 0, value: hostcfg.label },
                                { order: 1, value: itemPropertiesObj[child]['label'] ? itemPropertiesObj[child]['label'] : ' ' },
                                { order: 2, value: itemPropertiesObj[child]['host'] ? itemPropertiesObj[child]['host'] : ' ' },
                                { order: 3, value: itemPropertiesObj[child]['model'] ? itemPropertiesObj[child]['model'] : ' ' },
                                { order: 4, value: itemPropertiesObj[child]['serial_number'] ? itemPropertiesObj[child]['serial_number'] : ' ' },
                                {
                                    order: 5,
                                    value: version,
                                },
                                { order: 6, value: hostcfg.data['managementUrl'] ? 'link' : ' ', url: hostcfg.data['managementUrl'] ? hostcfg.data['managementUrl'] : ' ' },
                                { order: 7, value: hostcfg.data['description'] ? hostcfg.data['description'] : '' },
                            ]);
                        }
                        continue;
                    }
                    let serial_number = " ";
                    if (itemPropertiesObj[hostcfg.hostcfg_id]['serial']) {
                        serial_number = itemPropertiesObj[hostcfg.hostcfg_id]['serial'];
                    }
                    else if (itemPropertiesObj[hostcfg.hostcfg_id]['serial_number']) {
                        serial_number = itemPropertiesObj[hostcfg.hostcfg_id]['serial_number'];
                    }
                    let node = " ";
                    if (itemPropertiesObj[hostcfg.hostcfg_id]['node_name']) {
                        node = itemPropertiesObj[hostcfg.hostcfg_id]['node_name'];
                    }
                    let host = " ";
                    if (hostcfg.data.host) {
                        host = hostcfg.data.host;
                    }
                    else if (hostcfg.data.apiHost) {
                        host = hostcfg.data.apiHost;
                    }
                    else if (hostcfg.data.sshHost) {
                        host = hostcfg.data.sshHost;
                    }
                    else if (hostcfg.data.node1Host && hostcfg.data.node2Host) {
                        if (hostcfg.data.svpHost) {
                            host = hostcfg.data.svpHost;
                        }
                        else {
                            host = hostcfg.data.node1Host;
                        }
                        if (host !== hostcfg.data.node1Host) {
                            host = host + " " + hostcfg.data.node1Host;
                        }
                        if (host !== hostcfg.data.node2Host) {
                            host = host + " " + hostcfg.data.node2Host;
                        }
                    }
                    hwTable.addRow([
                        { order: 0, value: hostcfg.label },
                        { order: 1, value: node },
                        { order: 2, value: host },
                        { order: 3, value: itemPropertiesObj[hostcfg.hostcfg_id]['model'] ? itemPropertiesObj[hostcfg.hostcfg_id]['model'] : ' ' },
                        { order: 4, value: serial_number },
                        {
                            order: 5,
                            value: itemPropertiesObj[hostcfg.hostcfg_id]['version'] ? itemPropertiesObj[hostcfg.hostcfg_id]['version'] : ' ',
                        },
                        { order: 6, value: hostcfg.data['managementUrl'] ? 'link' : ' ', url: hostcfg.data['managementUrl'] ? hostcfg.data['managementUrl'] : ' ' },
                        { order: 7, value: hostcfg.data['description'] ? hostcfg.data['description'] : '' },
                    ]);
                }
            }
            hwTable.sortByIndex(0, false, true);
            hwTable.setBoxExport("storage-configuration");
            tabs.push({
                title: 'HW',
                content: [hwTable.generateBoxWithManagement()],
            });
            let volumes = await this.objectItemsRepository.find({
                relations: {
                    parents: {
                        _parent: true
                    },
                    mappings: true
                },
                where: {
                    hw_type: (0, typeorm_1.In)(Object.keys(Storage_1.Storage.technology)),
                    subsystem: 'volume',
                    parents: {
                        _parent: {
                            subsystem: (0, typeorm_1.In)(['device', 'pool', 'host'])
                        }
                    }
                },
                order: {
                    label: 'DESC'
                }
            });
            if (this.request) {
                const user = await User_1.User.getUserByRequest(this.request, true);
                const volumesIds = await ACLCheck_1.ACLCheck.filterItems(user.groups.map(group => group.group_id), volumes.map(volume => volume.item_id));
                volumes = volumes.filter(volume => volumesIds.includes(volume.item_id));
            }
            const lastValues = await new MetricsWrapper_1.MetricsWrapper(['capacity_total'], volumes.map(item => item.item_id)).getLastHourValueFromTable();
            let volumeTable = new Table_1.Table()
                .addHeader({ value: 'Volume' })
                .addHeader({ value: 'Storage' })
                .addHeader({ value: 'Pool' })
                .addHeader({ value: 'Capacity', unit: subsystemMetricsResponse_constants_1.UNIT.bytes, number: true, decimal: 0, prefix: pageResponse_constants_1.UNIT_PREFIX.gibi, multiplier: 1024 })
                .addHeader({ value: 'Host' })
                .addHeader({ value: 'Volume ID' });
            for (const volume of volumes) {
                let parent_device = volume.parents.find((item) => item._parent.subsystem === 'device');
                let parent_pool = volume.parents.find((item) => item._parent.subsystem === 'pool');
                let hosts = volume.parents.filter((item) => item._parent.subsystem === 'host');
                volumeTable.addRow([
                    { order: 0, value: volume.label, url: URL_1.URL.generate(volume.hw_type, 'volume', volume.item_id) },
                    { order: 1, value: parent_device ? parent_device._parent.label : ' ' },
                    {
                        order: 2,
                        value: parent_pool ? parent_pool._parent.label : ' ',
                        url: parent_pool ? URL_1.URL.generate(parent_pool._parent.hw_type, 'pool', parent_pool._parent.item_id) : undefined,
                    },
                    { order: 3, value: lastValues[volume.item_id] ? lastValues[volume.item_id]['capacity_total'] : null },
                    { order: 4, value: hosts.length >= 1 ? hosts.map(host => host._parent.label).toString() : ' ' },
                    { order: 5, value: volume.mappings.length >= 1 ? volume.mappings.map(mapping => mapping.wwn).toString() : ' ' },
                ]);
            }
            volumeTable.sortByIndex(0, false, true);
            volumeTable.setBoxExport("storage-volumes");
            tabs.push({
                title: 'Volume',
                content: [volumeTable.generateBox()],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StorConfigurationPage = StorConfigurationPage;
class StorVolumestopPage extends SimpleStorPage {
    constructor() {
        super(...arguments);
        this.title = 'Volumes TOP';
    }
    async getPage() {
        let tabs = [];
        const customTop = CustomTop_1.CustomTop.generateRequestBox('storage', 'volume', ['io_rate', 'read_io', 'write_io', 'data_rate', 'read', 'write', 'resp_t', 'resp_t_r', 'resp_t_w'], ['device', 'pool']);
        tabs.push({
            title: 'Custom',
            content: [customTop],
        });
        this.page = new pageResponse_dto_1.Page(this.title, tabs);
        return this.page;
    }
}
exports.StorVolumestopPage = StorVolumestopPage;
class StorHoststopPage extends SimpleStorPage {
    constructor() {
        super(...arguments);
        this.title = 'Hosts TOP';
    }
    async getPage() {
        let tabs = [];
        const customTop = CustomTop_1.CustomTop.generateRequestBox('storage', 'host', ['io_rate', 'read_io', 'write_io', 'data_rate', 'read', 'write', 'resp_t', 'resp_t_r', 'resp_t_w'], ['device']);
        tabs.push({
            title: 'Custom',
            content: [customTop],
        });
        this.page = new pageResponse_dto_1.Page(this.title, tabs);
        return this.page;
    }
}
exports.StorHoststopPage = StorHoststopPage;
class StorMappingPage extends SimpleStorPage {
    constructor() {
        super(...arguments);
        this.title = 'Mapping';
    }
    async getPage() {
        let title = 'Mapping';
        let tabs = [];
        let hosts = await this.objectItemsRepository.find({
            relations: {
                children: {
                    _child: true
                },
                parents: {
                    _parent: true
                },
                hw_type_entity: true
            },
            where: {
                hw_type_entity: {
                    class: class_constants_1.ClassKey.STORAGE
                },
                subsystem: 'host',
                parents: {
                    _parent: {
                        subsystem: 'device',
                        item_id: this.itemId ? this.itemId : undefined
                    }
                },
                children: {
                    _child: {
                        subsystem: 'volume'
                    }
                }
            }
        });
        let mapping = new Table_1.Table()
            .addHeader({ value: 'Host' })
            .addHeader({ value: 'Storage' })
            .addHeader({ value: 'Volume', trim: false });
        let volumeIds = [];
        for (const host of hosts) {
            const volumes = host.children.filter(child => child._child.subsystem === 'volume');
            volumeIds = volumeIds.concat(volumes.map(v => v.child));
        }
        volumeIds = await ACLCheck_1.ACLCheck.filterItemsWithRequest(this.request, volumeIds);
        for (const host of hosts) {
            const storage = host.parents.find(parent => parent._parent.subsystem === 'device');
            const volumes = host.children.filter(child => child._child.subsystem === 'volume' && volumeIds.includes(child.child));
            const volumesUrlList = volumes.map(volume => URL_1.URL.generate(volume._child.hw_type, 'volume', volume._child.item_id));
            const volumesList = volumes.map(volume => volume._child.label);
            if (volumes.length === 0) {
                continue;
            }
            mapping.addRow([
                { order: 0, value: host.label, url: URL_1.URL.generate(host.hw_type, 'host', host.item_id) },
                { order: 1, value: storage ? storage._parent.label : 'undefined', url: storage ? URL_1.URL.generate(storage._parent.hw_type, 'device', storage._parent.item_id) : undefined },
                { order: 2, value: volumesList, url: volumesUrlList }
            ]);
        }
        mapping.setOrientation('vertical');
        mapping.sortByIndex(0, false, true);
        mapping.setBoxExport("mapping");
        tabs.push({
            title: 'Volumes',
            content: [mapping.generateBox()],
        });
        if (this.itemId) {
            tabs.push({
                title: 'SAN Topology',
                content: [
                    await (0, San_1.sanDeviceTopologyBox)(this.itemId)
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StorMappingPage = StorMappingPage;
class StorSantopologyPage extends SimpleStorPage {
    constructor() {
        super(...arguments);
        this.title = 'SAN Topology';
    }
    async getPage() {
        let title = 'SAN Topology';
        let tabs = [];
        const topologyBox = await (0, San_1.sanGlobalTopologyBox)();
        tabs.push({
            title: 'SAN Topology',
            content: [topologyBox],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StorSantopologyPage = StorSantopologyPage;
class StorHealthstatusPage extends SimpleStorPage {
    constructor() {
        super(...arguments);
        this.title = 'Health Status';
    }
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        if (this.itemId) {
            let healthStatus = new HealthStatus_1.HealthStatus().getStatusByIds([this.itemId], 'Device');
            tabs.push({
                title: 'Health Status',
                content: [await healthStatus],
            });
        }
        else {
            let healthStatus = new HealthStatus_1.HealthStatus().setAcl(this.request).getStatusByParameters("device", "storage", "Storage", undefined);
            tabs.push({
                title: 'Health Status',
                content: [await healthStatus],
            });
            let healthStatusHistory = new HealthStatus_1.HealthStatus().setAcl(this.request).getHistory(class_constants_1.ClassKey.STORAGE, 'device', undefined, "Device");
            tabs.push({
                title: 'History',
                content: [await healthStatusHistory],
            });
            tabs.push({
                title: 'Mirrors',
                content: [new HealthStatus_1.HealthStatus().setAcl(this.request).getMirrors()],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StorHealthstatusPage = StorHealthstatusPage;
class StorOverviewPage extends SimpleStorPage {
    constructor() {
        super(...arguments);
        this.title = 'Overview';
    }
    async getPage() {
        let title = 'Overview';
        let tabs = [];
        const overview = new Overview_1.Overview('storage');
        let devices = await this.objectItemsRepository.find({
            relations: {
                hw_type_entity: true
            },
            where: {
                subsystem: 'device',
                hw_type_entity: {
                    class: 'storage'
                }
            }
        });
        if (this.request) {
            const user = await User_1.User.getUserByRequest(this.request, true);
            const devicesIds = await ACLCheck_1.ACLCheck.filterItems(user.groups.map(group => group.group_id), devices.map(device => device.item_id));
            devices = devices.filter(device => devicesIds.includes(device.item_id));
        }
        overview.addCategory('Storage', devices.map(item => {
            return {
                label: item.label,
                item_id: item.item_id
            };
        }));
        tabs.push({
            title: 'Storage',
            content: [
                overview.form()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StorOverviewPage = StorOverviewPage;
class StorTotalPage extends SimpleStorPage {
    constructor() {
        super(...arguments);
        this.title = 'Total';
    }
    async getPage() {
        let title = 'Total';
        let tabs = [];
        let devicesIds = [];
        if (this.itemId) {
            const sgroup = await this.storageGroupsRepository.findOne({
                where: {
                    storage_group_id: this.itemId.toString()
                },
                relations: {
                    storage_group_devices: true
                }
            });
            if (sgroup) {
                devicesIds = sgroup.storage_group_devices.map(device => device.item_id);
            }
        }
        else {
            devicesIds = (await this.objectItemsRepository.find({
                relations: {
                    hw_type_entity: true
                },
                where: {
                    subsystem: 'device',
                    hw_type_entity: {
                        class: 'storage'
                    }
                }
            })).map((item) => item.item_id);
        }
        if (this.request) {
            const user = await User_1.User.getUserByRequest(this.request, true);
            devicesIds = await ACLCheck_1.ACLCheck.filterItems(user.groups.map(group => group.group_id), devicesIds);
        }
        tabs.push({
            title: 'IO',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        {
                            ...Storage_1.Storage.metrics.io_rate,
                            type: pageResponse_constants_1.CHART_TYPE.area,
                            stacked: true,
                            order: 0,
                            label: 'IOPS',
                        },
                    ],
                    uuids: devicesIds,
                    aggregated: true,
                    label: 'Device'
                },
            ],
        });
        tabs.push({
            title: 'Data',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        {
                            ...Storage_1.Storage.metrics.data_rate,
                            type: pageResponse_constants_1.CHART_TYPE.area,
                            stacked: true,
                            order: 0,
                            label: 'Data',
                        },
                    ],
                    uuids: devicesIds,
                    aggregated: true,
                    label: 'Device'
                },
            ],
        });
        tabs.push({
            title: 'Latency',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        {
                            ...Storage_1.Storage.metrics.resp_t,
                            type: pageResponse_constants_1.CHART_TYPE.line,
                            stacked: false,
                            order: 0,
                            label: 'Latency',
                        },
                    ],
                    uuids: devicesIds,
                    aggregated: true,
                    label: 'Device'
                },
            ],
        });
        tabs.push({
            title: 'Capacity used',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        {
                            ...Storage_1.Storage.metrics.capacity_used,
                            defaultPrecision: 0,
                            type: pageResponse_constants_1.CHART_TYPE.area,
                            stacked: true,
                            order: 0,
                            label: 'Used',
                        },
                    ],
                    uuids: devicesIds,
                    aggregated: true,
                    label: 'Device'
                },
            ],
        });
        tabs.push({
            title: 'Capacity used %',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        {
                            ...Storage_1.Storage.metrics.capacity_used_percent,
                            type: pageResponse_constants_1.CHART_TYPE.line,
                            stacked: false,
                            order: 0,
                            label: 'Used',
                        },
                    ],
                    uuids: devicesIds,
                    aggregated: true,
                    label: 'Device'
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StorTotalPage = StorTotalPage;
class StorDevicetotalPage extends SimpleStorPage {
    constructor() {
        super(...arguments);
        this.title = 'Total';
    }
    async getPage() {
        let title = 'Total';
        let tabs = [];
        const device = await this.objectItemsRepository.findOneBy({ item_id: this.itemId });
        const metricsRepository = (0, dataSource_1.getDataSource)().getRepository("metrics.metrics_" + device.hw_type + "_" + device.subsystem);
        const columns = metricsRepository.metadata.columns.map((column) => {
            return column.propertyName;
        });
        if (columns.includes("io_rate")) {
            tabs.push({
                title: 'IO',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            {
                                ...Storage_1.Storage.metrics.io_rate,
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                order: 0,
                                label: 'IOPS',
                                color: Color_1.Color.pallete.redDark
                            },
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    },
                ],
            });
        }
        if (columns.includes("read_io") && columns.includes("write_io")) {
            tabs.push({
                title: 'IO R/W',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            {
                                ...Storage_1.Storage.metrics.read_io,
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                order: 0,
                                label: 'Read IO',
                                color: Color_1.Color.pallete.redDark
                            },
                            {
                                ...Storage_1.Storage.metrics.write_io,
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                order: 1,
                                label: 'Write IO',
                                color: Color_1.Color.pallete.blueDark
                            },
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    },
                ],
            });
        }
        if (columns.includes("data_rate")) {
            tabs.push({
                title: 'Data',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            {
                                ...Storage_1.Storage.metrics.data_rate,
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                order: 0,
                                label: 'Data',
                                color: Color_1.Color.pallete.redDark
                            },
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    },
                ],
            });
        }
        if (columns.includes("read") && columns.includes("write")) {
            tabs.push({
                title: 'Data R/W',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            {
                                ...Storage_1.Storage.metrics.read,
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                order: 0,
                                label: 'Read',
                                color: Color_1.Color.pallete.redDark
                            },
                            {
                                ...Storage_1.Storage.metrics.write,
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                order: 1,
                                label: 'Write',
                                color: Color_1.Color.pallete.blueDark
                            },
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    },
                ],
            });
        }
        if (columns.includes("resp_t")) {
            tabs.push({
                title: 'Latency',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            {
                                ...Storage_1.Storage.metrics.resp_t,
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                order: 0,
                                label: 'Latency',
                                color: Color_1.Color.pallete.redDark
                            },
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    },
                ],
            });
        }
        if (columns.includes("resp_t_r") && columns.includes("resp_t_w")) {
            tabs.push({
                title: 'Latency R/W',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            {
                                ...Storage_1.Storage.metrics.resp_t_r,
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                order: 0,
                                label: 'Latency Read',
                                color: Color_1.Color.pallete.redDark
                            },
                            {
                                ...Storage_1.Storage.metrics.resp_t_w,
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                order: 1,
                                label: 'Latency Write',
                                color: Color_1.Color.pallete.blueDark
                            },
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    },
                ],
            });
        }
        if (columns.includes("capacity_used") && columns.includes("capacity_free")) {
            tabs.push({
                title: 'Capacity',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            {
                                ...Storage_1.Storage.metrics.capacity_free,
                                defaultPrecision: 0,
                                type: pageResponse_constants_1.CHART_TYPE.area,
                                stacked: true,
                                order: 0,
                                label: 'Free',
                                color: Color_1.Color.pallete.green
                            },
                            {
                                ...Storage_1.Storage.metrics.capacity_used,
                                defaultPrecision: 0,
                                type: pageResponse_constants_1.CHART_TYPE.area,
                                stacked: true,
                                order: 0,
                                label: 'Used',
                                color: Color_1.Color.pallete.red
                            },
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    },
                ],
            });
        }
        if (columns.includes("capacity_used_percent")) {
            tabs.push({
                title: 'Capacity used %',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            {
                                ...Storage_1.Storage.metrics.capacity_used_percent,
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                order: 0,
                                label: 'Used %',
                                color: Color_1.Color.pallete.redDark
                            },
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    },
                ],
            });
        }
        if (Storage_1.Storage.technology[device.hw_type] && Storage_1.Storage.technology[device.hw_type]['subsystems']?.['device']) {
            const subsystem = Storage_1.Storage.technology[device.hw_type]['subsystems']['device'];
            if (subsystem.single && Object.keys(subsystem.single).length >= 1) {
                for (const tabIndex in subsystem['single']) {
                    const tab = subsystem['single'][tabIndex];
                    tabs.push({
                        title: tab.label,
                        content: [
                            {
                                type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                                metrics: tab.metrics,
                                uuids: [this.itemId],
                                aggregated: false,
                            },
                        ],
                    });
                }
            }
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StorDevicetotalPage = StorDevicetotalPage;
class StorDevicePage extends StorDevicetotalPage {
}
exports.StorDevicePage = StorDevicePage;
;
class StorCapacityPage extends SimpleStorPage {
    constructor() {
        super(...arguments);
        this.title = 'Capacity';
    }
    async getPage() {
        let title = 'Capacity';
        const user = await User_1.User.getUserByRequest(this.request);
        const timezone = user ? user.timezone : 'Etc/UTC';
        let tabs = [];
        if (this.itemId) {
            let poolsIds = [];
            let pools = [];
            const sgroup = await this.storageGroupsRepository.findOne({
                where: {
                    storage_group_id: this.itemId.toString()
                },
                relations: {
                    storage_group_devices: {
                        _item: true
                    }
                }
            });
            if (sgroup) {
                const devicesIds = sgroup.storage_group_devices.map(device => device.item_id);
                tabs.push({
                    title: 'Capacity',
                    content: [
                        await new CapacityTableBuilder_1.CapacityTableBuilder("device", this.request)
                            .setItemLabel("Device")
                            .addItems(devicesIds)
                            .addMetric("capacity_total", "Total")
                            .addMetric("capacity_used", "Used")
                            .addMetric("capacity_free", "Free")
                            .addUsed()
                            .addTotal()
                            .generateBox(),
                    ],
                });
                pools = await this.objectItemsRepository.find({
                    relations: {
                        parents: {
                            _parent: true
                        }
                    },
                    where: {
                        subsystem: 'pool',
                        parents: {
                            parent: (0, typeorm_1.In)(devicesIds)
                        }
                    }
                });
                poolsIds = pools.map((pool) => pool.item_id);
            }
            else {
                pools = await this.objectItemsRepository.find({
                    relations: {
                        parents: {
                            _parent: true
                        }
                    },
                    where: {
                        subsystem: 'pool',
                        parents: {
                            parent: this.itemId
                        }
                    }
                });
                poolsIds = pools.map((pool) => pool.item_id);
            }
            tabs.push({
                title: 'Pool Capacity',
                content: await new CapacityTableBuilder_1.CapacityTableBuilder("pool", this.request)
                    .setItemLabel("Pool")
                    .addItems(poolsIds)
                    .addMetric("capacity_total", "Total")
                    .addMetric("capacity_used", "Used")
                    .addMetric("capacity_free", "Free")
                    .addPrediction()
                    .addUsed()
                    .addTotal()
                    .addUrl()
                    .generateContentWithPredictions(),
            });
        }
        else {
            let devices = await this.objectItemsRepository.find({
                relations: {
                    hw_type_entity: true
                },
                where: {
                    subsystem: 'device',
                    hw_type_entity: {
                        class: 'storage'
                    }
                }
            });
            const user = this.request ? await User_1.User.getUserByRequest(this.request, true) : null;
            if (this.request && user) {
                const ids = await ACLCheck_1.ACLCheck.filterItems(user.groups.map(group => group.group_id), devices.map((device) => device.item_id));
                devices = devices.filter(device => ids.includes(device.item_id));
            }
            let devicesIds = devices.map((device) => device.item_id);
            const deviceCapacityTable = new CapacityTableBuilder_1.CapacityTableBuilder("device", this.request)
                .setItemLabel("Device")
                .addItems(devicesIds)
                .addMetric("capacity_total", "Total")
                .addMetric("capacity_used", "Used")
                .addMetric("capacity_free", "Free")
                .addUsed()
                .addTotal();
            tabs.push({
                title: 'Capacity',
                content: [await deviceCapacityTable
                        .generateBox()],
            });
            let pools = await this.objectItemsRepository.find({
                relations: {
                    hw_type_entity: true,
                    parents: {
                        _parent: true
                    }
                },
                where: [{
                        subsystem: (0, typeorm_1.In)(['pool', 'site']),
                        hw_type: (0, typeorm_1.Not)("3par"),
                        hw_type_entity: {
                            class: 'storage'
                        },
                        parents: {
                            _parent: {
                                subsystem: 'device'
                            }
                        }
                    }, {
                        subsystem: "tier",
                        hw_type: "3par",
                        hw_type_entity: {
                            class: 'storage'
                        },
                        parents: {
                            _parent: {
                                subsystem: 'device'
                            }
                        }
                    }]
            });
            if (this.request && user) {
                const ids = await ACLCheck_1.ACLCheck.filterItems(user.groups.map(group => group.group_id), pools.map((pool) => pool.item_id));
                pools = pools.filter(pool => ids.includes(pool.item_id));
            }
            const poolsIds = pools.map((device) => device.item_id);
            tabs.push({
                title: 'Capacity Pool',
                content: await new CapacityTableBuilder_1.CapacityTableBuilder("pool", this.request)
                    .setItemLabel("Pool")
                    .addItems(poolsIds)
                    .addMetric("capacity_total", "Total")
                    .addMetric("capacity_used", "Used")
                    .addMetric("capacity_free", "Free")
                    .addPrediction(true)
                    .addUsed()
                    .addTotal()
                    .addUrl()
                    .generateContentWithPredictions(),
            });
            const storageGroups = await this.storageGroupsRepository.find({
                relations: {
                    storage_group_devices: true
                },
                where: {
                    user_id: user.user_id
                }
            });
            deviceCapacityTable.setStorageGroups(storageGroups);
            tabs.push({
                title: 'Capacity Group',
                content: [
                    await deviceCapacityTable.generateStorageGroupBox(),
                    {
                        type: pageResponse_constants_1.BOX_TYPE.HtmlTextBox,
                        html: `Capacity of user-defined Storage Groups.<br>Define Storage Groups in Settings -> Configuration -> Storage Group.`
                    }
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StorCapacityPage = StorCapacityPage;
class StorSingleItemPage extends StorPage {
    constructor(hwType, itemId) {
        super(hwType);
        this.parentSubsystem = 'device';
        this.itemId = itemId;
    }
}
exports.StorSingleItemPage = StorSingleItemPage;
class StorItemPage extends StorSingleItemPage {
    constructor(hwType, pageType, itemId) {
        super(hwType, itemId);
        this.pageType = pageType;
    }
    async getPage() {
        if (this.pageType.split('-')[2]) {
            this.subsystem = this.pageType.replace('-' + this.pageType.split('-')[2], '');
            this.pageType = this.pageType.split('-')[2];
        }
        else {
            this.subsystem = this.pageType === 'cpu-core' ? 'cpu-core' : this.pageType.split('-')[0];
            this.pageType = this.pageType === 'cpu-core' ? null : this.pageType.split('-')[1];
        }
        let stor_items = [];
        let tabs = [];
        let title;
        if (this.pageType) {
            let items = await this.objectItemsRepository.findBy({
                hw_type: this.hwType,
                subsystem: this.subsystem,
            });
            let parentChildren = await this.itemRelationsRepository.find({ where: { parent: this.itemId.toString() } });
            let childrenIds = parentChildren.map((relation) => relation.child);
            for (let item of items) {
                if (childrenIds.includes(item.item_id)) {
                    stor_items.push(item.item_id);
                }
            }
            title = this.subsystem + ' totals';
            for (const tabIndex in Storage_1.Storage.technology[this.hwType]['subsystems'][this.subsystem]['totals'][this.pageType]['tabs']) {
                const subsys = Storage_1.Storage.technology[this.hwType]['subsystems'][this.subsystem];
                const tab = subsys['totals'][this.pageType]['tabs'][tabIndex];
                if (!tab) {
                    console.warn("No tab definition for " + this.hwType + " " + this.subsystem + " " + this.pageType + " " + tabIndex + " found");
                    continue;
                }
                const aggregated = subsys['totals'][this.pageType]['single'] ? false : true;
                const parentType = MetricsWrapper_1.MetricsWrapper.getParent(class_constants_1.ClassKey.STORAGE, this.hwType, this.subsystem);
                let regroupBox = {
                    type: pageResponse_constants_1.BOX_TYPE.RegroupButtonBox,
                    graphs: []
                };
                const regroupCategoryMetrics = checkRegroupMetric(tab.metrics);
                if (regroupCategoryMetrics !== null) {
                    const availableMetrics = (await MetricsWrapper_1.MetricsWrapper.getMetrics(this.hwType, this.subsystem)).map(metric => metric.metric);
                    const regroupMetrics = regroupCategoryMetrics.filter(categoryMetric => availableMetrics.includes(categoryMetric) === true);
                    if (regroupMetrics.find(metric => metric.includes("write")) !== undefined && regroupMetrics.find(metric => metric.includes("read")) !== undefined) {
                        for (const totalMetric in exports.storageRegroupTotalMetric) {
                            const graphLabel = `${subsys['label'] ? subsys['label'] : this.subsystem} ${totalMetric}`;
                            regroupBox.graphs.push({
                                uuids: aggregated ? stor_items : [this.itemId.toString()],
                                aggregated: aggregated,
                                label: subsys['label'] ? subsys['label'] : this.subsystem,
                                graphLabel: graphLabel,
                                parent: parentType ? {
                                    label: parentType.label,
                                    subsystem: parentType.subsystem
                                } : undefined,
                                url: URL_1.URL.generate(this.hwType, this.subsystem + "-" + getRegropMetricPage(exports.storageRegroupTotalMetric[totalMetric][0]), this.itemId),
                                tab: totalMetric === 'Latency' || totalMetric === 'Block Size' ? 'Average' : 'Total',
                                metrics: exports.storageRegroupTotalMetric[totalMetric][1] !== undefined
                                    ? [
                                        {
                                            ...Storage_1.Storage.metrics[exports.storageRegroupTotalMetric[totalMetric][0]],
                                            aggregate: pageResponse_constants_1.METRIC_AGGREGATE.sum,
                                            type: pageResponse_constants_1.CHART_TYPE.line,
                                            stacked: false,
                                            order: 0,
                                        },
                                        {
                                            ...Storage_1.Storage.metrics[exports.storageRegroupTotalMetric[totalMetric][1]],
                                            aggregate: pageResponse_constants_1.METRIC_AGGREGATE.sum,
                                            type: pageResponse_constants_1.CHART_TYPE.line,
                                            stacked: false,
                                            order: 1,
                                        }
                                    ]
                                    : [
                                        {
                                            ...Storage_1.Storage.metrics[exports.storageRegroupTotalMetric[totalMetric][0]],
                                            type: pageResponse_constants_1.CHART_TYPE.line,
                                            stacked: false,
                                            order: 0,
                                        }
                                    ]
                            });
                        }
                    }
                    else {
                        for (const regroupMetric of regroupMetrics) {
                            if (!Storage_1.Storage.metrics[regroupMetric]) {
                                continue;
                            }
                            const graphLabel = `${subsys['label'] ? subsys['label'] : this.subsystem} ${Storage_1.Storage.metrics[regroupMetric]['label'] ? Storage_1.Storage.metrics[regroupMetric]['label'] : regroupMetric}`;
                            regroupBox.graphs.push({
                                uuids: aggregated ? stor_items : [this.itemId.toString()],
                                aggregated: aggregated,
                                label: subsys['label'] ? subsys['label'] : this.subsystem,
                                graphLabel: graphLabel,
                                parent: parentType ? {
                                    label: parentType.label,
                                    subsystem: parentType.subsystem
                                } : undefined,
                                url: URL_1.URL.generate(this.hwType, this.subsystem + "-" + getRegropMetricPage(regroupMetric), this.itemId),
                                tab: getRegropMetricTab(regroupMetric),
                                metrics: [
                                    {
                                        ...Storage_1.Storage.metrics[regroupMetric],
                                        type: regroupMetric.includes("resp_t") || regroupMetric.includes("block_size")
                                            ? pageResponse_constants_1.CHART_TYPE.line
                                            : pageResponse_constants_1.CHART_TYPE.area,
                                        stacked: regroupMetric.includes("resp_t") || regroupMetric.includes("block_size")
                                            ? false
                                            : true,
                                        order: 0,
                                    }
                                ]
                            });
                        }
                    }
                }
                const newTab = {
                    title: tab.label,
                    content: []
                };
                if (regroupBox.graphs.length >= 1) {
                    newTab.content.push(regroupBox);
                }
                newTab.content.push({
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: tab.metrics,
                    uuids: aggregated ? stor_items : [this.itemId.toString()],
                    aggregated: aggregated,
                    label: subsys['label'] ? subsys['label'] : this.subsystem,
                    parent: parentType ? {
                        label: parentType.label,
                        subsystem: parentType.subsystem
                    } : undefined,
                });
                tabs.push(newTab);
            }
        }
        else {
            let item = await this.objectItemsRepository.findOneBy({
                hw_type: this.hwType,
                subsystem: this.subsystem,
                item_id: this.itemId,
            });
            stor_items.push(item.item_id);
            if (Storage_1.Storage.technology[this.hwType]['subsystems'][this.subsystem]['single']) {
                for (const tabIndex in Storage_1.Storage.technology[this.hwType]['subsystems'][this.subsystem]['single']) {
                    const tab = Storage_1.Storage.technology[this.hwType]['subsystems'][this.subsystem]['single'][tabIndex];
                    if (!tab) {
                        console.warn("No tab definition for " + this.hwType + " " + this.subsystem + " " + this.pageType + " " + tabIndex + " found");
                        continue;
                    }
                    let availableMetrics = undefined;
                    let content = [{
                            type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                            metrics: tab.metrics,
                            peakMetric: checkPeakMetric(this.subsystem, tab.metrics),
                            uuids: stor_items,
                            aggregated: false
                        }];
                    const capacityMetric = tab.metrics.find(metric => metric.metric === 'capacity_used');
                    if (this.subsystem === 'pool' && capacityMetric) {
                        const metricsWrapper = await (new MetricsWrapper_1.MetricsWrapper(['capacity_total'], [this.itemId])).getLastDailyValuesFromTable();
                        const capacityTotal = metricsWrapper[this.itemId] && metricsWrapper[this.itemId]['capacity_total'] !== undefined
                            ? metricsWrapper[this.itemId]['capacity_total']
                            : undefined;
                        content.push(await Prediction_1.Prediction.generatePredictionBox({
                            item_id: this.itemId,
                            metric: {
                                ...capacityMetric,
                                order: 0,
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                            },
                            other_metrics: [],
                            frequency: '1d',
                            command: 'predict_capacity',
                            interval: 'year',
                            max: capacityTotal
                        }));
                    }
                    tabs.push({
                        title: tab.label,
                        content: content,
                    });
                }
            }
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StorItemPage = StorItemPage;
class StorPortTypePage extends StorPage {
    constructor(itemId, metricType, hwType) {
        super(hwType);
        this.title = 'Port IO';
        this.itemId = itemId;
        this.metricType = metricType;
    }
    async getPage() {
        if (!['io', 'data'].includes(this.metricType)) {
            return [];
        }
        const unit = this.metricType === 'io' ? subsystemMetricsResponse_constants_1.UNIT.IOPS : subsystemMetricsResponse_constants_1.UNIT.bytes_per_second;
        const _shortcut = this.metricType === 'io' ? subsystemMetricsResponse_constants_1.SHORTCUT.IOPS : subsystemMetricsResponse_constants_1.SHORTCUT.bytes_per_second;
        const defaultPrefix = this.metricType === 'io' ? undefined : pageResponse_constants_1.UNIT_PREFIX.mega;
        let title = 'Port ' + this.metricType.toUpperCase();
        let tabs = [];
        if (this.itemId) {
            const itemIds = (await this.objectItemsRepository.find({
                relations: {
                    parents: true
                },
                where: {
                    parents: {
                        parent: this.itemId.toString()
                    },
                    hw_type: this.hwType,
                    subsystem: 'port'
                }
            })).map(item => item.item_id);
            tabs.push({
                title: 'Total',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            {
                                metric: this.metricType + "_rate",
                                unit: unit,
                                shortcut: _shortcut,
                                label: this.metricType.toUpperCase() + " rate",
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                defaultPrefix: defaultPrefix
                            }
                        ],
                        uuids: itemIds,
                        aggregated: true,
                    }
                ],
            });
            tabs.push({
                title: 'Read',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            {
                                metric: this.metricType === "data" ? "read" : "read_" + this.metricType,
                                unit: unit,
                                shortcut: _shortcut,
                                label: this.metricType.toUpperCase() + " read",
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                defaultPrefix: defaultPrefix
                            }
                        ],
                        uuids: itemIds,
                        aggregated: true,
                    }
                ],
            });
            tabs.push({
                title: 'Write',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            {
                                metric: this.metricType === "data" ? "write" : "write_" + this.metricType,
                                unit: unit,
                                shortcut: _shortcut,
                                label: this.metricType.toUpperCase() + " write",
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                defaultPrefix: defaultPrefix
                            }
                        ],
                        uuids: itemIds,
                        aggregated: true,
                    }
                ],
            });
            const portTypesIds = (await this.objectItemsRepository.find({
                relations: {
                    parents: true
                },
                where: {
                    parents: {
                        parent: this.itemId.toString()
                    },
                    hw_type: this.hwType,
                    subsystem: 'port_type'
                }
            })).map(item => item.item_id);
            tabs.push({
                title: 'Total Per Type',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            {
                                metric: this.metricType + "_rate",
                                unit: unit,
                                shortcut: _shortcut,
                                label: this.metricType.toUpperCase() + " rate",
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                defaultPrefix: defaultPrefix
                            }
                        ],
                        uuids: portTypesIds,
                        aggregated: true,
                    }
                ],
            });
            tabs.push({
                title: 'Read Per Type',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            {
                                metric: this.metricType === "data" ? "read" : "read_" + this.metricType,
                                unit: unit,
                                shortcut: _shortcut,
                                label: this.metricType.toUpperCase() + " read",
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                defaultPrefix: defaultPrefix
                            }
                        ],
                        uuids: portTypesIds,
                        aggregated: true,
                    }
                ],
            });
            tabs.push({
                title: 'Write Per Type',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            {
                                metric: this.metricType === "data" ? "write" : "write_" + this.metricType,
                                unit: unit,
                                shortcut: _shortcut,
                                label: this.metricType.toUpperCase() + " write",
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                defaultPrefix: defaultPrefix
                            }
                        ],
                        uuids: portTypesIds,
                        aggregated: true,
                    }
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StorPortTypePage = StorPortTypePage;
//# sourceMappingURL=Stor.js.map