import { Newable } from "@xormon/common/menuResponse.dto";
import { Page, ChartType, MetricAggregate } from "@xormon/common/pageResponse.dto";
import { AbstractFolder, AbstractPage } from './AbstractMenu';
export declare class WindowsFolder extends AbstractFolder {
    hwType: string;
}
export declare class WindowsSubsystemFolder extends WindowsFolder {
    subsystem: string;
    itemId: string;
    constructor(itemId?: string);
}
export declare class WindowsPage extends AbstractPage {
    hwType: string;
    rootFolder: Newable<AbstractFolder>;
}
export declare class WindowsRootFolder extends WindowsFolder {
    hwType: string;
    getChildren(): Promise<any[]>;
}
export declare class WindowsDomainFolder extends WindowsSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class WindowsClusterFolder extends WindowsSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class WindowsServerFolder extends WindowsSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class WindowsStorageFolder extends WindowsSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class WindowsVmFolder extends WindowsSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class WindowsStoragePage extends WindowsPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class WindowsVmPage extends WindowsPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class WindowsClusterPage extends WindowsPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class WindowsServerPage extends WindowsPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class WindowsMetrics {
    static Metric: {
        new (subsystem: string, metric: string): {
            getGraph(type: ChartType, stacked?: boolean, order?: number, color?: string): any;
            getAggrGraph(type: ChartType, stacked?: boolean, order?: number, aggregate?: MetricAggregate): any;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
}
export declare class WindowsVmtopPage extends WindowsPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class WindowsHeatmapPage extends WindowsPage {
    title: string;
    getPage(): Promise<Page>;
}
