import { IMetricType, IStatusDefinition } from "./Classes";
import { Item } from "@xormon/common/architecture.dto";
import { ObjectItem } from "@xormon/entity/objectItem.entity";
export declare enum MetricTypeKey {
    MEMORY = "memory",
    CAPACITY = "capacity",
    CAPACITY_VOLUME = "capacity_volume",
    CPU_CORE = "cpu_core",
    CPU_GHZ = "cpu_ghz",
    CPU_PERCENT = "cpu_percent",
    IOPS = "iops",
    LATENCY = "latency",
    THROUGHPUT = "throughput",
    THROUGHPUT_TOTAL = "throughput_total",
    PACKETS_PER_SECOND = "packets_per_second",
    PERCENT = "percent",
    BLOCK_SIZE = "block_size",
    SESSION = "session",
    POWER = "power",
    TEMPERATURE = "temperature"
}
export declare const metricTypes: {
    [key in MetricTypeKey]: IMetricType;
};
export declare const rootSubsystems: {
    power: string;
    proxmox: string;
    nutanix: string;
    vmware: string;
    windows: string;
    oraclevm: string;
    linux: string;
    docker: string;
    kubernetes: string;
    openshift: string;
    as400: string;
    ovirt: string;
    solaris: string;
};
export declare const isRootSubsystem: (hwType: string, subsystem: string) => boolean;
export declare const findRootSubsystem: (_class: string, hwType: string) => string | null;
export declare const findStatusSubsystem: (_class?: string, hwType?: string) => string | null;
export declare const findStatusSubsystemsPerHwtype: (_class?: string, hwType?: string) => {
    [hwType: string]: string[];
};
export declare const getStatusDefinitions: (incClass?: string, incHwType?: string) => {
    [hwtype: string]: IStatusDefinition;
};
export declare const addRootParent: (items: Array<Item & any>) => any[];
export declare const ObjectItemToArchItem: (items: ObjectItem[]) => Item[];
