import { TimeseriesItem } from "@xormon/common/timeseriesResponse.dto";
import { MetricItems } from "./metrics.controller";
import { HwTypeKey } from "@xormon/common/constants/hwTypeKey.constants";
export interface ItemMap {
    [item_id: string]: string;
}
export interface Transform {
    hwType: string;
    subsystem: string;
}
export declare class MetricsTransform {
    private itemIdsToTransform;
    private itemIdsTransformed;
    private mappedItems;
    constructor(itemIdsToTransform: string[]);
    getIdsToTransform(): string[];
    getIdsTransformed(): string[];
    static mapping: {
        sanbrcd: {
            fabric: string;
        };
        sannav: {
            fabric: string;
        };
        sancisco: {
            fabric: string;
        };
    };
    static check(hwType: HwTypeKey, subsystem: string): Promise<boolean>;
    static checkId(itemId: string): Promise<boolean>;
    transformIds(): Promise<void>;
    transformData(items: MetricItems, metadata: any, interval: number): Promise<TimeseriesItem[]>;
    static sanbrcd: {
        new (): {};
        fabric(items: MetricItems, metadata: any, interval: number): Promise<TimeseriesItem[]>;
    };
    static sancisco: {
        new (): {};
        fabric(items: MetricItems, metadata: any, interval: number): Promise<TimeseriesItem[]>;
    };
}
