"use strict";
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Lan = void 0;
const pageResponse_constants_1 = require("../../../common/constants/pageResponse.constants");
const subsystemMetricsResponse_constants_1 = require("../../../common/constants/subsystemMetricsResponse.constants");
const Definitions_1 = require("../Definitions");
const Color_1 = require("../Color");
class Lan {
}
exports.Lan = Lan;
_a = Lan;
Lan.label = "LAN";
Lan.order = 3;
Lan.metrics = {
    data_in: {
        ...Definitions_1.metricTypes.throughput,
        metric: 'data_in',
        label: 'Data in',
    },
    data_out: {
        ...Definitions_1.metricTypes.throughput,
        metric: 'data_out',
        label: 'Data out',
    },
    utilization_in: {
        ...Definitions_1.metricTypes.percent,
        metric: 'utilization_in',
        label: 'Data In',
    },
    utilization_out: {
        ...Definitions_1.metricTypes.percent,
        metric: 'utilization_out',
        label: 'Data Out',
    },
    unicast_pkts_in: {
        ...Definitions_1.metricTypes.packets_per_second,
        metric: 'unicast_pkts_in',
        label: 'Unicast pkts in',
    },
    unicast_pkts_out: {
        ...Definitions_1.metricTypes.packets_per_second,
        metric: 'unicast_pkts_out',
        label: 'Unicast pkts out',
    },
    error_in: {
        metric: 'error_in',
        label: 'Errors in',
        unit: subsystemMetricsResponse_constants_1.UNIT.errors_per_second,
        shortcut: subsystemMetricsResponse_constants_1.SHORTCUT.errors_per_second,
    },
    error_out: {
        metric: 'error_out',
        label: 'Errors out',
        unit: subsystemMetricsResponse_constants_1.UNIT.errors_per_second,
        shortcut: subsystemMetricsResponse_constants_1.SHORTCUT.errors_per_second,
    },
    cpu_system: {
        ...Definitions_1.metricTypes.percent,
        metric: 'cpu_system',
        label: 'CPU Utilization',
    },
    memory_used_percent: {
        ...Definitions_1.metricTypes.percent,
        metric: 'memory_used_percent',
        label: 'Memory Utilization',
    },
};
Lan.tabs = {
    totals: {
        data: {
            data_in: {
                label: 'Data In',
                metrics: [
                    {
                        ..._a.metrics.data_in,
                        type: pageResponse_constants_1.CHART_TYPE.area,
                        stacked: true,
                        order: 0,
                    },
                ],
            },
            data_out: {
                label: 'Data Out',
                metrics: [
                    {
                        ..._a.metrics.data_out,
                        type: pageResponse_constants_1.CHART_TYPE.area,
                        stacked: true,
                        order: 0,
                    },
                ],
            },
            utilization_in: {
                label: 'Data In %',
                metrics: [
                    {
                        ..._a.metrics.utilization_in,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    },
                ],
            },
            utilization_out: {
                label: 'Data Out %',
                metrics: [
                    {
                        ..._a.metrics.utilization_out,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    },
                ],
            },
        },
        packet: {
            unicast_pkts_in: {
                label: 'Unicast pkts In',
                metrics: [
                    {
                        ..._a.metrics.unicast_pkts_in,
                        type: pageResponse_constants_1.CHART_TYPE.area,
                        stacked: true,
                        order: 0,
                    },
                ],
            },
            unicast_pkts_out: {
                label: 'Unicast pkts Out',
                metrics: [
                    {
                        ..._a.metrics.unicast_pkts_out,
                        type: pageResponse_constants_1.CHART_TYPE.area,
                        stacked: true,
                        order: 0,
                    },
                ],
            },
            error_in: {
                label: 'Errors In',
                metrics: [
                    {
                        ..._a.metrics.error_in,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    },
                ],
            },
            error_out: {
                label: 'Errors Out',
                metrics: [
                    {
                        ..._a.metrics.error_out,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    },
                ],
            },
        },
        cpumemory: {
            cpu_system: {
                label: 'CPU',
                metrics: [{
                        ..._a.metrics.cpu_system,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    }]
            },
            memory_used_percent: {
                label: 'Memory',
                metrics: [{
                        ..._a.metrics.memory_used_percent,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    }]
            }
        },
    },
    single: {
        data: {
            data: {
                label: 'Data',
                metrics: [
                    {
                        ..._a.metrics.data_in,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.metric.read
                    },
                    {
                        ..._a.metrics.data_out,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 1,
                        color: Color_1.Color.metric.write
                    }
                ],
            },
            utilization: {
                label: 'Data %',
                metrics: [
                    {
                        ..._a.metrics.utilization_in,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.metric.read
                    },
                    {
                        ..._a.metrics.utilization_out,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 1,
                        color: Color_1.Color.metric.write
                    }
                ],
            },
        },
        packet: {
            packet: {
                label: 'Packet',
                metrics: [
                    {
                        ..._a.metrics.unicast_pkts_in,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.metric.read
                    },
                    {
                        ..._a.metrics.unicast_pkts_out,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 1,
                        color: Color_1.Color.metric.write
                    }
                ],
            },
            error: {
                label: 'Error',
                metrics: [
                    {
                        ..._a.metrics.error_in,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.metric.read
                    },
                    {
                        ..._a.metrics.error_out,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 1,
                        color: Color_1.Color.metric.write
                    }
                ],
            },
        },
    },
};
Lan.technology = {
    lancisco: {
        label: 'LAN Cisco',
        subsystems: {
            device: {
                label: "Device",
                totals: {},
                single: {},
                metrics: {
                    data_in: _a.metrics.data_in,
                    data_out: _a.metrics.data_out,
                    utilization_in: _a.metrics.utilization_in,
                    utilization_out: _a.metrics.utilization_out,
                    unicast_pkts_in: _a.metrics.unicast_pkts_in,
                    unicast_pkts_out: _a.metrics.unicast_pkts_out,
                    error_in: _a.metrics.error_in,
                    error_out: _a.metrics.error_out,
                    cpu_system: _a.metrics.cpu_system,
                    memory_used_percent: _a.metrics.memory_used_percent
                },
                configuration: {
                    ip: {
                        label: 'IP',
                    },
                    sysLocation: {
                        label: 'Location',
                    },
                    model: {
                        label: 'Model',
                    },
                    version: {
                        label: 'OS Version',
                    },
                    up_time: {
                        label: 'Days up',
                    },
                    serial: {
                        label: 'Serial',
                    },
                    total_ports: {
                        label: 'Total ports',
                    },
                    isl_ports: {
                        label: 'ISL ports',
                    },
                    unused_ports: {
                        label: 'Unused ports',
                    },
                }
            },
            physical: {
                label: "LAN Port",
                configuration: {
                    alias: {
                        label: 'Alias',
                    },
                    speed: {
                        label: 'Speed',
                        type: 'string'
                    },
                    working_state: {
                        label: 'State',
                    },
                    operational_status: {
                        label: 'Operational status',
                    },
                    admin_status: {
                        label: 'Physical status',
                    },
                    vlan_id_list: {
                        label: 'VLAN IDs',
                    },
                    vlan_name_list: {
                        label: 'VLAN names',
                    },
                    description: {
                        label: 'Description',
                    },
                    macs: {
                        label: 'MAC addresses',
                    },
                    isl: {
                        label: 'ISL',
                    },
                },
                totals: {
                    data: {
                        label: "Data",
                        tabs: {
                            data_in: _a.tabs.totals.data.data_in,
                            data_out: _a.tabs.totals.data.data_out,
                            utilization_in: _a.tabs.totals.data.utilization_in,
                            utilization_out: _a.tabs.totals.data.utilization_out,
                        }
                    },
                    packet: {
                        label: "Packet",
                        tabs: {
                            unicast_pkts_in: _a.tabs.totals.packet.unicast_pkts_in,
                            unicast_pkts_out: _a.tabs.totals.packet.unicast_pkts_out,
                            error_in: _a.tabs.totals.packet.error_in,
                            error_out: _a.tabs.totals.packet.error_out,
                        }
                    },
                },
                single: {
                    data: _a.tabs.single.data.data,
                    utilization: _a.tabs.single.data.utilization,
                    packet: _a.tabs.single.packet.packet,
                    error: _a.tabs.single.packet.error,
                },
            },
            vlan: {
                label: "VLAN Port",
                configuration: {
                    alias: {
                        label: 'Alias',
                    },
                    speed: {
                        label: 'Speed',
                        type: 'string'
                    },
                    working_state: {
                        label: 'State',
                    },
                    operational_status: {
                        label: 'Operational status',
                    },
                    admin_status: {
                        label: 'Physical status',
                    },
                    vlan_id_list: {
                        label: 'VLAN IDs',
                    },
                    vlan_name_list: {
                        label: 'VLAN names',
                    },
                    description: {
                        label: 'Description',
                    },
                    macs: {
                        label: 'MAC addresses',
                    },
                    isl: {
                        label: 'ISL',
                    },
                },
                totals: {
                    data: {
                        label: "Data",
                        tabs: {
                            data_in: _a.tabs.totals.data.data_in,
                            data_out: _a.tabs.totals.data.data_out,
                            utilization_in: _a.tabs.totals.data.utilization_in,
                            utilization_out: _a.tabs.totals.data.utilization_out,
                        }
                    },
                    packet: {
                        label: "Packet",
                        tabs: {
                            unicast_pkts_in: _a.tabs.totals.packet.unicast_pkts_in,
                            unicast_pkts_out: _a.tabs.totals.packet.unicast_pkts_out,
                            error_in: _a.tabs.totals.packet.error_in,
                            error_out: _a.tabs.totals.packet.error_out,
                        }
                    },
                },
                single: {
                    data: _a.tabs.single.data.data,
                    utilization: _a.tabs.single.data.utilization,
                    packet: _a.tabs.single.packet.packet,
                    error: _a.tabs.single.packet.error,
                },
            },
            vlancfg: {
                label: "VLAN configuration",
                configuration: {
                    index: {
                        label: 'Index',
                    },
                    unrouted_interface: {
                        label: 'Unrouted interface',
                    },
                    unrouted_ifalias: {
                        label: 'Description',
                    },
                    unrouted_cfgalias: {
                        label: 'Alias',
                    },
                    routed_interface: {
                        label: 'Routed interface',
                    },
                    routed_ifalias: {
                        label: 'Description',
                    },
                    routed_cfgalias: {
                        label: 'Alias',
                    },
                },
                totals: {},
                single: {},
            },
            stackcfg: {
                label: "STACK configuration",
                configuration: {
                    role: {
                        label: 'Role',
                    },
                    state: {
                        label: 'State',
                    },
                    serial_number: {
                        label: 'Serial Number',
                    },
                    model_number: {
                        label: 'Model',
                    },
                    stackport1: {
                        label: 'Stack Port 1',
                    },
                    stackport1_status: {
                        label: 'Stack Port 1 status',
                    },
                    stackport2: {
                        label: 'Stack Port 2',
                    },
                    stackport2_status: {
                        label: 'Stack port 2 status',
                    },
                },
                totals: {},
                single: {},
            },
            fexcfg: {
                label: "FEX configuration",
                configuration: {
                    fex_serial: {
                        label: 'Serial',
                    },
                    fex_model: {
                        label: 'Model',
                    },
                    fex_connection: {
                        label: 'Connection',
                    },
                },
                totals: {},
                single: {},
            },
            vsscfg: {
                label: "VSS configuration",
                configuration: {
                    vss_role: {
                        label: 'Role',
                    },
                    vss_serial_number: {
                        label: 'Serial Number',
                    },
                    vss_uptime: {
                        label: 'Days up',
                    },
                    vss_vsl: {
                        label: 'VSL',
                    },
                    vss_vsl_status: {
                        label: 'VSL status',
                    },
                },
                totals: {},
                single: {},
            },
            cpu: {
                label: "CPU",
                totals: {},
                single: {},
                metrics: {
                    cpu_system: _a.metrics.cpu_system,
                },
            },
            memory: {
                label: "Memory",
                totals: {},
                single: {},
                metrics: {
                    memory_used_percent: _a.metrics.memory_used_percent
                },
            },
            portchannel: {
                label: "Port channel",
                configuration: {
                    port_channel_members: {
                        label: 'Members',
                    },
                    alias: {
                        label: 'Alias',
                    },
                    speed: {
                        label: 'Speed',
                        type: 'string'
                    },
                    working_state: {
                        label: 'State',
                    },
                    operational_status: {
                        label: 'Operational status',
                    },
                    admin_status: {
                        label: 'Physical status',
                    },
                    vlan_id_list: {
                        label: 'VLAN IDs',
                    },
                    vlan_name_list: {
                        label: 'VLAN names',
                    },
                    description: {
                        label: 'Description',
                    },
                    macs: {
                        label: 'MAC addresses',
                    },
                    isl: {
                        label: 'ISL',
                    },
                },
                totals: {
                    data: {
                        label: "Data",
                        tabs: {
                            data_in: _a.tabs.totals.data.data_in,
                            data_out: _a.tabs.totals.data.data_out,
                            utilization_in: _a.tabs.totals.data.utilization_in,
                            utilization_out: _a.tabs.totals.data.utilization_out,
                        }
                    },
                    packet: {
                        label: "Packet",
                        tabs: {
                            unicast_pkts_in: _a.tabs.totals.packet.unicast_pkts_in,
                            unicast_pkts_out: _a.tabs.totals.packet.unicast_pkts_out,
                            error_in: _a.tabs.totals.packet.error_in,
                            error_out: _a.tabs.totals.packet.error_out,
                        }
                    },
                },
                single: {
                    data: _a.tabs.single.data.data,
                    utilization: _a.tabs.single.data.utilization,
                    packet: _a.tabs.single.packet.packet,
                    error: _a.tabs.single.packet.error,
                },
            },
        },
    },
    lanothers: {
        label: 'LAN Others',
        subsystems: {
            device: {
                label: "Device",
                totals: {},
                single: {},
                metrics: {
                    data_in: _a.metrics.data_in,
                    data_out: _a.metrics.data_out,
                    utilization_in: _a.metrics.utilization_in,
                    utilization_out: _a.metrics.utilization_out,
                    unicast_pkts_in: _a.metrics.unicast_pkts_in,
                    unicast_pkts_out: _a.metrics.unicast_pkts_out,
                    error_in: _a.metrics.error_in,
                    error_out: _a.metrics.error_out,
                    cpu_system: _a.metrics.cpu_system,
                    memory_used_percent: _a.metrics.memory_used_percent
                },
                configuration: {
                    ip: {
                        label: 'IP',
                    },
                    sysLocation: {
                        label: 'Location',
                    },
                    model: {
                        label: 'Model',
                    },
                    version: {
                        label: 'OS Version',
                    },
                    up_time: {
                        label: 'Days up',
                    },
                    serial: {
                        label: 'Serial',
                    },
                    total_ports: {
                        label: 'Total ports',
                    },
                    isl_ports: {
                        label: 'ISL ports',
                    },
                    unused_ports: {
                        label: 'Unused ports',
                    },
                }
            },
            physical: {
                label: "LAN Port",
                configuration: {
                    alias: {
                        label: 'Alias',
                    },
                    speed: {
                        label: 'Speed',
                        type: 'string'
                    },
                    working_state: {
                        label: 'State',
                    },
                    operational_status: {
                        label: 'Operational status',
                    },
                    admin_status: {
                        label: 'Physical status',
                    },
                    vlan_id_list: {
                        label: 'VLAN IDs',
                    },
                    vlan_name_list: {
                        label: 'VLAN names',
                    },
                    description: {
                        label: 'Description',
                    },
                    macs: {
                        label: 'MAC addresses',
                    },
                    isl: {
                        label: 'ISL',
                    },
                },
                totals: {
                    data: {
                        label: "Data",
                        tabs: {
                            data_in: _a.tabs.totals.data.data_in,
                            data_out: _a.tabs.totals.data.data_out,
                            utilization_in: _a.tabs.totals.data.utilization_in,
                            utilization_out: _a.tabs.totals.data.utilization_out,
                        }
                    },
                    packet: {
                        label: "Packet",
                        tabs: {
                            unicast_pkts_in: _a.tabs.totals.packet.unicast_pkts_in,
                            unicast_pkts_out: _a.tabs.totals.packet.unicast_pkts_out,
                            error_in: _a.tabs.totals.packet.error_in,
                            error_out: _a.tabs.totals.packet.error_out,
                        }
                    },
                },
                single: {
                    data: _a.tabs.single.data.data,
                    utilization: _a.tabs.single.data.utilization,
                    packet: _a.tabs.single.packet.packet,
                    error: _a.tabs.single.packet.error,
                },
            },
            vlan: {
                label: "VLAN Port",
                configuration: {
                    alias: {
                        label: 'Alias',
                    },
                    speed: {
                        label: 'Speed',
                        type: 'string'
                    },
                    working_state: {
                        label: 'State',
                    },
                    operational_status: {
                        label: 'Operational status',
                    },
                    admin_status: {
                        label: 'Physical status',
                    },
                    vlan_id_list: {
                        label: 'VLAN IDs',
                    },
                    vlan_name_list: {
                        label: 'VLAN names',
                    },
                    description: {
                        label: 'Description',
                    },
                    macs: {
                        label: 'MAC addresses',
                    },
                    isl: {
                        label: 'ISL',
                    },
                },
                totals: {
                    data: {
                        label: "Data",
                        tabs: {
                            data_in: _a.tabs.totals.data.data_in,
                            data_out: _a.tabs.totals.data.data_out,
                            utilization_in: _a.tabs.totals.data.utilization_in,
                            utilization_out: _a.tabs.totals.data.utilization_out,
                        }
                    },
                    packet: {
                        label: "Packet",
                        tabs: {
                            unicast_pkts_in: _a.tabs.totals.packet.unicast_pkts_in,
                            unicast_pkts_out: _a.tabs.totals.packet.unicast_pkts_out,
                            error_in: _a.tabs.totals.packet.error_in,
                            error_out: _a.tabs.totals.packet.error_out,
                        }
                    },
                },
                single: {
                    data: _a.tabs.single.data.data,
                    utilization: _a.tabs.single.data.utilization,
                    packet: _a.tabs.single.packet.packet,
                    error: _a.tabs.single.packet.error,
                },
            },
            vlancfg: {
                label: "VLAN configuration",
                configuration: {
                    index: {
                        label: 'Index',
                    },
                    unrouted_interface: {
                        label: 'Unrouted interface',
                    },
                    unrouted_ifalias: {
                        label: 'Description',
                    },
                    unrouted_cfgalias: {
                        label: 'Alias',
                    },
                    routed_interface: {
                        label: 'Routed interface',
                    },
                    routed_ifalias: {
                        label: 'Description',
                    },
                    routed_cfgalias: {
                        label: 'Alias',
                    },
                },
                totals: {},
                single: {},
            },
            portchannel: {
                label: "Port channel",
                configuration: {
                    port_channel_members: {
                        label: 'Members',
                    },
                    alias: {
                        label: 'Alias',
                    },
                    speed: {
                        label: 'Speed',
                        type: 'string'
                    },
                    working_state: {
                        label: 'State',
                    },
                    operational_status: {
                        label: 'Operational status',
                    },
                    admin_status: {
                        label: 'Physical status',
                    },
                    vlan_id_list: {
                        label: 'VLAN IDs',
                    },
                    vlan_name_list: {
                        label: 'VLAN names',
                    },
                    description: {
                        label: 'Description',
                    },
                    macs: {
                        label: 'MAC addresses',
                    },
                    isl: {
                        label: 'ISL',
                    },
                },
                totals: {
                    data: {
                        label: "Data",
                        tabs: {
                            data_in: _a.tabs.totals.data.data_in,
                            data_out: _a.tabs.totals.data.data_out,
                            utilization_in: _a.tabs.totals.data.utilization_in,
                            utilization_out: _a.tabs.totals.data.utilization_out,
                        }
                    },
                    packet: {
                        label: "Packet",
                        tabs: {
                            unicast_pkts_in: _a.tabs.totals.packet.unicast_pkts_in,
                            unicast_pkts_out: _a.tabs.totals.packet.unicast_pkts_out,
                            error_in: _a.tabs.totals.packet.error_in,
                            error_out: _a.tabs.totals.packet.error_out,
                        }
                    },
                },
                single: {
                    data: _a.tabs.single.data.data,
                    utilization: _a.tabs.single.data.utilization,
                    packet: _a.tabs.single.packet.packet,
                    error: _a.tabs.single.packet.error,
                },
            },
        },
    },
};
//# sourceMappingURL=Lan.js.map