"use strict";
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.San = void 0;
const pageResponse_constants_1 = require("../../../common/constants/pageResponse.constants");
const subsystemMetricsResponse_constants_1 = require("../../../common/constants/subsystemMetricsResponse.constants");
const Definitions_1 = require("../Definitions");
const Color_1 = require("../Color");
class San {
}
exports.San = San;
_a = San;
San.label = "SAN";
San.order = 2;
San.metrics = {
    data_in: {
        ...Definitions_1.metricTypes.throughput,
        metric: 'data_in',
        label: 'Data in',
    },
    data_out: {
        ...Definitions_1.metricTypes.throughput,
        metric: 'data_out',
        label: 'Data out',
    },
    frames_in: {
        metric: 'frames_in',
        label: 'Frames in',
        unit: subsystemMetricsResponse_constants_1.UNIT.frames_per_second,
        shortcut: subsystemMetricsResponse_constants_1.SHORTCUT.frames_per_second,
    },
    frames_out: {
        metric: 'frames_out',
        label: 'Frames out',
        unit: subsystemMetricsResponse_constants_1.UNIT.frames_per_second,
        shortcut: subsystemMetricsResponse_constants_1.SHORTCUT.frames_per_second,
    },
    bb_credits: {
        metric: 'bb_credits',
        label: 'BBCredits',
        unit: subsystemMetricsResponse_constants_1.UNIT.bb_credits,
        shortcut: subsystemMetricsResponse_constants_1.SHORTCUT.bb_credits,
    },
    crc_errors: {
        metric: 'crc_errors',
        label: 'CRC errors',
        unit: subsystemMetricsResponse_constants_1.UNIT.crc_errors,
        shortcut: subsystemMetricsResponse_constants_1.SHORTCUT.crc_errors,
    },
    link_fail: {
        metric: 'link_fail',
        label: 'Link Failures',
        unit: subsystemMetricsResponse_constants_1.UNIT.link_fail,
        shortcut: subsystemMetricsResponse_constants_1.SHORTCUT.link_fail,
    },
    loss_sync: {
        metric: 'loss_sync',
        label: 'Synchronization Loss',
        unit: subsystemMetricsResponse_constants_1.UNIT.loss_sync,
        shortcut: subsystemMetricsResponse_constants_1.SHORTCUT.loss_sync,
    },
    pcs_errors: {
        metric: 'pcs_errors',
        label: 'PCS Errors',
        unit: subsystemMetricsResponse_constants_1.UNIT.pcs_errors,
        shortcut: subsystemMetricsResponse_constants_1.SHORTCUT.pcs_errors,
    },
    enc_out: {
        metric: 'enc_out',
        label: 'Encoding Errors',
        unit: subsystemMetricsResponse_constants_1.UNIT.enc_out,
        shortcut: subsystemMetricsResponse_constants_1.SHORTCUT.enc_out,
    },
    disc_c3: {
        metric: 'disc_c3',
        label: 'Disc C3 Frames',
        unit: subsystemMetricsResponse_constants_1.UNIT.disc_c3,
        shortcut: subsystemMetricsResponse_constants_1.SHORTCUT.disc_c3,
    },
    sfp_power_out: {
        metric: 'sfp_power_out',
        label: 'SFP Power Out',
        unit: subsystemMetricsResponse_constants_1.UNIT.sfp_power_out,
        shortcut: subsystemMetricsResponse_constants_1.SHORTCUT.sfp_power_out,
    },
    sfp_power_in: {
        metric: 'sfp_power_in',
        label: 'SFP Power In',
        unit: subsystemMetricsResponse_constants_1.UNIT.sfp_power_in,
        shortcut: subsystemMetricsResponse_constants_1.SHORTCUT.sfp_power_in,
    },
    cpu_system: {
        ...Definitions_1.metricTypes.percent,
        metric: 'cpu_system',
        label: 'CPU Utilization',
    },
    memory_used_percent: {
        ...Definitions_1.metricTypes.percent,
        metric: 'memory_used_percent',
        label: 'Memory Utilization',
    },
    utilization_in: {
        ...Definitions_1.metricTypes.percent,
        metric: 'utilization_in',
        label: 'Data In',
    },
    utilization_out: {
        ...Definitions_1.metricTypes.percent,
        metric: 'utilization_out',
        label: 'Data Out',
    },
};
San.tabs = {
    totals: {
        data: {
            data_in: {
                label: 'In',
                metrics: [
                    {
                        ..._a.metrics.data_in,
                        type: pageResponse_constants_1.CHART_TYPE.area,
                        stacked: true,
                        order: 0,
                    },
                ],
            },
            data_out: {
                label: 'Out',
                metrics: [
                    {
                        ..._a.metrics.data_out,
                        type: pageResponse_constants_1.CHART_TYPE.area,
                        stacked: true,
                        order: 0,
                    },
                ],
            },
            utilization_in: {
                label: 'In %',
                metrics: [
                    {
                        ..._a.metrics.utilization_in,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    },
                ],
            },
            utilization_out: {
                label: 'Out %',
                metrics: [
                    {
                        ..._a.metrics.utilization_out,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    },
                ],
            },
        },
        cpumemory: {
            cpu_system: {
                label: 'CPU',
                metrics: [{
                        ..._a.metrics.cpu_system,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    }]
            },
            memory_used_percent: {
                label: 'Memory',
                metrics: [{
                        ..._a.metrics.memory_used_percent,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    }]
            }
        },
        frames: {
            frames_in: {
                label: 'In',
                metrics: [
                    {
                        ..._a.metrics.frames_in,
                        type: pageResponse_constants_1.CHART_TYPE.area,
                        stacked: true,
                        order: 0,
                    },
                ],
            },
            frames_out: {
                label: 'Out',
                metrics: [
                    {
                        ..._a.metrics.frames_out,
                        type: pageResponse_constants_1.CHART_TYPE.area,
                        stacked: true,
                        order: 0,
                    },
                ],
            },
            bb_credits: {
                label: 'BBCredits',
                metrics: [
                    {
                        ..._a.metrics.bb_credits,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    },
                ],
            },
            crc_errors: {
                label: 'CRC errors',
                metrics: [
                    {
                        ..._a.metrics.crc_errors,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    },
                ],
            },
            link_fail: {
                label: 'Link fail',
                metrics: [
                    {
                        ..._a.metrics.link_fail,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    },
                ],
            },
            loss_sync: {
                label: 'Loss sync',
                metrics: [
                    {
                        ..._a.metrics.loss_sync,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    },
                ],
            },
            pcs_errors: {
                label: 'PCS errors',
                metrics: [
                    {
                        ..._a.metrics.pcs_errors,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    },
                ],
            },
            enc_out: {
                label: 'Enc out',
                metrics: [
                    {
                        ..._a.metrics.enc_out,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    },
                ],
            },
            disc_c3: {
                label: 'Disc C3 frames',
                metrics: [
                    {
                        ..._a.metrics.disc_c3,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    },
                ],
            },
            sfp_power_in: {
                label: 'SFP power in',
                metrics: [
                    {
                        ..._a.metrics.sfp_power_in,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    },
                ],
            },
            sfp_power_out: {
                label: 'SFP power out',
                metrics: [
                    {
                        ..._a.metrics.sfp_power_out,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                    },
                ],
            },
        }
    },
    single: {
        data: {
            data: {
                label: 'Data',
                metrics: [
                    {
                        ..._a.metrics.data_in,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.metric.read
                    },
                    {
                        ..._a.metrics.data_out,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 1,
                        color: Color_1.Color.metric.write
                    }
                ],
            },
            utilization: {
                label: 'Data %',
                metrics: [
                    {
                        ..._a.metrics.utilization_in,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.metric.read
                    },
                    {
                        ..._a.metrics.utilization_out,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 1,
                        color: Color_1.Color.metric.write
                    }
                ],
            }
        },
        frames: {
            frames: {
                label: 'Frame',
                metrics: [
                    {
                        ..._a.metrics.frames_in,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.metric.read
                    },
                    {
                        ..._a.metrics.frames_out,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 1,
                        color: Color_1.Color.metric.write
                    }
                ],
            }
        },
        bb_credits: {
            bb_credits: {
                label: 'BBCredits',
                metrics: [
                    {
                        ..._a.metrics.bb_credits,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.metric.read
                    },
                ],
            }
        },
        crc_errors: {
            crc_errors: {
                label: 'CRC errors',
                metrics: [
                    {
                        ..._a.metrics.crc_errors,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.pallete.redDark
                    },
                ],
            }
        },
        link_fail: {
            link_fail: {
                label: 'Link fail',
                metrics: [
                    {
                        ..._a.metrics.link_fail,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.pallete.blueDark
                    },
                ],
            }
        },
        loss_sync: {
            loss_sync: {
                label: 'Loss sync',
                metrics: [
                    {
                        ..._a.metrics.loss_sync,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.pallete.greenDark
                    },
                ],
            }
        },
        pcs_errors: {
            pcs_errors: {
                label: 'PCS errors',
                metrics: [
                    {
                        ..._a.metrics.pcs_errors,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.pallete.brownDark
                    },
                ],
            }
        },
        enc_out: {
            enc_out: {
                label: 'Enc out',
                metrics: [
                    {
                        ..._a.metrics.enc_out,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.pallete.orangeDark
                    },
                ],
            }
        },
        disc_c3: {
            disc_c3: {
                label: 'Disc C3 frames',
                metrics: [
                    {
                        ..._a.metrics.disc_c3,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.pallete.purpleDark
                    },
                ],
            }
        },
        sanbrcd_errors: {
            sanbrcd_errors: {
                label: 'Errors',
                metrics: [
                    {
                        ..._a.metrics.crc_errors,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.pallete.redDark
                    },
                    {
                        ..._a.metrics.link_fail,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.pallete.blueDark
                    },
                    {
                        ..._a.metrics.loss_sync,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.pallete.greenDark
                    },
                    {
                        ..._a.metrics.pcs_errors,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.pallete.orangeDark
                    },
                    {
                        ..._a.metrics.enc_out,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.pallete.brownDark
                    },
                    {
                        ..._a.metrics.disc_c3,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.pallete.yellowDark
                    },
                ],
            },
        },
        sancisco_errors: {
            sancisco_errors: {
                label: 'Errors',
                metrics: [
                    {
                        ..._a.metrics.crc_errors,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.pallete.redDark
                    },
                    {
                        ..._a.metrics.link_fail,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.pallete.blueDark
                    },
                    {
                        ..._a.metrics.loss_sync,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.pallete.greenDark
                    },
                ],
            },
        },
        sfp_power: {
            sfp_power: {
                label: 'SFP power',
                metrics: [
                    {
                        ..._a.metrics.sfp_power_in,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.pallete.redDark
                    },
                    {
                        ..._a.metrics.sfp_power_out,
                        type: pageResponse_constants_1.CHART_TYPE.line,
                        stacked: false,
                        order: 0,
                        color: Color_1.Color.pallete.blueDark
                    },
                ],
            }
        },
    }
};
San.technology = {
    sanbrcd: {
        label: 'SAN Brocade',
        status: {
            explicit: 'device',
            calculated: ['sanport'],
        },
        subsystems: {
            device: {
                label: "Device",
                totals: {},
                single: {},
                metrics: {
                    data_in: _a.metrics.data_in,
                    data_out: _a.metrics.data_out,
                    frames_in: _a.metrics.frames_in,
                    frames_out: _a.metrics.frames_out,
                    bb_credits: _a.metrics.bb_credits,
                    crc_errors: _a.metrics.crc_errors,
                    pcs_errors: _a.metrics.pcs_errors,
                    enc_out: _a.metrics.enc_out,
                    disc_c3: _a.metrics.disc_c3,
                    link_fail: _a.metrics.link_fail,
                    loss_sync: _a.metrics.loss_sync,
                    cpu_system: _a.metrics.cpu_system,
                    memory_used_percent: _a.metrics.memory_used_percent
                },
                configuration: {
                    chassis_name: {
                        label: 'Chassis Name',
                    },
                    ip: {
                        label: 'IP',
                    },
                    wwn: {
                        label: 'WWN',
                        type: 'string',
                    },
                    model: {
                        label: 'Model',
                    },
                    speed: {
                        label: 'Speed',
                    },
                    version: {
                        label: 'OS Version',
                    },
                    days_up: {
                        label: 'Days up',
                    },
                    serial: {
                        label: 'Serial',
                    },
                    total_ports: {
                        label: 'Total ports',
                    },
                    available_ports: {
                        label: 'Available ports',
                    },
                    free_ports: {
                        label: 'Free ports',
                    },
                    unused_ports: {
                        label: 'Unused ports',
                    },
                }
            },
            sanport: {
                label: "SAN Port",
                configuration: {
                    alias: {
                        label: 'Alias',
                    },
                    wwn: {
                        label: 'WWN',
                        type: 'string'
                    },
                    host_wwn: {
                        label: 'Host WWN',
                        type: 'string'
                    },
                    speed: {
                        label: 'Speed',
                    },
                    working_state: {
                        label: 'State',
                    },
                    operational_status: {
                        label: 'Operational status',
                    },
                    physical_status: {
                        label: 'Physical status',
                    },
                    encrypt: {
                        label: 'Encrypt',
                    },
                    compression: {
                        label: 'Compression',
                    },
                },
                totals: {
                    data: {
                        label: "Data",
                        tabs: {
                            data_in: _a.tabs.totals.data.data_in,
                            data_out: _a.tabs.totals.data.data_out,
                            utilization_in: _a.tabs.totals.data.utilization_in,
                            utilization_out: _a.tabs.totals.data.utilization_out,
                        }
                    },
                    frames: {
                        label: "Frame",
                        tabs: {
                            frames_in: _a.tabs.totals.frames.frames_in,
                            frames_out: _a.tabs.totals.frames.frames_out,
                            bb_credits: _a.tabs.totals.frames.bb_credits,
                            crc_errors: _a.tabs.totals.frames.crc_errors,
                            link_fail: _a.tabs.totals.frames.link_fail,
                            loss_sync: _a.tabs.totals.frames.loss_sync,
                            pcs_errors: _a.tabs.totals.frames.pcs_errors,
                            enc_out: _a.tabs.totals.frames.enc_out,
                            disc_c3: _a.tabs.totals.frames.disc_c3,
                            sfp_power_in: _a.tabs.totals.frames.sfp_power_in,
                            sfp_power_out: _a.tabs.totals.frames.sfp_power_out,
                        }
                    },
                    cpumemory: {
                        label: "System",
                        tabs: {}
                    },
                },
                single: {
                    data: _a.tabs.single.data.data,
                    utilization: _a.tabs.single.data.utilization,
                    frames: _a.tabs.single.frames.frames,
                    bb_credits: _a.tabs.single.bb_credits.bb_credits,
                    sanbrcd_errors: _a.tabs.single.sanbrcd_errors.sanbrcd_errors,
                    sfp_power: _a.tabs.single.sfp_power.sfp_power,
                },
            }
        }
    },
    sancisco: {
        label: 'SAN Cisco',
        subsystems: {
            device: {
                label: "Device",
                totals: {},
                single: {},
                metrics: {
                    data_in: _a.metrics.data_in,
                    data_out: _a.metrics.data_out,
                    frames_in: _a.metrics.frames_in,
                    frames_out: _a.metrics.frames_out,
                    bb_credits: _a.metrics.bb_credits,
                    crc_errors: _a.metrics.crc_errors,
                    link_fail: _a.metrics.link_fail,
                    loss_sync: _a.metrics.loss_sync,
                    cpu_system: _a.metrics.cpu_system,
                    memory_used_percent: _a.metrics.memory_used_percent
                },
                configuration: {
                    chassis_name: {
                        label: 'Chassis Name',
                    },
                    ip: {
                        label: 'IP',
                    },
                    wwn: {
                        label: 'WWN',
                        type: 'string'
                    },
                    model: {
                        label: 'Model',
                    },
                    speed: {
                        label: 'Speed',
                    },
                    version: {
                        label: 'OS Version',
                    },
                    days_up: {
                        label: 'Days up',
                    },
                    serial: {
                        label: 'Serial',
                    },
                    total_ports: {
                        label: 'Total ports',
                    },
                    available_ports: {
                        label: 'Available ports',
                    },
                    free_ports: {
                        label: 'Free ports',
                    },
                    unused_ports: {
                        label: 'Unused ports',
                    },
                    licensed_ports: {
                        label: 'Licensed ports',
                    },
                }
            },
            sanport: {
                label: "SAN Port",
                configuration: {
                    alias: {
                        label: 'Alias',
                    },
                    wwn: {
                        label: 'WWN',
                        type: 'string',
                    },
                    host_wwn: {
                        label: 'Host WWN',
                        type: 'string',
                    },
                    vsan_name: {
                        label: 'VSAN',
                    },
                    speed: {
                        label: 'Speed',
                    },
                    working_state: {
                        label: 'State',
                    },
                    operational_status: {
                        label: 'Operational status',
                    },
                    operational_status_reason: {
                        label: 'Operational status reason',
                    },
                    physical_status: {
                        label: 'Physical status',
                    },
                    encrypt: {
                        label: 'Encrypt',
                    },
                    compression: {
                        label: 'Compression',
                    },
                },
                totals: {
                    data: {
                        label: "Data",
                        tabs: {
                            data_in: _a.tabs.totals.data.data_in,
                            data_out: _a.tabs.totals.data.data_out,
                            utilization_in: _a.tabs.totals.data.utilization_in,
                            utilization_out: _a.tabs.totals.data.utilization_out,
                        }
                    },
                    frames: {
                        label: "Frame",
                        tabs: {
                            frames_in: _a.tabs.totals.frames.frames_in,
                            frames_out: _a.tabs.totals.frames.frames_out,
                            bb_credits: _a.tabs.totals.frames.bb_credits,
                            crc_errors: _a.tabs.totals.frames.crc_errors,
                            link_fail: _a.tabs.totals.frames.link_fail,
                            loss_sync: _a.tabs.totals.frames.loss_sync,
                        }
                    },
                    cpumemory: {
                        label: "System",
                        tabs: {}
                    }
                },
                single: {
                    data: _a.tabs.single.data.data,
                    utilization: _a.tabs.single.data.utilization,
                    frames: _a.tabs.single.frames.frames,
                    bb_credits: _a.tabs.single.bb_credits.bb_credits,
                    sancisco_errors: _a.tabs.single.sancisco_errors.sancisco_errors,
                },
            }
        }
    },
    sannav: {
        label: 'Brocade SANnav',
        subsystems: {
            device: {
                label: "Device",
                totals: {},
                single: {},
                metrics: {
                    data_in: _a.metrics.data_in,
                    data_out: _a.metrics.data_out,
                    bb_credits: _a.metrics.bb_credits,
                    crc_errors: _a.metrics.crc_errors,
                    pcs_errors: _a.metrics.pcs_errors,
                    enc_out: _a.metrics.enc_out,
                    disc_c3: _a.metrics.disc_c3,
                    link_fail: _a.metrics.link_fail,
                    loss_sync: _a.metrics.loss_sync,
                    cpu_system: _a.metrics.cpu_system,
                    memory_used_percent: _a.metrics.memory_used_percent
                },
                configuration: {
                    chassis_name: {
                        label: 'Chassis Name',
                    },
                    fabric_name: {
                        label: 'Fabric Name',
                    },
                    domain_id: {
                        label: 'Domain ID',
                        type: 'string'
                    },
                    ip: {
                        label: 'IP',
                    },
                    wwn: {
                        label: 'WWN',
                        type: 'string',
                    },
                    model: {
                        label: 'Model',
                    },
                    speed: {
                        label: 'Speed',
                    },
                    version: {
                        label: 'OS Version',
                    },
                    days_up: {
                        label: 'Days up',
                    },
                    serial: {
                        label: 'Serial',
                    },
                    total_ports: {
                        label: 'Total ports',
                        type: 'string'
                    },
                    available_ports: {
                        label: 'Available ports',
                        type: 'string'
                    },
                    isl_ports: {
                        label: 'ISL ports',
                        type: 'string'
                    },
                    free_ports: {
                        label: 'Free ports',
                        type: 'string'
                    },
                    unused_ports: {
                        label: 'Unused ports',
                        type: 'string'
                    },
                    licensed_ports: {
                        label: 'Licensed ports',
                        type: 'string'
                    },
                }
            },
            sanport: {
                label: "SAN Port",
                configuration: {
                    alias: {
                        label: 'Alias',
                    },
                    wwn: {
                        label: 'WWN',
                        type: 'string'
                    },
                    host_wwn: {
                        label: 'Host WWN',
                        type: 'string'
                    },
                    speed: {
                        label: 'Speed',
                    },
                    isl: {
                        label: 'ISL',
                    },
                    working_state: {
                        label: 'State',
                    },
                    operational_status: {
                        label: 'Operational status',
                    },
                    physical_status: {
                        label: 'Physical status',
                    },
                    encrypt: {
                        label: 'Encrypt',
                    },
                    compression: {
                        label: 'Compression',
                    },
                    license: {
                        label: 'Licensed',
                    },
                    zone_alias: {
                        label: 'Zone',
                    },
                    target_port: {
                        label: 'Target Port',
                    },
                },
                totals: {
                    data: {
                        label: "Data",
                        tabs: {
                            data_in: _a.tabs.totals.data.data_in,
                            data_out: _a.tabs.totals.data.data_out,
                            utilization_in: _a.tabs.totals.data.utilization_in,
                            utilization_out: _a.tabs.totals.data.utilization_out,
                            bb_credits: _a.tabs.totals.frames.bb_credits,
                            crc_errors: _a.tabs.totals.frames.crc_errors,
                            link_fail: _a.tabs.totals.frames.link_fail,
                            loss_sync: _a.tabs.totals.frames.loss_sync,
                            pcs_errors: _a.tabs.totals.frames.pcs_errors,
                            enc_out: _a.tabs.totals.frames.enc_out,
                            disc_c3: _a.tabs.totals.frames.disc_c3,
                            sfp_power_in: _a.tabs.totals.frames.sfp_power_in,
                            sfp_power_out: _a.tabs.totals.frames.sfp_power_out,
                        }
                    },
                    cpumemory: {
                        label: "System",
                        tabs: {}
                    },
                },
                single: {
                    data: _a.tabs.single.data.data,
                    utilization: _a.tabs.single.data.utilization,
                    bb_credits: _a.tabs.single.bb_credits.bb_credits,
                    sanbrcd_errors: _a.tabs.single.sanbrcd_errors.sanbrcd_errors,
                    sfp_power: _a.tabs.single.sfp_power.sfp_power,
                },
            }
        }
    },
};
//# sourceMappingURL=San.js.map