import { IConfiguration, IDefaultSubsystem, IFullMetric, IMetric, ITechnology } from '../Classes';
export interface IMetrics {
    [metric: string]: IMetric;
}
export interface ITabsDefinitions {
    totals: {
        [category: string]: {
            [tab: string]: {
                label: string;
                metrics: IFullMetric[];
            };
        };
    };
    single: {
        [category: string]: {
            [tab: string]: {
                label: string;
                metrics: IFullMetric[];
            };
        };
    };
}
export interface IPagesDefinitions {
    totals: {
        [page: string]: {
            label: string;
            tabs: {
                [tab: string]: {
                    label: string;
                    metrics: IFullMetric[];
                };
            };
        };
    };
}
export interface IStorageSubsystem extends IDefaultSubsystem {
    totals: {
        [page: string]: {
            label: string;
            single?: boolean;
            tabs: {
                [tab: string]: {
                    label: string;
                    metrics: IFullMetric[];
                };
            };
        };
    };
    single: {
        [tab: string]: {
            label: string;
            metrics: IFullMetric[];
        };
    };
    configuration?: IConfiguration;
}
export declare class Storage {
    static order: number;
    static metrics: IMetrics;
    static tabs: ITabsDefinitions;
    static configurations: IConfiguration;
    static pages: IPagesDefinitions;
    static defaultConfiguration: IConfiguration;
    static defaultPoolConfiguration: IConfiguration;
    static technology: ITechnology<IStorageSubsystem>;
    private hwType;
    constructor(hwType: string);
    hasHeatmap(): boolean;
}
