import { ArrayResponseDTO, BasicResponseDTO } from '@xormon/common/basicResponse.dto';
import { SubsystemMetrics, SubsystemMetricsResponseDTO } from '@xormon/common/subsystemMetricsResponse.dto';
import { PredictionRequestDTO, TimeseriesRequestDTO, TimeseriesTopOrder } from '@xormon/common/timeseriesRequest.dto';
import { PredictionResponseDTO, TimeseriesResponseDTO } from '@xormon/common/timeseriesResponse.dto';
import { Request, Response } from 'express';
import { MetricsService } from './metrics.service';
export interface MetricItems {
    [key: string]: {
        metadata: {};
        timeseries: number[];
    };
}
export declare class MetricsController {
    private readonly metricsService;
    constructor(metricsService: MetricsService);
    saveMetrics(res: Response, data: any, hw_type?: string, subsystem?: string): Promise<BasicResponseDTO>;
    saveMetrics2(res: Response, data: any): Promise<BasicResponseDTO>;
    saveMetricsCSV(req: any, hw_type?: string, subsystem?: string): Promise<BasicResponseDTO>;
    getPrediction(request: Request, predictionRequest: PredictionRequestDTO): Promise<PredictionResponseDTO>;
    getMetrics(request: Request, timeseriesRequest: TimeseriesRequestDTO, top?: number, order?: TimeseriesTopOrder, fixedUIDs?: string[], parent?: string, overrideInterval?: 1 | 5 | 60 | 360 | 1440): Promise<TimeseriesResponseDTO>;
    metricsDefinitionByHWType(hw_type: string): Promise<SubsystemMetricsResponseDTO>;
    saveMetricsDefinitions(subsystemMetrics: SubsystemMetrics[]): Promise<BasicResponseDTO>;
    metricsDefinitionBySubsystem(hw_type: string, subsystem: string): Promise<SubsystemMetricsResponseDTO>;
    getColorPallete(): ArrayResponseDTO;
}
