import { OnApplicationBootstrap } from '@nestjs/common';
import { BackendService } from '@xormon/common/backendResponse.dto';
import { MicroserviceRequestDTO } from '@xormon/common/microserviceRequest.dto';
import { HostCfg } from '@xormon/entity/hostcfg.entity';
import { Microservice as MicroserviceEntity } from '@xormon/entity/microservice.entity';
import { MicroserviceJob } from '@xormon/entity/microserviceJobs.entity';
import { MicroserviceJobStatus } from '@xormon/entity/microserviceJobsStatus.entity';
import { Repository } from 'typeorm';
import { MicroserviceVariables } from '@xormon/entity/microserviceVariables.entity';
export declare class MicroservicesService implements OnApplicationBootstrap {
    private microservicesRepository;
    private microservicesJobsRepository;
    private microservicesJobsStatusRepository;
    private hostcfgRepository;
    private microserviceVariablesRepository;
    private logger;
    constructor(microservicesRepository: Repository<MicroserviceEntity>, microservicesJobsRepository: Repository<MicroserviceJob>, microservicesJobsStatusRepository: Repository<MicroserviceJobStatus>, hostcfgRepository: Repository<HostCfg>, microserviceVariablesRepository: Repository<MicroserviceVariables>);
    onApplicationBootstrap(): Promise<void>;
    startAnalyzerService(): Promise<void>;
    startServicesFromDB(): Promise<void>;
    getServices(): Promise<BackendService[]>;
    registerService(microservice: MicroserviceRequestDTO): Promise<boolean>;
    deleteMicroservice(microsevice: string): Promise<boolean>;
    describeService(name: string): Promise<BackendService>;
    startService(name: string, changeOnStartup?: boolean): Promise<BackendService>;
    stopService(name: string, changeOnStartup?: boolean): Promise<BackendService>;
    restartService(name: string): Promise<boolean>;
    sendTask(name: string, task: string, data: any): Promise<string | {}>;
    saveMicroservice(items: any): Promise<boolean>;
    getMicroservice(microservice: string): Promise<MicroserviceEntity>;
    getMicroserviceJobsHistory(microservice: string): Promise<MicroserviceJobStatus[]>;
    getMicroserviceJobs(microservice: string): Promise<MicroserviceJob[]>;
    getCfg(hostcfg_id: any): Promise<HostCfg>;
    isJson(str: any): boolean;
    sleep(ms: number): Promise<unknown>;
    getMicroserviceVariables(hw_type: string, hostcfg_id: string): Promise<{
        [x: string]: string;
    }>;
}
