import { ExporterHistoryResponseDTO, PublicExportCapacityRequestDTO, PublicExportConfigurationRequestDTO, PublicExportMappingRequestDTO, PublicExportTimeseriesRequestDTO } from "@xormon/common/exporter.dto";
import { ExporterService } from "@xormon/service/exporter/exporter.service";
import { Request, Response } from 'express';
import { PropsResponseDTO } from "@xormon/common/architecture.dto";
export declare class ExporterPublicController {
    private readonly exporterService;
    constructor(exporterService: ExporterService);
    exports(request: Request): Promise<ExporterHistoryResponseDTO>;
    export(request: Request, res: Response, export_id?: string): Promise<void>;
    timeseries(res: Response, request: PublicExportTimeseriesRequestDTO): Promise<void>;
    configuration(request: Request, res: Response, exportRequest: PublicExportConfigurationRequestDTO): Promise<void>;
    mapping(request: Request, res: Response, exportRequest: PublicExportMappingRequestDTO): Promise<void>;
    capacity(request: Request, res: Response, exportRequest: PublicExportCapacityRequestDTO): Promise<void>;
    getConfigurationProperties(hwType: string, subsystem: string): Promise<PropsResponseDTO>;
}
