import { UnitPrefix } from "@xormon/common/pageResponse.dto";
import { Unit } from "@xormon/common/subsystemMetricsResponse.dto";
import { IMetric } from "@xormon/service/metrics/Classes";
export declare const UNIT_PREFIX_BASE: {
    readonly base10: "base10";
    readonly base2: "base2";
    readonly noprefix: "noprefix";
};
type UnitPrefixBase = typeof UNIT_PREFIX_BASE[keyof typeof UNIT_PREFIX_BASE];
type ValueUsageContext = 'graphYAxis' | 'graphLegend' | 'table' | 'export' | 'report';
export declare class MetricTools {
    static formatNumber(value: any, metricSpecification: Partial<IMetric>, addUnit?: boolean): any | string;
    static makeUnitString(unit: Unit, prefix?: UnitPrefix): string;
    static makeLabel(metricSpecification: Partial<IMetric>, useDefaultPrefix: boolean): string;
    static prefixToValue(prefix: UnitPrefix): number;
    static makeBinaryPrefix(value: number): UnitPrefix | '';
    static getUnitPrefixBase(unit: Unit, usedIn: ValueUsageContext): UnitPrefixBase;
}
export {};
