"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReportFileTools = void 0;
const promises_1 = require("fs/promises");
const pathUtils = require("path");
const Reporter_1 = require("./Reporter");
class ReportFileTools {
    static async removeIfOldEnough(filePath, olderThanDate) {
        try {
            const fileStat = await (0, promises_1.stat)(filePath);
            if (fileStat.ctime >= olderThanDate) {
                return 0;
            }
            await (0, promises_1.rm)(filePath);
            return 1;
        }
        catch (e) {
            Reporter_1.Reporter.winstonLogger.warn(e);
            return 0;
        }
    }
    static async clearTmpDir(olderThanDate) {
        const directoryContent = await (0, promises_1.readdir)(Reporter_1.Reporter.getReportTmpPath(), { withFileTypes: true });
        const fileDirents = directoryContent.filter(dirent => dirent.isFile());
        const fileFullPaths = fileDirents.map(fileDirent => pathUtils.join(fileDirent.path, fileDirent.name));
        const removePromises = fileFullPaths.map(filePath => ReportFileTools.removeIfOldEnough(filePath, olderThanDate));
        const removed = await Promise.all(removePromises);
        const removedCount = removed.reduce((a, b) => (a + b), 0);
        Reporter_1.Reporter.winstonLogger.info(`Reporter: ${removedCount} temporary Report files were deleted.`);
    }
}
exports.ReportFileTools = ReportFileTools;
//# sourceMappingURL=ReportFileTools.js.map