import { ServerGroupDTO } from "@xormon/common/serverGroup.dto";
import { ObjectItem } from "@xormon/entity/objectItem.entity";
import { ServerGroup } from "@xormon/entity/serverGroup.entity";
import { ServerGroupItems } from "@xormon/entity/serverGroupItems.entity";
import { DeleteResult, Repository } from "typeorm";
export declare class ServerGroupService {
    private objectItemRepository;
    private serverGroupRepository;
    private serverGroupItemsRepository;
    constructor(objectItemRepository: Repository<ObjectItem>, serverGroupRepository: Repository<ServerGroup>, serverGroupItemsRepository: Repository<ServerGroupItems>);
    getServerGroups(user_id: number, hw_types?: string[], _class?: string): Promise<ServerGroup[]>;
    getServerGroupWithRelation(server_group_id: string): Promise<ServerGroup>;
    saveServerGroup(server_group: ServerGroupDTO): Promise<ServerGroup>;
    getValidItems(hw_type?: string, _class?: string): Promise<ObjectItem[]>;
    updateServerGroup(server_group_id: string, server_group: ServerGroupDTO): Promise<ServerGroup>;
    deleteServerGroup(server_group_id: string): Promise<DeleteResult>;
    checkOwnership(server_group_id: string, user_id: number): Promise<boolean>;
}
