import { BasicResponseDTO } from '@xormon/common/basicResponse.dto';
import { Request } from 'express';
import { DevicesResponseDTO, RegexPreviewDTO, StorageGroupDTO, StorageGroupResponseDTO, StorageGroupsResponseDTO } from '../../common/storageGroups.dto';
import { StorageGroupService } from './storage_group.service';
export declare class StorageGroupController {
    private readonly storageGroupService;
    constructor(storageGroupService: StorageGroupService);
    getStorageGroups(request: Request): Promise<StorageGroupsResponseDTO>;
    preview(preview: RegexPreviewDTO): Promise<DevicesResponseDTO>;
    createStorageGroup(request: Request, storage_group: StorageGroupDTO): Promise<StorageGroupResponseDTO>;
    updateStorageGroup(request: Request, storage_group_id: string, storage_group: Partial<StorageGroupDTO>): Promise<StorageGroupResponseDTO>;
    deleteStorageGroup(request: Request, storage_group_id: string): Promise<BasicResponseDTO>;
}
