import { StorageGroupDTO } from '@xormon/common/storageGroups.dto';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
import { StorageGroup } from '@xormon/entity/storageGroup.entity';
import { StorageGroupDevice } from '@xormon/entity/storageGroupDevice.entity';
import { StorageGroupRegex } from '@xormon/entity/storageGroupRegex.entity';
import { Repository } from 'typeorm';
export declare class StorageGroupService {
    private storageGroupsRepository;
    private storageGroupDevicesRepository;
    private storageGroupRegexRepository;
    private objectItemsRepository;
    constructor(storageGroupsRepository: Repository<StorageGroup>, storageGroupDevicesRepository: Repository<StorageGroupDevice>, storageGroupRegexRepository: Repository<StorageGroupRegex>, objectItemsRepository: Repository<ObjectItem>);
    getStorageGroups(userId: number): Promise<StorageGroup[]>;
    getGroupStorageGroups(groupIds: number[]): Promise<StorageGroup[]>;
    getStorageGroupsWithRelations(userId: number, groupIds: number[]): Promise<StorageGroup[]>;
    findStorageGroupByLabel(label: string): Promise<StorageGroup>;
    getStorageGroup(storage_group_id: string): Promise<StorageGroup>;
    saveStorageGroup(storage_group: StorageGroupDTO, user_id?: number): Promise<StorageGroup>;
    updateStorageGroup(storage_group_id: string, storage_group: Partial<StorageGroupDTO>): Promise<StorageGroup>;
    checkStorageGroupOwner(storage_group_id: string, user_id: number): Promise<boolean>;
    deleteStorageGroup(storage_group_id: string): Promise<import("typeorm").DeleteResult>;
    regex(regex: string[]): Promise<ObjectItem[]>;
}
