import { ObjectItem } from "@xormon/entity/objectItem.entity";
import { Item } from "@xormon/common/architecture.dto";
import { ParentRegex, ParentTag } from "@xormon/common/customGroup.dto";
export declare class TagWrapper {
    static getItemsByTagParents(parents: string[], tags: string[], hwTypeOrClass: string, intersection?: boolean, subsystem?: string): Promise<Item[]>;
    static getItemsByTag(tags: string[], hwTypeOrClass: string, intersection?: boolean, subsystem?: string): Promise<Item[]>;
    static getFullItemsForTag(tagToUse: string): Promise<Item[]>;
    static getFullItemsForTagById(tagIdToUse: string): Promise<Item[]>;
    static getFullItemsForItemIds(itemIds: string[]): Promise<Item[]>;
    static getFilteredItemsForItemIds(item_ids: string[], hw_type: string, subsystem: string, class_name: string): Promise<any[]>;
    static getFullObjectItemsForItemIds(itemIds: string[]): Promise<ObjectItem[]>;
    static getItems(hwTypeOrClass: string, subsystem: string, tags: string[]): Promise<ObjectItem[]>;
    static getItemsByParents(parents: string[], hwTypeOrClass: string, subsystem: string, tags: string[], intersection?: boolean): Promise<ObjectItem[]>;
    static getItemsByRegexParentsRegex(parentsRegex: ParentRegex[], hwTypeOrClass: string, subsystem: string, tags: string[], intersection?: boolean): Promise<ObjectItem[]>;
    static getItemsByParentsTag(parentTags: ParentTag[], hwTypeOrClass: string, subsystem: string, tags: string[], intersection?: boolean): Promise<ObjectItem[]>;
    static tagSearch(tag_label: string, value: string): Promise<ObjectItem[]>;
}
