import { Request } from 'express';
import { TagService } from './tag.service';
import { TagValueResponseDTO, TagValuesResponseDTO } from '@xormon/common/tagValue.dto';
import { TagValueItemResponseDTO, TagValueItemsResponseDTO } from '@xormon/common/tagValueItem.dto';
import { TagResponseDTO, TagsWithValueIndicatorResponseDTO } from '@xormon/common/tag.dto';
import { ItemsResponseDTO } from '@xormon/common/architecture.dto';
export declare class TagController {
    private readonly tagService;
    constructor(tagService: TagService);
    listAllTags(request: Request): Promise<TagsWithValueIndicatorResponseDTO>;
    listAllTagValues(request: Request): Promise<TagValuesResponseDTO>;
    listAllTagValueItems(request: Request): Promise<TagValueItemsResponseDTO>;
    listTagValuesByTag(request: Request, tag_id: string): Promise<TagValuesResponseDTO>;
    listTagValueItemsByItem(request: Request, item_id: string): Promise<TagValueItemsResponseDTO>;
    getTag(request: Request, body: any): Promise<TagResponseDTO>;
    getTagById(request: Request, tag_id: string): Promise<TagResponseDTO>;
    getTagValuesByName(request: Request, tag_label: string): Promise<TagValuesResponseDTO>;
    getItemsForTag(request: Request, tag_label: string): Promise<ItemsResponseDTO>;
    getItemsForTagId(request: Request, tag_id: string): Promise<ItemsResponseDTO>;
    getItemsForTagValueId(request: Request, tag_value_id: string, hw_type?: string, subsystem?: string, class_name?: string): Promise<ItemsResponseDTO>;
    saveTag(request: Request, body: any): Promise<TagResponseDTO>;
    deleteTagByName(request: Request, body: any): Promise<TagResponseDTO>;
    updateTag(request: Request, body?: any): Promise<TagResponseDTO>;
    deleteTag(request: Request, body?: any): Promise<TagResponseDTO>;
    saveTagValueByName(request: Request, body: any): Promise<TagValueResponseDTO>;
    saveTagValueById(request: Request, body: any): Promise<TagValueResponseDTO>;
    updateTagValueByName(request: Request, body: any): Promise<TagValueResponseDTO>;
    updateTagValueById(request: Request, body: any): Promise<TagValueResponseDTO>;
    saveTagValueItem(request: Request, body: any): Promise<TagValueItemResponseDTO>;
    deleteTagValueItem(request: Request, body: any): Promise<TagValueItemResponseDTO>;
    updateTagValueItems(request: Request, body: any): Promise<TagValueItemsResponseDTO>;
    deleteTagValueItems(request: Request, body: any): Promise<TagValueItemsResponseDTO>;
    saveTagValueItems(request: Request, body: any): Promise<TagValueItemsResponseDTO>;
    updateTagValueItemsByTagId(request: Request, body: any): Promise<TagValueItemsResponseDTO>;
    deleteTagValueItemsByTagId(request: Request, body: any): Promise<TagValueItemsResponseDTO>;
    saveTagValueItemsByTagId(request: Request, body: any): Promise<TagValueItemsResponseDTO>;
    deleteTagValuesById(request: Request, body?: any): Promise<TagValuesResponseDTO>;
    deleteTagValuesByLabel(request: Request, body?: any): Promise<TagValuesResponseDTO>;
    deleteTagValueByName(request: Request, body?: any): Promise<TagValueResponseDTO>;
    deleteTagValueById(request: Request, body?: any): Promise<TagValueResponseDTO>;
    deleteTagValuesByItem(request: Request, body?: any): Promise<TagValueItemsResponseDTO>;
}
