import { AdminGroupsResponseDTO } from '@xormon/common/adminGroups.dto';
import { ArrayResponseDTO, BasicResponseDTO } from '@xormon/common/basicResponse.dto';
import { GroupDTO, GroupResponseDTO, GroupsResponseDTO, LdapGroupsResponseDTO, UpdateLdapGroupDTO } from '@xormon/common/groupsResponse.dto';
import { CreateUserApiKey, RegisterUserDTO, UpdateLoggedUserDTO, UpdateUserDTO, UserApiKeyResponseDTO, UserApiKeysResponseDTO, UserBase, UserResponseDTO, UsersResponseDTO } from '@xormon/common/usersResponse.dto';
import { Request } from 'express';
import { LdapService } from '../ldap/ldap.service';
import { UsersService } from './users.service';
export declare class UsersController {
    private readonly usersService;
    private readonly ldapService;
    private readonly logger;
    constructor(usersService: UsersService, ldapService: LdapService);
    registerUser(request: Request, headers: any, user: RegisterUserDTO): Promise<UserResponseDTO>;
    getProfile(request: Request): Promise<UserResponseDTO>;
    getUserApiKeys(request: Request): Promise<UserApiKeysResponseDTO>;
    generateUserApiKeys(request: Request, apiKeyRequest: CreateUserApiKey): Promise<UserApiKeyResponseDTO>;
    deleteUserApiKey(request: Request, key: string): Promise<BasicResponseDTO>;
    updateProfile(request: Request, update: UpdateLoggedUserDTO): Promise<UserResponseDTO>;
    updateUser(request: Request, headers: any, user_id: number, user: UpdateUserDTO): Promise<UserResponseDTO>;
    getUsers(): Promise<UsersResponseDTO>;
    getUser(user_id: number): Promise<UserResponseDTO>;
    deleteUser(request: Request, headers: any, user_id: number): Promise<BasicResponseDTO>;
    registerGroup(request: Request, headers: any, group: GroupDTO): Promise<GroupResponseDTO>;
    getLdapGroups(): Promise<LdapGroupsResponseDTO>;
    updateLdapGroups(group_id: number, ldap_groups: UpdateLdapGroupDTO): Promise<BasicResponseDTO>;
    getGroups(): Promise<GroupsResponseDTO>;
    getGroup(group_id: number): Promise<GroupResponseDTO>;
    deleteGroup(request: Request, headers: any, group_id: number): Promise<BasicResponseDTO>;
    updateGroup(request: Request, headers: any, group_id: number, group: GroupDTO): Promise<GroupResponseDTO>;
    getAdminGroupConfig(group_id?: number): Promise<AdminGroupsResponseDTO>;
    exportUsers(): Promise<UserBase[]>;
    importUsers(users: UserBase[]): Promise<ArrayResponseDTO>;
}
