"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomTask = void 0;
const common_1 = require("@nestjs/common");
const TaskMonitor_1 = require("./TaskMonitor");
const dataSource_1 = require("../config/dataSource");
const customTask_entity_1 = require("../entity/customTask.entity");
function diffHours(dt2, dt1) {
    var diff = (dt2.getTime() - dt1.getTime()) / 1000;
    diff /= (60 * 60);
    return Math.abs(Math.round(diff));
}
let CustomTask = class CustomTask {
    constructor() { }
    async handleTask() {
        const taskMonitor = new TaskMonitor_1.TaskMonitor('customTask', 'Custom tasks');
        taskMonitor.start();
        try {
            await (0, dataSource_1.createDataSource)();
            const dataSource = (0, dataSource_1.getDataSource)();
            const customTaskRepository = dataSource.createEntityManager().getRepository(customTask_entity_1.CustomTask);
            const customTasks = await customTaskRepository.find({
                relations: {
                    mailGroups: true
                }
            });
            for (const customTask of customTasks) {
                try {
                    const taskFile = require(customTask.filePath.replace(".ts", ".js"));
                    const taskClass = taskFile[Object.keys(taskFile)[0]];
                    const task = new taskClass();
                    if (task.handle && typeof task.handle === 'function') {
                        const shouldRun = customTask.lastRunAt
                            ? diffHours(customTask.lastRunAt, new Date()) >= task.intervalInHours
                            : true;
                        if (shouldRun) {
                            console.log(customTask.createdAt);
                            task.handle(dataSource, customTask.mailGroups);
                            customTask.lastRunAt = new Date();
                            customTaskRepository.save(customTask);
                        }
                    }
                }
                catch (e) {
                    console.error(`[CustomReport] [${customTask.name}] error: ${e}`);
                }
            }
        }
        catch (e) {
            taskMonitor.log("[CustomReport Error]: " + e);
        }
        taskMonitor.end();
    }
};
exports.CustomTask = CustomTask;
exports.CustomTask = CustomTask = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [])
], CustomTask);
//# sourceMappingURL=custom.task.js.map