"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@nestjs/core");
const dataSource_1 = require("../config/dataSource");
const app_module_1 = require("./app.module");
const typeorm_transactional_1 = require("typeorm-transactional");
async function bootstrap() {
    await (0, dataSource_1.createDataSource)();
    (0, typeorm_transactional_1.initializeTransactionalContext)({ storageDriver: typeorm_transactional_1.StorageDriver.AUTO });
    const app = await core_1.NestFactory.createApplicationContext(app_module_1.TaskServerModule);
    app.enableShutdownHooks();
}
bootstrap();
//# sourceMappingURL=main.js.map