/// <reference types="node" />
export declare enum CacheKeys {
    HEALTH_STATUS = "health_status"
}
export declare class CacheItem<T> {
    value: T;
    interval: NodeJS.Timeout;
    onInterval: () => Promise<any>;
    constructor(value: T, ttl: number, onInterval: () => Promise<any>);
    cancelTimeout(): void;
    setValue(value: T): this;
}
export declare class Cache<K, V> {
    private cache;
    constructor();
    set(key: K, value: V): void;
    get(key: K): any | undefined;
    update(key: K, value: V): void;
    getValue(key: K): V | undefined;
    delete(key: K): void;
}
export declare const createGlobalTaskCache: () => Cache<string, any>;
export declare const getGlobalTaskCache: () => Cache<string, any>;
