package ISILON;

use strict;
use warnings;

use LWP::UserAgent;
use HTTP::Request;
use Data::Dumper;
use FindBin;
use lib "$FindBin::Bin/"; # use lib in this folder
use lib "../../../perl-modules";
use Xormon;
use JSON qw(encode_json decode_json);
use Date::Parse;
use FindBin;
use Test;
use XormonLogger;

my $logger;
my %data;
my $xormon;
my $cfg;
my $stats_found = 0;
my $api_version = "";
my $urls;
my $data_directory = "$FindBin::Bin";
my $debug = 0;

my $storage_name = "";
my $active_minute = "";
my $debug_data = "";
my $debug_data_configuration = "";
my %performance_data;
my %configuration_data;
my %pools;
my %node;
my %pool;
my $st_serial;
my $request_count;
my @architecture = ();
my $service_data_out;
my $st_type = "isilon";
my $token = "";
my $cookie = "";
my @rows_api_test = ();
my @health_status = ();
my @rows_api_test_data = ();
my @health_status_global = ();
my $service_data_in;


#test


sub collect {
  $xormon = shift;
  $cfg    = shift;
  #print Dumper \$cfg;

  #'hostcfg_id' => '4107e4a8-0ff3-4dd9-9f72-3a798aaf9e75',
  #'apiHost' => 'localhost',
  #'created' => '1651046205524',
  #'apiPassword' => 'ibm4you',
  #'apiUsername' => 'stor2rrd',
  #'apiPort' => 8080,
  #'device' => 'DELL_EMC_ISILON',
  #'hostalias' => 'Isilon'
  # test main variables


  unless ( exists $cfg->{'hostcfg_id'} )    { Xormon::error("Cannot continue, 'hostcfg_id' is not configured!") && return "error"; }
  unless ( exists $cfg->{'hostalias'} )     { Xormon::error("Cannot continue, 'hostalias' is not configured!") && return "error"; }
  $logger = XormonLogger->new('isilon', $cfg->{'hostcfg_id'}, $cfg->{hostalias} );
  unless ( exists $cfg->{'apiHost'} )       { $logger->error("Cannot continue, 'apiHost' is not configured!") && return "error"; }
  unless ( exists $cfg->{'apiPort'} )       { $logger->error("Cannot continue, 'apiPort' is not configured!") && return "error"; }
  unless ( exists $cfg->{'apiUsername'} )   { $logger->error("Cannot continue, 'apiUsername' is not configured!") && return "error"; }
  unless ( exists $cfg->{'apiPassword'} )   { $logger->error("Cannot continue, 'apiPassword' is not configured!") && return "error"; }
  #$cfg->{'api-pass'}    = Xormon::unobscure_password($cfg->{'apiPassword'});
  $cfg->{'api-pass'}    = $cfg->{'apiPassword'};
  $cfg->{'sample_rate'} = 300;
  my $act_timestamp     = time();

  $storage_name = $cfg->{hostalias};
  $cfg->{'uuid'} = $cfg->{'hostcfg_id'};
  $st_serial = $cfg->{'uuid'};

  $service_data_in = $xormon->getData();
  if ( exists $service_data_in->{last_conf_timestamp} ) {
    $service_data_out->{last_conf_timestamp} = $service_data_in->{last_conf_timestamp};
  }

  #### create data structure
  data_structure();

  $urls = cmd("platform/?describe&list", "$debug_data/list_command.json"); ### list all commands
  if ($urls eq "" || $urls eq "0"){
    login_api();
    if ( !defined $cookie || $cookie eq "" || !defined $token || $token eq "" ) {
      #push(@rows_api_test,"ERROR: cookie or token is not defined. Connection failed!!\n");
      $xormon->isConnected(0, "Connection failed!");
      $logger->error( "Connection failed!!! Exitting... " . __FILE__ . ":" . __LINE__ ) && return "error";
    }
    else{
      $urls = cmd("platform/?describe&list", "$debug_data/list_command.json"); ### list all commands
    }
  }
  my $ret = get_cluster_info("$debug_data/cluster_info.json");
  if ($ret eq "0"){
    $xormon->isConnected(0, "Connection failed!");
    $logger->error( "Connection failed!!! Exitting... " . __FILE__ . ":" . __LINE__ ) && return "error";
  }
  if (!defined $data{conf}{device}{'apiVersion'} || $data{conf}{device}{'apiVersion'} eq ""){
    $xormon->isConnected(0, "Connection failed!");
    $logger->error( "API version is not defined\nConnection failed!!! Exitting... " . __FILE__ . ":" . __LINE__ ) && return "error";
  }
  $api_version = $data{conf}{device}{'apiVersion'};
  ### hostcfg_status
  $xormon->isConnected(1);
  ### hostcfg_status

  set_data_drive_old();
  set_data_pool_capacity();
  set_data_node();
  set_data_pool();
  set_data_cpu();
  set_data_port();
  set_data_device();
  #}
  #print Dumper \$performance_data{$st_type}{pool};
  delete_empty_metrics();
  calculate_missing_metrics();
  #print "Request count $request_count\n";
  #print "Ending " . localtime() . "\n";
  #print Dumper \$performance_data{"b7f47bf17c"};
  my $size_key = keys %performance_data;
  my $rc = $xormon->saveJSON2(\%performance_data);
  my $status = get_status($rc, "saveJSON2 (performance)");

  ### host_cfg_data
  if (Xormon::isdigit($service_data_out->{last_perf_timestamp})){
    if ( ( time() -  $service_data_out->{last_perf_timestamp} ) > 10800 ) {
      $xormon->hasData(0, "last available stats are older than 3 hours: " . $service_data_out->{last_perf_timestamp});
    }
    else{
      $xormon->hasData(1);
    }
  }
  else{
    $xormon->hasData(0, "no available stats");
  }
  ###

  if (( ! exists $service_data_in->{last_conf_timestamp} ) || ( ! Xormon::isdigit($service_data_in->{last_conf_timestamp}) ) || ( $act_timestamp - $service_data_in->{last_conf_timestamp} > 3600 ) || ( !-f "$debug_data_configuration/config-$st_serial.out" )) {
    `touch "$debug_data_configuration/config-$st_serial.out"`;
    #set_architecture();
    set_data_drive_cfg();
    set_data_node_cfg();
    set_data_quota_cfg();

    #$status = set_architecture();
    $service_data_out->{last_conf_timestamp} = $act_timestamp;
    #$xormon->saveConfJSON(\%configuration_data);
    #print Dumper \@health_status;
    ###

    #my $rc = $xormon->saveConfJSON(\%configuration_data);
    #my $status = get_status($rc, "saveConfJSON (configuration)");
    #$logger->info("Task for configuration ".$cfg->{hostalias}." is done. Status: $status");
    set_data_health_status();
    ($status, my $status_configuration, my $status_health) = set_architecture();
    if ($status eq "successful" && $status_configuration eq "successful" && $status_health eq "successful" ){
      my $save_data = $xormon->saveData(\%{ $service_data_out });
      my $status_save_data = get_status($save_data, "SaveData");
    }
    logout_api();
    $logger->info("Task for ".$cfg->{hostalias}." is done. Status: $status");
    return $status;
  }
  logout_api();
  my $save_data = $xormon->saveData(\%{ $service_data_out });
  my $status_save_data = get_status($save_data, "SaveData");
  $logger->info("Task for ".$cfg->{hostalias}." is done. Status: $status");

  #print Dumper \$service_data_out;
  return $status;
}

sub delete_empty_metrics{
  my $first_time = "";
  foreach my $type (keys %{$performance_data{$st_type}}){
    foreach my $uid (keys %{$performance_data{$st_type}{$type}}){
      foreach my $time (keys %{$performance_data{$st_type}{$type}{$uid}}){
        if ($first_time eq "" && Xormon::isdigit($time)){
          $first_time = $time;
        }
        if (Xormon::isdigit($first_time) && Xormon::isdigit($time) && $time < $first_time){
          $first_time = $time;
        }
        foreach my $item (keys %{$performance_data{$st_type}{$type}{$uid}{$time}}){
          if (!Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{$item}) || $performance_data{$st_type}{$type}{$uid}{$time}{$item} < 0){
            delete $performance_data{$st_type}{$type}{$uid}{$time}{$item};
          }
        }
      }
    }
  }
  if (Xormon::isdigit($first_time)){
    $service_data_out->{last_perf_timestamp} = $first_time;
  }
  else{
    if (Xormon::isdigit($service_data_in->{last_perf_timestamp})){
      $service_data_out->{last_perf_timestamp} = $service_data_in->{last_perf_timestamp};
    }
  }
}

sub calculate_missing_metrics{
  my $item_total = "capacity_total";
  my $item_used = "capacity_used";
  my $item_used_percent = "capacity_used_percent";

  foreach my $type (keys %{$performance_data{$st_type}}){
    foreach my $uid (keys %{$performance_data{$st_type}{$type}}){
      foreach my $time (keys %{$performance_data{$st_type}{$type}{$uid}}){
        #capacity_used_percent
        if (Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{$item_total}) && Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{$item_used})){
          if ($performance_data{$st_type}{$type}{$uid}{$time}{$item_total} == 0){
            $performance_data{$st_type}{$type}{$uid}{$time}{$item_used_percent} = 0;
          }
          else{
            my $pom = ($performance_data{$st_type}{$type}{$uid}{$time}{$item_used} / $performance_data{$st_type}{$type}{$uid}{$time}{$item_total}) * 100;
            $performance_data{$st_type}{$type}{$uid}{$time}{$item_used_percent} = round($pom,2);
          }
        }
      }
    }
  }
}

sub get_status {
  my $rc = shift;
  my $task = shift;
  if ($rc eq "201" || $rc eq "200") {
    $logger->info("Task for $task ".$cfg->{hostalias}." is done. Status: successful");
    return "successful";
  } elsif ($rc eq "401") {
    $logger->error("Task for $task ".$cfg->{hostalias}." is done. Status: unauthorized");
    return "unauthorized";
  } else {
    $logger->error("Task for $task ".$cfg->{hostalias}." is done. Status: error");
    return "error";
  }
}

sub set_data_health_status{

  my $cmd = "platform/$api_version/statistics/current?key=cluster.health";
  my $data = cmd($cmd, "$debug_data/cluster_hs.json");
  my $status = "ok";
  #my @hs = ();
  my %vm_status;
  my $status_event = "ok";
  my $message_global = "";
  #print STDERR Dumper $data;

  if ($data eq "0" || !defined $data->{'stats'} || ref($data->{'stats'}) ne "ARRAY"){return;}
  foreach my $element ( @{$data->{stats}} ) {
    my $value = $element->{'value'};
    if ($value eq "1"){
      $status = "error";
      last;
    }
  }
  $cmd = "platform/$api_version/event/eventlists";
  $data = cmd($cmd, "$debug_data/cluster_hs.json");
  if ($data eq "0" || !defined $data->{'eventlists'} || ref($data->{'eventlists'}) ne "ARRAY"){return;}
  foreach my $event ( @{$data->{'eventlists'}} ) {
    my $list = $event->{'events'};
    if ( defined $list && $list ne "" && ref($list) eq "ARRAY") {
      my $count = 0;
      foreach my $element ( @{$list} ) {
        my $devid    = $element->{'devid'};
        my $message  = $element->{'message'};
        my $id       = $element->{'id'};
        my $time     = $element->{'time'};
        my $severity = $element->{'severity'};
        my $resolve_time = $element->{"resolve_time"};
        if (!defined $severity){next;}
        if (!defined $devid){$devid = "";}
        if (!defined $message){$devid = "";}
        if (!defined $id){$devid = "";}
        if (!defined $time){$devid = "";}
        #if ( Xormon::isdigit($time) ) {
        #  $time = localtime($time);
        #}
        #else { $time = "-"; }
        #if ( $severity ne 'information' && $severity ne 'unknown' && $severity ne 'emergency' && $count < 100 ) {
        if (defined $resolve_time && $resolve_time ne "0"){next;}
        if ( $severity ne 'information' && $severity ne 'unknown' && $severity ne 'emergency') {
          $count++;
          my %data;
          $data{time} = $time;
          $data{id} = $id;
          $data{severity} = $severity;
          $data{message} = $message;
          if ($message_global ne "" && $severity !~ m/warning/i ){
            $message_global = $message;
          }
          elsif($message_global eq ""){
            $message_global = $message;
          }
          $data{devid} = $devid;
          if ($severity eq "critical"){
            $status_event = $severity;
          }
          if ($severity =~ m/warning/i && $status_event ne "critical"){
            $status_event = "warning";
          }
          push(@health_status,\%data);
        }
      }
    }
  }
  $status = $status_event;
  if ($status eq "critical"){$status = "error";}
  #if ($status_event eq "warning"){
  #  $status = $status_event;
  #}
  #if ($status eq "error" && $status_event ne "warning"){
  #  $status = "error";
  #}
  %vm_status = (
    "item_id" => $st_serial,
    "status" => $status,
    "data" => $message_global
  );
  push(@health_status_global, \%vm_status);
  #print Dumper \@hs;
  #my $rc = $xormon->saveStatus(\@hs);
  #my $status_job = get_status($rc, "health status");
  #$logger->info("Task healh status ".$cfg->{hostalias}." is done. Status: $status_job");
  return;

}

sub set_data_device{
  my $type = "pool";
  #my @metrics = ("data_rate", "capacity_total", "capacity_used", "capacity_free", "read", "write");
  my %data;
  my $time = "";
  foreach my $uid (keys %{$performance_data{$st_type}{$type}}){
    $time = (keys %{$performance_data{$st_type}{$type}{$uid}})[0];
    foreach my $metric (keys %{$performance_data{$st_type}{$type}{$uid}{$time}}){
      if (Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{$metric})){
        if (Xormon::isdigit($data{$metric})){
          $data{$metric} = $data{$metric} + $performance_data{$st_type}{$type}{$uid}{$time}{$metric};
        }
        else{
          $data{$metric} = $performance_data{$st_type}{$type}{$uid}{$time}{$metric};
        }
      }
    }
  }
  foreach my $metric (keys %data){
    $performance_data{$st_type}{device}{$st_serial}{$time}{$metric} = $data{$metric};
  }
  #$performance_data{$st_type}{device}{$st_serial}{$time} = \%data;
  #print Dumper \$performance_data{$st_type}{device};
  #print Dumper \%data;
}


sub set_architecture{

  my %device_arch = (
    "item_id" => $cfg->{'uuid'},
    "label" => $cfg->{'hostalias'},
    "hw_type" => "isilon",
    "subsystem" => "device",
    "parents" => [],
    "hostcfg_id" => $cfg->{'uuid'}
  );
  push(@architecture, \%device_arch);
  #print Dumper \%configuration_data;

  foreach my $uid (keys %configuration_data){
    my $name = $configuration_data{$uid}{label};
    my $type = $configuration_data{$uid}{TYPE};
    if (!defined $name || !defined $type){next;}
    my %arch = (
      "item_id" => $uid,
      "label" => $name,
      "hw_type" => "isilon",
      "subsystem" => $type,
      "parents" => [$cfg->{'uuid'}],
      "hostcfg_id" => $cfg->{'hostcfg_id'}
      );
    push(@architecture, \%arch);
  }
  #print Dumper \%data;
  foreach my $item (keys %{$data{conf}{device}}){
    $configuration_data{$st_serial}{$item} = $data{conf}{device}{$item};
  }

  #print Dumper \$configuration_data{device}{$st_serial};

  #save configuration
  #$xormon->saveConfJSON(\%configuration_data);

  #save architecture
  #$xormon->saveArchitecture(\@architecture);
  ### events
  $configuration_data{$st_serial}{events} = encode_json(\@health_status);


  my $rc = $xormon->saveConfJSON(\%configuration_data);
  my $status_configuration = get_status($rc, "saveConfJSON (configuration)");


  $rc = $xormon->saveArchitecture(\@architecture);
  my $status_architecture = get_status($rc, "SaveArchitecture");
  #$logger->info("Task for saveArchitecture ".$cfg->{hostalias}." is done. Status: $status");

  $rc = $xormon->saveStatus(\@health_status_global);
  my $status_health = get_status($rc, "health status");

  return ($status_architecture, $status_configuration, $status_health);

}

sub logout_api{
  my $connection_test = shift;
  if (!($cookie ne "" && $token ne "")){return;}
  my $url = "https://$cfg->{apiHost}:$cfg->{'apiPort'}/session/1/session";
  my $ua  = LWP::UserAgent->new( ssl_opts => { SSL_cipher_list => 'DEFAULT:!DH', verify_hostname => 0, SSL_verify_mode => 0 } );
  my $req = HTTP::Request->new( DELETE => $url );
  $req->header( 'Content-Type' => 'application/json; charset=UTF-8' );
  $req->header( 'Accept'       => 'application/json' );
  $req->header( 'Cookie'       => $cookie );
  $req->header( 'X-CSRF-Token' => $token );
  $req->header( 'Referer'      => "https://$cfg->{apiHost}" );

  #$req->content($json_body);
  my $res = $ua->request($req);
  if ( !$res->is_success ) {
    if ($connection_test){
      push(@rows_api_test,"ERROR: Logout to API failed" . __FILE__ . ":" . __LINE__ . "\n");
      push(@rows_api_test,$res->content);
      push(@rows_api_test_data,"ERROR: Logout to API failed" . __FILE__ . ":" . __LINE__ . "\n");
      push(@rows_api_test_data,$res->content);


    }
    else{
      $logger->error( "ERROR: Logout to API failed" . __FILE__ . ":" . __LINE__ );
      $logger->error( $res->content );
      print Dumper \$res;
      return 0;
    }
  }
  else {
    #print "Logout OK\n";
    #my $data  = decode_json( $res->content );
    #print Dumper \$res;
    return 1;
  }


}

sub login_api {
  my $connection_test = shift;
  if (!defined $connection_test){
    $connection_test = 0;
  }

  my $url = "https://$cfg->{apiHost}:$cfg->{'apiPort'}/session/1/session";
  my %hash_filter;
  my @services = ();
  push( @services, "platform" );

  #push(@services, "namespace");
  $hash_filter{"username"} = $cfg->{'apiUsername'};
  $hash_filter{"password"} = $cfg->{'api-pass'};
  $hash_filter{"services"} = \@services;
  my $json_body = encode_json( \%hash_filter );

  ### agent
  my $ua  = LWP::UserAgent->new( ssl_opts => { SSL_cipher_list => 'DEFAULT:!DH', verify_hostname => 0, SSL_verify_mode => 0 } );
  my $req = HTTP::Request->new( POST => $url );
  $req->header( 'Content-Type' => 'application/json; charset=UTF-8' );
  $req->header( 'Accept'       => 'application/json' );

  #$req->header( 'Connection'   => 'keep-alive' );
  $req->content($json_body);
  my $res = $ua->request($req);

  #print Dumper \$res;
  if ( !$res->is_success ) {
    if ($connection_test){
      push(@rows_api_test,"ERROR: Login to API failed" . __FILE__ . ":" . __LINE__ . "\n");
      push(@rows_api_test,$res->content);
      push(@rows_api_test_data,"ERROR: Login to API failed" . __FILE__ . ":" . __LINE__ . "\n");
      push(@rows_api_test_data,$res->content);

    }
    else{
      $logger->error( "ERROR: Login to API failed" . __FILE__ . ":" . __LINE__ );
      $logger->error( $res->content );
      print Dumper \$res;
      return 0;
    }
  }
  else {
    if ($debug) {
      if ($connection_test){
        push(@rows_api_test,"Login OK\n");
        #push(@rows_api_test,\$res);
      }
      else{
        print "Login OK\n";
        print Dumper \$res;
      }
    }
    #my $data  = decode_json( $res->content );
    #print Dumper \$res;
    my $cookie_line = $res->headers->{"set-cookie"};
    if ( defined $cookie_line && ref($cookie_line) eq "ARRAY" ) {
      foreach my $element ( @{$cookie_line} ) {
        if ( $element =~ m/isisessid/ ) {
          ( $cookie, undef ) = split( /;/, $element, 2 );
        }
        if ( $element =~ m/isicsrf/ ) {
          ( $token, undef ) = split( /;/, $element, 2 );
          if ( defined $token ) {
            $token =~ s/isicsrf=//g;
          }
        }
      }
    }
  }
  if ($debug) {
    if ($connection_test){
      push(@rows_api_test,"Login is ok\n");
      push(@rows_api_test,"Cookie is $cookie\n");
      push(@rows_api_test,"Token is $token\n");

    }
    else{
      print "Login is ok\n";
      print "Cookie is $cookie\n";
      print "Token is $token\n";
    }
  }
  return 1;

}



sub connection_test {
  my $client = shift;
  $cfg = shift;


  #print Dumper \$cfg;
  # test main variables
  #unless ( exists $cfg->{'hostcfg_id'} )    { push(@rows_api_test, "Cannot continue, 'hostcfg_id' is not configured!");    return Xormon::conn_test(0, \@rows_api_test); }
  #unless ( exists $cfg->{'hostalias'} )   { push(@rows_api_test, "Cannot continue, 'hostalias' is not configured!");   return Xormon::conn_test(0, \@rows_api_test); }
  #unless ( exists $cfg->{'apiHost'} )          { push(@rows_api_test, "Cannot continue, 'apiHost' is not configured!");          return Xormon::conn_test(0, \@rows_api_test); }
  #unless ( exists $cfg->{'apiPort'} )      { push(@rows_api_test, "Cannot continue, 'apiPort' is not configured!");      return Xormon::conn_test(0, \@rows_api_test); }
  #unless ( exists $cfg->{'apiUsername'} )      { push(@rows_api_test, "Cannot continue, 'apiUsername' is not configured!");      return Xormon::conn_test(0, \@rows_api_test); }
  #unless ( exists $cfg->{'apiPassword'} )      { push(@rows_api_test, "Cannot continue, 'apiPassword' is not configured!"); return Xormon::conn_test(0, \@rows_api_test); }
  $logger = XormonLogger->new('isilon', $cfg->{hostcfg_id}, $cfg->{hostalias} );

  my $test = Test->new($client);
  my @variables = ("hostcfg_id", "hostalias", "apiHost", "apiPort", "apiUsername", "apiPassword");
  foreach my $variable (@variables){
    unless ( exists $cfg->{$variable} ){
      $test->addSection("Validation of variables", 0 , "Cannot continue, $variable is not configured!");
      return $test->stop();
    }
  }
  $test->addSection("Validation of variables", 1 , "");

  $cfg->{'api-pass'}  = $cfg->{'apiPassword'};
  $storage_name = $cfg->{hostalias};
  #return $test->stop();

  #### connection network test ####
  my ($code, $text) = Xormon::conntest_tcp($cfg->{'apiHost'},$cfg->{'apiPort'});
  $test->addSection("API host network connection", $code, $text);
  if ($code == 0){
    return $test->stop();
  }
  #return $test->stop();



  $urls = cmd("platform/?describe&list"); ### list all commands
  #$urls = 0;
  if ($urls eq "" || $urls eq "0"){
    login_api(1);
    if ( !defined $cookie || $cookie eq "" || !defined $token || $token eq "" ) {
      push(@rows_api_test,"ERROR: cookie or token is not defined. Connection failed!!\n");
      $test->addSection("API authorization", 0, \@rows_api_test);
      return $test->stop();
      #push(@rows_api_test,"ERROR: cookie or token is not defined. Connection failed!!");
      #return Xormon::conn_test(0, \@rows_api_test);
    }
    else{
      $urls = cmd("platform/?describe&list"); ### list all commands

    }
  }
  my $ret = get_cluster_info("");
  if ($ret eq "0"){
    logout_api();
    push(@rows_api_test, "Connection failed!!\n");
    $test->addSection("API authorization", 0, \@rows_api_test);
    return $test->stop();
    #return Xormon::conn_test(0, \@rows_api_test);
  }
  if (!defined $data{conf}{device}{'apiVersion'} || $data{conf}{device}{'apiVersion'} eq ""){
    push(@rows_api_test, "API version is not defined!!\n");
    push(@rows_api_test, "Connection failed!!\n");
    logout_api();
    $test->addSection("API authorization", 0, \@rows_api_test);
    return $test->stop();
    #return Xormon::conn_test(0, \@rows_api_test);
  }
  else {
    if ( exists $data{conf}{device}{cluster_guid} )        { push(@rows_api_test, "cluster guid      : $data{conf}{device}{cluster_guid}\n"); }
    if ( exists $data{conf}{device}{cluster_name} )        { push(@rows_api_test, "name                  : $data{conf}{device}{cluster_name}\n"); }
    if ( exists $data{conf}{device}{version} )             { push(@rows_api_test, "OneFS version : $data{conf}{device}{version}\n"); }
    if ( exists $data{conf}{device}{"apiVersion"} )       { push(@rows_api_test, "API version       : $data{conf}{device}{'apiVersion'}\n"); }
    $api_version = $data{conf}{device}{'apiVersion'};
  }
  $test->addSection("API authorization", 1, \@rows_api_test);
  #
  # collect perf stats
  #
  my $result = perf_test();
  if ( $result == 0 ) {
    push(@rows_api_test_data, "Cannot collect stats!\n");
    push(@rows_api_test_data, "Connection failed!!\n");
    logout_api();
    $test->addSection("API data test", 0, \@rows_api_test_data);
    return $test->stop();
    #return Xormon::conn_test(0, \@rows_api_test);
  }
  else {
    push(@rows_api_test_data, "Performance data ok\n");
  }
  logout_api();
  $test->addSection("API data test", 1, \@rows_api_test_data);
  return $test->stop();
  #return Xormon::conn_test(1, \@rows_api_test);
}

sub get_cluster_info{
  my $save = shift;

  my $cmd = "platform/1/cluster/config";
  my $data = cmd($cmd,$save);
  my $version = "";
  my $api_version = "";
  my $name = "";
  my $cluster_uuid = "";
  if ($data eq "0"){
    $logger->error( "get_cluster_info failed! Cannot continue, exiting...  $!" . __FILE__ . ":" . __LINE__ ) && return 0;
  }
  if ( defined $data->{'onefs_version'}->{release} ) {
    $version = $data->{'onefs_version'}->{release};
    $version =~ s/^v//g;
    if ($version =~ m/^9.0.0.0/){
      $api_version = 10;
    }
    if ($version =~ m/^9.1.0.0/){
      $api_version = 11;
    }
    if ($version =~ m/^8.1/){
      $api_version = 5;
    }
    if ($version =~ m/^8.1.1/){
      $api_version = 6;
    }
    if ($version =~ m/^8.2/){
      $api_version = 7;
    }
    if ($version =~ m/^8.2.1/){
      $api_version = 8;
    }
    if ($version =~ m/^8.2.2/){
      $api_version = 9;
    }
    if ($version =~ m/^8.0/){
      $api_version = 3;
    }
    if ($version =~ m/^8.0.1/){
      $api_version = 4;
    }
    if ($version =~ m/^7.2/){
      $api_version = 1;
    }
    if ($version =~ m/^7.2.1/){
      $api_version = 2;
    }
  }
  if ($api_version eq ""){
    my $data = cmd("platform/latest");
    if (defined $data->{latest}){
      $api_version = $data->{latest};
    }
  }
  if (defined $data->{name}){
    $name = $data->{name};
  }
  if (defined $data->{guid}){
    $cluster_uuid = $data->{guid};
  }
  $data{conf}{device}{"apiVersion"} = $api_version;
  $data{conf}{device}{"version"} = $version;
  $data{conf}{device}{"cluster_name"} = $name;
  $data{conf}{device}{"cluster_guid"} = $cluster_uuid;

  return 1;
}

sub perf_test{
  my $cmd = "platform/$api_version/storagepool/nodepools?interval=300";
  if ($api_version eq "1"){
    $cmd = "platform/$api_version/storagepool/nodepools";
  }
  my $data = cmd($cmd);
  if ($data eq "0"){
    #$logger->error( "Performance test failed! Cannot continue, exiting...  $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    push(@rows_api_test,"Performance test failed! Cannot continue, exiting...\n");
    return 0;
  }
  else{return 1;}
}

sub cmd {
  my $cmd = shift;
  my $debug_file = shift;
  my $http_method = shift;
  if (!defined $http_method){$http_method = "GET";}
  my $check_url = "";
  if ($cmd !~ m/describe/){
    $check_url = check_url($cmd);
    if ($check_url ne "0" && $check_url ne "1"){
      $cmd = $check_url;
    }
  }
  my $url     = "https://$cfg->{apiHost}:$cfg->{'apiPort'}/" . $cmd;
  my $agent   = LWP::UserAgent->new( ssl_opts => { verify_hostname => 0, SSL_verify_mode => 0 } );
  my $request = HTTP::Request->new( $http_method => $url );
  #print "$url\n";

  $request->header( 'Content-Type' => 'application/json' );
  if ( $token eq "" && $cookie eq "" ) {
    $request->authorization_basic( $cfg->{'apiUsername'}, $cfg->{'api-pass'} );
  }
  else {
    $request->header( 'Cookie'       => $cookie );
    $request->header( 'X-CSRF-Token' => $token );
    $request->header( 'Referer'      => "https://$cfg->{apiHost}" );
  }
  my $results = $agent->request($request);
  $request_count++;
  #print STDERR Dumper \$results;

  if ( !$results->is_success ) {
    $logger->error("$http_method url      : $url");
    $logger->error("Request error:\n" . $results->status_line);
    $logger->error("Request error:\n" . $results->content);
    return 0;
  }

  my $result = decode_json( $results->content );
  if (defined $debug_file && $debug_file ne ""){
    eval {Xormon::save_as_json($debug_file,$result);};
    if ($@){
      $logger->error("Save data to file $debug_file failed");
    }
  }
  if (defined $result->{errors} && ref($result->{errors}) eq "ARRAY"){
    my $error = 0;
    foreach my $element (@{$result->{errors}}){
      my $message=$element->{'message'};
      if (defined $message){
        $logger->error("Request error: $message");
        $error = 1;
      }
    }
    if ($error){
      return 0;
    }
  }
  return $result;
}

sub check_url{
  my $url = shift;
  #my $out = cmd($element);
  #if ($out ne ""){
  #  return 1;
  #}
  my ($prefix, $postfix) = split( /\?/, $url);
  #$url =~ s/\?interval=300//g;
  if ($urls eq "" || $urls eq 0 ){return 0;}
  if ( grep { $prefix eq $_ } @{$urls->{directory}} ) {
    return 1;
  }
  else{
    $prefix =~ s/platform//g;
    $prefix =~ s/\/$api_version//g;
    my @href = grep {/\/\d+$prefix/} @{$urls->{directory}};
    if (defined $href[0] && $href[0] ne ""){
      if (defined $postfix){
        return "platform$href[0]?$postfix";
      }
      else{
        return "platform$href[0]";
      }
    }
  }
  return 0;
}

sub set_data_pool_capacity{
  my $type = "pool";
  my $cmd = "platform/$api_version/storagepool/nodepools?interval=300";
  ### from this command you do not have time
  my $data = cmd($cmd, "$debug_data/nodepool.json");
  my $timestamp = time();
  #my $gtime = gmtime($time);
  #my $timestamp = str2time($gtime);
  #print Dumper \$data;
  ### spatne id poolu

  if ($data eq "0" || !defined $data->{'nodepools'} || ref($data->{'nodepools'}) ne "ARRAY"){return;}

  foreach my $element (@{$data->{nodepools}}){
    my $id = "";
    my $lnns;
    if (!defined $element->{id}){next;}

    $id = $element->{id};

    my $name = $id;

    my $pool_id = $id;

    my $hash_key = Xormon::create_hash_key($st_serial."pool".$id);

    $id = $hash_key;
    if (defined $element->{lnns}){
      $lnns = $element->{lnns};
    }
    if (defined $element->{name}){
      $name = $element->{name};
    }

    $configuration_data{$hash_key}{id} = $id;
    $configuration_data{$hash_key}{label} = $name;
    $configuration_data{$hash_key}{TYPE} = "pool";

    #pool capacity
    if (Xormon::isdigit($element->{usage}->{total_bytes})){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{capacity_total} = round($element->{usage}->{total_bytes},0);
      $configuration_data{$hash_key}{capacity_total} = round($element->{usage}->{total_bytes},0);
    }
    else{
      print Dumper \$data;
    }
    if (Xormon::isdigit($element->{usage}->{free_bytes})){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{capacity_free} = round($element->{usage}->{free_bytes},0);
      $configuration_data{$hash_key}{capacity_free} = round($element->{usage}->{free_bytes},0);
    }
    if (Xormon::isdigit($performance_data{$st_type}{$type}{$id}{$timestamp}{capacity_free}) && Xormon::isdigit($performance_data{$st_type}{$type}{$id}{$timestamp}{capacity_total})){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{capacity_used} = $performance_data{$st_type}{$type}{$id}{$timestamp}{capacity_total} - $performance_data{$st_type}{$type}{$id}{$timestamp}{capacity_free};
      $configuration_data{$hash_key}{capacity_used} = $performance_data{$st_type}{$type}{$id}{$timestamp}{capacity_total} - $performance_data{$st_type}{$type}{$id}{$timestamp}{capacity_free};
    }
    if (Xormon::isdigit($element->{usage}->{total_ssd_bytes})){
      #$performance_data{$st_type}{$type}{$id}{$timestamp}{capacity_ssd_total} = round($element->{usage}->{total_ssd_bytes},0);
    }
    if (Xormon::isdigit($element->{usage}->{free_ssd_bytes})){
      #$performance_data{$st_type}{$type}{$id}{$timestamp}{capacity_sdd_free} = round($element->{usage}->{free_ssd_bytes},0);
    }
    if (Xormon::isdigit($element->{usage}->{used_ssd_bytes})){
      #$performance_data{$st_type}{$type}{$id}{$timestamp}{capacity_ssd_used} = round($element->{usage}->{used_ssd_bytes},0);
    }
    if (defined $lnns && ref($lnns) eq "ARRAY"){
      #foreach my $node (@{$lnns}){
      #  $pools{$node} = $pool_id;
      #}
      $pools{$pool_id} = $lnns;
    }
  }
  #print Dumper \$performance_data{$st_type}{$type};
}

sub set_data_pool{

  #print Dumper \$performance_data{$st_type}{$type}{$id};
  #print Dumper \%pool;
  my $type = "pool";

  foreach my $pool_id (keys %pool){
    my $read = "";
    my $write = "";
    my $data_rate = "";
    my $nfs_read  = "";
    my $nfs_write = "";
    my $nfs_rate = "";
    my $nfs4_read = "";
    my $nfs4_write = "";
    my $nfs4_rate = "";
    my $smb1_read = "";
    my $smb1_write = "";
    my $smb1_rate = "";
    my $smb2_read = "";
    my $smb2_write = "";
    my $smb2_rate = "";
    my $nfs_ops_rate = "";
    my $nfs4_ops_rate = "";
    my $smb1_ops_rate = "";
    my $smb2_ops_rate = "";
    my $read_ops = "";
    my $write_ops = "";
    my $ops_rate = "";
    my $time = "";
    foreach my $node_id (keys %{$pool{$pool_id}{node}}){
      if (!Xormon::isdigit($pool{$pool_id}{node}{$node_id}{time})){
        next;
      }
      else{
        $time = $pool{$pool_id}{node}{$node_id}{time};
      }
      if (Xormon::isdigit($pool{$pool_id}{node}{$node_id}{out})){
        if (Xormon::isdigit($read)){
          $read = $read + $pool{$pool_id}{node}{$node_id}{out};
        }
        else{
          $read = $pool{$pool_id}{node}{$node_id}{out};
        }
      }
      if (Xormon::isdigit($pool{$pool_id}{node}{$node_id}{in})){
        if (Xormon::isdigit($write)){
          $write = $write + $pool{$pool_id}{node}{$node_id}{in};
        }
        else{
          $write = $pool{$pool_id}{node}{$node_id}{in};
        }
      }
      if (Xormon::isdigit($pool{$pool_id}{node}{$node_id}{ops_out})){
        if (Xormon::isdigit($read_ops)){
          $read_ops = $read_ops + $pool{$pool_id}{node}{$node_id}{ops_out};
        }
        else{
          $read_ops = $pool{$pool_id}{node}{$node_id}{ops_out};
        }
      }
      if (Xormon::isdigit($pool{$pool_id}{node}{$node_id}{ops_in})){
        if (Xormon::isdigit($write_ops)){
          $write_ops = $write_ops + $pool{$pool_id}{node}{$node_id}{ops_in};
        }
        else{
          $write_ops = $pool{$pool_id}{node}{$node_id}{ops_in};
        }
      }
      if (Xormon::isdigit($pool{$pool_id}{node}{$node_id}{"nfs"}{"out_rate"})){
        if (Xormon::isdigit($nfs_read)){
          $nfs_read = $nfs_read + $pool{$pool_id}{node}{$node_id}{"nfs"}{"out_rate"};
        }
        else{
          $nfs_read = $pool{$pool_id}{node}{$node_id}{"nfs"}{"out_rate"};
        }
      }
      if (Xormon::isdigit($pool{$pool_id}{node}{$node_id}{"nfs"}{"in_rate"})){
        if (Xormon::isdigit($nfs_write)){
          $nfs_write = $nfs_write + $pool{$pool_id}{node}{$node_id}{"nfs"}{"in_rate"};
        }
        else{
          $nfs_write = $pool{$pool_id}{node}{$node_id}{"nfs"}{"in_rate"};
        }
      }
      if (Xormon::isdigit($pool{$pool_id}{node}{$node_id}{"nfs"}{"op_rate"})){
        if (Xormon::isdigit($nfs_ops_rate)){
          $nfs_ops_rate =  $nfs_ops_rate + $pool{$pool_id}{node}{$node_id}{"nfs"}{"op_rate"};
        }
        else{
          $nfs_ops_rate = $pool{$pool_id}{node}{$node_id}{"nfs"}{"op_rate"};
        }
      }
      if (Xormon::isdigit($pool{$pool_id}{node}{$node_id}{"nfs4"}{"out_rate"})){
        if (Xormon::isdigit($nfs4_read)){
          $nfs4_read = $nfs4_read + $pool{$pool_id}{node}{$node_id}{"nfs4"}{"out_rate"};
        }
        else{
          $nfs4_read = $pool{$pool_id}{node}{$node_id}{"nfs4"}{"out_rate"};
        }
      }
      if (Xormon::isdigit($pool{$pool_id}{node}{$node_id}{"nfs4"}{"in_rate"})){
        if (Xormon::isdigit($nfs4_write)){
          $nfs4_write = $nfs4_write + $pool{$pool_id}{node}{$node_id}{"nfs4"}{"in_rate"};
        }
        else{
          $nfs4_write = $pool{$pool_id}{node}{$node_id}{"nfs4"}{"in_rate"};
        }
      }
      if (Xormon::isdigit($pool{$pool_id}{node}{$node_id}{"nfs4"}{"op_rate"})){
        if (Xormon::isdigit($nfs4_ops_rate)){
          $nfs4_ops_rate = $nfs4_ops_rate  + $pool{$pool_id}{node}{$node_id}{"nfs4"}{"op_rate"};
        }
        else{
          $nfs4_ops_rate = $pool{$pool_id}{node}{$node_id}{"nfs4"}{"op_rate"};
        }
      }

      if (Xormon::isdigit($pool{$pool_id}{node}{$node_id}{"smb1"}{"out_rate"})){
        if (Xormon::isdigit($smb1_read)){
          $smb1_read = $nfs_read + $pool{$pool_id}{node}{$node_id}{"smb1"}{"out_rate"};
        }
        else{
          $smb1_read = $pool{$pool_id}{node}{$node_id}{"smb1"}{"out_rate"};
        }
      }
      if (Xormon::isdigit($pool{$pool_id}{node}{$node_id}{"smb1"}{"in_rate"})){
        if (Xormon::isdigit($smb1_write)){
          $smb1_write = $smb1_write + $pool{$pool_id}{node}{$node_id}{"smb1"}{"in_rate"};
        }
        else{
          $smb1_write = $pool{$pool_id}{node}{$node_id}{"smb1"}{"in_rate"};
        }
      }
      if (Xormon::isdigit($pool{$pool_id}{node}{$node_id}{"smb1"}{"op_rate"})){
        if (Xormon::isdigit($smb1_ops_rate)){
          $smb1_ops_rate =  $smb1_ops_rate + $pool{$pool_id}{node}{$node_id}{"smb1"}{"op_rate"};
        }
        else{
          $smb1_ops_rate = $pool{$pool_id}{node}{$node_id}{"smb1"}{"op_rate"};
        }
      }
      if (Xormon::isdigit($pool{$pool_id}{node}{$node_id}{"smb2"}{"out_rate"})){
        if (Xormon::isdigit($smb2_read)){
          $smb2_read = $smb2_read + $pool{$pool_id}{node}{$node_id}{"smb2"}{"out_rate"};
        }
        else{
          $smb2_read = $pool{$pool_id}{node}{$node_id}{"smb2"}{"out_rate"};
        }
      }
      if (Xormon::isdigit($pool{$pool_id}{node}{$node_id}{"smb2"}{"in_rate"})){
        if (Xormon::isdigit($smb2_write)){
          $smb2_write = $smb2_write + $pool{$pool_id}{node}{$node_id}{"smb2"}{"in_rate"};
        }
        else{
          $smb2_write = $pool{$pool_id}{node}{$node_id}{"smb2"}{"in_rate"};
        }
      }
      if (Xormon::isdigit($pool{$pool_id}{node}{$node_id}{"smb2"}{"op_rate"})){
        if (Xormon::isdigit($smb2_ops_rate)){
          $smb2_ops_rate = $smb2_ops_rate  + $pool{$pool_id}{node}{$node_id}{"smb2"}{"op_rate"};
        }
        else{
          $smb2_ops_rate = $pool{$pool_id}{node}{$node_id}{"smb2"}{"op_rate"};
        }
      }
    }
    if (Xormon::isdigit($read)){
      $data_rate = $read;
    }
    if (Xormon::isdigit($write)){
      if (Xormon::isdigit($data_rate)){
        $data_rate = $data_rate + $write;
      }
      else{
        $data_rate = $write;
      }
    }
    if (Xormon::isdigit($read_ops)){
      $ops_rate = $read_ops;
    }
    if (Xormon::isdigit($write)){
      if (Xormon::isdigit($ops_rate)){
        $ops_rate = $ops_rate + $write_ops;
      }
      else{
        $ops_rate = $write_ops;
      }
    }
    my $hash_key = Xormon::create_hash_key($st_serial."pool".$pool_id);
    my $hash_time = (keys %{$performance_data{$st_type}{$type}{$hash_key}})[0];
    $performance_data{$st_type}{$type}{$hash_key}{$time} = $performance_data{$st_type}{$type}{$hash_key}{$hash_time};
    delete $performance_data{$st_type}{$type}{$hash_key}{$hash_time};
    if (Xormon::isdigit($nfs_read)){
      $nfs_rate = $nfs_read;
    }
    if (Xormon::isdigit($nfs_write)){
      if (Xormon::isdigit($nfs_rate)){
        $nfs_rate = $nfs_rate + $nfs_write;
      }
      else{
        $nfs_rate = $nfs_write;
      }
    }

    if (Xormon::isdigit($nfs4_read)){
      $nfs4_rate = $nfs4_read;
    }
    if (Xormon::isdigit($nfs4_write)){
      if (Xormon::isdigit($nfs4_rate)){
        $nfs4_rate = $nfs4_rate + $nfs4_write;
      }
      else{
        $nfs4_rate = $nfs4_write;
      }
    }

    if (Xormon::isdigit($smb1_read)){
      $smb1_rate = $smb1_read;
    }
    if (Xormon::isdigit($smb1_write)){
      if (Xormon::isdigit($smb1_rate)){
        $smb1_rate = $smb1_rate + $smb1_write;
      }
      else{
        $smb1_rate = $smb1_write;
      }
    }

    if (Xormon::isdigit($smb2_read)){
      $smb2_rate = $smb2_read;
    }
    if (Xormon::isdigit($smb2_write)){
      if (Xormon::isdigit($smb2_rate)){
        $smb2_rate = $smb2_rate + $smb2_write;
      }
      else{
        $smb2_rate = $smb2_write;
      }
    }


    $performance_data{$st_type}{$type}{$hash_key}{$time}{read} = $read;
    $performance_data{$st_type}{$type}{$hash_key}{$time}{"write"} = $write;
    $performance_data{$st_type}{$type}{$hash_key}{$time}{"data_rate"} = $data_rate;

    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"nfs_read"} = $nfs_read;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"nfs_write"} = $nfs_write;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"nfs_rate"} = $nfs_rate;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"nfs4_read"} = $nfs4_read;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"nfs4_write"} = $nfs4_write;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"nfs4_rate"} = $nfs4_rate;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"smb1_read"} = $smb1_read;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"smb1_write"} = $smb1_write;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"smb1_rate"} = $smb1_rate;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"smb2_read"} = $smb2_read;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"smb2_write"} = $smb2_write;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"smb2_rate"} = $smb2_rate;

    $performance_data{$st_type}{$type}{$hash_key}{$time}{"nfs_ops_rate"} = $nfs_ops_rate;
    $performance_data{$st_type}{$type}{$hash_key}{$time}{"nfs4_ops_rate"} = $nfs4_ops_rate;
    $performance_data{$st_type}{$type}{$hash_key}{$time}{"smb1_ops_rate"} = $smb1_ops_rate;
    $performance_data{$st_type}{$type}{$hash_key}{$time}{"smb2_ops_rate"} = $smb2_ops_rate;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{read_ops} = $read_ops;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"write_ops"} = $write_ops;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"ops_rate"} = $ops_rate;
    #if (Xormon::isdigit($ops_rate) && $ops_rate > 0 && Xormon::isdigit($data_rate)){
    #  $performance_data{$st_type}{$type}{$hash_key}{$time}{block_size} = round($data_rate / $ops_rate,0);
    #}
    #if (Xormon::isdigit($read_ops) && $read_ops > 0 && Xormon::isdigit($read)){
    #  $performance_data{$st_type}{$type}{$hash_key}{$time}{block_size_r} = round($read / $read_ops,0);
    #}
    #if (Xormon::isdigit($write_ops) && $write_ops > 0 && Xormon::isdigit($write)){
    #  $performance_data{$st_type}{$type}{$hash_key}{$time}{block_size_w} = round($write / $write_ops,0);
    #}
    #print "$hash_key\n";

    #print Dumper \$performance_data{$st_type}{$type}{$hash_key};
  }
  #print Dumper \$performance_data{$st_type}{$type};
  #print Dumper \%configuration_data;
}

sub set_data_system{

  my $cmd = "platform/$api_version/statistics/summary/system?interval=300";
  my $data = cmd($cmd, "$debug_data/system.json");
  my $type = "SYSTEM";
  #$cmd = "platform/$api_version/statistics/summary/protocol?interval=300";
  #$data = cmd($cmd, "$debug_data/protocol.json");
  #$cmd = "platform/$api_version/statistics/summary/protocol-stats?interval=300";
  #$data = cmd($cmd, "$debug_data/protocol_stats.json");
  return;
  #### node,time,net_read,net_write,disk_read,disk_write,cpu,total,smb,nfs,ftp,http,hdfs
  #statistics for cluster

  if ($data eq "0" || !defined $data->{'system'} || ref($data->{'system'}) ne "ARRAY"){return;}
  foreach my $section (@{$data->{system}}){
    my $id = "";
    my $timestamp = "";
    my $net_rate = "";
    my $drive_rate = "";
    if (!defined $section->{'node'} || $section->{'node'} eq "" || $section->{node} ne "All"){next;}
    if (!Xormon::isdigit($section->{time})){next;}
    $id = $section->{'node'};
    $timestamp = $section->{time};
    my $hash_key = Xormon::create_hash_key($st_serial."SYSTEM".$id);
    $id = $hash_key;
    if (Xormon::isdigit($section->{'net_in'})){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{net_write} = round($section->{'net_in'},0);
      $net_rate = $section->{'net_in'};
    }
    if (Xormon::isdigit($section->{'net_out'})){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{net_read} = round($section->{'net_out'},0);
      if (Xormon::isdigit($net_rate)){
        $net_rate = $net_rate + $section->{'net_out'};
      }
      else{
        $net_rate = $section->{'net_out'};
      }
    }
    if (Xormon::isdigit($section->{'disk_in'})){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{drive_write} = round($section->{'disk_in'},0);
      $drive_rate = $section->{'disk_in'};
    }
    if (Xormon::isdigit($section->{'disk_out'})){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{drive_read} = round($section->{'disk_out'},0);
      if (Xormon::isdigit($drive_rate)){
        $drive_rate = $drive_rate + $section->{'disk_out'};
      }
      else{
        $drive_rate = $section->{'disk_out'};
      }
    }
    if (Xormon::isdigit($section->{'total'})){  ### The total throughput (in bytes/sec) for all protocols listed.
      $performance_data{$st_type}{$type}{$id}{$timestamp}{total_rate} = round($section->{'total'},0);
    }
    if (Xormon::isdigit($section->{'smb'})){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{"smb_rate"} = round($section->{'smb'},0);
    }
    if (Xormon::isdigit($section->{'nfs'})){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{"nfs_rate"} = round($section->{'nfs'},0);
    }
    if (Xormon::isdigit($section->{'hdfs'})){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{"hdfs_rate"} = round($section->{'hdfs'},0);
    }
    if (Xormon::isdigit($section->{'http'})){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{"http_rate"} = round($section->{'http'},0);
    }
    if (Xormon::isdigit($section->{'ftp'})){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{"ftp_rate"} = round($section->{'ftp'},0);
    }
    if (Xormon::isdigit($section->{'cpu'})){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{"sys"} = round($section->{'cpu'},0);
    }
    if ($net_rate ne ""){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{"net_rate"} = round($net_rate,0);
    }
    if ($drive_rate ne ""){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{"drive_rate"} = round($drive_rate,0);
    }
  }
  #print STDERR Dumper \$performance_data{All};

  return;
}

sub set_data_node{
  my @keys = ("node.ifs.bytes.out.rate", "node.ifs.bytes.in.rate", "node.ifs.bytes.used", "node.ifs.bytes.free", "node.ifs.bytes.total", "node.protostats.nfs.total", "node.protostats.nfs4.total", "node.protostats.smb1.total", "node.protostats.smb2.total");
  #my $cmd = "platform/$api_version/cluster/nodes/ALL/hardware";
  #my $data = cmd($cmd,"hardware.json");
  #if ($data eq "0" || !defined $data->{'nodes'} || ref($data->{'nodes'}) ne "ARRAY"){return;}
  #foreach my $node (@{$data->{'nodes'}}){
  #  if (!defined $node->{id} || !defined $node->{lnn}){next;}
  #foreach my $pool_id (keys %pools){
  #if (ref($pools{$pool_id}) ne "ARRAY"){next;}
    #my $cmd = "platform/$api_version/statistics/current?key=$k&devid=all&interval=300";  ### this command could be with devid=all
  my $cmd = "platform/$api_version/statistics/current?keys=node.ifs.bytes.out.rate,node.ifs.bytes.in.rate,node.ifs.bytes.used,node.ifs.bytes.free,node.ifs.bytes.total,node.protostats.nfs.total,node.protostats.nfs4.total,node.protostats.smb1.total,node.protostats.smb2.total,node.ifs.ops.in.rate,node.ifs.ops.out.rate&devid=all&interval=300";
  my $data = cmd($cmd);
  #print Dumper \$data;
  if ($data eq "0" || !defined $data->{'stats'} || ref($data->{'stats'}) ne "ARRAY"){next;}
  foreach my $node_stats (@{$data->{'stats'}}){
    my $devid = $node_stats->{'devid'};
    if (!defined $devid){next;}
    #if (!grep { $devid eq $_ } @{$pools{$pool_id}}){next;}
    my $ln = $devid;
    my $value ="";
    my $key = "";
    my $type = "";
    my $out_rate = "";
    my $in_rate = "";
    my $op_rate = "";
    if (defined $node_stats->{key} && $node_stats->{key} =~ m/nfs|smb/){
      (undef,undef,$type,undef)=split(/\./,$node_stats->{key});
      $key = $node_stats->{key};
      if (!defined $type){$type = "";}
      if (defined $node_stats->{'value'} && ref ($node_stats->{'value'}) eq "ARRAY"){
        foreach my $element (@{$node_stats->{'value'}}){
          foreach my $pool_id (keys %pools){
            if (!defined $pools{$pool_id}){next;}
            foreach my $node (@{$pools{$pool_id}}){
              if ($devid eq $node){
                if (Xormon::isdigit($node_stats->{time})){
                  $pool{$pool_id}{"node"}{$devid}{$type}{'time'} = $node_stats->{time};
                }
                if (Xormon::isdigit($element->{'out_rate'})){
                  $pool{$pool_id}{"node"}{$devid}{$type}{'out_rate'} = round($element->{'out_rate'},0);
                }
                if (Xormon::isdigit($element->{'in_rate'})){
                  $pool{$pool_id}{"node"}{$devid}{$type}{'in_rate'} = round($element->{'in_rate'},0);
                }
                if (Xormon::isdigit($element->{'op_rate'})){
                  $pool{$pool_id}{"node"}{$devid}{$type}{'op_rate'} = round($element->{'op_rate'},0);
                }
              }
            }
          }
          if (Xormon::isdigit($element->{'out_rate'})){
            $node{$devid}{$type}{'out_rate'} = round($element->{'out_rate'},0);
          }
          if (Xormon::isdigit($node_stats->{time})){
            $node{$devid}{$type}{'time'} = $node_stats->{time};
          }
          if (Xormon::isdigit($element->{'in_rate'})){
            $node{$devid}{$type}{'in_rate'} = round($element->{'in_rate'},0);
          }
          if (Xormon::isdigit($element->{'op_rate'})){
            $node{$devid}{$type}{'op_rate'} = round($element->{'op_rate'},0);
          }
        }
      }
    }
    else{
      if (defined $node_stats->{key}){
        (undef,undef,my $metric,$type,undef)=split(/\./,$node_stats->{key});
        $key = $node_stats->{key};
        if (!defined $type){$type = "";}
        if (!defined $metric){$metric = "";}
        if ($metric eq "ops"){
          $type = $metric . "_$type";
        }
      }
      my $devid = $node_stats->{'devid'};
      if (!defined $devid){next;}
      my $ln = $devid;
      if (Xormon::isdigit($node_stats->{'value'})){
        $value = round($node_stats->{'value'},0);
      }
      $node{$devid}{$type} = $value;
      if (Xormon::isdigit($node_stats->{time})){
        $node{$devid}{'time'} = $node_stats->{time};
      }
      foreach my $pool_id (keys %pools){
        if (!defined $pools{$pool_id}){next;}
        foreach my $node (@{$pools{$pool_id}}){
          if ($devid eq $node){
            $pool{$pool_id}{"node"}{$devid}{$type} = $value;
          }
          if (Xormon::isdigit($node_stats->{time})){
            $pool{$pool_id}{"node"}{$devid}{'time'} = $node_stats->{time};
          }
        }
      }
    }
  }
  #print STDERR Dumper \%pool;
  #print Dumper \%node;
  #my @keys = ("node.ifs.bytes.out.rate", "node.ifs.bytes.in.rate", "node.ifs.bytes.used", "node.ifs.bytes.free", "node.ifs.bytes.total", "node.protostats.nfs.total", "node.protostats.nfs4.total", "node.protostats.smb1.total", "node.protostats.smb2.total");
  foreach my $node_id (keys %node){
    my $read = $node{$node_id}{out};
    my $write = $node{$node_id}{in};
    my $read_ops = $node{$node_id}{ops_out};
    my $write_ops = $node{$node_id}{ops_in};
    my $ops_rate = "";
    my $data_rate = "";
    my $nfs_rate = "";
    my $nfs4_rate = "";
    my $smb1_rate = "";
    my $smb2_rate = "";
    my $capacity_total = $node{$node_id}{total};
    my $capacity_used = $node{$node_id}{used};
    my $capacity_free = $node{$node_id}{free};
    my $time = $node{$node_id}{time};
    my $nfs_read  = $node{$node_id}{"nfs"}{out_rate};
    my $nfs_write = $node{$node_id}{"nfs"}{in_rate};
    my $nfs_ops_rate  = $node{$node_id}{"nfs"}{op_rate};
    my $nfs4_read  = $node{$node_id}{"nfs4"}{out_rate};
    my $nfs4_write = $node{$node_id}{"nfs4"}{in_rate};
    my $nfs4_ops_rate  = $node{$node_id}{"nfs4"}{op_rate};
    my $smb1_read  = $node{$node_id}{"smb1"}{out_rate};
    my $smb1_write = $node{$node_id}{"smb1"}{in_rate};
    my $smb1_ops_rate  = $node{$node_id}{"smb1"}{op_rate};
    my $smb2_read  = $node{$node_id}{"smb2"}{out_rate};
    my $smb2_write = $node{$node_id}{"smb2"}{in_rate};
    my $smb2_ops_rate  = $node{$node_id}{"smb2"}{op_rate};

    if (!Xormon::isdigit($time)){next;}
    if (!Xormon::isdigit($read)){ $read = "";}
    else{
      $data_rate = $read;
    }
    if (!Xormon::isdigit($write)){ $write = "";}
    else{
      if (Xormon::isdigit($data_rate)){
        $data_rate = $data_rate + $write;
      }
      else{
        $data_rate = $write;
      }
    }
    if (!Xormon::isdigit($read_ops)){ $read_ops = "";}
    else{
      $ops_rate = $read_ops;
    }
    if (!Xormon::isdigit($write_ops)){ $write_ops = "";}
    else{
      if (Xormon::isdigit($ops_rate)){
        $ops_rate = $ops_rate + $write_ops;
      }
      else{
        $ops_rate = $write_ops;
      }
    }
    if (!Xormon::isdigit($capacity_total)){ $capacity_total = "";}
    if (!Xormon::isdigit($capacity_used)){ $capacity_used = "";}
    if (!Xormon::isdigit($capacity_free)){ $capacity_free = "";}
    if (!Xormon::isdigit($nfs_read)){ $nfs_read = "";}
    if (!Xormon::isdigit($nfs_write)){ $nfs_write = "";}
    if (!Xormon::isdigit($nfs_rate)){ $nfs_rate = "";}
    if (!Xormon::isdigit($nfs4_read)){ $nfs4_read = "" ;}
    if (!Xormon::isdigit($nfs4_write)){ $nfs4_write = "";}
    if (!Xormon::isdigit($nfs4_rate)){ $nfs4_rate = "";}
    if (!Xormon::isdigit($smb1_read)){ $smb1_read = "";}
    if (!Xormon::isdigit($smb1_write)){ $smb1_write = "";}
    if (!Xormon::isdigit($smb1_rate)){ $smb1_rate = "";}
    if (!Xormon::isdigit($smb2_read)){ $smb2_read = "";}
    if (!Xormon::isdigit($smb2_write)){ $smb2_write = "";}
    if (!Xormon::isdigit($smb2_rate)){ $smb2_rate = "";}

    if (!Xormon::isdigit($nfs_ops_rate)){ $nfs_ops_rate = "";}
    if (!Xormon::isdigit($nfs4_ops_rate)){ $nfs4_ops_rate = "";}
    if (!Xormon::isdigit($smb1_ops_rate)){ $smb1_ops_rate = "";}
    if (!Xormon::isdigit($smb2_ops_rate)){ $smb2_ops_rate = "";}

    if (Xormon::isdigit($nfs_read)){
      $nfs_rate = $nfs_read;
    }
    if (Xormon::isdigit($nfs_write)){
      if (Xormon::isdigit($nfs_rate)){
        $nfs_rate = $nfs_rate + $nfs_write;
      }
      else{
        $nfs_rate = $nfs_write;
      }
    }

    if (Xormon::isdigit($nfs4_read)){
     $nfs4_rate = $nfs4_read;
    }
    if (Xormon::isdigit($nfs4_write)){
      if (Xormon::isdigit($nfs4_rate)){
        $nfs4_rate = $nfs4_rate + $nfs4_write;
      }
      else{
        $nfs4_rate = $nfs4_write;
      }
    }
    if (Xormon::isdigit($smb1_read)){
      $smb1_rate = $smb1_read;
    }
    if (Xormon::isdigit($smb1_write)){
      if (Xormon::isdigit($smb1_rate)){
        $smb1_rate = $smb1_rate + $smb1_write;
      }
      else{
        $smb1_rate = $smb1_write;
      }
    }
    if (Xormon::isdigit($smb2_read)){
      $smb2_rate = $smb2_read;
    }
    if (Xormon::isdigit($smb2_write)){
      if (Xormon::isdigit($smb2_rate)){
        $smb2_rate = $smb2_rate + $smb2_write;
      }
      else{
        $smb2_rate = $smb2_write;
      }
    }


    my $hash_key = Xormon::create_hash_key($st_serial."node".$node_id);
    my $type = "node";
    $performance_data{$st_type}{$type}{$hash_key}{$time}{read} = $read;
    $performance_data{$st_type}{$type}{$hash_key}{$time}{"write"} = $write_ops;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{read_ops} = $read_ops;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"write_ops"} = $write_ops;
    $performance_data{$st_type}{$type}{$hash_key}{$time}{"capacity_total"} = $capacity_total;
    $performance_data{$st_type}{$type}{$hash_key}{$time}{"capacity_used"} = $capacity_used;
    $performance_data{$st_type}{$type}{$hash_key}{$time}{"capacity_free"} = $capacity_free;
    $performance_data{$st_type}{$type}{$hash_key}{$time}{"data_rate"} = $data_rate;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"ops_rate"} = $ops_rate;

    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"nfs_read"} = $nfs_read;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"nfs_write"} = $nfs_write;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"nfs_rate"} = $nfs_rate;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"nfs4_read"} = $nfs4_read;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"nfs4_write"} = $nfs4_write;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"nfs4_rate"} = $nfs4_rate;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"smb1_read"} = $smb1_read;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"smb1_write"} = $smb1_write;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"smb1_rate"} = $smb1_rate;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"smb2_read"} = $smb2_read;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"smb2_write"} = $smb2_write;
    #$performance_data{$st_type}{$type}{$hash_key}{$time}{"smb2_rate"} = $smb2_rate;

    $performance_data{$st_type}{$type}{$hash_key}{$time}{"nfs_ops_rate"} = $nfs_ops_rate;
    $performance_data{$st_type}{$type}{$hash_key}{$time}{"nfs4_ops_rate"} = $nfs4_ops_rate;
    $performance_data{$st_type}{$type}{$hash_key}{$time}{"smb1_ops_rate"} = $smb1_ops_rate;
    $performance_data{$st_type}{$type}{$hash_key}{$time}{"smb2_ops_rate"} = $smb2_ops_rate;
    if ($api_version eq "1"){
      $configuration_data{$hash_key}{id} = $node_id;
      $configuration_data{$hash_key}{name} = $node_id;

    }

    #if (Xormon::isdigit($ops_rate) && $ops_rate > 0 && Xormon::isdigit($data_rate)){
    #  $performance_data{$st_type}{$type}{$hash_key}{$time}{block_size} = round($data_rate / $ops_rate,0);
    #}
    #if (Xormon::isdigit($read_ops) && $read_ops > 0 && Xormon::isdigit($read)){
    #  $performance_data{$st_type}{$type}{$hash_key}{$time}{block_size_r} = round($read / $read_ops,0);
    #}
    #if (Xormon::isdigit($write_ops) && $write_ops > 0 && Xormon::isdigit($write)){
    #  $performance_data{$st_type}{$type}{$hash_key}{$time}{block_size_w} = round($write / $write_ops,0);
    #}

    $configuration_data{$hash_key}{id} = $node_id;
    $configuration_data{$hash_key}{label} = $node_id;
    $configuration_data{$hash_key}{TYPE} = "node";

    #print Dumper \$performance_data{$st_type}{$type}{$hash_key};

  }
  #print Dumper \$performance_data{$st_type}{node};

  ### node convert to correct format
  #print Dumper \%performance_data;
  #print "end " . localtime() . "\n";

}

sub set_data_port{
  my $type = "port";
  my $cmd = "platform/$api_version/statistics/current?key=node.net.iface.count&devid=all";
  my $datas = cmd($cmd);
  if (!defined $datas->{'stats'} || ref($datas->{'stats'}) ne "ARRAY"){return;}
  #my @keys = ("bytes.out.rate", "bytes.in.rate", "packets.in.rate", "packets.out.rate", "errors.in.rate", "errors.out.rate");
  my @keys = ("bytes.out.rate", "bytes.in.rate");
  foreach my $port (@{$datas->{'stats'}}){
  if (!Xormon::isdigit($port->{value}) || !Xormon::isdigit($port->{devid})){next;}
    my $devid = $port->{devid};
    for (my $i = 0; $i < $port->{value};$i++){
      #my $cmd = "platform/$api_version/statistics/current?keys=node.net.iface.bytes.out.rate.$i,node.net.iface.bytes.in.rate.$i,node.net.iface.packets.in.rate.$i,node.net.iface.packets.out.rate.$i,node.net.iface.errors.in.rate.$i,node.net.iface.errors.out.rate.$i&devid=$devid&interval=300";
      my $cmd = "platform/$api_version/statistics/current?keys=node.net.iface.bytes.out.rate.$i,node.net.iface.bytes.in.rate.$i&devid=$devid&interval=300";
      my $data = cmd($cmd);
      if ($data eq "0" || !defined $data->{'stats'} || ref($data->{'stats'}) ne "ARRAY"){next;}
      foreach my $element (@{$data->{'stats'}}){
        if (!Xormon::isdigit($element->{value}) || !Xormon::isdigit($element->{time}) || !defined $element->{key}){next;}
        my (undef, undef, undef, $t1, $t2, $t3) = split (/\./,$element->{key});
        my $key = "$t1.$t2.$t3";
        my $id = "$devid-$i";
        my $hash_key = Xormon::create_hash_key($st_serial."port".$id);
        $configuration_data{$hash_key}{id} = $id;
        $configuration_data{$hash_key}{label} = "$devid $i";
        $configuration_data{$hash_key}{TYPE} = "port";
        $configuration_data{$hash_key}{node} = $devid;
        $configuration_data{$hash_key}{port} = $i;
        my $metric = $key;
        $element->{value} = round($element->{value},0);
        my $select_time = 0;
        if (defined $performance_data{$st_type}{$type}{$hash_key}){
          my ($t1, $t2, $t3) = split (/\./,$key);
          if ($t1 eq "bytes"){
            if ($t2 eq "out"){
              $metric = "read";
            }
            else{
              $metric = "write";
            }
          }
          if ($t1 eq "packets"){
            if ($t2 eq "out"){
              $metric = "packet_read";
            }
            else{
              $metric = "packet_write";
            }
          }
          if ($t1 eq "errors"){
            if ($t2 eq "out"){
              $metric = "error_read";
            }
            else{
              $metric = "error_write";
            }
          }
          my $time = (keys %{$performance_data{$st_type}{$type}{$hash_key}})[0];
          $performance_data{$st_type}{$type}{"$hash_key"}{$time}{$metric} = $element->{value};
          $select_time = $time;
        }
        else{
          if ($t1 eq "bytes"){
            if ($t2 eq "out"){
              $metric = "read";
            }
            else{
              $metric = "write";
            }
          }
          if ($t1 eq "packets"){
            if ($t2 eq "out"){
              $metric = "packet_read";
            }
            else{
              $metric = "packet_write";
            }
          }
          if ($t1 eq "errors"){
            if ($t2 eq "out"){
              $metric = "error_read";
            }
            else{
              $metric = "error_write";
            }
          }
          $performance_data{$st_type}{$type}{$hash_key}{$element->{time}}{$metric} = $element->{value};
          $select_time = $element->{time};
        }
        if ($metric =~ /^read$|^write$/){
          if (Xormon::isdigit($performance_data{$st_type}{$type}{$hash_key}{$select_time}{"data_rate"})){
            $performance_data{$st_type}{$type}{$hash_key}{$select_time}{"data_rate"} = $performance_data{$st_type}{$type}{$hash_key}{$select_time}{"data_rate"} + $element->{value};
          }
          else{
            $performance_data{$st_type}{$type}{$hash_key}{$select_time}{"data_rate"} = $element->{value};
          }
        }
        if ($metric =~ /packet/){
          if (Xormon::isdigit($performance_data{$st_type}{$type}{$hash_key}{$select_time}{"packet_rate"})){
            $performance_data{$st_type}{$type}{$hash_key}{$select_time}{"packet_rate"} = $performance_data{$st_type}{$type}{$hash_key}{$select_time}{"packet_rate"} + $element->{value};
          }
          else{
            $performance_data{$st_type}{$type}{$hash_key}{$select_time}{"packet_rate"} = $element->{value};
          }
        }
        if ($metric =~ /error/){
          if (Xormon::isdigit($performance_data{$st_type}{$type}{$hash_key}{$select_time}{"error_rate"})){
            $performance_data{$st_type}{$type}{$hash_key}{$select_time}{"error_rate"} = $performance_data{$st_type}{$type}{$hash_key}{$select_time}{"error_rate"} + $element->{value};
          }
          else{
            $performance_data{$st_type}{$type}{$hash_key}{$select_time}{"error_rate"} = $element->{value};
          }
        }
      }
    }
  }
  #print Dumper \$performance_data{"9f2370949e"};
  #print Dumper \$performance_data{$st_type}{$type};
}

sub set_data_cpu{

  my %cpu;
  my $type = "cpu";
  my $cmd = "platform/$api_version/statistics/current?key=node.cpu.count&devid=all";
  my $data = cmd($cmd, "$debug_data/cpu.json");
  if ($data eq "0" || !defined $data->{'stats'} || ref($data->{'stats'}) ne "ARRAY"){return;}
  my @keys = ("idle", "user", "sys");
  foreach my $cpu (@{$data->{'stats'}}){
    if (!Xormon::isdigit($cpu->{value}) || !Xormon::isdigit($cpu->{devid})){next;}
    my $node_id = $cpu->{devid};
    for (my $i = 0; $i < $cpu->{value};$i++){
      my $cmd = "platform/$api_version/statistics/current?keys=node.cpu.idle.$i,node.cpu.user.$i,node.cpu.sys.$i&devid=$node_id&interval=300";
      my $data = cmd($cmd);
      if ($data eq "0" || !defined $data->{'stats'} || ref($data->{'stats'}) ne "ARRAY"){return;}
      foreach my $element (@{$data->{'stats'}}){
        if (!Xormon::isdigit($element->{value}) || !Xormon::isdigit($element->{time}) || !defined $element->{key}){next;}
        my $value = round($element->{value} / 10,1);
        my (undef, undef, $key, undef) = split(/\./,$element->{key});
        #print "set_data_cpu : $key\n";
        if ($key eq "sys"){
          $key = "system";
        }
        $key = "cpu_" . $key;
        my $id = "$node_id-$i";
        my $hash_key = Xormon::create_hash_key($st_serial."cpu".$id);
        if (defined $performance_data{$st_type}{$type}{$hash_key}){
          my $time = (keys %{$performance_data{$st_type}{$type}{$hash_key}})[0];
          $performance_data{$st_type}{$type}{$hash_key}{$time}{$key} = $value;
          $cpu{$hash_key} = $time;
        }
        else{
          $performance_data{$st_type}{$type}{$hash_key}{$element->{time}}{$key} = $value;
          $cpu{$hash_key} = $element->{time};
        }
        $configuration_data{$hash_key}{id} = $id;
        $configuration_data{$hash_key}{label} = $id;
        $configuration_data{$hash_key}{cpu} = $i;
        $configuration_data{$hash_key}{node} = $node_id;
        $configuration_data{$hash_key}{TYPE} = "cpu";
      }
      ### calculate busy
      foreach my $hash_key (keys %cpu){
        my $time = $cpu{$hash_key};
        my $sys = $performance_data{$st_type}{$type}{$hash_key}{$time}{cpu_system};
        my $user = $performance_data{$st_type}{$type}{$hash_key}{$time}{cpu_user};
        my $busy = "";
        if (Xormon::isdigit($sys)){
          $busy = $sys;
        }
        if (Xormon::isdigit($user)){
          if (Xormon::isdigit($busy)){
            $busy = $busy + $user;
          }
          else{
            $busy = $user;
          }
        }
        $performance_data{$st_type}{$type}{$hash_key}{$time}{cpu_busy} = $busy;
      }
    }
  }

  #print Dumper \$data;
  #print Dumper \%node;
  #print Dumper \%performance_data;
  #print Dumper \$performance_data{$st_type}{$type};

}

sub set_data_drive_old{

  #my $c = "platform/$api_version/statistics/summary/drive";
  #my $d = cmd($c);
  #print Dumper \$d;
  #return;

  #### optimalize
  my $type = "drive";
  my $cmd = "platform/$api_version/statistics/current?keys=node.disk.bytes.out.rate.all,node.disk.bytes.in.rate.all,node.disk.access.latency.all,node.disk.busy.all,node.disk.xfers.out.rate.all,node.disk.ifs.bytes.used.all&devid=all&interval=300";
  my $data = cmd($cmd,"$debug_data/drive_performance.json");
  #print Dumper \$data;
  if ($data ne "0" && defined $data->{'stats'} && ref($data->{'stats'}) eq "ARRAY"){
    foreach my $element (@{$data->{'stats'}}){
      if (!defined $element->{value} || ref($element->{value}) ne "ARRAY" || !Xormon::isdigit($element->{time}) || !defined $element->{key} || !defined $element->{devid}){next;}
      my $time = $element->{time};
      my $key = $element->{key};
      my $devid = $element->{devid};
      foreach my $val (@{$element->{value}}){
        foreach my $id (keys %{$val}){
          my $data_rate = "";
          my $hash_key = Xormon::create_hash_key($st_serial."drive"."$devid:$id");
          $configuration_data{$hash_key}{id} = "$devid:$id";
          $configuration_data{$hash_key}{label} = "$devid:$id";
          $configuration_data{$hash_key}{TYPE} = "drive";
          if (defined $performance_data{$st_type}{$type}{$hash_key}){
            my $t = (keys %{$performance_data{$st_type}{$type}{$hash_key}})[0];
            if (Xormon::isdigit($t)){
              $time = $t;
            }
          }
          my $value = $val->{$id};
          if (!Xormon::isdigit($value)){next;}
          if ($key =~ m/^node.disk.busy/){
            $value = $value / 10;
            $performance_data{$st_type}{$type}{$hash_key}{$time}{busy}=round($value,1);
          }
          elsif ($key =~ m/^node.disk.ifs.bytes.used./){
            $performance_data{$st_type}{$type}{$hash_key}{$time}{capacity_used} = round($value,0);
          }
          elsif ($key =~ m/^node.disk.access.latency./){
            #$value = 2.66;
            $performance_data{$st_type}{$type}{$hash_key}{$time}{resp_t} = round($value,3);
          }
          #elsif ($key =~ m/^node.disk.xfers.out.rate/){
          #  $performance_data{$st_type}{$type}{$hash_key}{$time}{xfers_write} = round($value,3);
          #}
          else{
            if ($key =~ m/node.disk.bytes.out.rate/ ){
              $performance_data{$st_type}{$type}{$hash_key}{$time}{read} = round($value,0);
              if (Xormon::isdigit($data_rate)){
                $data_rate = $data_rate + $value;
              }
              else{
                $data_rate = round($value,0);
              }
            }
            else{
              $performance_data{$st_type}{$type}{$hash_key}{$time}{write} = round($value,0);
              if (Xormon::isdigit($data_rate)){
                $data_rate = $data_rate + $value;
              }
              else{
                $data_rate = round($value,0);
              }
            }
          }
          if (Xormon::isdigit($performance_data{$st_type}{$type}{$hash_key}{$time}{data_rate})){
            if (Xormon::isdigit($data_rate)){
              $performance_data{$st_type}{$type}{$hash_key}{$time}{data_rate} = $performance_data{$st_type}{$type}{$hash_key}{$time}{data_rate} + $data_rate;
            }
          }
          else{
            $performance_data{$st_type}{$type}{$hash_key}{$time}{data_rate} = $data_rate;
          }
        }
      }
    }
    #print Dumper \$performance_data{$st_type}{$type};
    return;
  }
  ###


  $cmd = "platform/$api_version/statistics/current?key=node.disk.count&devid=all";
  $data = cmd($cmd, "$debug_data/node_disk_count.json");
  if ($data eq "0" || !defined $data->{'stats'} || ref($data->{'stats'}) ne "ARRAY"){return;}
  #my @keys = ("bytes.out.rate", "bytes.in.rate", "access.latency", "busy", "xfers.out.rate", "ifs.bytes.used");
  foreach my $drive (@{$data->{'stats'}}){
    if (!Xormon::isdigit($drive->{value}) || !Xormon::isdigit($drive->{devid}) ){next;}
    my $devid = $drive->{devid};
    for (my $i = 0; $i < $drive->{value};$i++){
      my $cmd = "platform/$api_version/statistics/current?keys=node.disk.bytes.out.rate.$i,node.disk.bytes.in.rate.$i,node.disk.access.latency.$i,node.disk.busy.$i,node.disk.xfers.out.rate.$i,node.disk.ifs.bytes.used.$i&devid=$devid&interval=300";
      my $data = cmd($cmd,"$debug_data/drive_$devid-$i.json");
      #print Dumper \$data;
      if ($data eq "0" || !defined $data->{'stats'} || ref($data->{'stats'}) ne "ARRAY"){next;}
      my $data_rate = "";
      foreach my $element (@{$data->{'stats'}}){
        if (!Xormon::isdigit($element->{value}) || !Xormon::isdigit($element->{time}) || !defined $element->{key} ){next;}
        my $id = "$devid:$i";
        my $hash_key = Xormon::create_hash_key($st_serial."drive".$id);

        $configuration_data{$hash_key}{id} = "$id";
        $configuration_data{$hash_key}{label} = "$id";
        $configuration_data{$hash_key}{TYPE} = "drive";


        my $value = $element->{value};
        my $time = $element->{time};
        if (defined $performance_data{$st_type}{$type}{$hash_key}){
          my $t = (keys %{$performance_data{$st_type}{$type}{$hash_key}})[0];
          if (Xormon::isdigit($t)){
            $time = $t;
          }
        }
        my $key = $element->{key};
        if ($key =~ m/^node.disk.busy/){
          $value=$value/10;
          $performance_data{$st_type}{$type}{$hash_key}{$time}{busy}=round($value,1);
        }
        elsif ($key =~ m/^node.disk.ifs.bytes.used./){
          $performance_data{$st_type}{$type}{$hash_key}{$time}{capacity_used} = round($value,0);
        }
        elsif ($key =~ m/^node.disk.access.latency./){
          $performance_data{$st_type}{$type}{$hash_key}{$time}{access_latency} = round($value,3);
        }
        #elsif ($key =~ m/^node.disk.xfers.out.rate/){
        #  $performance_data{$st_type}{$type}{$hash_key}{$time}{xfers_write} = round($value,3);
        #}
        else{
          if ($key =~ m/node.disk.bytes.out.rate/ ){
            $performance_data{$st_type}{$type}{$hash_key}{$time}{read} = round($value,0);
            if (Xormon::isdigit($data_rate)){
              $data_rate = $data_rate + $value;
            }
            else{
              $data_rate = round($value,0);
            }
          }
          else{
            $performance_data{$st_type}{$type}{$hash_key}{$time}{write} = round($value,0);
            if (Xormon::isdigit($data_rate)){
              $data_rate = $data_rate + $value;
            }
            else{
              $data_rate = round($value,0);
            }
          }
        }
        if (Xormon::isdigit($performance_data{$st_type}{$type}{$hash_key}{$time}{data_rate})){
          if (Xormon::isdigit($data_rate)){
            $performance_data{$st_type}{$type}{$hash_key}{$time}{data_rate} = $performance_data{$st_type}{$type}{$hash_key}{$time}{data_rate} + $data_rate;
          }
        }
        else{
          $performance_data{$st_type}{$type}{$hash_key}{$time}{data_rate} = $data_rate;
        }
        #print Dumper \$element;
        #print "$id $hash_key $element->{value}\n";
      }
    }
  }
  #print Dumper \%performance_data;
  return;
}

sub set_data_quota_cfg{
  my $cmd = "platform/$api_version/quota/quotas?resolve_names=true";
  my $data = cmd($cmd, "$debug_data/quota.json");
  if ($data eq "0" || !defined $data->{'quotas'} || ref($data->{'quotas'}) ne "ARRAY"){return;}
  foreach my $quota (@{$data->{quotas}}){
    my $path = $quota->{path};
    my $type = $quota->{type};
    my $physical_usage = $quota->{usage}->{physical};
    my $logical_usage = $quota->{usage}->{logical};
    my $advisory_limit = $quota->{thresholds}->{advisory};
    my $soft_limit = $quota->{thresholds}->{soft};
    my $hard_limit = $quota->{thresholds}->{hard};
    my $persona = $quota->{persona};
    my $linked = $quota->{linked};
    if (!defined $path || !defined $type){next;}
    if (!defined $physical_usage){$physical_usage = "";}
    if (!defined $logical_usage){$logical_usage = "";}
    if (!defined $advisory_limit){$advisory_limit = "";}
    if (!defined $soft_limit){$soft_limit = "";}
    if (!defined $hard_limit){$hard_limit = "";}
    if (!defined $linked){$linked = "";}
    if (defined $persona){
      my $name = $persona->{name};
      my $id = $persona->{id};
      if (!defined $name && defined $id){
        $name = $id;
      }
      if (defined $name){
        $type = "$type: $name";
      }
    }
    if ($linked eq "1" || $linked eq "true"){
      $type = "$type linked";
    }
    my $hash_key = Xormon::create_hash_key($st_serial."QUOTA".$path.$type);
    $configuration_data{$hash_key}{advisory_limit} = $advisory_limit;
    $configuration_data{$hash_key}{hard_limit} = $hard_limit;
    $configuration_data{$hash_key}{logical_usage}= $logical_usage;
    $configuration_data{$hash_key}{path} = $path;
    $configuration_data{$hash_key}{physical_usage} = $physical_usage;
    $configuration_data{$hash_key}{soft_limit} = $soft_limit;
    $configuration_data{$hash_key}{type} = $type;
    $configuration_data{$hash_key}{label} = $type;
    $configuration_data{$hash_key}{TYPE} =  "QUOTA";
  }
}


sub set_data_node_cfg{
  if ($api_version eq "1"){return;}

  my $cmd = "platform/$api_version/cluster/nodes/ALL/hardware";
  my $data = cmd($cmd, "$debug_data/node.json");
  if ($data eq "0" || !defined $data->{'nodes'} || ref($data->{'nodes'}) ne "ARRAY"){return;}
  foreach my $node (@{$data->{nodes}}){
    if (!defined $node->{id}){next;}
    my $id=$node->{'id'};
    my $hash_key = Xormon::create_hash_key($st_serial."node".$id);
    if (!defined $configuration_data{$hash_key}){next;}
    my $serial_number=$node->{'serial_number'};
    my $ram=$node->{'ram'};
    my $product=$node->{'product'};
    my $imb=$node->{'imb_version'};
    my $model = $node->{model};
    if (!defined $model){$model = "";}
    if (!defined $serial_number){ $serial_number = "";}
    if (!defined $ram){$ram = "";}
    if (!defined $id){$id = "";}
    if (!defined $product){$product = "";}
    if (!defined $imb){$imb = "";}
    if (!defined $model){$model = "";}
    $configuration_data{$hash_key}{ram} = $ram;
    $configuration_data{$hash_key}{serial_number} = $serial_number;
    $configuration_data{$hash_key}{product} = $product;
    $configuration_data{$hash_key}{imb_version} = $imb;
    $configuration_data{$hash_key}{model} = $model;
  }
}

sub set_data_drive_cfg{

  my $cmd = "platform/$api_version/statistics/summary/drive?interval=300";
  my $data = cmd($cmd, "$debug_data/drive.json");
  #print STDERR Dumper $data;

  if ($data eq "0" || !defined $data->{'drive'} || ref($data->{'drive'}) ne "ARRAY"){return;}
  foreach my $drive (@{$data->{drive}}){
    my $id = "";
    if (!defined $drive->{'drive_id'} || $drive->{'drive_id'} eq ""){next;}
    $id = $drive->{'drive_id'};
    my $type = $drive->{type};
    if (!defined $type ){
      $type = "";
    }

    my $hash_key = Xormon::create_hash_key($st_serial."drive".$id);
    if (defined $configuration_data{$hash_key}){
      $configuration_data{$hash_key}{type} = $type;
    }
  }



}

sub set_data_drive{

  my $cmd = "platform/$api_version/statistics/summary/drive?interval=300";
  my $data = cmd($cmd, "$debug_data/drive.json");
  my $type = "drive";
  #print STDERR Dumper $data;

  if ($data eq "0" || !defined $data->{'drive'} || ref($data->{'drive'}) ne "ARRAY"){return;}
  foreach my $drive (@{$data->{drive}}){
    my $id = "";
    my $timestamp = "";
    my $data_rate = "";
    if (!defined $drive->{'drive_id'} || $drive->{'drive_id'} eq ""){next;}
    if (!Xormon::isdigit($drive->{time})){next;}
    $id = $drive->{'drive_id'};
    my $old_id = $id;

    $timestamp = $drive->{time};
    my $hash_key = Xormon::create_hash_key($st_serial."drive".$id);
    #print "$hash_key ||| $id\n";
    $id = $hash_key;
    $configuration_data{$hash_key}{id} = $old_id;
    $configuration_data{$hash_key}{label} = $old_id;
    $configuration_data{$hash_key}{TYPE} = "drive";


    if (Xormon::isdigit($drive->{'bytes_in'})){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{write} = round($drive->{'bytes_in'},0);
      $data_rate = $drive->{'bytes_in'};
    }
    if (Xormon::isdigit($drive->{'bytes_out'})){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{read} = round($drive->{'bytes_out'},0);
      if (Xormon::isdigit($data_rate)){
        $data_rate = $data_rate + $drive->{'bytes_out'};
      }
      else{
        $data_rate = $drive->{'bytes_out'};
      }
    }
    if (Xormon::isdigit($drive->{'access_latency'})){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{resp_t} = round($drive->{'access_latency'}, 3);
    }
    if (Xormon::isdigit($drive->{'used_bytes_percent'})){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{"capacity_used_percent"} = round($drive->{'used_bytes_percent'},0);
    }
    #if (Xormon::isdigit($drive->{'xfers_write'})){
    #  $performance_data{$st_type}{$type}{$id}{$timestamp}{"xfers_write"} = round($drive->{'xfers_write'},3);
    #}
    if (Xormon::isdigit($drive->{'busy'})){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{"cpu_busy"} = round($drive->{'busy'},1);
    }
    if ($data_rate ne ""){
      $performance_data{$st_type}{$type}{$id}{$timestamp}{"data_rate"} = round($data_rate,0);
    }
  }
  #print STDERR Dumper \%performance_data;

  return;
}

sub data_structure {
  if (!-d "$data_directory/data"){
    mkdir "$data_directory/data" || $logger->error( "Cannot mkdir $data_directory/data: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
  }

  if (!-d "$data_directory/data/$st_serial"){
    mkdir "$data_directory/data/$st_serial" || $logger->error( "Cannot mkdir $data_directory/data/$st_serial: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
  }
  if (!-d "$data_directory/data/$st_serial/IOSTATS"){
    mkdir "$data_directory/data/$st_serial/IOSTATS" || $logger->error( "Cannot mkdir $data_directory/data/$st_serial/IOSTATS: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
  }
  my $directory = "$data_directory/data/$st_serial/IOSTATS";
  if ( !-d $directory ) {
    mkdir $directory || $logger->error( "Cannot mkdir $directory: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
  }
  if ( !-d "$directory/configuration" ) {
    mkdir "$directory/configuration" || $logger->error( "Cannot mkdir $directory/configuration: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
  }

  for ( my $i = 0; $i < 60; $i = $i + 5 ) {
    if ( $i < 10 ) {
      if ( !-d "$directory/0$i" ) {
        mkdir "$directory/0$i" || $logger->error( "Cannot mkdir $directory/0$i: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
      }
    }
    else {
      if ( !-d "$directory/$i" ) {
        mkdir "$directory/$i" || $logger->error( "Cannot mkdir $directory/$i: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
      }
    }
  } ## end for ( my $i = 0; $i < 60...)
  my @entry_time = split( " ", localtime() );
  ( undef, $active_minute, undef ) = split( ":", $entry_time[3] );
  if ( !-d "$directory/$active_minute" ) {
    mkdir "$directory/$active_minute" || $logger->error( "Cannot mkdir $directory/$active_minute: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
  }
  $debug_data = "$directory/$active_minute";
  $debug_data_configuration = "$directory/configuration";

} ## end sub data_structure

sub round {
  my $number         = shift;
  my $decimal_plates = shift;
  if ( !defined $decimal_plates ) {
    $decimal_plates = 3;
  }
  my $num = $number;
  if ( $number =~ /\./ ) {
    $number =~ s/.*\.//g;
    my $length = length($number);
    if ( $length > $decimal_plates ) {
      my $rounded = sprintf( "%.$decimal_plates" . "f", $num );
      return $rounded;
    }
    else {
      return $num;
    }
  } ## end if ( $number =~ /\./ )
  else {
    return $num;
  }
} ## end sub round



1;
