package OCEANSTOR;

use strict;
use warnings;
use Data::Dumper;
use JSON qw(encode_json decode_json);
use Date::Parse;
use FindBin;
use lib "$FindBin::Bin/"; # use lib in this folder
use lib "../../../perl-modules";
#use lib "/home/xormon/nextgen/perl-modules";
use POSIX ":sys_wait_h";
use LWP::UserAgent;
use File::Copy;
use File::Temp qw(tempfile);
use Test;
use XormonLogger;
use Xormon;
no warnings 'utf8';
my $logger;

my %data;
my $xormon;
my $cfg;
my $stats_found = 0;
my $data_directory = "$FindBin::Bin";
my $debug = 0;

my $storage_name = "";
my $active_minute = "";
my $debug_data = "";
my $debug_data_configuration = "";
my %performance_data;
my %configuration_data;
my $st_serial;
my @architecture = ();
my $service_data_out;
my $st_type = "oceanstor";
my @rows_api_test = ();
my @rows_api_test_data = ();
my $protocol = "";
my $wrkdir = "";
my $service_data_in;
my $connection_test = 0;
my $cookie = "";
my @health_status = ();
my %hosts;
my @hardware = ();
my $replication_capacity_used = "";
my @health_status_global = ();
my $token = "";
my $device_id = "";
my $api_host = "";
my $port = 8088;
my %performance_statistics;
my %metric_inventory;
my $timestamp_global;
my $enviroment = 1;






sub collect {
  $xormon = shift;
  $cfg    = shift;

  #print Dumper \$cfg;
  #return "successful";

  #12|oceanstor  | 2023-11-07 09:40:01: Tue Nov  7 09:40:01 2023: Connection from 127.0.0.1:50462
  #12|oceanstor  | 2023-11-07 09:40:01: Tue Nov  7 09:40:01 2023: Received task: fetch
  #12|oceanstor  | 2023-11-07 09:40:01: $VAR1 = \{
  #12|oceanstor  | 2023-11-07 09:40:01:             'apiUsername' => 'admin',
  #12|oceanstor  | 2023-11-07 09:40:01:             'node1Host' => 'localhost',
  #12|oceanstor  | 2023-11-07 09:40:01:             'created' => '1699346110736',
  #12|oceanstor  | 2023-11-07 09:40:01:             'hostalias' => 'Huawei-oceanstor',
  #12|oceanstor  | 2023-11-07 09:40:01:             'updated' => undef,
  #12|oceanstor  | 2023-11-07 09:40:01:             'device' => 'HUAWEI__OCEAN_STOR',
  #12|oceanstor  | 2023-11-07 09:40:01:             'node2Host' => 'localhost',
  #12|oceanstor  | 2023-11-07 09:40:01:             'hostcfg_id' => '5e892f7d-427a-4618-981e-0641eda6019c',
  #12|oceanstor  | 2023-11-07 09:40:01:             'apiPassword' => 'admin'
  #12|oceanstor  | 2023-11-07 09:40:01:           };
  #print Dumper \$cfg;
  $timestamp_global = get_global_timestamp();
  unless ( exists $cfg->{'hostcfg_id'} )        { Xormon::error("Cannot continue, 'hostcfg_id' is not configured!") && return "error"; }
  $logger = XormonLogger->new( 'oceanstor', $cfg->{hostcfg_id}, $cfg->{hostalias} );
  unless ( exists $cfg->{'node1Host'} )         { $logger->error("Cannot continue, 'node1Host' is not configured!") && return "error"; }
  unless ( exists $cfg->{'apiUsername'} )      { $logger->error("Cannot continue, 'apiUsername' is not configured!") && return "error"; }
  unless ( exists $cfg->{'apiPassword'} )      { $logger->error("Cannot continue, 'apiPassword' is not configured!") && return "error"; }
  if (!defined $cfg->{sampleRate}){
    $cfg->{sampleRate} = 5;
  }
  my $act_timestamp     = time();
  $service_data_in = $xormon->getData();
  #if (ref(\$service_data_in) eq "SCALAR"){
  #  $service_data_in = {};
  #}
  if ( exists $service_data_in->{last_conf_timestamp} ) {
    $service_data_out->{last_conf_timestamp} = $service_data_in->{last_conf_timestamp};
  }

  $storage_name = $cfg->{hostalias};
  $cfg->{'uuid'} = $cfg->{'hostcfg_id'};
  $st_serial = $cfg->{'uuid'};
  $api_host = $cfg->{'node1Host'};
  if (exists $service_data_in->{api_host} && $service_data_in->{api_host} ne $api_host){
    $api_host = $service_data_in->{api_host};
  }
  if (defined $cfg->{OCEANSTOR_ENVIROMENT} && $cfg->{OCEANSTOR_ENVIROMENT} eq "development"){
    $enviroment = 0;
  }
  data_structure();
  set_data_perf_list();
  ### login
  login();
  if (!defined $token || $token eq "" || !defined $device_id || $device_id eq "" || !defined $cookie || $cookie eq ""){
    if (defined $cfg->{node2Host}){
      if ($cfg->{node2Host} eq $api_host){
        $api_host = $cfg->{'node1Host'};
      }
      $api_host = $cfg->{'node2Host'};
      login();
      if (!defined $token || $token eq "" || !defined $device_id || $device_id eq "" || !defined $cookie || $cookie eq ""){
        $xormon->isConnected(0, "Connection failed!");
        $logger->error("Cookie, token or device_id is not defined") && return "error";
      }
    }
    else{
      $xormon->isConnected(0, "Connection failed!");
      $logger->error("Cookie, token or device_id is not defined") && return "error";
    }
  }
  ###
  ### check connection
  if (!check_connection()){
    logout();
    $xormon->isConnected(0, "Connection failed!");
    $logger->info("Task for ".$cfg->{hostalias}." is done. Status: error");
    return "error";
  }
  $service_data_out->{api_host} = $api_host;
  ###
  #print "$token $device_id $cookie\n";
  $xormon->isConnected(1);
  set_data_pool();
  set_data_drive();
  set_data_volume();
  set_data_node();
  set_data_host();
  set_data_filesystem();
  set_data_port_fc();
  set_data_port_sas();
  set_data_port_fcoe();
  set_data_port_eth();
  set_data_port_log();
  set_data_port_link();
  set_data_device();
  #set_data_device_capacity();
  logout();

  #set_data_device();
  #logout();
  delete_empty_metrics();
  calculate_missing_metrics();
  #print Dumper \%performance_data;
  my $rc = $xormon->saveJSON2(\%performance_data);
  my $status = get_status($rc, "saveJSON2 (performance)");

  ### host_cfg_data
  if (Xormon::isdigit($service_data_out->{last_perf_timestamp})){
    if ( ( time() -  $service_data_out->{last_perf_timestamp} ) > 10800 ) {
      $xormon->hasData(0, "last available stats are older than 3 hours: " . $service_data_out->{last_perf_timestamp});
    }
    else{
      $xormon->hasData(1);
    }
  }
  else{
    $xormon->hasData(0, "no available stats");
  }

  my $save_data = $xormon->saveData(\%{ $service_data_out });
  #print Dumper \$service_data_out;
  my $status_save_data = get_status($save_data, "SaveData");
  #print "$status | $save_data $status_save_data\n";

  #($status, my $status_configuration, my $status_health) = set_architecture();
  #print "$status ||| $status_configuration ||| $status_health\n";


  #return "successful";
  if (( ! exists $service_data_in->{last_conf_timestamp} ) || ( ! Xormon::isdigit($service_data_in->{last_conf_timestamp}) ) || ( $act_timestamp - $service_data_in->{last_conf_timestamp} > 3600 ) || ( !-f "$debug_data_configuration/config-$st_serial.out" )){
    `touch "$debug_data_configuration/config-$st_serial.out"`;
    ### login
    login();
    if (!defined $token || $token eq "" || !defined $device_id || $device_id eq "" || !defined $cookie || $cookie eq ""){
      if (defined $cfg->{node2Host}){
        if ($cfg->{node2Host} eq $api_host){
          $api_host = $cfg->{'node1Host'};
        }
        $api_host = $cfg->{'node2Host'};
        login();
        if (!defined $token || $token eq "" || !defined $device_id || $device_id eq "" || !defined $cookie || $cookie eq ""){
          $logger->error("Cookie, token or device_id is not defined") && return "error";
        }
      }
      else{
        $logger->error("Cookie, token or device_id is not defined") && return "error";
      }
    }
    ###
    ### check connection
    if (!check_connection()){
      logout();
      $logger->info("Task for ".$cfg->{hostalias}." is done. Status: error");
      return "error";
    }

    set_data_pool_conf();
    set_data_drive_conf();
    set_data_node_conf();
    set_data_filesystem_conf();
    set_data_volume_conf();
    set_data_host_conf();
    set_data_port_fc_conf();
    set_data_port_fcoe_conf();
    set_data_port_sas_conf();
    set_data_port_eth_conf();
    set_data_port_log_conf();
    set_data_device_conf();
    set_data_health_status();
    logout();
    my @types = ("pool", "volume", "host", "node", "fcport", "drive", "sasport", "fcoeport", "logport", "fs", "ethport", "device");
    foreach my $uid (keys %configuration_data){
      my $active = 0;
      foreach my $type (@types){
        if (defined $performance_data{$st_type}{$type}{$uid}){
          $active++;
          last;
        }
      }
      if ($active == 0){
        delete $configuration_data{$uid};
      }
    }
    $service_data_out->{last_conf_timestamp} = $act_timestamp;
    ($status, my $status_configuration, my $status_health) = set_architecture();
    if ($status eq "successful" && $status_configuration eq "successful" && $status_health eq "successful" ){
      my $save_data = $xormon->saveData(\%{ $service_data_out });
      my $status_save_data = get_status($save_data, "saveData");
    }
    $logger->info("Task for ".$cfg->{hostalias}." is done. Status: $status");
    return $status;
  }
  $logger->info("Task for ".$cfg->{hostalias}." is done. Status: $status");
  return $status;
}



sub set_data_health_status{
  my $data = cmd("alarm/currentalarm", "GET", 1, "alarmcurrentalarm");
  #print Dumper \$data;
  if ( !defined $data || $data eq "" || ref($data->{data}) ne "ARRAY" ) {
    return;
  }

  my $message_global = "";
  my $status_global = "ok";
  my %items;
  $items{eventID} = "event";
  $items{startTime} = "time";
  $items{name} = "name";
  $items{type} = "type";
  $items{level} = "level";
  $items{description} = "description";

  foreach my $element ( @{$data->{data}} ) {
    if ( !defined $element->{eventID} || $element->{eventID} eq "") { next; }
    my %data;
    foreach my $item (sort keys %items){
      if (defined $element->{$item}){
        if ($item eq "type"){
          $data{$items{$item}} = get_type_text($element->{$item});
        }
        elsif($item eq "level"){
          $data{$items{$item}} = get_level_text($element->{$item});
          if ($data{$items{$item}} =~ m/critical|major/){
            $status_global = "error";
            $message_global = $data{description};
          }
        }
        else{
          $data{$items{$item}} = $element->{$item};
        }
      }
      else{
        if ($item eq "level"){
          $data{$items{$item}} = "unknown";
        }
        else{
          $data{$items{$item}} = "";
        }
      }
    }
    #print Dumper \%data;
    push(@health_status,\%data);
  }

  my %vm_status = (
    "item_id" => $st_serial,
    "status" => $status_global,
    "data" => $message_global
  );
  #print "$st_serial | $status_global | $message_global\n";
  push(@health_status_global, \%vm_status);
  #my $rc = $xormon->saveStatus(\@hs);
  #my $status = get_status($rc, "health status");
  #$logger->info("Task healh status ".$cfg->{hostalias}." is done. Status: $status");
  #print Dumper \@health_status_global;
  #print Dumper \@health_status;
  return;
}

sub get_utc_time{
  my $d = shift;
  my ($date, $time) = split ("T",$d);
  if (defined $date && defined $time){
    my @t = ();
    $date =~ s/-/\//g;
    $t[0] = $date;
    $t[1] = $time;
    my ($t, $timezone) = split(/\+/,$time);
    if (defined $t){
      $t[1] = $t;
    }
    if (!defined $timezone || $timezone eq ""){
      (undef, $timezone) = split(/-/,$time);
      if (defined $timezone && $timezone ne ""){
        $timezone = "-$timezone";
      }
    }
    else{
      $timezone = "+$timezone";
    }
    if (defined $timezone && $timezone ne ""){
      $t[2] = $timezone;
    }
    #print Dumper \@t;
    return str2time( join( " ", @t ) );
  }
  return $d;
}

sub set_data_device{
  my $type = "pool";
  my $section = "device";
  my @items = ("read_io","write_io","read","write", "resp_t_r" ,"resp_t_w","io_rate", "data_rate", "resp_t","capacity_total", "capacity_used", "capacity_free", "virtual_capacity_total");
  foreach my $uid (keys %{$performance_data{$st_type}{$type}}){
    foreach my $timestamp (keys %{$performance_data{$st_type}{$type}{$uid}}){
      foreach my $item (@items){
        my $value = $performance_data{$st_type}{$type}{$uid}{$timestamp}{$item};
        my $io_rate = $performance_data{$st_type}{$type}{$uid}{$timestamp}{io_rate};
        if ($item eq "resp_t_r"){
          if (Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$timestamp}{read_io})){
            $io_rate = $performance_data{$st_type}{$type}{$uid}{$timestamp}{read_io};
          }
          else{
            undef $io_rate;
          }
        }
        if ($item eq "resp_t_w"){
          if (Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$timestamp}{write_io})){
            $io_rate = $performance_data{$st_type}{$type}{$uid}{$timestamp}{write_io};
          }
          else{
            undef $io_rate;
          }
        }
        if (Xormon::isdigit($value)){
          if ($item =~ m/resp/){
            if (defined $performance_data{$st_type}{$section} && defined $performance_data{$st_type}{$section}{$st_serial} && defined $performance_data{$st_type}{$section}{$st_serial}{$timestamp} && defined $performance_data{$st_type}{$section}{$st_serial}{$timestamp}{"numerator_$item"}){
              if (Xormon::isdigit($io_rate)){
                $performance_data{$st_type}{$section}{$st_serial}{$timestamp}{"numerator_$item"} = $performance_data{$st_type}{$section}{$st_serial}{$timestamp}{"numerator_$item"} + ($value * $io_rate);
                $performance_data{$st_type}{$section}{$st_serial}{$timestamp}{"denominator_$item"} = $performance_data{$st_type}{$section}{$st_serial}{$timestamp}{"denominator_$item"} + $io_rate;
              }
            }
            else{
              if (Xormon::isdigit($io_rate)){
                $performance_data{$st_type}{$section}{$st_serial}{$timestamp}{"numerator_$item"} = $value * $io_rate;
                $performance_data{$st_type}{$section}{$st_serial}{$timestamp}{"denominator_$item"} = $io_rate;
              }
            }
            next;
          }
          if (defined $performance_data{$st_type}{$section} && defined $performance_data{$st_type}{$section}{$st_serial} && defined $performance_data{$st_type}{$section}{$st_serial}{$timestamp} && defined $performance_data{$st_type}{$section}{$st_serial}{$timestamp}{$item}){
            $performance_data{$st_type}{$section}{$st_serial}{$timestamp}{$item} = $performance_data{$st_type}{$section}{$st_serial}{$timestamp}{$item} + $value;
          }
          else{
            $performance_data{$st_type}{$section}{$st_serial}{$timestamp}{$item} = $value;
          }
        }
      }
    }
  }
  @items = ("resp_t_r", "resp_t_w", "resp_t");
  foreach my $id (keys %{$performance_data{$st_type}{$section}}){
    foreach my $timestamp (keys %{$performance_data{$st_type}{$section}{$id}}){
      foreach my $item (@items){
        my $numerator = $performance_data{$st_type}{$section}{$id}{$timestamp}{"numerator_$item"};
        my $denominator = $performance_data{$st_type}{$section}{$id}{$timestamp}{"denominator_$item"};
        if (Xormon::isdigit($numerator) && Xormon::isdigit($denominator)){
          if ($denominator == 0){
            $performance_data{$st_type}{$section}{$id}{$timestamp}{$item} = 0;
          }
          else{
            $performance_data{$st_type}{$section}{$id}{$timestamp}{$item} = round($numerator / $denominator,3);
          }
        }
        if (defined $performance_data{$st_type}{$section}{$id}{$timestamp}{"numerator_$item"}){
          delete $performance_data{$st_type}{$section}{$id}{$timestamp}{"numerator_$item"};
        }
        if (defined $performance_data{$st_type}{$section}{$id}{$timestamp}{"denominator_$item"}){
          delete $performance_data{$st_type}{$section}{$id}{$timestamp}{"denominator_$item"};
        }
      }
    }
  }
  #print Dumper \$performance_data{$st_type}{$section};
}

sub get_status {
  my $rc = shift;
  my $task = shift;
  if ($rc eq "201" || $rc eq "200") {
    $logger->info("Task for $task ".$cfg->{hostalias}." is done. Status: successful");
    return "successful";
  } elsif ($rc eq "401") {
    $logger->error("Task for $task ".$cfg->{hostalias}." is done. Status: unauthorized");
    return "unauthorized";
  } else {
    $logger->error("Task for $task ".$cfg->{hostalias}." is done. Status: error");
    return "error";
  }
}


sub set_data_pool_conf{
  my $section = "pool";
  my $config_data          = cmd("StoragePool", "GET", 1, "StoragePool");
  my %pools;
  if ( $config_data eq "" ) {
    $config_data = cmd("storagepool", "GET", 1, "storagepool");
  }
  if ( $config_data eq "" ) { return; }
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    if ( !defined $id || !defined $type ) { next; }
    my $name = $element_id->{NAME};
    if (!defined $name){$name = $id;}
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);
    $pools{$uid} = $id;
    $configuration_data{$uid}{id} = $id;
    $configuration_data{$uid}{label} = $name;
    $configuration_data{$uid}{TYPE} = $section;
    my %capacity = get_capacity_pool($element_id);
    #print Dumper \%capacity;
    foreach my $item (keys %capacity){
      $configuration_data{$uid}{$item} = $capacity{$item};
    }
  }
  foreach my $uid (keys %configuration_data){
    if (!defined $pools{$uid}){next;}
    if (!Xormon::isdigit($configuration_data{"compression_ratio"})){
      $config_data = cmd("storagepool_data_info/$pools{$uid}", "GET", 1, "storagepool_data_info$pools{$uid}");
      if ($config_data eq ""){next;}
      my %capacity = get_capacity_pool($config_data->{data});
      foreach my $item (keys %capacity){
        $configuration_data{$uid}{$item} = $capacity{$item};
      }
    }
  }
  #print Dumper \%configuration_data;
}
sub set_data_drive_conf{
  my $section = "drive";
  my $config_data          = cmd("Disk", "GET", 1, "Disk");
  if ( $config_data eq "" ) {
    $config_data = cmd("disk", "GET", 1, "disk");
  }
  if ($config_data eq ""){return;}
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    my $health_status    = $element_id->{"HEALTHSTATUS"};
    my $running_status   = $element_id->{"RUNNINGSTATUS"};
    if ( !defined $id || !defined $type ) { next; }
    my $name = $element_id->{NAME};
    if (!defined $name){$name = $id;}
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);
    $configuration_data{$uid}{id} = $id;
    $configuration_data{$uid}{label} = $name;
    $configuration_data{$uid}{TYPE} = $section;
    my %capacity = get_capacity_section($element_id,$section);
    foreach my $item (keys %capacity){
      $configuration_data{$uid}{$item} = $capacity{$item};
    }
    if ( defined $health_status && $health_status ne "" ) {
      $health_status = get_health_status_text($health_status);
     $configuration_data{$uid}{"health_status"} = $health_status;
    }
    if ( defined $running_status && $running_status ne "" ) {
      $running_status = get_running_status_text($running_status);
      $configuration_data{$uid}{"running_status"} = $running_status;
    }
  }
  #print Dumper \%configuration_data;
}

sub set_data_filesystem_conf{
  my $section = "fs";
  my $config_data          = cmd("Filesystem", "GET", 1, "Filesystem");
  if ( $config_data eq "" ) {
    $config_data = cmd("filesystem", "GET", 1, "filesystem");
  }
  if ( $config_data eq "" ) { return; }
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    my $health_status    = $element_id->{"HEALTHSTATUS"};
    my $running_status   = $element_id->{"RUNNINGSTATUS"};
    if ( !defined $id || !defined $type ) { next; }
    my $name = $element_id->{NAME};
    if (!defined $name){$name = $id;}
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);
    $configuration_data{$uid}{id} = $id;
    $configuration_data{$uid}{label} = $name;
    $configuration_data{$uid}{TYPE} = $section;
    my %capacity = get_capacity_section($element_id,$section);
    foreach my $item (keys %capacity){
      $configuration_data{$uid}{$item} = $capacity{$item};
    }
    if ( defined $health_status && $health_status ne "" ) {
      $health_status = get_health_status_text($health_status);
     $configuration_data{$uid}{"health_status"} = $health_status;
    }
    if ( defined $running_status && $running_status ne "" ) {
      $running_status = get_running_status_text($running_status);
      $configuration_data{$uid}{"running_status"} = $running_status;
    }
    #print Dumper \$configuration_data{$uid};
  }
  #print Dumper \%configuration_data;
}

sub set_data_node_conf{
  my $section = "node";
  my %nodes_label;
  my $config_data          = cmd("Controller", "GET", 1, "Controller");
  if ( $config_data eq "" ) {
    $config_data = cmd("controller", "GET", 1, "controller");
  }
  if ( $config_data eq "" ) { return; }
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    my $health_status    = $element_id->{"HEALTHSTATUS"};
    my $running_status   = $element_id->{"RUNNINGSTATUS"};
    if ( !defined $id || !defined $type ) { next; }
    my $name = $element_id->{NAME};
    if (!defined $name){$name = $id;}
    else{
      ### check label is unique
      if (defined $nodes_label{$name}){
        $nodes_label{"ID_AS_LABEL"} = 1;
      }
      else{
        $nodes_label{$name} = $name;
      }
    }
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);
    $configuration_data{$uid}{id} = $id;
    $configuration_data{$uid}{label} = $name;
    $configuration_data{$uid}{TYPE} = $section;
    if ( defined $health_status && $health_status ne "" ) {
      $health_status = get_health_status_text($health_status);
     $configuration_data{$uid}{"health_status"} = $health_status;
    }
    if ( defined $running_status && $running_status ne "" ) {
      $running_status = get_running_status_text($running_status);
      $configuration_data{$uid}{"running_status"} = $running_status;
    }
  }
  if (defined $nodes_label{"ID_AS_LABEL"}){
    foreach my $uid (keys %configuration_data){
      if (defined $configuration_data{$uid}{TYPE} && $configuration_data{$uid}{TYPE} eq "node"){
        $configuration_data{label} = $configuration_data{$uid}{id};
      }
    }
  }
  #print Dumper \%configuration_data;
}


sub set_data_host_conf{
  my $section = "host";

  my $config_data          = cmd("Host", "GET", 1, "Host");
  if ( $config_data eq "" ) {
    $config_data = cmd("host", "GET", 1, "host");
  }
  if ( $config_data eq "" ) { return; }
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    my $health_status    = $element_id->{"HEALTHSTATUS"};
    my $running_status   = $element_id->{"RUNNINGSTATUS"};
    if ( !defined $id || !defined $type ) { next; }
    my $name = $element_id->{NAME};
    if (!defined $name){$name = $id;}
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);
    $configuration_data{$uid}{id} = $id;
    $configuration_data{$uid}{label} = $name;
    $configuration_data{$uid}{TYPE} = $section;
    if ( defined $health_status && $health_status ne "" ) {
      $health_status = get_health_status_text($health_status);
     $configuration_data{$uid}{"health_status"} = $health_status;
    }
    if ( defined $running_status && $running_status ne "" ) {
      $running_status = get_running_status_text($running_status);
      $configuration_data{$uid}{"running_status"} = $running_status;
    }
    my $cmd = "lun/associate?ASSOCIATEOBJTYPE=21&ASSOCIATEOBJID=$id";
    my $data = cmd($cmd, "GET", 1, "lunassociate?ASSOCIATEOBJTYPE=21&ASSOCIATEOBJID=$id");
    if ( $data eq "" ) {
      $cmd = "namespace/associate?ASSOCIATEOBJTYPE=21&ASSOCIATEOBJID=$id";
      $data = cmd($cmd, "GET", 1, "namespaceassociate?ASSOCIATEOBJTYPE=21&ASSOCIATEOBJID=$id");
    }
    if ($data eq ""){next;}
    foreach my $id_vol ( @{ $data->{data} } ) {
      my $id   = $id_vol->{ID};
      if (!defined $id){next;}
      my $uid_volume = Xormon::create_hash_key($st_serial."volume".$id);
      if (defined $configuration_data{$uid_volume}){
        push(@{$configuration_data{$uid}{children}},$uid_volume);
      }
    }
    #print Dumper \$configuration_data{$uid};
    #print Dumper \$data;
  }
  #print Dumper \%configuration_data;


}


sub set_data_volume_conf{
  my $section = "volume";
  my $config_data          = cmd("Lun", "GET", 1, "Lun");
  if ( $config_data eq "" ) {
    $config_data = cmd("lun", "GET", 1, "lun");
  }
  if ( $config_data eq "" ) {
    $config_data = cmd("namespace", "GET", 1, "namespace");
  }
  if ($config_data eq ""){return;}
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $health_status    = $element_id->{"HEALTHSTATUS"};
    my $running_status   = $element_id->{"RUNNINGSTATUS"};
    my $pool_name      = $element_id->{"PARENTNAME"};
    my $pool_id        = $element_id->{"PARENTID"};
    my $type           = $element_id->{"SUBTYPE"};
    my $wwn            = $element_id->{WWN};
    my $nguid          = $element_id->{NGUID};
    if ( !defined $id || !defined $type ) { next; }
    my $name = $element_id->{NAME};
    if (!defined $name){$name = $id;}
    if ((!defined $pool_name || $pool_name eq "" ) && defined $pool_id){
      $pool_name = $pool_id;
    }
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);
    $configuration_data{$uid}{id} = $id;
    $configuration_data{$uid}{label} = $name;
    $configuration_data{$uid}{TYPE} = $section;
    my %capacity = get_capacity_section($element_id,$section);
    foreach my $item (keys %capacity){
      $configuration_data{$uid}{$item} = $capacity{$item};
    }
    if ( defined $health_status && $health_status ne "" ) {
      $health_status = get_health_status_text($health_status);
     $configuration_data{$uid}{"health_status"} = $health_status;
    }
    if ( defined $running_status && $running_status ne "" ) {
      $running_status = get_running_status_text($running_status);
      $configuration_data{$uid}{"running_status"} = $running_status;
    }
    if (defined $pool_id){
      my $string = $st_serial . "pool" . $pool_id;
      my $pool_uid = Xormon::create_hash_key($string);
      if (defined $configuration_data{$pool_uid}){
        push(@{$configuration_data{$uid}{parents}},$pool_uid);
        $configuration_data{$uid}{"pool_id"} = $pool_id;
        $configuration_data{$uid}{"pool_name"} = $pool_name;
      }
    }
    if ( defined $type && $type ne "" ) {
      if ( $type eq "0" ) {
        $type = "common LUN";
      }
      if ( $type eq "1" ) {
        $type = "vVol LUN";
      }
      if ( $type eq "2" ) {
        $type = "PE LUN";
      }
      $configuration_data{$uid}{type} = $type;
    }
    if ( defined $wwn && $wwn ne "" ) {
      $configuration_data{$uid}{"wwn"} = $wwn;
      $configuration_data{$uid}{"lun_id"} = $wwn;
    }
    if ( defined $nguid && $nguid ne "" ) {
      $configuration_data{$uid}{"nguid"} = $nguid;
    }
  }
}


sub sum_metric{
  my $metric = shift;
  my $data_tmp = shift;
  my @data = @{$data_tmp};
  my $response_metric = shift;
  my $numerator = shift;
  my $sum = "";
  my $numerator_sum = "";
  my $index = 0;
  foreach my $element (@data){
    if (Xormon::isdigit($element->{$metric})){
      #if ($element->{$metric} == 0){
      #  $element->{$metric} = int(rand(300));
      #}
      if (Xormon::isdigit($sum)){
        $sum = $sum + $element->{$metric};
        $index++;
      }
      else{
        $sum = $element->{$metric};
        $index++;
      }
      if (defined $response_metric && Xormon::isdigit($element->{$response_metric})){
        #if ($element->{$response_metric} == 0){
        #  my $x = 1000 + int(rand(3000 - 1000));
        #  $element->{$response_metric} = $x;
        #}
        if (Xormon::isdigit($numerator_sum)){
          $numerator_sum = $numerator_sum + ($element->{$response_metric} * $element->{$metric});
        }
        else{
          $numerator_sum = $element->{$response_metric} * $element->{$metric};
        }
      }
    }
  }
  if ($index == 0){return ("","","");}
  return ($sum / $index, $numerator_sum, $sum);
}

sub sum_metrics{
  my $data_tmp = shift;
  my $metric1 = shift;
  my $metric2 = shift;
  my %data = %{$data_tmp};
  my $sum = "";
  if (Xormon::isdigit($data{$metric1})){
    $sum = $data{$metric1};
  }
  if (Xormon::isdigit($data{$metric2})){
    if (Xormon::isdigit($sum)){
      $sum = $sum + $data{$metric2};
    }
    else{
      $sum = $data{$metric2};
    }
  }
  return $sum;
}

sub calculate_weighted_average{
  my $data_tmp = shift;
  my $numerator_metric1 = shift;
  my $denominator_metric1 = shift;
  my $numerator_metric2 = shift;
  my $denominator_metric2 = shift;


  my %data = %{$data_tmp};

  my $sum = "";
  my $denominator = "";
  if (Xormon::isdigit($data{$denominator_metric1}) && Xormon::isdigit($data{$numerator_metric1})){
    $sum = $data{$denominator_metric1} * $data{$numerator_metric1};
    $denominator = $data{$denominator_metric1};
  }
  if (Xormon::isdigit($data{$denominator_metric2}) && Xormon::isdigit($data{$numerator_metric2})){
    if (Xormon::isdigit($sum)){
      $sum = $sum + ($data{$denominator_metric2} * $data{$numerator_metric2});
      $denominator = $denominator + $data{$denominator_metric2};
    }
    else{
      $sum = $data{$denominator_metric2} * $data{$numerator_metric2};
      $denominator = $data{$denominator_metric2};
    }
  }
  if (Xormon::isdigit($sum) && Xormon::isdigit($denominator)){
    if ($denominator == 0){
      return 0;
    }
    return $sum / $denominator;
  }
  return "";
}


sub set_data_port_fc_conf{

  my $section = "fcport";
  my $config_data          = cmd("fc_port", "GET", 1, "fc_port");
  if ($config_data eq ""){return;}
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    my $health_status    = $element_id->{"HEALTHSTATUS"};
    my $running_status   = $element_id->{"RUNNINGSTATUS"};
    my $wwn = $element_id->{"WWN"};
    my $name   = $element_id->{"LOCATION"};
    if ( !defined $id || !defined $type ) { next; }
    if (!defined $name){$name = $id;}
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);
    $configuration_data{$uid}{id} = $id;
    $configuration_data{$uid}{label} = $name;
    $configuration_data{$uid}{TYPE} = $section;
    if ( defined $health_status && $health_status ne "" ) {
      $health_status = get_health_status_text($health_status);
     $configuration_data{$uid}{"health_status"} = $health_status;
    }
    if ( defined $running_status && $running_status ne "" ) {
      $running_status = get_running_status_text($running_status);
      $configuration_data{$uid}{"running_status"} = $running_status;
    }
    if (defined $wwn && $wwn ne ""){
      $configuration_data{$uid}{"wwn"} = $wwn;
    }
  }


}
sub set_data_port_fcoe_conf{

  my $section = "fcoeport";
  my $config_data          = cmd("fcoe_port", "GET", 1, "fcoe_port");
  if ($config_data eq ""){return;}
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    my $health_status    = $element_id->{"HEALTHSTATUS"};
    my $running_status   = $element_id->{"RUNNINGSTATUS"};
    my $name   = $element_id->{"LOCATION"};
    if ( !defined $id || !defined $type ) { next; }
    if (!defined $name){$name = $id;}
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);
    $configuration_data{$uid}{id} = $id;
    $configuration_data{$uid}{label} = $name;
    $configuration_data{$uid}{TYPE} = $section;
    if ( defined $health_status && $health_status ne "" ) {
      $health_status = get_health_status_text($health_status);
     $configuration_data{$uid}{"health_status"} = $health_status;
    }
    if ( defined $running_status && $running_status ne "" ) {
      $running_status = get_running_status_text($running_status);
      $configuration_data{$uid}{"running_status"} = $running_status;
    }
  }


}
sub set_data_port_sas_conf{

  my $section = "sasport";
  my $config_data          = cmd("sas_port", "GET", 1, "sas_port");
  if ($config_data eq ""){return;}
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    my $health_status    = $element_id->{"HEALTHSTATUS"};
    my $running_status   = $element_id->{"RUNNINGSTATUS"};
    my $name   = $element_id->{"LOCATION"};
    my $wwn = $element_id->{"WWN"};
    if ( !defined $id || !defined $type ) { next; }
    if (!defined $name){$name = $id;}
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);
    $configuration_data{$uid}{id} = $id;
    $configuration_data{$uid}{label} = $name;
    $configuration_data{$uid}{TYPE} = $section;
    if ( defined $health_status && $health_status ne "" ) {
      $health_status = get_health_status_text($health_status);
     $configuration_data{$uid}{"health_status"} = $health_status;
    }
    if ( defined $running_status && $running_status ne "" ) {
      $running_status = get_running_status_text($running_status);
      $configuration_data{$uid}{"running_status"} = $running_status;
    }
    if (defined $wwn && $wwn ne ""){
      $configuration_data{$uid}{"wwn"} = $wwn;
    }
  }

}
sub set_data_port_eth_conf{

  my $section = "ethport";
  my $config_data          = cmd("eth_port", "GET", 1, "eth_port");
  if ($config_data eq ""){return;}
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    my $health_status    = $element_id->{"HEALTHSTATUS"};
    my $running_status   = $element_id->{"RUNNINGSTATUS"};
    my $name   = $element_id->{"LOCATION"};
    if ( !defined $id || !defined $type ) { next; }
    if (!defined $name){$name = $id;}
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);
    $configuration_data{$uid}{id} = $id;
    $configuration_data{$uid}{label} = $name;
    $configuration_data{$uid}{TYPE} = $section;
    if ( defined $health_status && $health_status ne "" ) {
      $health_status = get_health_status_text($health_status);
     $configuration_data{$uid}{"health_status"} = $health_status;
    }
    if ( defined $running_status && $running_status ne "" ) {
      $running_status = get_running_status_text($running_status);
      $configuration_data{$uid}{"running_status"} = $running_status;
    }
  }


}
sub set_data_port_log_conf{

  my $section = "logport";
  my $config_data          = cmd("lif", "GET", 1, "lif");
  if ($config_data eq ""){return;}
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    my $health_status    = $element_id->{"HEALTHSTATUS"};
    my $running_status   = $element_id->{"RUNNINGSTATUS"};
    my $name   = $element_id->{"LOCATION"};
    my $port_id_lif    = $element_id->{CURRENTPORTNAME};
    my $port_name_lif  = $element_id->{NAME};
    my $wwn            = $element_id->{"HOMESITEWWN"};
    if (defined $port_id_lif){
      $name       = $port_id_lif;
      if ( defined $port_name_lif ) {
        $name = $port_name_lif;
      }
    }
    if ( !defined $id || !defined $type ) { next; }
    if (!defined $name){$name = $id;}
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);
    $configuration_data{$uid}{id} = $id;
    $configuration_data{$uid}{label} = $name;
    $configuration_data{$uid}{TYPE} = $section;
    if ( defined $health_status && $health_status ne "" ) {
      $health_status = get_health_status_text($health_status);
     $configuration_data{$uid}{"health_status"} = $health_status;
    }
    if ( defined $running_status && $running_status ne "" ) {
      $running_status = get_running_status_text($running_status);
      $configuration_data{$uid}{"running_status"} = $running_status;
    }
    if (defined $wwn && $wwn ne ""){
      $configuration_data{$uid}{"wwn"} = $wwn;
    }
  }


}

sub set_data_port_fc{

  my $section     = "fcport";
  my $config_data          = cmd("fc_port", "GET", 0, "fc_port");
  if ($config_data eq ""){return;}
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    if ( !defined $id || !defined $type ) { next; }
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);

    my $cmd_perf = "performace_statistic/cur_statistic_data?CMO_STATISTIC_UUID=$type:$id&CMO_STATISTIC_DATA_ID_LIST=$performance_statistics{$section}";
    my $data = cmd($cmd_perf,"GET", 1, "$type" . "_$id");
    if ( $data eq "" ) { next; }
    $performance_data{$st_type}{$section}{$uid} = get_performance_data($data);
  }
}
sub set_data_port_link{

  my $section     = "fcport";
  my $config_data          = cmd("fc_link", "GET", 0, "fc_link");
  if ($config_data eq ""){return;}
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    my $fc_id = $element_id->{LOCALPORTID};
    if ( !defined $id || !defined $type || !defined $fc_id) { next; }
    my $uid = Xormon::create_hash_key($st_serial.$section.$fc_id);

    my $cmd_perf = "performace_statistic/cur_statistic_data?CMO_STATISTIC_UUID=$type:$id&CMO_STATISTIC_DATA_ID_LIST=$performance_statistics{$section}";
    my $data = cmd($cmd_perf,"GET", 1, "$type" . "_$id");
    if ( $data eq "" ) { next; }
    if (defined $performance_data{$st_type}{$section}{$uid} && sum_all_metrics($performance_data{$st_type}{$section}{$uid}) == 0){
      delete $performance_data{$st_type}{$section}{$uid};
      $performance_data{$st_type}{$section}{$uid} = get_performance_data($data);
    }
  }
  #print Dumper \$performance_data{$st_type}{$section};
}

sub sum_all_metrics {

  my $data_tmp = shift;
  my %data     = %{$data_tmp};
  my $sum      = 0;
  foreach my $item ( keys %data ) {
    if ( Xormon::isdigit( $data{$item} ) ) {
      $sum = $sum + $data{$item};
    }
  }
  return $sum;
}

sub set_data_port_fcoe{

  my $section     = "fcoeport";
  my $config_data          = cmd("fcoe_port", "GET", 0, "fcoe_port");
  if ($config_data eq ""){return;}
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    if ( !defined $id || !defined $type ) { next; }
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);

    my $cmd_perf = "performace_statistic/cur_statistic_data?CMO_STATISTIC_UUID=$type:$id&CMO_STATISTIC_DATA_ID_LIST=$performance_statistics{$section}";
    my $data = cmd($cmd_perf,"GET", 1, "$type" . "_$id");
    if ( $data eq "" ) { next; }
    $performance_data{$st_type}{$section}{$uid} = get_performance_data($data);
  }
}
sub set_data_port_sas{

  my $section     = "sasport";
  my $config_data          = cmd("sas_port", "GET", 0, "sas_port");
  if ($config_data eq ""){return;}
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    if ( !defined $id || !defined $type ) { next; }
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);

    my $cmd_perf = "performace_statistic/cur_statistic_data?CMO_STATISTIC_UUID=$type:$id&CMO_STATISTIC_DATA_ID_LIST=$performance_statistics{$section}";
    my $data = cmd($cmd_perf,"GET", 1, "$type" . "_$id");
    if ( $data eq "" ) { next; }
    #print Dumper \$data;
    $performance_data{$st_type}{$section}{$uid} = get_performance_data($data);
  }
}
sub set_data_port_eth{

  my $section     = "ethport";
  my $config_data          = cmd("eth_port", "GET", 0, "eth_port");
  if ($config_data eq ""){return;}
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    if ( !defined $id || !defined $type ) { next; }
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);
    my $cmd_perf = "performace_statistic/cur_statistic_data?CMO_STATISTIC_UUID=$type:$id&CMO_STATISTIC_DATA_ID_LIST=$performance_statistics{$section}";
    my $data = cmd($cmd_perf,"GET", 1, "$type" . "_$id");
    if ( $data eq "" ) { next; }
    $performance_data{$st_type}{$section}{$uid} = get_performance_data($data);
  }
  #print Dumper \$performance_data{$st_type}{$section};
}
sub set_data_port_log{

  my $section     = "logport";
  my $config_data          = cmd("lif", "GET", 0, "lif");
  if ($config_data eq ""){return;}
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    if ( !defined $id || !defined $type ) { next; }
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);

    my $cmd_perf = "performace_statistic/cur_statistic_data?CMO_STATISTIC_UUID=$type:$id&CMO_STATISTIC_DATA_ID_LIST=$performance_statistics{$section}";
    my $data = cmd($cmd_perf,"GET", 1, "$type" . "_$id");
    if ( $data eq "" ) { next; }
    $performance_data{$st_type}{$section}{$uid} = get_performance_data($data);
  }
  #print Dumper \$performance_data{$st_type}{$section};

}


sub set_data_pool {
  my $section     = "pool";
  my $config_data          = cmd("StoragePool", "GET", 0, "StoragePool");
  my %pools;
  if ( $config_data eq "" ) {
    $config_data = cmd("storagepool", "GET", 0, "storagepool");
  }
  if ( $config_data eq "" ) { return; }
  my $cmd_perf_test = 1;
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    if ( !defined $id || !defined $type ) { next; }
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);
    $pools{$uid} = $id;

    my $cmd_perf = "performace_statistic/cur_statistic_data?CMO_STATISTIC_UUID=$type:$id&CMO_STATISTIC_DATA_ID_LIST=$performance_statistics{$section}";
    if ($cmd_perf_test == 0){
      $cmd_perf = "performace_statistic/cur_statistic_data?CMO_STATISTIC_UUID=$type:$id&CMO_STATISTIC_DATA_ID_LIST=22,25,28,370,384,385,23,26";
    }
    my $data = cmd($cmd_perf,"GET", 1, "$type" . "_$id");
    if ( $data eq "" ) {
      $cmd_perf = "performace_statistic/cur_statistic_data?CMO_STATISTIC_UUID=$type:$id&CMO_STATISTIC_DATA_ID_LIST=22,25,28,370,384,385,23,26";
      $data = cmd($cmd_perf,"GET", 1, "$type" . "_$id");
      if ($data ne ""){
        $cmd_perf_test = 0;
      }
    } 
    if ( $data eq "" ) { 
      next; 
    }
    $performance_data{$st_type}{$section}{$uid} = get_performance_data($data,$section);
    #print Dumper \$performance_data{$st_type}{$section}{$uid};
    my $timestamp = (keys %{$performance_data{$st_type}{$section}{$uid}})[0];
    if (Xormon::isdigit($timestamp)){
      my %capacity = get_capacity_pool($element_id);
      foreach my $item (keys %capacity){
        $performance_data{$st_type}{$section}{$uid}{$timestamp}{$item} = $capacity{$item};
      }
    }
  }
  foreach my $uid (keys %{$performance_data{$st_type}{$section}}){
    foreach my $timestamp (keys %{$performance_data{$st_type}{$section}{$uid}}){
      if (!Xormon::isdigit($performance_data{$st_type}{$section}{$uid}{$timestamp}{"compression_ratio"})){
        $config_data = cmd("storagepool_data_info/$pools{$uid}", "GET", 0, "storagepool_data_info$pools{$uid}");
        if ($config_data eq ""){next;}
        my %capacity = get_capacity_pool($config_data->{data});
        foreach my $item (keys %capacity){
          $performance_data{$st_type}{$section}{$uid}{$timestamp}{$item} = $capacity{$item};
        }
        #print Dumper \$config_data;
      }
    }
  }
  #print Dumper \$performance_data{$st_type}{$section};
}

sub set_data_host {
  my $section     = "host";
  my $config_data          = cmd("Host", "GET", 0, "Host");
  if ( $config_data eq "" ) { return; }
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    if ( !defined $id || !defined $type ) { next; }
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);

    my $cmd_perf = "performace_statistic/cur_statistic_data?CMO_STATISTIC_UUID=$type:$id&CMO_STATISTIC_DATA_ID_LIST=$performance_statistics{$section}";
    my $data = cmd($cmd_perf,"GET", 1, "$type" . "_$id");
    if ( $data eq "" ) { next; }
    $performance_data{$st_type}{$section}{$uid} = get_performance_data($data);
  }
  #print Dumper \$performance_data{$st_type}{$section};
}
sub set_data_filesystem {
  my $section     = "fs";
  my $config_data          = cmd("Filesystem", "GET", 0, "Filesystem");
  if ( $config_data eq "" ) {
    $config_data = cmd("filesystem", "GET", 0, "filesystem");
  }
  if ( $config_data eq "" ) { return; }
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    if ( !defined $id || !defined $type ) { next; }
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);

    my $cmd_perf = "performace_statistic/cur_statistic_data?CMO_STATISTIC_UUID=$type:$id&CMO_STATISTIC_DATA_ID_LIST=$performance_statistics{$section}";
    my $data = cmd($cmd_perf,"GET", 1, "$type" . "_$id");
    #print Dumper \$data;
    if ( $data eq "" ) { next; }
    $performance_data{$st_type}{$section}{$uid} = get_performance_data($data);
    my $timestamp = (keys %{$performance_data{$st_type}{$section}{$uid}})[0];
    if (Xormon::isdigit($timestamp)){
      my %capacity = get_capacity_section($element_id,$section);
      foreach my $item (keys %capacity){
        $performance_data{$st_type}{$section}{$uid}{$timestamp}{$item} = $capacity{$item};
      }
    }
  }
  #print Dumper \$performance_data{$st_type}{$section};
}

sub set_data_drive {
  my $section     = "drive";
  my $config_data          = cmd("Disk", "GET", 0, "Disk");
  if ( $config_data eq "" ) {
    $config_data = cmd("disk", "GET", 0, "disk");
  }
  if ( $config_data eq "" ) { return; }
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    if ( !defined $id || !defined $type ) { next; }
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);

    my $cmd_perf = "performace_statistic/cur_statistic_data?CMO_STATISTIC_UUID=$type:$id&CMO_STATISTIC_DATA_ID_LIST=$performance_statistics{$section}";
    my $data = cmd($cmd_perf,"GET", 1, "$type" . "_$id");
    if ( $data eq "" ) { next; }
    $performance_data{$st_type}{$section}{$uid} = get_performance_data($data);
    my $timestamp = (keys %{$performance_data{$st_type}{$section}{$uid}})[0];
    if (Xormon::isdigit($timestamp)){
      my %capacity = get_capacity_section($element_id,$section);
      foreach my $item (keys %capacity){
        $performance_data{$st_type}{$section}{$uid}{$timestamp}{$item} = $capacity{$item};
      }
    }
  }
  #print Dumper \$performance_data{$st_type}{$section};
}
sub set_data_volume {
  my $section     = "volume";
  my $config_data          = cmd("Lun", "GET", 0, "Lun");
  if ( $config_data eq "" ) {
    $config_data = cmd("lun", "GET", 0, "lun");
  }
  if ( $config_data eq "" ) {
    $config_data = cmd("namespace", "GET", 1, "namespace");
  }
  if ($config_data eq ""){return;}
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    if ( !defined $id || !defined $type ) { next; }
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);
    my $cmd_perf = "performace_statistic/cur_statistic_data?CMO_STATISTIC_UUID=$type:$id&CMO_STATISTIC_DATA_ID_LIST=$performance_statistics{$section}";
    my $data = cmd($cmd_perf,"GET", 1, "$type" . "_$id");
    if ( $data eq "" ) { next; }
    $performance_data{$st_type}{$section}{$uid} = get_performance_data($data);
    my $timestamp = (keys %{$performance_data{$st_type}{$section}{$uid}})[0];
    if (Xormon::isdigit($timestamp)){
      my %capacity = get_capacity_section($element_id,$section);
      foreach my $item (keys %capacity){
        $performance_data{$st_type}{$section}{$uid}{$timestamp}{$item} = $capacity{$item};
      }
    }
  }
  #print Dumper \$performance_data{$st_type}{$section};
}

sub set_data_node {
  my $section     = "node";
  my $config_data          = cmd("Controller", "GET", 0, "Controller");
  if ( $config_data eq "" ) {
    $config_data = cmd("controller", "GET", 0, "controller");
  }
  my $enclosure_data = cmd("enclosure", "GET", 0, "enclosure");
  my %temperatures;
  if ( $config_data eq "" ) { return; }
  foreach my $element_id ( @{ $config_data->{data} } ) {
    my $id  = $element_id->{ID};
    my $type = $element_id->{TYPE};
    my $localtion = $element_id->{LOCATION};
    if ( !defined $id || !defined $type ) { next; }
    my $uid = Xormon::create_hash_key($st_serial.$section.$id);
    #print "$st_serial | $section | $id | $uid\n";

    my $cmd_perf = "performace_statistic/cur_statistic_data?CMO_STATISTIC_UUID=$type:$id&CMO_STATISTIC_DATA_ID_LIST=$performance_statistics{$section}";
    my $data = cmd($cmd_perf,"GET", 1, "$type" . "_$id");
    if ( $data eq "" ) { next; }
    $performance_data{$st_type}{$section}{$uid} = get_performance_data($data);
    my $timestamp = (keys %{$performance_data{$st_type}{$section}{$uid}})[0];
    if (Xormon::isdigit($timestamp) && defined $localtion){
      $performance_data{$st_type}{$section}{$uid}{$timestamp}{location} = $localtion;
    }
  }
  #print Dumper \$enclosure_data;
  if ( $enclosure_data ne "" && defined $enclosure_data->{data} && ref( $enclosure_data->{data} ) eq "ARRAY" ) {
    foreach my $enclosure_id ( @{ $enclosure_data->{data} } ) {
      if ( defined $enclosure_id->{LOGICTYPE} && $enclosure_id->{LOGICTYPE} eq "1" && defined $enclosure_id->{NAME} && defined $enclosure_id->{TEMPERATURE} ) {
        $temperatures{ $enclosure_id->{NAME} } = $enclosure_id->{TEMPERATURE};
      }
    }
  }
  foreach my $uid (keys %{$performance_data{$st_type}{$section}}){
    foreach my $t ( keys %{$performance_data{$st_type}{$section}{$uid}}) {
      my $location = $performance_data{$st_type}{$section}{$uid}{$t}{location};
      if ( defined $location ) {
        chop $location;
        chop $location;
        if ( defined $temperatures{$location} && Xormon::isdigit( $temperatures{$location}) ) {
          $performance_data{$st_type}{$section}{$uid}{$t}{temperature} = $temperatures{$location};
        }
        delete $performance_data{$st_type}{$section}{$uid}{$t}{location};
      }
    }
  }
  # NAS section
  my @sections = ( "ControllerNFSV3", "ControllerSMBV2", "ControllerNFSV41" );
  foreach my $s (@sections) {
    my $config_data = cmd($s, "GET", 0, $s);
    if ($config_data eq ""){next;}
    foreach my $element_id ( @{ $config_data->{data} } ) {
      my $id   = $element_id->{ID};
      my $type = $element_id->{TYPE};
      if ( !defined $id || !defined $type ) { next; }
      my $uid = Xormon::create_hash_key($st_serial.$section.$id);
      #print "$st_serial | $section | $id | $uid -> nas statistiky\n";

      my $cmd_perf = "performace_statistic/cur_statistic_data?CMO_STATISTIC_UUID=$type:$id&CMO_STATISTIC_DATA_ID_LIST=$performance_statistics{$s}";
      my $data = cmd($cmd_perf,"GET", 1, "$type" . "_$id");
      if ( $data eq "" || ref( $data->{data} ) ne "ARRAY" ) { next; }
      my %datas = %{get_performance_data($data,$s)};
      if (defined $performance_data{$st_type}{$section}{$uid}){
        my $timestamp = (keys %{$performance_data{$st_type}{$section}{$uid}})[0];
        foreach my $t (keys %datas){
          foreach my $item (keys %{$datas{$t}}){
            $performance_data{$st_type}{$section}{$uid}{$timestamp}{$item} = $datas{$t}{$item};
          }
        }
      }
    }
  }
  #print Dumper \$performance_data{$st_type}{$section};
}

sub get_performance_data{
  my $data = shift;
  my $section = shift;
  my %data_out;
  if (defined $section && $section =~ m/Controller/){
    $section =~ s/Controller//g;
    $section         = lc($section);
  }
  if (!defined $data || $data eq "" || ref($data->{data}) ne "ARRAY"){return \%data_out;}
  foreach my $element ( @{ $data->{data} } ) {
    if ( !defined $element->{CMO_STATISTIC_DATA_LIST} || !defined $element->{CMO_STATISTIC_DATA_ID_LIST} || !defined $element->{CMO_STATISTIC_TIMESTAMP} ) { next; }
    my @statistics    = split( ",", $element->{CMO_STATISTIC_DATA_LIST} );
    my @statistics_id = split( ",", $element->{CMO_STATISTIC_DATA_ID_LIST} );
    my $timestamp     = $element->{CMO_STATISTIC_TIMESTAMP};
    if (!$enviroment){
      $timestamp = $timestamp_global;
    }
    my $index = -1;
    foreach my $statistic (@statistics_id) {
      $index++;
      if (defined $section && $section =~ m/nfs|smb/){
        $statistic = $section . "_" . $statistic;
      }
      if (!defined $metric_inventory{$statistic} ){
        next;
      }
      if ( $statistic =~ m/^523$|^524$|^525$/ && defined $section && $section eq "pool") {
        my $metric = "ops_resp_t_w";
          if ( $statistic eq "523" ) {
            $metric = "ops_resp_t";
          }
          elsif ( $statistic eq "524" ) {
            $metric = "ops_resp_t_r";
          }
          $data_out{$timestamp}{$metric} = round( $statistics[$index] / 1000 );    ### micro to mili
          next;
      }
      if ( $metric_inventory{$statistic} eq "read" || $metric_inventory{$statistic} eq "write" ) {
        $data_out{$timestamp}{ $metric_inventory{$statistic} } = $statistics[$index] * (1000 * 1000);
        next;
      }
      if ( $metric_inventory{$statistic} =~ m/resp_t/ ) {
        $data_out{$timestamp}{ $metric_inventory{$statistic} } = round( $statistics[$index] / 1000 );    ### micro to mili
      }
      else {
        $data_out{$timestamp}{ $metric_inventory{$statistic} } = $statistics[$index];
      }
    }
  }
  foreach my $t (keys %data_out){
    my $data_rate = "";
    if (Xormon::isdigit($data_out{$t}{read})){
      $data_rate = $data_out{$t}{read};
    }
    if (Xormon::isdigit($data_out{$t}{write})){
      if (Xormon::isdigit($data_rate)){
        $data_rate += $data_out{$t}{write};
      }
      else{
        $data_rate = $data_out{$t}{write};
      }
    }
    if (Xormon::isdigit($data_rate)){
      $data_out{$t}{data_rate} = $data_rate;
    }
  }
  return \%data_out;
}

sub get_capacity_section{
  my $data = shift;
  my $section = shift;
  my %data_out;

  if ($section eq "volume"){
    my $cap        = $data->{"CAPACITY"};
    my $used_cap   = $data->{"ALLOCCAPACITY"};
    my $block_size = $data->{"SECTORSIZE"};
    if ( !Xormon::isdigit($block_size) ) {
        $block_size = 512;    ### default
    }
    if (Xormon::isdigit($cap) && Xormon::isdigit($used_cap) && $cap < $used_cap ) {
      $used_cap = $cap;
    }
    if (Xormon::isdigit($cap) && Xormon::isdigit($block_size)){
      $data_out{capacity_total} = $cap * $block_size;
    }
    if (Xormon::isdigit($used_cap) && Xormon::isdigit($block_size)){
      $data_out{capacity_used} = $used_cap * $block_size;
    }
    if (Xormon::isdigit($cap) && Xormon::isdigit($block_size) && Xormon::isdigit($used_cap) && Xormon::isdigit($block_size)){
      $data_out{capacity_free} = ($cap * $block_size) - ($used_cap * $block_size);
    }
  }
  if ($section eq "drive"){
    my $count_sectors    = $data->{"SECTORS"};
    my $size_sector      = $data->{"SECTORSIZE"};
    my $used_cap_percent = $data->{"CAPACITYUSAGE"};
    if ( Xormon::isdigit($size_sector) && Xormon::isdigit($count_sectors) ) {
      my $pom = ( $size_sector * $count_sectors );    ## in B
      my $cap = round( $pom, 0 );
      if ( Xormon::isdigit($used_cap_percent) ) {
        my $pom      = ( $used_cap_percent / 100 ) * $cap;
        my $used_cap = round( $pom,             0 );
        my $free_cap = round( $cap - $used_cap, 0 );
        $data_out{capacity_total} = $cap;
        $data_out{capacity_used} = $used_cap;
        $data_out{capacity_free}= $free_cap;
      }
    }
  }
  if ($section eq "fs"){
    my $sector_size  = 512;                                 ## default 512 bytes
    my $cap          = $data->{"CAPACITY"};
    my $used_cap     = $data->{"ALLOCCAPACITY"};
    my $free_cap  = "";
    #my $free_cap     = $data->{"AVAILABLECAPCITY"};
    my $allocated_used = $data->{"allocatedPoolQuota"};
    if ( Xormon::isdigit($allocated_used) ) {
      $used_cap = $allocated_used;
    }
    if ( Xormon::isdigit($cap) && Xormon::isdigit($used_cap) && $cap >= $used_cap ) {
      $free_cap = $cap - $used_cap;
    }
    if (Xormon::isdigit($cap)){
      $data_out{capacity_total} = $cap * $sector_size;
    }
    if (Xormon::isdigit($used_cap)){
      $data_out{capacity_used} = $used_cap * $sector_size;
    }
    if (Xormon::isdigit($free_cap)){
      $data_out{capacity_free} = $free_cap * $sector_size;
    }
  }
  return %data_out;
}

sub get_capacity_pool{
  my $data = shift;
  my %data_out;
  my %convert;
  my %ratio_items;
  $convert{USERTOTALCAPACITY} = "capacity_total";
  $convert{USERCONSUMEDCAPACITY} = "capacity_used";
  $convert{USERFREECAPACITY} = "capacity_free";
  $convert{TIER0CAPACITY} = "tier0_capacity_total";
  $convert{TIER1CAPACITY} = "tier1_capacity_total";
  $convert{TIER2CAPACITY} = "tier2_capacity_total";
  $convert{LUNCONFIGEDCAPACITY} = "lun_configured_capacity_total";
  $convert{TOTALFSCAPACITY} = "fs_capacity_total";
  $convert{RESERVEDCAPACITY} = "reserved_capacity_used";
  $convert{REPLICATIONCAPACITY} = "replication_capacity_used";
  $convert{DATASPACE} = "capacity_available";
  $convert{compressedCapacity} = "compression_saving";
  $convert{COMPRESSEDCAPACITY} = "compression_saving";
  $convert{compressRatio} = "compress_ratio";
  $convert{dedupedCapacity} = "dedupe_saving";
  $convert{dedupCompressRatio} = "dedupe_compress_ratio";
  $convert{dedupRatio} = "dedupe_ratio";
  $convert{reductionInvolvedCapacity} = "reduction_involved_capacity_total";
  $convert{DEDUPEDCAPACITY} = "dedupe_saving";
  $convert{REDUCTIONINVOLVEDCAPACITY} = "reduction_involved_capacity_total";
  $convert{SPACEREDUCTIONRATE} = "data_reduction_ratio";
  $ratio_items{compressRatio} = "COMPRESSIONRATE";
  $ratio_items{dedupRatio} = "DEDUPLICATIONRATE";
  $ratio_items{SPACEREDUCTIONRATE} = "SPACEREDUCTIONRATE";




  #print Dumper \$data;
  foreach my $raw_item (keys %convert){
    if (Xormon::isdigit($data->{$raw_item})){
      my $multiple = 512;
      if ($raw_item =~ m/ratio/i){
        $multiple = 1;
      }
      $data_out{$convert{$raw_item}} = $multiple * $data->{$raw_item};
    }
    else{
      if (defined $ratio_items{$raw_item} && defined $data->{$ratio_items{$raw_item}}){
        my $data_new;
        eval { $data_new = decode_json( $data->{$ratio_items{$raw_item}} ); };
        if ( !$@ ) {
          if ( Xormon::isdigit( $data_new->{numerator} ) && Xormon::isdigit( $data_new->{denominator} ) ) {
            $data_out{$convert{$raw_item}} = round( $data_new->{numerator} / $data_new->{denominator}, 2 );
          }
        }
      }
    }
  }
  my $virtual_capacity_total = "";
  if (Xormon::isdigit($data_out{"fs_capacity_total"})){
    $virtual_capacity_total = $data_out{"fs_capacity_total"};
  }
  if (Xormon::isdigit($data_out{"lun_configured_capacity_total"})){
    if (Xormon::isdigit($virtual_capacity_total)){
      $virtual_capacity_total += $data_out{"lun_configured_capacity_total"};
    }
    else{
      $virtual_capacity_total = $data_out{"lun_configured_capacity_total"};
    }
  }
  if (Xormon::isdigit($virtual_capacity_total)){
    $data_out{"virtual_capacity_total"} = $virtual_capacity_total;
  }
  ### add oversubscription metrics
  if (Xormon::isdigit($data_out{"virtual_capacity_total"}) && $data_out{"capacity_total"}){
    $data_out{"capacity_oversubscr"} = $data_out{"virtual_capacity_total"} - $data_out{"capacity_total"};
    if ($data_out{"capacity_oversubscr"} < 0){$data_out{"capacity_oversubscr"} = 0; $data_out{"capacity_oversubscr_percent"} = 0;}
    elsif ($data_out{"capacity_total"} != 0){
      $data_out{"capacity_oversubscr_percent"} = round(($data_out{"virtual_capacity_total"} / $data_out{"capacity_total"}) * 100,0);
    }
    #print Dumper \%data_out;
  }
  ###
  return %data_out;
}

sub convert_data{
  #$performance_data{$st_type}{$section}{$uid}{$time}{capacity_used} = $capacity_used;
  my $section = shift;
  my $data_tmp = shift;
  my $type = shift;
  my %data = %{$data_tmp};
  foreach my $name (keys %data){
    if (!defined $data{$name}{id} || $data{$name}{id} eq "" || ($type eq "perf" && (!defined $data{$name}{time} || $data{$name}{time} eq "" ))){next;}
    my $uid = $data{$name}{id};
    my $time = "";
    if ($section eq "host" || $section eq "host_group" || $section eq "pool" || $section eq "pod"){
      $uid = Xormon::create_hash_key($st_serial.$section.$uid);
    }
    #if ($section eq "pool"){
    #  if (!defined $data{$name}{name} || $data{$name}{name} eq ""){next;}
      #print "$uid " . Xormon::create_hash_key($st_serial.$section.$uid) . "\n";
    #  $uid = Xormon::create_hash_key($st_serial.$section.$uid);
      #print "$uid\n";

    #}
    if ($type eq "perf"){
      $time = str2time($data{$name}{time});
    }
    foreach my $metric (keys %{$data{$name}}){
      my $rounded = 0;
      if ($metric =~ m/id|time|name/ && $type eq "perf"){next;}
      if ($metric =~ m/resp/){
        $rounded = 3;
      }
      if ($metric =~ m/reduction/){
        $rounded = 1;
      }
      if ($type eq "conf"){
        if (!defined $configuration_data{$uid}{label}){
          $configuration_data{$uid}{label} = $name;
        }
        if ($section eq "pool" && defined $data{$name}{name}){
          $configuration_data{$uid}{label} = $data{$name}{name};
        }
        if (Xormon::isdigit($data{$name}{$metric})){
          $configuration_data{$uid}{$metric} = round($data{$name}{$metric},$rounded);
        }
        else{
          $configuration_data{$uid}{$metric} = $data{$name}{$metric};
        }
        $configuration_data{$uid}{TYPE} = $section;
      }
      else{
        if (!Xormon::isdigit($data{$name}{$metric})){next;}
        $performance_data{$st_type}{$section}{$uid}{$time}{$metric} = round($data{$name}{$metric},$rounded);
      }
    }
  }
}

sub delete_empty_metrics{
  my $first_time = "";
  foreach my $type (keys %{$performance_data{$st_type}}){
    foreach my $uid (keys %{$performance_data{$st_type}{$type}}){
      foreach my $time (keys %{$performance_data{$st_type}{$type}{$uid}}){
        if ($first_time eq "" && Xormon::isdigit($time)){
          $first_time = $time;
        }
        if (Xormon::isdigit($first_time) && Xormon::isdigit($time) && $time < $first_time){
          $first_time = $time;
        }
        foreach my $item (keys %{$performance_data{$st_type}{$type}{$uid}{$time}}){
          if (!Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{$item}) || $performance_data{$st_type}{$type}{$uid}{$time}{$item} < 0){
            delete $performance_data{$st_type}{$type}{$uid}{$time}{$item};
          }
          if ($item =~ m/numerator|denominator/){
            delete $performance_data{$st_type}{$type}{$uid}{$time}{$item};
          }
        }
      }
      if (!keys %{$performance_data{$st_type}{$type}{$uid}}){
        delete $performance_data{$st_type}{$type}{$uid};
        ### poznamka
      }
    }
  }
  if (Xormon::isdigit($first_time)){
    $service_data_out->{last_perf_timestamp} = $first_time;
  }
  else{
    if (Xormon::isdigit($service_data_in->{last_perf_timestamp})){
      $service_data_out->{last_perf_timestamp} = $service_data_in->{last_perf_timestamp};
    }
  }
}

sub calculate_missing_metrics{

  my $item_total = "capacity_total";
  my $item_used = "capacity_used";
  my $item_used_percent = "capacity_used_percent";

  foreach my $type (keys %{$performance_data{$st_type}}){
    foreach my $uid (keys %{$performance_data{$st_type}{$type}}){
      foreach my $time (keys %{$performance_data{$st_type}{$type}{$uid}}){
        #capacity_used_percent
        if (Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{$item_total}) && Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{$item_used})){
          if ($performance_data{$st_type}{$type}{$uid}{$time}{$item_total} == 0){
            $performance_data{$st_type}{$type}{$uid}{$time}{$item_used_percent} = 0;
          }
          else{
            my $pom = ($performance_data{$st_type}{$type}{$uid}{$time}{$item_used} / $performance_data{$st_type}{$type}{$uid}{$time}{$item_total}) * 100;
            $performance_data{$st_type}{$type}{$uid}{$time}{$item_used_percent} = round($pom,2);
          }
        }
        if (Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{data_rate}) && Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{io_rate}) && $performance_data{$st_type}{$type}{$uid}{$time}{io_rate} > 0){
          my $block_size = round($performance_data{$st_type}{$type}{$uid}{$time}{data_rate} / $performance_data{$st_type}{$type}{$uid}{$time}{io_rate},0);
          $performance_data{$st_type}{$type}{$uid}{$time}{block_size} = $block_size;
        }
        if (Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{io_rate}) && Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{io_rate}) == 0){
          $performance_data{$st_type}{$type}{$uid}{$time}{block_size} = 0;
        }
        if (Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{read}) && Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{read_io}) && $performance_data{$st_type}{$type}{$uid}{$time}{read_io} > 0){
          my $block_size = round($performance_data{$st_type}{$type}{$uid}{$time}{read} / $performance_data{$st_type}{$type}{$uid}{$time}{read_io},0);
          $performance_data{$st_type}{$type}{$uid}{$time}{block_size_r} = $block_size;
        }
        if (Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{read_io}) && Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{read_io}) == 0){
          $performance_data{$st_type}{$type}{$uid}{$time}{block_size_r} = 0;
        }
        if (Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{write}) && Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{write_io}) && $performance_data{$st_type}{$type}{$uid}{$time}{write_io} > 0){
          my $block_size = round($performance_data{$st_type}{$type}{$uid}{$time}{write} / $performance_data{$st_type}{$type}{$uid}{$time}{write_io},0);
          $performance_data{$st_type}{$type}{$uid}{$time}{block_size_w} = $block_size;
        }
        if (Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{write_io}) && Xormon::isdigit($performance_data{$st_type}{$type}{$uid}{$time}{write_io}) == 0){
          $performance_data{$st_type}{$type}{$uid}{$time}{block_size_w} = 0;
        }
      }
    }
  }
}

sub logout{
  my $cmd = "sessions";
  cmd($cmd,"DELETE",1,"close_session");
}

sub login{
  my $cmd =  "xxxxx/sessions";
  my %hash_filter;
  $hash_filter{"username"} = $cfg->{apiUsername};
  $hash_filter{"password"} = $cfg->{apiPassword};
  $hash_filter{"scope"}    = "0";
  my $json_body = encode_json( \%hash_filter );
  my $data = cmd($cmd, "POST", 1, "sessions", $json_body);
  if ($data eq ""){return;}
  if (defined $data->{data}->{deviceid}){
    $device_id = $data->{data}->{deviceid};
  }
  if (defined $data->{data}->{iBaseToken}){
    $token     = $data->{data}->{iBaseToken};
  }
}

sub cmd{
  my $cmd = shift;
  my $type = shift;
  my $execute = shift;
  my $debug_file = shift;
  my $json_body = shift;
  if (!defined $type || $type eq ""){$type = "GET";}
  if (!defined $execute || $execute eq ""){
    $execute = 1;
  }
  ### debug
  if (!$enviroment){
    $execute = 0;
  }
  if (!defined $debug_file){$debug_file = "";}
  if ($execute == 0 && -f "$debug_data_configuration/$debug_file.json"){
    if ($cmd =~ m/sessions/ && !$enviroment){
      $cookie = "123456789";
    }
    return Xormon::read_json("$debug_data_configuration/$debug_file.json");
  }
  elsif(-f "$debug_data/$debug_file.json" && $execute == 0){
    return Xormon::read_json("$debug_data/$debug_file.json");
  }
  elsif ($debug_file eq "close_session" && !$enviroment){return;}

  my $url = "https://$api_host:$port/deviceManager/rest/$device_id/$cmd";
  if ($cmd =~ m/xxxxx/){
    $url = "https://$api_host:$port/deviceManager/rest/$cmd";
  }
  my $ua  = LWP::UserAgent->new( ssl_opts => { SSL_cipher_list => 'DEFAULT:!DH', verify_hostname => 0, SSL_verify_mode => 0 } );
  my $req = HTTP::Request->new( $type => $url );
  $req->header( 'Content-Type' => 'application/json' );
  $req->header( 'Accept'       => 'application/json' );
  $req->header( 'Connection'   => 'keep-alive' );
  $req->header( 'Accept-Language' => 'en' );
  if (defined $json_body && $json_body ne ""){
    $req->content($json_body);
  }
  if (defined $cookie && $cookie ne ""){
    $req->header( 'cookie' => $cookie );
  }
  if (defined $token && $token ne ""){
    $req->header( 'iBaseToken'   => $token );
  }
  my $res = $ua->request($req);
  #print $res->content;
  if ( ! $res->is_success ) {
    if (!$connection_test){
      $logger->error("API command $cmd failed");
    }
    else{
      push(@rows_api_test,"API command $cmd failed\n");
      push(@rows_api_test,$res->content . "\n");
      push(@rows_api_test_data,"API command $cmd failed\n");
      push(@rows_api_test_data,$res->content . "\n");
    }
    my $out = $res->content;
    $logger->error($out);
    return "";
  }
  if ($cmd =~ m/xxxxx/){
    $cookie    = $res->headers->{"set-cookie"};
  }
  my $data = decode_json( $res->content );
  if (defined $debug_file && $debug_file ne ""){
    if ($debug_file =~ m/_/){
      eval {Xormon::save_as_json("$debug_data/$debug_file.json",$data);};
    }
    else{
      eval {Xormon::save_as_json("$debug_data_configuration/$debug_file.json",$data);};
    }
    if ($@){
      $logger->error("Save data to file $debug_data/$debug_file.json failed");
    }
  }
  if (!defined $data->{data}){
    print Dumper \$data;
  }
  if ((defined $data->{data} && ref($data->{data}) eq "HASH" && defined $data->{error}->{code} && $data->{error}->{code} ne "0") || ( defined $data->{data} && ref( $data->{data} ) ne "ARRAY" && defined $data->{error}->{code} && $data->{error}->{code} ne "0")){
    my $error_description = $data->{error}->{description};
    my $error_code        = $data->{error}->{code};
    if ( defined $error_code && $error_code eq "83890432" ) {
      return $error_code;
    }
    if (!$connection_test){
      $logger->error("No data found for cmd $cmd  description : $error_description error_code : $error_code");
    }
    else{
      push(@rows_api_test,"No data found for cmd $cmd  description : $error_description error_code : $error_code\n");
      push(@rows_api_test_data,"No data found cmd $cmd  description : $error_description error_code : $error_code\n");
    }
    return "";
  }
  return $data;
}

sub set_architecture{

  my %device_arch = (
    "item_id" => $cfg->{'uuid'},
    "label" => $cfg->{'hostalias'},
    "hw_type" => $st_type,
    "subsystem" => "device",
    "parents" => [],
    "hostcfg_id" => $cfg->{'uuid'}
  );
  #if (defined $cfg->{serial_number}){
  #  $device_arch{serial_number} = $cfg->{serial_number};
  #}
  #if (defined $cfg->{version}){
  #  $device_arch{version} = $cfg->{version};
  #}
  #if (defined $cfg->{model}){
  #  $device_arch{model} = $cfg->{model};
  #}
  push(@architecture, \%device_arch);
  #print Dumper \$configuration_data{$st_serial};
  #return;

  foreach my $uid (keys %configuration_data){
    my $name = $configuration_data{$uid}{label};
    my $type = $configuration_data{$uid}{TYPE};
    if (!defined $name || !defined $type){next;}
    my @children = ();
    my @parents = ();
    if (defined $configuration_data{$uid}{children}){
      @children = @{$configuration_data{$uid}{children}};
      ## delete children and parent from item_properties
      delete $configuration_data{$uid}{children};

    }
    if (defined $configuration_data{$uid}{parents}){
      @parents = @{$configuration_data{$uid}{parents}};
      delete $configuration_data{$uid}{parents};

    }
    #print Dumper \@children;
    #print Dumper \@parents;
    my %arch = (
      "item_id" => $uid,
      "label" => $name,
      "hw_type" => $st_type,
      "subsystem" => $type,
      "hostcfg_id" => $cfg->{'uuid'},
      "parents" => [$cfg->{'uuid'}]
      );
    if (@parents){
      push(@{$arch{parents}},@parents);
    }
    if (@children){
      push(@{$arch{children}},@children);
    }
    if ($type eq "port_type"){
      $arch{port_type} = $name;
    }
    #if ($type eq "volume"){
      # WWN for mapping
    #  $arch{wwn} = Xormon::formatWWN($uid);
    #}
    if (($type eq "port" || $type eq "volume" ) && defined $configuration_data{$uid}{wwn}){
      # WWN for mapping
      $arch{wwn} = Xormon::formatWWN($configuration_data{$uid}{wwn});
      $configuration_data{$uid}{wwn} = Xormon::formatWWN($configuration_data{$uid}{wwn});
    }
    #push(@{$arch{parents}},$cfg->{'uuid'});
    push(@architecture, \%arch);

  }
  #print Dumper \@architecture;
  #foreach my $item (keys %{$data{conf}{device}}){
  #  $configuration_data{$st_serial}{$item} = $data{conf}{device}{$item};
  #}
  #print Dumper \$configuration_data{device}{$st_serial};

  #save configuration
  #$configuration_data{$cfg->{'uuid'}}{"label"} = $cfg->{'hostalias'};
  #event log
  $configuration_data{$cfg->{'uuid'}}{events} = encode_json(\@health_status);
  #$configuration_data{$cfg->{'uuid'}}{hardware} = encode_json(\@hardware);
  #print Dumper \$configuration_data{$cfg->{'uuid'}}{alerts};
  #print Dumper \@architecture;
  #print Dumper \%configuration_data;
  ### device information save


  my $rc = $xormon->saveConfJSON(\%configuration_data);
  my $status_configuration = get_status($rc, "saveConfJSON (configuration)");
  #$logger->info("Task for configuration ".$cfg->{hostalias}." is done. Status: $status");

  #save architecture
  #print Dumper \@architecture;

  $rc = $xormon->saveArchitecture(\@architecture);
  my $status_architecture = get_status($rc, "saveArchitecture");
  #$logger->info("Task for saveArchitecture ".$cfg->{hostalias}." is done. Status: $status");

  $rc = $xormon->saveStatus(\@health_status_global);
  my $status_health = get_status($rc, "health status");
  return ($status_architecture, $status_configuration, $status_health);
}


sub connection_test {
  my $client = shift;
  $cfg = shift;
  $connection_test = 1;

  my $test = Test->new($client);
  my @variables = ("hostcfg_id", "hostalias", "node1Host", "apiUsername", "apiPassword");
  foreach my $variable (@variables){
    unless ( exists $cfg->{$variable} ){
      $test->addSection("Validation of variables", 0 , "Cannot continue, $variable is not configured!");
      return $test->stop();
    }
  }
  $test->addSection("Validation of variables", 1 , "");

  $logger = XormonLogger->new( 'oceanstor', $cfg->{hostcfg_id}, $cfg->{hostalias} );
  $storage_name = $cfg->{hostalias};
  $st_serial = $cfg->{hostcfg_id};
  data_structure();

  #### connection network test ####
  my $tcp_text = "";
  my ($code1, $text) = Xormon::conntest_tcp($cfg->{node1Host},$port);
  $tcp_text = $tcp_text . "$text\n";
  if (defined $cfg->{node2Host}){
    my ($code2, $text) = Xormon::conntest_tcp($cfg->{node2Host},$port);
    $tcp_text = $tcp_text . "$text\n";
    if ($code1 == 0 && $code2 == 0){
      $test->addSection("API host network connection", 0, $tcp_text);
      return $test->stop();
    }
    $test->addSection("API host network connection", 1, $tcp_text);
  }
  else{
    $test->addSection("API host network connection", $code1, $tcp_text);
    if ($code1 == 0){
      return $test->stop();
    }
  }
  ### API authorization
  $api_host = $cfg->{'node1Host'};
  login();
  if (!defined $token || $token eq "" || !defined $device_id || $device_id eq "" || !defined $cookie || $cookie eq ""){
    if (defined $cfg->{node2Host}){
      if ($cfg->{node2Host} eq $api_host){
        $api_host = $cfg->{'node1Host'};
      }
      $api_host = $cfg->{'node2Host'};
      login();
      if (!defined $token || $token eq "" || !defined $device_id || $device_id eq "" || !defined $cookie || $cookie eq ""){
        push(@rows_api_test, "Cookie, token or device_id is not defined\n");
        $test->addSection("API authorization", 0, \@rows_api_test);
        return $test->stop();
      }
    }
    else{
      push(@rows_api_test, "Cookie, token or device_id is not defined\n");
      $test->addSection("API authorization", 0, \@rows_api_test);
      return $test->stop();
    }
  }
  set_data_device_conf(1);
  if (%configuration_data){
    my %items;
    $items{version} = "Version";
    $items{model} = "Model";
    $items{id} = "ID";
    $items{name} = "Name";
    $items{health_status} = "Health status";
    $items{running_status} = "Running status";
    foreach my $item (keys %items){
      my $line;
      if (defined $configuration_data{$st_serial}{$item}){
        $line = $items{$item} . " : ". $configuration_data{$st_serial}{$item};
      }
      else{
        $line = $items{$item} . " : ";
      }
      push(@rows_api_test,"$line\n");
    }
    $test->addSection("API authorization", 1, \@rows_api_test);
  }
  else{
    logout();
    $test->addSection("API authorization", 0, \@rows_api_test);
    return $test->stop();
  }
  ###
  ### API test data
  set_data_perf_list();
  if (!check_connection()){
    $test->addSection("API test data", 0, \@rows_api_test_data);
    return $test->stop();
  }
  else{
    $test->addSection("API test data", 1, "Performance data ok");
  }
  ###

  return $test->stop();
  #return Xormon::conn_test($connection_test, \@rows_api_test);
}

sub data_structure {
  if (!-d "$data_directory/data"){
    mkdir "$data_directory/data" || $logger->error( "Cannot mkdir $data_directory/data: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
  }
  if (!-d "$data_directory/data/$st_serial"){
    mkdir "$data_directory/data/$st_serial" || $logger->error( "Cannot mkdir $data_directory/data/$st_serial: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
  }
  if (!-d "$data_directory/data/$st_serial/IOSTATS"){
    mkdir "$data_directory/data/$st_serial/IOSTATS" || $logger->error( "Cannot mkdir $data_directory/data/$st_serial/IOSTATS: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
  }


  my $directory = "$data_directory/data/$st_serial/IOSTATS";
  if ( !-d $directory ) {
    mkdir $directory || $logger->error( "Cannot mkdir $directory: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
  }
  if ( !-d "$directory/configuration" ) {
    mkdir "$directory/configuration" || $logger->error( "Cannot mkdir $directory/configuration: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
  }

  for ( my $i = 0; $i < 60; $i = $i + 5 ) {
    if ( $i < 10 ) {
      if ( !-d "$directory/0$i" ) {
        mkdir "$directory/0$i" || $logger->error( "Cannot mkdir $directory/0$i: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
      }
    }
    else {
      if ( !-d "$directory/$i" ) {
        mkdir "$directory/$i" || $logger->error( "Cannot mkdir $directory/$i: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
      }
    }
  } ## end for ( my $i = 0; $i < 60...)
  my @entry_time = split( " ", localtime() );
  ( undef, $active_minute, undef ) = split( ":", $entry_time[3] );
  if ( !-d "$directory/$active_minute" ) {
    mkdir "$directory/$active_minute" || $logger->error( "Cannot mkdir $directory/$active_minute: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
  }
  #$debug_data_performance = "$directory/$active_minute";
  #$debug_data = "$directory/configuration";
  $debug_data = "$directory/$active_minute";
  $debug_data_configuration = "$directory/configuration";
  #print "$debug_data\n";
  $wrkdir = "$data_directory/data/$st_serial";

} ## end sub data_structure

sub round {
  my $number         = shift;
  my $decimal_plates = shift;
  if ( !defined $decimal_plates ) {
    $decimal_plates = 3;
  }
  my $num = $number;
  if ( $number =~ /\./ ) {
    $number =~ s/.*\.//g;
    my $length = length($number);
    if ( $length > $decimal_plates ) {
      my $rounded = sprintf( "%.$decimal_plates" . "f", $num );
      return $rounded;
    }
    else {
      return $num;
    }
  } ## end if ( $number =~ /\./ )
  else {
    return $num;
  }
} ## end sub round

sub check_connection{
  my $data = cmd("system/", "GET", 1, "system");
  if ( $data eq "" ) {
    if ($connection_test){
      push(@rows_api_test_data,"connection to $api_host on port $port has failed!\n");
    }
    else{
      $logger->error("connection to $api_host on port $port has failed!");
    }
    return 0;
  }
  $data = cmd("Controller", "GET", 1,"Controller");
  if ($data eq ""){
    $data = cmd("controller", "GET", 1,"controller");
    if ($data ne ""){
      foreach my $node (@{$data->{data}}){
        my $id = $node->{ID};
        my $type = $node->{TYPE};
        if ( !defined $id || !defined $type ) { next; }
        my $cmd_perf = "performace_statistic/cur_statistic_data?CMO_STATISTIC_UUID=$type:$id&CMO_STATISTIC_DATA_ID_LIST=$performance_statistics{node}";
        my $perf_data = cmd($cmd_perf,"GET", 1, "$type" . "_$id");
        if ($perf_data eq ""){
          return 0;
        }
        if (!defined $perf_data->{data} && $perf_data eq "83890432"){
          return relogin();
        }
      }
    }
    else{
      if ($connection_test){
        push(@rows_api_test_data,"connection to $api_host on port $port has failed!\n");
      }
      else{
        $logger->error("connection to $api_host on port $port has failed!");
      }
      return 0;
    }
  }
  else{
    foreach my $node (@{$data->{data}}){
      my $id = $node->{ID};
      my $type = $node->{TYPE};
      if ( !defined $id || !defined $type ) { next; }
      my $cmd_perf = "performace_statistic/cur_statistic_data?CMO_STATISTIC_UUID=$type:$id&CMO_STATISTIC_DATA_ID_LIST=$performance_statistics{node}";
      my $perf_data = cmd($cmd_perf,"GET", 1, "$type" . "_$id");
      if ($perf_data eq ""){
        return 0;
      }
      if ($perf_data ne "" && !defined $perf_data->{data} && $perf_data eq "83890432"){
        return relogin();
      }
      #print Dumper \$perf_data;
    }
  }
  return 1;
}

sub relogin{
  logout();
  if ($api_host ne $cfg->{'node2Host'}){
    $api_host = $cfg->{'node2Host'};
  }
  else{
    $api_host = $cfg->{'node1Host'};
  }
  $token = "";
  $device_id = "";
  $cookie = "";
  login();
  if (!defined $token || $token eq "" || !defined $device_id || $device_id eq "" || !defined $cookie || $cookie eq ""){
    return 0;
  }
  return 1;
}

sub set_data_perf_list{
  $performance_statistics{node} = "22,25,28,370,384,385,23,26,93,95,68,69,110,120,19";
  $performance_statistics{pool} = "22,25,28,370,384,385,23,26,182,232,233,523,524,525,511,770,771,805,806,807";
  $performance_statistics{drive} = "22,25,28,370,384,385,23,26,19";
  $performance_statistics{volume} = "22,25,28,370,384,385,23,26,93,95,19";
  $performance_statistics{host} = "22,25,28,370,384,385,23,26";
  $performance_statistics{fcport} = "22,25,28,370,384,385,23,26";
  $performance_statistics{sasport} = "22,25,28,370,384,385,23,26";
  $performance_statistics{fcoeport} = "22,25,28,370,384,385,23,26";
  $performance_statistics{ethport} = "22,25,28,370,384,385,23,26,721,724,727,730,733,736,745,748,751,754,757,760,703,706,709,712,715,718";
  $performance_statistics{logport} = "22,25,28,370,384,385,23,26,721,724,727,730,733,736,745,748,751,754,757,760,703,706,709,712,715,718";
  $performance_statistics{fs} = "182,232,123,524,233,124,525,523"; ### data rate in KB/s change denominator
  $performance_statistics{ControllerNFSV3} = "123,124,182,232,233,511,524,525,739,742,763,766";
  $performance_statistics{ControllerSMBV2} = "123,124,182,232,233,511,524,525,739,742,763,766";
  $performance_statistics{ControllerNFSV41} = "123,124,182,232,233,511,524,525,739,763";

  $metric_inventory{22}  = "io_rate";
  $metric_inventory{25}  = "read_io";
  $metric_inventory{28}  = "write_io";
  $metric_inventory{23}  = "read";
  $metric_inventory{26}  = "write";
  $metric_inventory{370} = "resp_t";
  $metric_inventory{384} = "resp_t_r";
  $metric_inventory{385} = "resp_t_w";
  $metric_inventory{93}  = "r_cache_hit";
  $metric_inventory{95}  = "w_cache_hit";
  $metric_inventory{68}  = "cpu_system";
  $metric_inventory{69}  = "cache_usage_percent";
  $metric_inventory{110} = "r_cache_usage_percent";
  $metric_inventory{120} = "w_cache_usage_percent";
  $metric_inventory{19}  = "queue_length";
  $metric_inventory{182} = "ops_rate";
  $metric_inventory{232} = "read_ops";
  $metric_inventory{123} = "read";
  $metric_inventory{524} = "resp_t_r";
  $metric_inventory{233} = "write_ops";
  $metric_inventory{124} = "write";
  $metric_inventory{525} = "resp_t_w";
  $metric_inventory{523} = "resp_t";
  $metric_inventory{721} = "nfs_ops_rate";
  $metric_inventory{724} = "cifs_ops_rate";
  $metric_inventory{727} = "nfs_read_ops";
  $metric_inventory{730} = "cifs_read_ops";
  $metric_inventory{733} = "nfs_write_ops";
  $metric_inventory{736} = "cifs_write_ops";
  $metric_inventory{739} = "nfs_other_ops_rate";
  $metric_inventory{742} = "cifs_other_ops_rate";
  $metric_inventory{745} = "nfs_resp_t";
  $metric_inventory{748} = "cifs_resp_t";
  $metric_inventory{751} = "nfs_resp_t_r";
  $metric_inventory{754} = "cifs_resp_t_r";
  $metric_inventory{757} = "nfs_resp_t_w";
  $metric_inventory{760} = "cifs_resp_t_w";
  #$metric_inventory{763} = "nfs_other_resp_t";
  #$metric_inventory{766} = "cifs_other_resp_t";
  $metric_inventory{703} = "nfs_data_rate";
  $metric_inventory{706} = "cifs_data_rate";
  $metric_inventory{709} = "nfs_read";
  $metric_inventory{712} = "cifs_read";
  $metric_inventory{715} = "nfs_write";
  $metric_inventory{718} = "cifs_write";
  $metric_inventory{511} = "file_data_rate";
  $metric_inventory{770} = "file_read";
  $metric_inventory{771} = "file_write";
  $metric_inventory{805} = "resp_t_r_b";
  $metric_inventory{806} = "resp_t_w_b";
  $metric_inventory{807} = "resp_t_b";
  $metric_inventory{703} = "nfs_data_rate";
  $metric_inventory{706} = "cifs_data_rate";
  $metric_inventory{709} = "nfs_read";
  $metric_inventory{712} = "cifs_read";
  $metric_inventory{715} = "nfs_write";
  $metric_inventory{718} = "cifs_write";

  ### controllers protocols
  $metric_inventory{"nfsv3_123"} = "nfsv3_read";
  $metric_inventory{"nfsv3_124"} = "nfsv3_write";
  $metric_inventory{"nfsv3_511"} = "nfsv3_data_rate";
  $metric_inventory{"nfsv3_182"} = "nfsv3_ops_rate";
  $metric_inventory{"nfsv3_232"} = "nfsv3_read_ops";
  $metric_inventory{"nfsv3_233"} = "nfsv3_write_ops";
  $metric_inventory{"nfsv3_524"} = "nfsv3_resp_t_r";
  $metric_inventory{"nfsv3_525"} = "nfsv3_resp_t_w";

  $metric_inventory{"nfsv41_123"} = "nfsv41_read";
  $metric_inventory{"nfsv41_124"} = "nfsv41_write";
  $metric_inventory{"nfsv41_511"} = "nfsv41_data_rate";
  $metric_inventory{"nfsv41_182"} = "nfsv41_ops_rate";
  $metric_inventory{"nfsv41_232"} = "nfsv41_read_ops";
  $metric_inventory{"nfsv41_233"} = "nfsv41_write_ops";
  $metric_inventory{"nfsv41_524"} = "nfsv41_resp_t_r";
  $metric_inventory{"nfsv41_525"} = "nfsv41_resp_t_w";

  $metric_inventory{"smbv2_123"} = "smb2_read";
  $metric_inventory{"smbv2_124"} = "smb2_write";
  $metric_inventory{"smbv2_511"} = "smb2_data_rate";
  $metric_inventory{"smbv2_182"} = "smb2_ops_rate";
  $metric_inventory{"smbv2_232"} = "smb2_read_ops";
  $metric_inventory{"smbv2_233"} = "smb2_write_ops";
  $metric_inventory{"smbv2_524"} = "smb2_resp_t_r";
  $metric_inventory{"smbv2_525"} = "smb2_resp_t_w";


}

sub get_health_status_text {
  my $number = shift;

  if ( $number == 1 ) {
    return "normal";
  }
  if ( $number == 0 ) {
    return "unknown";
  }
  if ( $number == 2 ) {
    return "faulty";
  }
  if ( $number == 3 ) {
    return "Pre-Fail";
  }
  if ( $number == 9 ) {
    return "inconsistent";
  }
  if ( $number == 4 ) {
    return "partially damaged";
  }
  if ( $number == 12 ) {
    return "low battery";
  }
  if ( $number == 5 ) {
    return "degraded";
  }

  return $number;

}

sub get_running_status_text {
  my $number = shift;

  if ( $number == 1 ) {
    return "normal";
  }
  if ( $number == 0 ) {
    return "unknown";
  }
  if ( $number == 2 ) {
    return "running";
  }
  if ( $number == 27 ) {
    return "online";
  }
  if ( $number == 28 ) {
    return "offline";
  }
  if ( $number == 48 ) {
    return "charging completed";
  }
  if ( $number == 50 ) {
    return "discharging";
  }
  if ( $number == 10 ) {
    return "link up";
  }
  if ( $number == 11 ) {
    return "link down";
  }
  if ( $number == 14 ) {
    return "pre-copy";
  }
  if ( $number == 16 ) {
    return "reconstruction";
  }
  if ( $number == 32 ) {
    return "balancing";
  }
    if ( $number == 53 ) {
    return "Initializing";
  }
  return $number;
}

sub get_global_timestamp{
  my $act_timestamp = time();
  (my $sec,my $min,my $hour,my $mday,my $mon, my $year,my $wday,my $yday,my $isdst) = localtime();
  return $act_timestamp - $sec;

}

sub get_level_text {
  my $type = shift;
  if ( !defined $type ) { return "unknown"; }
  if ( $type == 2 )     { return "info"; }
  if ( $type == 3 )     { return "warning"; }
  if ( $type == 5 )     { return "major"; }
  if ( $type == 6 )     { return "critical"; }
  return "unknown";

}

sub get_type_text {
  my $type = shift;
  if ( !Xormon::isdigit($type) ) { return "unknown"; }
  if ( $type == 0 )      { return "event"; }
  if ( $type == 1 )      { return "alarm"; }
  if ( $type == 2 )      { return "cleared alarm"; }
  return "unknown";

}

sub set_data_device_capacity{
  my $section = "device";
  my $data = cmd("system/", "GET", 0, "system");
  #print Dumper \$data;
  if ( $data eq "" ) {
    return;
  }
  my $sector_size = 512;
  if (Xormon::isdigit($data->{data}->{SECTORSIZE})){
    $sector_size = $data->{data}->{SECTORSIZE};
  }
  my $timestamp = (keys %{$performance_data{$st_type}{$section}{$st_serial}})[0];
  if (ref($data->{data}) eq "HASH" && Xormon::isdigit($data->{data}->{TOTALCAPACITY}) && Xormon::isdigit($data->{data}->{USEDCAPACITY})){
    $performance_data{$st_type}{$section}{$st_serial}{$timestamp}{capacity_total} = $data->{data}->{TOTALCAPACITY} * $sector_size;
    $performance_data{$st_type}{$section}{$st_serial}{$timestamp}{capacity_used} = $data->{data}->{USEDCAPACITY} * $sector_size;
    $performance_data{$st_type}{$section}{$st_serial}{$timestamp}{capacity_free} = ($data->{data}->{TOTALCAPACITY} * $sector_size) - ($data->{data}->{USEDCAPACITY} * $sector_size)
    #print "nastavujeme kapacity globalni\n";

  }
}
sub set_data_device_conf{
  my $conn_test = shift;
  if (!defined $conn_test){$conn_test = 0;}

  my %items;
  $items{"TOTALCAPACITY"} = "capacity_total";
  $items{"USEDCAPACITY"} = "capacity_used";
  #$items{"userFreeCapacity"} = "capacity_free";
  $items{HEALTHSTATUS} = "health_status";
  $items{RUNNINGSTATUS} = "running_status";
  $items{PRODUCTVERSION} = "version";
  $items{patchVersion} = "patch_version";
  $items{PRODUCTMODE} = "model";
  $items{ID} = "id";
  $items{NAME} = "node_name";

  my $section = "device";
  my $data = cmd("system/", "GET", $conn_test, "system");
  #print Dumper \$data;
  if ( $data eq "" ) {
    return;
  }

  if (ref($data->{data}) eq "HASH"){
    foreach my $item (keys %items){
      if (defined $data->{data}->{$item}){
        if ($items{$item} eq "model"){
          $configuration_data{$st_serial}{$items{$item}} = get_model($data->{data}->{$item});
        }
        elsif($items{$item} =~ m/health_status/){
          $configuration_data{$st_serial}{$items{$item}} = get_health_status_text($data->{data}->{$item});
        }
        elsif($items{$item} eq "running_status"){
          $configuration_data{$st_serial}{$items{$item}} = get_running_status_text($data->{data}->{$item});
        }
        elsif($items{$item} =~ m/capacity/){
          my $sector_size = 512;
          if (Xormon::isdigit($data->{data}->{SECTORSIZE})){
            $sector_size = $data->{data}->{SECTORSIZE};
            if (Xormon::isdigit($data->{data}->{$item})){
              $configuration_data{$st_serial}{$items{$item}} = $data->{data}->{$item} * $sector_size;
            }
          }

        }
        else{
          $configuration_data{$st_serial}{$items{$item}} = $data->{data}->{$item};
        }
      }
      else{
        $configuration_data{$st_serial}{$items{$item}} = "";
      }
    }
  }
  if (defined $configuration_data{$st_serial}{patch_version} && defined $configuration_data{$st_serial}{version}){
    $configuration_data{$st_serial}{version} = $configuration_data{$st_serial}{version} . " " . $configuration_data{$st_serial}{patch_version};
  }
  my $capacity_total = $configuration_data{$st_serial}{capacity_total};
  my $capacity_used = $configuration_data{$st_serial}{capacity_used};
  if (Xormon::isdigit($capacity_total) && Xormon::isdigit($capacity_used)){
    $configuration_data{$st_serial}{capacity_free} = $capacity_total - $capacity_used;
  }
}

sub get_model{
  my $model = shift;
  if ( $model eq "61" )  { return "6800 V3"; }
  if ( $model eq "62" )  { return "6900 V3"; }
  if ( $model eq "63" )  { return "5600 V3"; }
  if ( $model eq "64" )  { return "5800 V3"; }
  if ( $model eq "68" )  { return "5500 V3"; }
  if ( $model eq "69" )  { return "2600 V3"; }
  if ( $model eq "70" )  { return "5300 V3"; }
  if ( $model eq "71" )  { return "2800 V3"; }
  if ( $model eq "72" )  { return "18500 V3"; }
  if ( $model eq "73" )  { return "18800 V3"; }
  if ( $model eq "74" )  { return "2200 V3"; }
  if ( $model eq "82" )  { return "2600 V3 for Video"; }
  if ( $model eq "84" )  { return "2600F V3"; }
  if ( $model eq "85" )  { return "5500F V3"; }
  if ( $model eq "86" )  { return "5600F V3"; }
  if ( $model eq "87" )  { return "5800F V3"; }
  if ( $model eq "88" )  { return "6800F V3"; }
  if ( $model eq "89" )  { return "18500F V3"; }
  if ( $model eq "90" )  { return "18800F V3"; }
  if ( $model eq "92" )  { return "2800 V5"; }
  if ( $model eq "93" )  { return "5300 V5"; }
  if ( $model eq "94" )  { return "5300F V5"; }
  if ( $model eq "95" )  { return "5500 V5"; }
  if ( $model eq "96" )  { return "5500F V5"; }
  if ( $model eq "97" )  { return "5600 V5"; }
  if ( $model eq "98" )  { return "5600F V5"; }
  if ( $model eq "99" )  { return "5800 V5"; }
  if ( $model eq "100" ) { return "5800F V5"; }
  if ( $model eq "101" ) { return "6800 V5"; }
  if ( $model eq "102" ) { return "6800F V5"; }
  if ( $model eq "103" ) { return "18500 V5"; }
  if ( $model eq "104" ) { return "18500F V5"; }
  if ( $model eq "105" ) { return "18800 V5"; }
  if ( $model eq "106" ) { return "18800F V5"; }
  if ( $model eq "107" ) { return "5500 V5 Elite"; }
  if ( $model eq "108" ) { return "2100 V3"; }
  if ( $model eq "116" ) { return "5110 V5"; }
  if ( $model eq "810" ) { return "Dorado3000 V3"; }
  if ( $model =~ m/^811$|^812$|^821$/){return "OceanStor Dorado 5000 V6";}
  if ( $model eq "834"){return "OceanStor 5310";}
  if ( $model =~ m/^813$|^814$|^822$/){ return "OceanStor Dorado 6000 V6";}
  if ( $model =~ m/^815$|^816$|^823$/){ return "OceanStor Dorado 8000 V6";}
  if ( $model =~ m/^817$|^818$|^824$/){ return "OceanStor Dorado 18000 V6";}
  if ( $model =~ m/^819$/){ return "OceanStor Dorado 3000 V6";}
  if ( $model =~ m/^825$/){ return "OceanStor Dorado 5300 V6";}
  if ( $model =~ m/^826$/){ return "OceanStor Dorado 5500 V6";}
  if ( $model =~ m/^827$/){ return "OceanStor Dorado 5600 V6";}
  if ( $model =~ m/^828$/){ return "OceanStor Dorado 5800 V6";}
  if ( $model =~ m/^829$/){ return "OceanStor Dorado 6800 V6";}
  if ( $model =~ m/^830$/){ return "OceanStor Dorado 18500 V6";}
  if ( $model =~ m/^831$/){ return "OceanStor Dorado 18800 V6";}




  return $model;

}



1;
