package Parsing;
use strict;
use warnings 'FATAL' => 'all';
use Exporter;
use Xormon qw(VrDump);

our @ISA       = qw(Exporter);
our @EXPORT_OK = qw(string2arrayLikeUnity trim);


###
# string2arrayLikeUnity($string)
# converts a string to a array. the format of the string corresponds to the output from unity
# @format
# section number: name  = value
#  				  name2 = value2
# @return array
# [
#   [section number, name, value],
#   [section number, name2, value2]
# ]
sub string2arrayLikeUnity {
  my $string = shift;

  my @outputArray;
  my $section = 4;

  my @lines = split /\n/, $string;
  my $name  = 4;
  my $value = 4;

  foreach my $line ( @lines ) {
    $line = trim($line);
    if( $line !~ /^\s*$/ ) {
      if( $line =~ /^(.+):\s*(.*)\s*=\s*(.*)\s*$/ ) {
        ( $section, $name, $value ) = ( $1, $2, $3 );
      } elsif( $line =~ /^\s*(.*)\s*=\s*(.*)\s*$/ ) {
        ( $name, $value ) = ( $1, $2 );
      } else {
        next;
      }
      $name  = trim($name);
      $value = trim($value);
      push(@outputArray, [$section, $name, $value]);
    }
  }
  return \@outputArray;
}

###
# trim($string)
# remove spaces from the beginning and end of the string
# @param
#  @var $string - string - input string
# @return string
sub trim {
  my $string = shift;
  $string =~ s/^\s+|\s+$//g;
  return $string;
}

1;
